/*
 * ndpi_content_match.c
 *
 * Copyright (C) 2011-19 - ntop.org
 *
 * nDPI is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * nDPI is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with nDPI.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

/* ****************************************************** */

#if 0
static ndpi_network host_protocol_list[] = {
  /*
    SoundCloud
  */
  { 0x22FB2FEE /* 34.251.47.238 */, 32, NDPI_PROTOCOL_SOUNDCLOUD },
  { 0x23A06456 /* 35.160.100.86 */, 32, NDPI_PROTOCOL_SOUNDCLOUD },
  { 0x36C0CA58 /* 54.192.202.88 */, 32, NDPI_PROTOCOL_SOUNDCLOUD },

  /*
    Facebook, Inc.
    origin AS32934, AS54115
  */

  { 0x1F0D1800 /* 31.13.24.0/21 */, 21, NDPI_PROTOCOL_FACEBOOK },
  { 0x1F0D4000 /* 31.13.64.0/18 */, 18, NDPI_PROTOCOL_FACEBOOK },
  { 0x2D402800 /* 45.64.40.0/22 */, 22, NDPI_PROTOCOL_FACEBOOK },
  { 0x42DC9000 /* 66.220.144.0/20 */, 20, NDPI_PROTOCOL_FACEBOOK },
  { 0x453FB000 /* 69.63.176.0/20 */, 20, NDPI_PROTOCOL_FACEBOOK },
  { 0x45ABE000 /* 69.171.224.0/19 */, 19, NDPI_PROTOCOL_FACEBOOK },
  { 0x4A774C00 /* 74.119.76.0/22 */, 22, NDPI_PROTOCOL_FACEBOOK },
  { 0x67046000 /* 103.4.96.0/22 */, 22, NDPI_PROTOCOL_FACEBOOK },
  { 0x81860000 /* 129.134.0.0/16 */, 16, NDPI_PROTOCOL_FACEBOOK },
  { 0x81CD5E00 /* 129.205.94.0/23 */, 23, NDPI_PROTOCOL_FACEBOOK },
  { 0x9df00000 /* 157.240.0.0/16 */, 16, NDPI_PROTOCOL_FACEBOOK },
  { 0xADFC4000 /* 173.252.64.0/18 */, 18, NDPI_PROTOCOL_FACEBOOK },
  { 0xB33CC000 /* 179.60.192.0/22 */, 22, NDPI_PROTOCOL_FACEBOOK },
  { 0xB93CD800 /* 185.60.216.0/22 */, 22, NDPI_PROTOCOL_FACEBOOK },
  { 0xC7C94000 /* 199.201.64.0/22 */, 22, NDPI_PROTOCOL_FACEBOOK },
  { 0xCC0F1400 /* 204.15.20.0/22 */, 22, NDPI_PROTOCOL_FACEBOOK },

  /*
    Twitter Inc.
    origin AS13414, AS35995
  */

  { 0x0819C200 /* 8.25.194.0/23 */, 23, NDPI_PROTOCOL_TWITTER },
  { 0x0819C400 /* 8.25.196.0/23 */, 23, NDPI_PROTOCOL_TWITTER },
  { 0x450C3800 /* 69.12.56.0/21 */, 21, NDPI_PROTOCOL_TWITTER },
  { 0x67FC7000 /* 103.252.112.0/22 */, 22, NDPI_PROTOCOL_TWITTER },
  { 0x68F42800 /* 104.244.40.0/24 */, 24, NDPI_PROTOCOL_TWITTER },
  { 0x68F42900 /* 104.244.41.0/24 */, 24, NDPI_PROTOCOL_TWITTER },
  { 0x68F42A00 /* 104.244.42.0/24 */, 24, NDPI_PROTOCOL_TWITTER },
  { 0x68F42B00 /* 104.244.43.0/24 */, 24, NDPI_PROTOCOL_TWITTER },
  { 0x68F42C00 /* 104.244.44.0/24 */, 24, NDPI_PROTOCOL_TWITTER },
  { 0x68F42D00 /* 104.244.45.0/24 */, 24, NDPI_PROTOCOL_TWITTER },
  { 0x68F42E00 /* 104.244.46.0/24 */, 24, NDPI_PROTOCOL_TWITTER },
  { 0x68F42F00 /* 104.244.47.0/24 */, 24, NDPI_PROTOCOL_TWITTER },
  { 0xB92D0400 /* 185.45.4.0/23 */, 23, NDPI_PROTOCOL_TWITTER },
  { 0xB92D0600 /* 185.45.6.0/23 */, 23, NDPI_PROTOCOL_TWITTER },
  { 0xBC40E000 /* 188.64.224.0/21 */, 21, NDPI_PROTOCOL_TWITTER },
  { 0xC02C4400 /* 192.44.68.0/23 */, 23, NDPI_PROTOCOL_TWITTER },
  { 0xC0854C00 /* 192.133.76.0/22 */, 22, NDPI_PROTOCOL_TWITTER },
  { 0xC7109C00 /* 199.16.156.0/22 */, 22, NDPI_PROTOCOL_TWITTER },
  { 0xC73B9400 /* 199.59.148.0/22 */, 22, NDPI_PROTOCOL_TWITTER },
  { 0xC7453A00 /* 199.69.58.0/23 */, 23, NDPI_PROTOCOL_TWITTER },
  { 0xC7603800 /* 199.96.56.0/21 */, 21, NDPI_PROTOCOL_TWITTER },
  { 0xCAA08000 /* 202.160.128.0/22 */, 22, NDPI_PROTOCOL_TWITTER },

  /*
    WhatsApp Inc.
    List of the WhatsApp server IP addresses and ranges
    https://developers.facebook.com/docs/whatsapp/network-debugging/
    Dec 1st, 2019
  */
  { 0x1F0D4033 /* 31.13.64.51/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D4035 /* 31.13.64.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D4131 /* 31.13.65.49/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D4132 /* 31.13.65.50/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D4233 /* 31.13.66.51/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D4238 /* 31.13.66.56/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D4239 /* 31.13.66.57/32  */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D4334 /* 31.13.67.52/31 */, 31, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D4430 /* 31.13.68.48/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D4434 /* 31.13.68.52/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D4631 /* 31.13.70.49/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D4632 /* 31.13.70.50/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D4731 /* 31.13.71.49/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D4732 /* 31.13.71.50/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D4830 /* 31.13.72.48/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D4834 /* 31.13.72.52/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D4934 /* 31.13.73.52/31 */, 31, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D4A34 /* 31.13.74.52/31 */, 31, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D4C3C /* 31.13.76.60/32  */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D4C3D /* 31.13.76.61/32  */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D4F35 /* 31.13.79.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D4F36 /* 31.13.79.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5030 /* 31.13.80.48/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5035 /* 31.13.80.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5130 /* 31.13.81.48/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5135 /* 31.13.81.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5233 /* 31.13.82.51/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5237 /* 31.13.82.55/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5331 /* 31.13.83.49/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5333 /* 31.13.83.51/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5431 /* 31.13.84.49/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5433 /* 31.13.84.51/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5531 /* 31.13.85.49/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5533 /* 31.13.85.51/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5631 /* 31.13.86.49/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5633 /* 31.13.86.51/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5730 /* 31.13.87.48/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5733 /* 31.13.87.51/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5935 /* 31.13.89.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5936 /* 31.13.89.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5A31 /* 31.13.90.49/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5A33 /* 31.13.90.51/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5B31 /* 31.13.91.49/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5B33 /* 31.13.91.51/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5C3E /* 31.13.92.62/32  */, 32, NDPI_PROTOCOL_WHATSAPP },  
  { 0x1F0D5C30 /* 31.13.92.48/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5C34 /* 31.13.92.52/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5D35 /* 31.13.93.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5D36 /* 31.13.93.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5D37 /* 31.13.93.55/32  */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5E34 /* 31.13.94.52/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5E36 /* 31.13.94.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5F32 /* 31.13.95.50/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x1F0D5F3F /* 31.13.95.63/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x3216F0A0 /* 50.22.240.160/27*/, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0x32175A80 /* 50.23.90.128/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0x45ABEF0B /* 69.171.239.11/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x45ABFA34 /* 69.171.250.52/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x45ABFA36 /* 69.171.250.54/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x45ABFF0B /* 69.171.255.11/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x66846036 /* 102.132.96.54/31*/, 31, NDPI_PROTOCOL_WHATSAPP },
  { 0x66846136 /* 102.132.97.54/31*/, 31, NDPI_PROTOCOL_WHATSAPP },
  { 0x6CA8AE00 /* 108.168.174.0/27*/, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0x6CA8B0C0 /* 108.168.176.192/26*/, 26, NDPI_PROTOCOL_WHATSAPP },
  { 0x6CA8B100 /* 108.168.177.0/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0x6CA8B460 /* 108.168.180.96/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0x6CA8FE41 /* 108.168.254.65/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x6CA8FFE0 /* 108.168.255.224/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x6CA8FFE3 /* 108.168.255.227/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF00135 /* 157.240.1.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF00136 /* 157.240.1.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF00235 /* 157.240.2.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF00236 /* 157.240.2.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF00336 /* 157.240.3.54/31 */, 31, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF00635 /* 157.240.6.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF00636 /* 157.240.6.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF00735 /* 157.240.7.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF00736 /* 157.240.7.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF00835 /* 157.240.8.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF00836 /* 157.240.8.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF00935 /* 157.240.9.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF00936 /* 157.240.9.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF00A35 /* 157.240.10.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF00A36 /* 157.240.10.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF00B35 /* 157.240.11.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF00B36 /* 157.240.11.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF00C35 /* 157.240.12.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF00C36 /* 157.240.12.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF00D36 /* 157.240.13.54/31 */, 31, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF00E34 /* 157.240.14.52/31 */, 31, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF00F35 /* 157.240.15.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF00F36 /* 157.240.15.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF01034 /* 157.240.16.52/31 */, 31, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF01234 /* 157.240.18.52/31 */, 31, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF01335 /* 157.240.19.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF01336 /* 157.240.19.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF01434 /* 157.240.20.52/31 */, 31, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF01534 /* 157.240.21.52/31 */, 31, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF01635 /* 157.240.22.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF01636 /* 157.240.22.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF01735 /* 157.240.23.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF01736 /* 157.240.23.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF01836 /* 157.240.24.54/31 */, 31, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF01936 /* 157.240.25.54/31 */, 31, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF01A36 /* 157.240.26.54/31 */, 31, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF01B36 /* 157.240.27.54/31 */, 31, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF01C33 /* 157.240.28.51/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF01C37 /* 157.240.28.55/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF01D35 /* 157.240.29.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF01D36 /* 157.240.29.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF01E36 /* 157.240.30.54/31 */, 31, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0C034 /* 157.240.192.52/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0C037 /* 157.240.192.55/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0C132 /* 157.240.193.50/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0C137 /* 157.240.193.55/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0C236 /* 157.240.194.54/31 */, 31, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0C336 /* 157.240.195.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0C338 /* 157.240.195.56/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0C43C /* 157.240.196.60/31 */, 31, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0C93C /* 157.240.201.60/31 */, 31, NDPI_PROTOCOL_WHATSAPP },
  { 0x9E550060 /* 158.85.0.96/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0x9E5505C0 /* 158.85.5.192/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0x9E552E80 /* 158.85.46.128/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0x9E5530E0 /* 158.85.48.224/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0x9E553A20 /* 158.85.58.32/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0x9E553A60 /* 158.85.58.96/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0x9E553DC0 /* 158.85.61.192/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0x9E55E0A0 /* 158.85.224.160/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0x9E55E920 /* 158.85.233.32/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA92C2400 /* 169.44.36.0/26 */, 26, NDPI_PROTOCOL_WHATSAPP },
  { 0xA92C5020 /* 169.44.80.32/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA92C5260 /* 169.44.82.96/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA92C5480 /* 169.44.84.128/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA92D4720 /* 169.45.71.32/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA92D5780 /* 169.45.87.128/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA92DA9C0 /* 169.45.169.192/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA92DD240 /* 169.45.210.64/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA92DD6E0 /* 169.45.214.224/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA92DDBE0 /* 169.45.219.224/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA92DEE20 /* 169.45.238.32/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA92DF2C0 /* 169.45.242.192/26 */, 26, NDPI_PROTOCOL_WHATSAPP },
  { 0xA92DF860 /* 169.45.248.96/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA92DF8A0 /* 169.45.248.160/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA92F05C0 /* 169.47.5.192/26 */, 26, NDPI_PROTOCOL_WHATSAPP },
  { 0xA92F0640 /* 169.47.6.64/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA92F2320 /* 169.47.35.32/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA92F2880 /* 169.47.40.128/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA92F2A60 /* 169.47.42.96/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA92F2AA0 /* 169.47.42.160/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA92F2AC0 /* 169.47.42.192/26 */, 26, NDPI_PROTOCOL_WHATSAPP },
  { 0xA92F8260 /* 169.47.130.96/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA92F9980 /* 169.47.153.128/25 */, 25, NDPI_PROTOCOL_WHATSAPP },
  { 0xA92FC680 /* 169.47.198.128/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA92FD4A0 /* 169.47.212.160/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA93547E0 /* 169.53.71.224/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA9355140 /* 169.53.81.64/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA9363320 /* 169.54.51.32/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA93637C0 /* 169.54.55.192/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA936DE80 /* 169.54.222.128/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA9373C94 /* 169.55.60.148/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0xA9373CAA /* 169.55.60.170/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0xA93743E0 /* 169.55.67.224/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA93745A0 /* 169.55.69.160/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA9374A20 /* 169.55.74.32/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA9374B60 /* 169.55.75.96/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA93C4B80 /* 169.60.75.128/25 */, 25, NDPI_PROTOCOL_WHATSAPP },
  { 0xA93C4F00 /* 169.60.79.0/24 */, 24, NDPI_PROTOCOL_WHATSAPP },
  { 0xA93C9300 /* 169.60.147.0/24 */, 24, NDPI_PROTOCOL_WHATSAPP },
  { 0xA93D6500 /* 169.61.101.0/24 */, 24, NDPI_PROTOCOL_WHATSAPP },
  { 0xA93E9F10 /* 169.62.159.16/28 */, 28, NDPI_PROTOCOL_WHATSAPP },
  { 0xA93F4080 /* 169.63.64.128/28 */, 28, NDPI_PROTOCOL_WHATSAPP },
  { 0xA93F4920 /* 169.63.73.32/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xA93F4940 /* 169.63.73.64/26 */, 26, NDPI_PROTOCOL_WHATSAPP },
  { 0xA93F4C00 /* 169.63.76.0/25 */, 25, NDPI_PROTOCOL_WHATSAPP },
  { 0xADC0A220 /* 173.192.162.32/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xADC0DEA0 /* 173.192.222.160/27*/, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xADC1E680 /* 173.193.230.128/27*/, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xADC1EF00 /* 173.193.239.0/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xAE24D080 /* 174.36.208.128/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xAE24D220 /* 174.36.210.32/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xAE25F340 /* 174.37.243.64/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xB33CC031 /* 179.60.192.49/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0xB33CC033 /* 179.60.192.51/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0xB33CC134 /* 179.60.193.52/31 */, 31, NDPI_PROTOCOL_WHATSAPP },
  { 0xB33CC235 /* 179.60.194.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0xB33CC236 /* 179.60.194.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0xB33CC331 /* 179.60.195.49/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0xB33CC333 /* 179.60.195.51/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0xB8AD8840 /* 184.173.136.64/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xB8AD9320 /* 184.173.147.32/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xB8ADA140 /* 184.173.161.64/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0xB8ADAD74 /* 184.173.173.116/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0xB93CD835 /* 185.60.216.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0xB93CD836 /* 185.60.216.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0xB93CD935 /* 185.60.217.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0xB93CD936 /* 185.60.217.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0xB93CDA35 /* 185.60.218.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0xB93CDA36 /* 185.60.218.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0xB93CDB35 /* 185.60.219.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0xB93CDB36 /* 185.60.219.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0xC09BD4C0 /* 192.155.212.192/27*/, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xC60BC1B6 /* 198.11.193.182/31 */, 31, NDPI_PROTOCOL_WHATSAPP },
  { 0xC60BFB20 /* 198.11.251.32/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xC6175000 /* 198.23.80.0/27 */, 27, NDPI_PROTOCOL_WHATSAPP },
  { 0xD02B73C0 /* 208.43.115.192/27 */, 27, NDPI_PROTOCOL_WHATSAPP },

  /* Files */
  { 0xB93CD835 /* 185.60.216.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP_FILES },
  { 0xB93CD836 /* 185.60.216.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP_FILES },
  { 0xB93CD935 /* 185.60.217.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP_FILES },
  { 0xB93CD936 /* 185.60.217.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP_FILES },
  { 0xB93CDA35 /* 185.60.218.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP_FILES },
  { 0xB93CDA36 /* 185.60.218.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP_FILES },
  { 0xB93CDB35 /* 185.60.219.53/32 */, 32, NDPI_PROTOCOL_WHATSAPP_FILES },
  { 0xB93CDB36 /* 185.60.219.54/32 */, 32, NDPI_PROTOCOL_WHATSAPP_FILES },

  /*
    WhatsApp Web
    List of the WhatsApp Web server IP addresses and ranges
  */
  { 0x9DF01337 /* 157.240.19.55/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0143D /* 157.240.20.61/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF080A0 /* 157.240.128.160/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF08121 /* 157.240.129.33/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF08221 /* 157.240.130.33/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF08321 /* 157.240.131.33/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF08421 /* 157.240.132.33/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF08521 /* 157.240.133.33/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF08621 /* 157.240.134.33/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF08721 /* 157.240.135.33/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF08821 /* 157.240.136.33/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF08921 /* 157.240.137.33/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF08A21 /* 157.240.138.33/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF08B22 /* 157.240.139.34/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF08C22 /* 157.240.140.34/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF08D22 /* 157.240.141.34/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF08E22 /* 157.240.142.34/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF08F22 /* 157.240.143.34/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF09022 /* 157.240.144.34/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF09122 /* 157.240.145.34/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF09222 /* 157.240.146.34/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF09322 /* 157.240.147.34/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF09422 /* 157.240.148.34/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF09722 /* 157.240.151.34/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF09822 /* 157.240.152.34/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF09BA2 /* 157.240.155.162/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF09EA2 /* 157.240.158.162/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF09FA2 /* 157.240.159.162/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0A0A2 /* 157.240.160.162/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0A222 /* 157.240.162.34/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0A262 /* 157.240.162.98/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0A2A2 /* 157.240.162.162/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0A2E2 /* 157.240.162.226/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0A422 /* 157.240.164.34/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0A462 /* 157.240.164.98/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0A522 /* 157.240.165.34/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0A562 /* 157.240.165.98/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0A622 /* 157.240.166.34/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0A662 /* 157.240.166.98/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0A722 /* 157.240.167.34/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0A762 /* 157.240.167.98/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0A822 /* 157.240.168.34/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0A862 /* 157.240.168.98/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0ACA0 /* 157.240.172.160/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0AD22 /* 157.240.173.34/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0AEA2 /* 157.240.174.162/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0AF22 /* 157.240.175.34/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0B0A2 /* 157.240.176.162/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0B1A2 /* 157.240.177.162/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0B2A2 /* 157.240.178.162/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0B3A2 /* 157.240.179.162/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0B4A2 /* 157.240.180.162/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0B5A2 /* 157.240.181.162/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0B622 /* 157.240.182.34/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0B722 /* 157.240.183.34/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0B822 /* 157.240.184.34/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0B922 /* 157.240.185.34/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0B962 /* 157.240.185.98/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0BA62 /* 157.240.186.98/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0BB62 /* 157.240.187.98/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0BCA2 /* 157.240.188.162/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0BCE2 /* 157.240.188.226/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0BD21 /* 157.240.189.33/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0BD61 /* 157.240.189.97/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0BDA2 /* 157.240.189.162/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0BDE2 /* 157.240.189.226/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0BE21 /* 157.240.190.33/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0BE61 /* 157.240.190.97/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0BEA2 /* 157.240.190.162/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0BEE2 /* 157.240.190.226/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0BF22 /* 157.240.191.34/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0BFA2 /* 157.240.191.162/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0BFE2 /* 157.240.191.226/32*/, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0C53C /* 157.240.197.60/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0C53D /* 157.240.197.61/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0C63C /* 157.240.198.60/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0C63D /* 157.240.198.61/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0C83C /* 157.240.200.60/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0C83D /* 157.240.200.61/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0CB3C /* 157.240.203.60/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0CB3D /* 157.240.203.61/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0CC3C /* 157.240.204.60/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0CC3D /* 157.240.204.61/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0CE3C /* 157.240.206.60/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0CE3D /* 157.240.206.61/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0CF3C /* 157.240.207.60/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0CF3D /* 157.240.207.61/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0D03C /* 157.240.208.60/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0D03D /* 157.240.208.61/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0D13C /* 157.240.209.60/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0D13D /* 157.240.209.61/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0D23C /* 157.240.210.60/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0D23D /* 157.240.210.61/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0D43C /* 157.240.212.60/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0D43D /* 157.240.212.61/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0D53C /* 157.240.213.60/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0D53D /* 157.240.213.61/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0D63C /* 157.240.214.60/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0D63D /* 157.240.214.61/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0D83C /* 157.240.216.60/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0D83D /* 157.240.216.61/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0DE3C /* 157.240.222.60/32 */, 32, NDPI_PROTOCOL_WHATSAPP },
  { 0x9DF0DE3D /* 157.240.222.61/32 */, 32, NDPI_PROTOCOL_WHATSAPP },

  /*
    WeChat
    origin AS132203, AS132591, AS45090
  */
  { 0xCBCD93AB /* 203.205.147.171/32 */, 32, NDPI_PROTOCOL_WECHAT },
  { 0xCBCD93AD /* 203.205.147.173/32 */, 32, NDPI_PROTOCOL_WECHAT },
  { 0xCBCD97A2 /* 203.205.151.162/32 */, 32, NDPI_PROTOCOL_WECHAT },
  { 0x67071E25 /* 103.7.30.37/32     */, 32, NDPI_PROTOCOL_WECHAT },
  { 0XCBCDB000 /* 203.205.176.0/20   */, 20, NDPI_PROTOCOL_WECHAT },
  { 0XCBCDC000 /* 203.205.192.0/18   */, 18, NDPI_PROTOCOL_WECHAT },

  /*
    OpenDNS, LLC
    origin AS36692, AS30607
  */

  { 0x26631400 /* 38.99.20.0/23 */, 23, NDPI_PROTOCOL_OPENDNS },
  { 0x3F504FC0 /* 63.80.79.192/26 */, 26, NDPI_PROTOCOL_OPENDNS },
  { 0x43D74000 /* 67.215.64.0/19 */, 19, NDPI_PROTOCOL_OPENDNS },
  { 0x92700000 /* 146.112.0.0/16 */, 16, NDPI_PROTOCOL_OPENDNS },
  { 0xB93C5400 /* 185.60.84.0/24 */, 24, NDPI_PROTOCOL_OPENDNS },
  { 0xB93C5500 /* 185.60.85.0/24 */, 24, NDPI_PROTOCOL_OPENDNS },
  { 0xB93C5600 /* 185.60.86.0/24 */, 24, NDPI_PROTOCOL_OPENDNS },
  { 0xB93C5700 /* 185.60.87.0/24 */, 24, NDPI_PROTOCOL_OPENDNS },
  { 0xCCC2E800 /* 204.194.232.0/21*/, 21, NDPI_PROTOCOL_OPENDNS },
  { 0xD043D800 /* 208.67.216.0/21 */, 21, NDPI_PROTOCOL_OPENDNS },
  { 0xD0452000 /* 208.69.32.0/21 */, 21, NDPI_PROTOCOL_OPENDNS },

  /*
    Microsoft Corporation (MS One Drive)
  */

  { 0xCC4FC300 /* 204.79.195.0/24 */, 24, NDPI_PROTOCOL_MS_ONE_DRIVE },
  { 0xCC4FC400 /* 204.79.196.0/23 */, 23, NDPI_PROTOCOL_MS_ONE_DRIVE },
  { 0x86AA0000 /* 134.170.0.0/16 */, 16, NDPI_PROTOCOL_MS_ONE_DRIVE },
  { 0x83FD0C00 /* 131.253.12.0/22 */, 22, NDPI_PROTOCOL_MS_ONE_DRIVE },
  { 0x83FD1000 /* 131.253.16.0/23 */, 23, NDPI_PROTOCOL_MS_ONE_DRIVE },
  { 0x83FD1200 /* 131.253.18.0/24 */, 24, NDPI_PROTOCOL_MS_ONE_DRIVE },
  { 0x4136BF00 /* 65.54.191.0/24 */, 24, NDPI_PROTOCOL_MS_ONE_DRIVE },

  /*
    Amazon.com, Inc. / Amazon Data Services Ireland Ltd
    origin AS16509, AS14618, AS7224, AS62785, AS8987
  */

  { 0x08129000 /* 8.18.144.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x08129100 /* 8.18.145.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x08F84F00 /* 8.248.79.0/24 */, 24, NDPI_PROTOCOL_AMAZON_VIDEO },
  { 0x0D200000 /* 13.32.0.0/14 */, 14, NDPI_PROTOCOL_AMAZON },
  { 0x0D340000 /* 13.52.0.0/14 */, 14, NDPI_PROTOCOL_AMAZON },
  { 0x0D380000 /* 13.56.0.0/14 */, 14, NDPI_PROTOCOL_AMAZON },
  { 0x0D700000 /* 13.112.0.0/14 */, 14, NDPI_PROTOCOL_AMAZON },
  { 0x0D7C0000 /* 13.124.0.0/14 */, 14, NDPI_PROTOCOL_AMAZON },
  { 0x0DD00000 /* 13.208.0.0/14 */, 14, NDPI_PROTOCOL_AMAZON },
  { 0x0DE40000 /* 13.228.0.0/14 */, 14, NDPI_PROTOCOL_AMAZON },
  { 0x0DE80000 /* 13.232.0.0/13 */, 13, NDPI_PROTOCOL_AMAZON },
  { 0x0DF80000 /* 13.248.0.0/14 */, 14, NDPI_PROTOCOL_AMAZON },
  { 0x17140000 /* 23.20.0.0/14 */, 14, NDPI_PROTOCOL_AMAZON },
  { 0x1B000000 /* 27.0.0.0/22 */, 22, NDPI_PROTOCOL_AMAZON },
  { 0x22C00000 /* 34.192.0.0/10 */, 10, NDPI_PROTOCOL_AMAZON },
  { 0x23980000 /* 35.152.0.0/13 */, 13, NDPI_PROTOCOL_AMAZON },
  { 0x23B00000 /* 35.176.0.0/13 */, 13, NDPI_PROTOCOL_AMAZON },
  { 0x2BFAC000 /* 43.250.192.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x2BFAC100 /* 43.250.193.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x2E338000 /* 46.51.128.0/18 */, 18, NDPI_PROTOCOL_AMAZON },
  { 0x2E33C000 /* 46.51.192.0/20 */, 20, NDPI_PROTOCOL_AMAZON },
  { 0x2E33D800 /* 46.51.216.0/21 */, 21, NDPI_PROTOCOL_AMAZON },
  { 0x2E33E000 /* 46.51.224.0/19 */, 19, NDPI_PROTOCOL_AMAZON },
  { 0x2E890000 /* 46.137.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x2E898000 /* 46.137.128.0/18 */, 18, NDPI_PROTOCOL_AMAZON },
  { 0x2E89C000 /* 46.137.192.0/19 */, 19, NDPI_PROTOCOL_AMAZON },
  { 0x2E89E000 /* 46.137.224.0/19 */, 19, NDPI_PROTOCOL_AMAZON },
  { 0x32100000 /* 50.16.0.0/14 */, 14, NDPI_PROTOCOL_AMAZON },
  { 0x32700000 /* 50.112.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x34000000 /* 52.0.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x34020000 /* 52.2.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x34040000 /* 52.4.0.0/14 */, 14, NDPI_PROTOCOL_AMAZON },
  { 0x34080000 /* 52.8.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x34090000 /* 52.9.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x340A0000 /* 52.10.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x340C0000 /* 52.12.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x340E0000 /* 52.14.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x34100000 /* 52.16.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x34120000 /* 52.18.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x34140000 /* 52.20.0.0/14 */, 14, NDPI_PROTOCOL_AMAZON },
  { 0x34180000 /* 52.24.0.0/14 */, 14, NDPI_PROTOCOL_AMAZON },
  { 0x341C0000 /* 52.28.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x341D0000 /* 52.29.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x341E0000 /* 52.30.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x34200000 /* 52.32.0.0/14 */, 14, NDPI_PROTOCOL_AMAZON },
  { 0x34240000 /* 52.36.0.0/14 */, 14, NDPI_PROTOCOL_AMAZON },
  { 0x34280000 /* 52.40.0.0/14 */, 14, NDPI_PROTOCOL_AMAZON },
  { 0x342C0000 /* 52.44.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x342E0000 /* 52.46.0.0/18 */, 18, NDPI_PROTOCOL_AMAZON },
  { 0x342E5000 /* 52.46.80.0/21 */, 21, NDPI_PROTOCOL_AMAZON },
  { 0x342F0000 /* 52.47.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x34300000 /* 52.48.0.0/14 */, 14, NDPI_PROTOCOL_AMAZON },
  { 0x34340000 /* 52.52.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x34360000 /* 52.54.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x34380000 /* 52.56.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x34390000 /* 52.57.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x343A0000 /* 52.58.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x343C0000 /* 52.60.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x343E0000 /* 52.62.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x34400000 /* 52.64.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x34408000 /* 52.64.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x34410000 /* 52.65.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x34420000 /* 52.66.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x34430000 /* 52.67.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x34440000 /* 52.68.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x34460000 /* 52.70.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x34480000 /* 52.72.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x344A0000 /* 52.74.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x344C0000 /* 52.76.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x344C8000 /* 52.76.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x344D0000 /* 52.77.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x344E0000 /* 52.78.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x344F0000 /* 52.79.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x34520000 /* 52.82.0.0/14 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x34540000 /* 52.84.0.0/14 */, 14, NDPI_PROTOCOL_AMAZON },
  { 0x34580000 /* 52.88.0.0/13 */, 13, NDPI_PROTOCOL_AMAZON },
  { 0x345A0000 /* 52.90.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x345EE000 /* 52.94.224.0/19 */, 19, NDPI_PROTOCOL_AMAZON },
  { 0x345F0000 /* 52.95.0.0/21 */, 21, NDPI_PROTOCOL_AMAZON },
  { 0x345F0A00 /* 52.95.10.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x345F0C00 /* 52.95.12.0/22 */, 22, NDPI_PROTOCOL_AMAZON },
  { 0x345F1000 /* 52.95.16.0/21 */, 21, NDPI_PROTOCOL_AMAZON },
  { 0x345F1800 /* 52.95.24.0/22 */, 22, NDPI_PROTOCOL_AMAZON },
  { 0x345F1E00 /* 52.95.30.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x345F2200 /* 52.95.34.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x345F2300 /* 52.95.35.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x345F2400 /* 52.95.36.0/22 */, 22, NDPI_PROTOCOL_AMAZON },
  { 0x345F3000 /* 52.95.48.0/22 */, 22, NDPI_PROTOCOL_AMAZON },
  { 0x345F3400 /* 52.95.52.0/22 */, 22, NDPI_PROTOCOL_AMAZON },
  { 0x345F3800 /* 52.95.56.0/22 */, 22, NDPI_PROTOCOL_AMAZON },
  { 0x345F4000 /* 52.95.64.0/20 */, 20, NDPI_PROTOCOL_AMAZON },
  { 0x345F5000 /* 52.95.80.0/20 */, 20, NDPI_PROTOCOL_AMAZON },
  { 0x345F6000 /* 52.95.96.0/22 */, 22, NDPI_PROTOCOL_AMAZON },
  { 0x345F6400 /* 52.95.100.0/22 */, 22, NDPI_PROTOCOL_AMAZON },
  { 0x345F6800 /* 52.95.104.0/22 */, 22, NDPI_PROTOCOL_AMAZON },
  { 0x345F6F00 /* 52.95.111.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x345F8000 /* 52.95.128.0/19 */, 19, NDPI_PROTOCOL_AMAZON },
  { 0x345FA000 /* 52.95.160.0/19 */, 19, NDPI_PROTOCOL_AMAZON },
  { 0x345FC000 /* 52.95.192.0/20 */, 20, NDPI_PROTOCOL_AMAZON },
  { 0x345FD400 /* 52.95.212.0/22 */, 22, NDPI_PROTOCOL_AMAZON },
  { 0x345FE000 /* 52.95.224.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x345FF000 /* 52.95.240.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x345FF100 /* 52.95.241.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x345FF200 /* 52.95.242.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x345FF300 /* 52.95.243.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x345FF400 /* 52.95.244.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x345FF500 /* 52.95.245.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x345FF600 /* 52.95.246.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x345FF700 /* 52.95.247.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x345FF800 /* 52.95.248.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x345FF900 /* 52.95.249.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x345FFA00 /* 52.95.250.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x345FFB00 /* 52.95.251.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x345FFC00 /* 52.95.252.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x345FFD00 /* 52.95.253.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x345FFE00 /* 52.95.254.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x34778000 /* 52.119.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x347C8000 /* 52.124.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x34818000 /* 52.129.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x34908000 /* 52.144.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x34C00000 /* 52.192.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x34C40000 /* 52.196.0.0/14 */, 14, NDPI_PROTOCOL_AMAZON },
  { 0x34C80000 /* 52.200.0.0/13 */, 13, NDPI_PROTOCOL_AMAZON },
  { 0x34D00000 /* 52.208.0.0/13 */, 13, NDPI_PROTOCOL_AMAZON },
  { 0x34D80000 /* 52.216.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x34DA0000 /* 52.218.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x34DA8000 /* 52.218.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x34DB0000 /* 52.219.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x34DB8000 /* 52.219.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x34DC0000 /* 52.220.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x34DE0000 /* 52.222.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x34DE8000 /* 52.222.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36400000 /* 54.64.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x36420000 /* 54.66.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36428000 /* 54.66.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36430000 /* 54.67.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36440000 /* 54.68.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x36460000 /* 54.70.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x36480000 /* 54.72.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x36490000 /* 54.73.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x364A0000 /* 54.74.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x364C0000 /* 54.76.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x364E0000 /* 54.78.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x364F0000 /* 54.79.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x364F8000 /* 54.79.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36500000 /* 54.80.0.0/14 */, 14, NDPI_PROTOCOL_AMAZON },
  { 0x36540000 /* 54.84.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x36560000 /* 54.86.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x36570000 /* 54.87.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x36580000 /* 54.88.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x36590000 /* 54.89.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x365A0000 /* 54.90.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x365C0000 /* 54.92.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x365C8000 /* 54.92.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x365D0000 /* 54.93.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x365E0000 /* 54.94.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x365E8000 /* 54.94.128.0/18 */, 18, NDPI_PROTOCOL_AMAZON },
  { 0x365EC000 /* 54.94.192.0/18 */, 18, NDPI_PROTOCOL_AMAZON },
  { 0x365F0000 /* 54.95.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x365F8000 /* 54.95.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36900000 /* 54.144.0.0/14 */, 14, NDPI_PROTOCOL_AMAZON },
  { 0x36940000 /* 54.148.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x36960000 /* 54.150.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x36970000 /* 54.151.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36978000 /* 54.151.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36980000 /* 54.152.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x36990000 /* 54.153.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36998000 /* 54.153.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x369A0000 /* 54.154.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x369B0000 /* 54.155.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x369C0000 /* 54.156.0.0/14 */, 14, NDPI_PROTOCOL_AMAZON },
  { 0x36A00000 /* 54.160.0.0/14 */, 14, NDPI_PROTOCOL_AMAZON },
  { 0x36A40000 /* 54.164.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x36A60000 /* 54.166.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x36A80000 /* 54.168.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x36A90000 /* 54.169.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36A98000 /* 54.169.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36AA0000 /* 54.170.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x36AB0000 /* 54.171.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x36AC0000 /* 54.172.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x36AE0000 /* 54.174.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x36B00000 /* 54.176.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x36B20000 /* 54.178.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36B28000 /* 54.178.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36B30000 /* 54.179.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36B38000 /* 54.179.128.0/18 */, 18, NDPI_PROTOCOL_AMAZON },
  { 0x36B3C000 /* 54.179.192.0/18 */, 18, NDPI_PROTOCOL_AMAZON },
  { 0x36B60000 /* 54.182.0.0/21 */, 21, NDPI_PROTOCOL_AMAZON },
  { 0x36B60800 /* 54.182.8.0/22 */, 22, NDPI_PROTOCOL_AMAZON },
  { 0x36B61000 /* 54.182.16.0/22 */, 22, NDPI_PROTOCOL_AMAZON },
  { 0x36B68000 /* 54.182.128.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B68200 /* 54.182.130.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B68400 /* 54.182.132.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B68600 /* 54.182.134.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B68800 /* 54.182.136.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B68A00 /* 54.182.138.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B68C00 /* 54.182.140.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B68E00 /* 54.182.142.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B69000 /* 54.182.144.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B69200 /* 54.182.146.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B69400 /* 54.182.148.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B69600 /* 54.182.150.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B69800 /* 54.182.152.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B69A00 /* 54.182.154.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B69C00 /* 54.182.156.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B69E00 /* 54.182.158.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B6A200 /* 54.182.162.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B6A400 /* 54.182.164.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B6A600 /* 54.182.166.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B6A800 /* 54.182.168.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B6AA00 /* 54.182.170.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6AE00 /* 54.182.174.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B6B000 /* 54.182.176.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B6B200 /* 54.182.178.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B6B400 /* 54.182.180.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B6B600 /* 54.182.182.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B6B800 /* 54.182.184.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B6BA00 /* 54.182.186.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B6BF00 /* 54.182.191.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6C000 /* 54.182.192.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6C100 /* 54.182.193.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6C200 /* 54.182.194.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6C300 /* 54.182.195.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6C400 /* 54.182.196.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6C500 /* 54.182.197.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6C600 /* 54.182.198.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6C700 /* 54.182.199.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6C800 /* 54.182.200.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6C900 /* 54.182.201.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6CA00 /* 54.182.202.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6CB00 /* 54.182.203.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6CC00 /* 54.182.204.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6CD00 /* 54.182.205.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6CE00 /* 54.182.206.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6CF00 /* 54.182.207.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6D100 /* 54.182.209.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6D200 /* 54.182.210.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6D300 /* 54.182.211.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6D400 /* 54.182.212.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6D500 /* 54.182.213.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6D600 /* 54.182.214.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6D700 /* 54.182.215.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6D800 /* 54.182.216.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6D900 /* 54.182.217.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6DA00 /* 54.182.218.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6DB00 /* 54.182.219.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6DC00 /* 54.182.220.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6DD00 /* 54.182.221.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6DE00 /* 54.182.222.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6DF00 /* 54.182.223.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6E000 /* 54.182.224.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B6E200 /* 54.182.226.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B6E400 /* 54.182.228.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B6E600 /* 54.182.230.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6E700 /* 54.182.231.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6E800 /* 54.182.232.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6E900 /* 54.182.233.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6EA00 /* 54.182.234.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6EB00 /* 54.182.235.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6EC00 /* 54.182.236.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6ED00 /* 54.182.237.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6EE00 /* 54.182.238.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6EF00 /* 54.182.239.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6F000 /* 54.182.240.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B6F200 /* 54.182.242.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6F300 /* 54.182.243.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6F400 /* 54.182.244.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6F500 /* 54.182.245.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6F600 /* 54.182.246.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B6F800 /* 54.182.248.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B6FA00 /* 54.182.250.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x36B6FC00 /* 54.182.252.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6FD00 /* 54.182.253.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6FE00 /* 54.182.254.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B6FF00 /* 54.182.255.0/24 */, 24, NDPI_PROTOCOL_AMAZON },
  { 0x36B70000 /* 54.183.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36B78000 /* 54.183.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36B80000 /* 54.184.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x36BA0000 /* 54.186.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x36BC0000 /* 54.188.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x36BE0000 /* 54.190.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x36BF0000 /* 54.191.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x36C00000 /* 54.192.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x36C10000 /* 54.193.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36C18000 /* 54.193.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36C20000 /* 54.194.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x36C30000 /* 54.195.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x36C40000 /* 54.196.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x36C60000 /* 54.198.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x36C70000 /* 54.199.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36C78000 /* 54.199.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36C80000 /* 54.200.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x36CA0000 /* 54.202.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x36CC0000 /* 54.204.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x36CE0000 /* 54.206.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36CE8000 /* 54.206.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36CF0000 /* 54.207.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36CF8000 /* 54.207.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36D00000 /* 54.208.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x36D20000 /* 54.210.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x36D30000 /* 54.211.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x36D40000 /* 54.212.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x36D50000 /* 54.213.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x36D60000 /* 54.214.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36D68000 /* 54.214.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36D70000 /* 54.215.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36D78000 /* 54.215.128.0/18 */, 18, NDPI_PROTOCOL_AMAZON },
  { 0x36D7C000 /* 54.215.192.0/18 */, 18, NDPI_PROTOCOL_AMAZON },
  { 0x36D80000 /* 54.216.0.0/15 */, 15, NDPI_PROTOCOL_AMAZON },
  { 0x36DA0000 /* 54.218.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36DA8000 /* 54.218.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36DB0000 /* 54.219.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x36DB8000 /* 54.219.128.0/18 */, 18, NDPI_PROTOCOL_AMAZON },
  { 0x36DBC000 /* 54.219.192.0/18 */, 18, NDPI_PROTOCOL_AMAZON },
  { 0x36DC0000 /* 54.220.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x36DD0000 /* 54.221.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0x36DF2000 /* 54.223.32.0/19 */, 19, NDPI_PROTOCOL_AMAZON },
  { 0x36DF4000 /* 54.223.64.0/18 */, 18, NDPI_PROTOCOL_AMAZON },
  { 0x36E00000 /* 54.224.0.0/12 */, 12, NDPI_PROTOCOL_AMAZON },
  { 0x36F00000 /* 54.240.0.0/12 */, 12, NDPI_PROTOCOL_AMAZON },
  { 0x3F5C0C00 /* 63.92.12.0/22 */, 22, NDPI_PROTOCOL_AMAZON },
  { 0x3FEE0C00 /* 63.238.12.0/22 */, 22, NDPI_PROTOCOL_AMAZON },
  { 0x3FEE1000 /* 63.238.16.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0x42074000 /* 66.7.64.0/19 */, 19, NDPI_PROTOCOL_AMAZON },
  { 0x43CA0000 /* 67.202.0.0/18 */, 18, NDPI_PROTOCOL_AMAZON },
  { 0x4815C000 /* 72.21.192.0/19 */, 19, NDPI_PROTOCOL_AMAZON },
  { 0x482C2000 /* 72.44.32.0/19 */, 19, NDPI_PROTOCOL_AMAZON },
  { 0x4B658000 /* 75.101.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x4F7D0000 /* 79.125.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x57EE5000 /* 87.238.80.0/21 */, 21, NDPI_PROTOCOL_AMAZON },
  { 0x607F0000 /* 96.127.0.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0x67040800 /* 103.4.8.0/21 */, 21, NDPI_PROTOCOL_AMAZON },
  { 0x6708AC00 /* 103.8.172.0/22 */, 22, NDPI_PROTOCOL_AMAZON },
  { 0x67F69400 /* 103.246.148.0/23*/, 23, NDPI_PROTOCOL_AMAZON },
  { 0x67F69600 /* 103.246.150.0/23*/, 23, NDPI_PROTOCOL_AMAZON },
  { 0x6B140000 /* 107.20.0.0/14 */, 14, NDPI_PROTOCOL_AMAZON },
  { 0x7AF8C000 /* 122.248.192.0/18*/, 18, NDPI_PROTOCOL_AMAZON },
  { 0xAC606000 /* 172.96.96.0/20 */, 20, NDPI_PROTOCOL_AMAZON },
  { 0xAE810000 /* 174.129.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0xAF298000 /* 175.41.128.0/18 */, 18, NDPI_PROTOCOL_AMAZON },
  { 0xAF29C000 /* 175.41.192.0/18 */, 18, NDPI_PROTOCOL_AMAZON },
  { 0xB0204000 /* 176.32.64.0/19 */, 19, NDPI_PROTOCOL_AMAZON },
  { 0xB0206000 /* 176.32.96.0/21 */, 21, NDPI_PROTOCOL_AMAZON },
  { 0xB0206800 /* 176.32.104.0/21 */, 21, NDPI_PROTOCOL_AMAZON },
  { 0xB0207000 /* 176.32.112.0/21 */, 21, NDPI_PROTOCOL_AMAZON },
  { 0xB0207800 /* 176.32.120.0/22 */, 22, NDPI_PROTOCOL_AMAZON },
  { 0xB0207E00 /* 176.32.126.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0xB0220000 /* 176.34.0.0/19 */, 19, NDPI_PROTOCOL_AMAZON },
  { 0xB0222000 /* 176.34.32.0/19 */, 19, NDPI_PROTOCOL_AMAZON },
  { 0xB0224000 /* 176.34.64.0/18 */, 18, NDPI_PROTOCOL_AMAZON },
  { 0xB0228000 /* 176.34.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0xB1478000 /* 177.71.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0xB148F000 /* 177.72.240.0/21 */, 21, NDPI_PROTOCOL_AMAZON },
  { 0xB2EC0000 /* 178.236.0.0/20 */, 20, NDPI_PROTOCOL_AMAZON },
  { 0xB8480000 /* 184.72.0.0/18 */, 18, NDPI_PROTOCOL_AMAZON },
  { 0xB8484000 /* 184.72.64.0/19 */, 19, NDPI_PROTOCOL_AMAZON },
  { 0xB8486000 /* 184.72.96.0/19 */, 19, NDPI_PROTOCOL_AMAZON },
  { 0xB8488000 /* 184.72.128.0/17 */, 17, NDPI_PROTOCOL_AMAZON },
  { 0xB8490000 /* 184.73.0.0/16 */, 16, NDPI_PROTOCOL_AMAZON },
  { 0xB8A98000 /* 184.169.128.0/17*/, 17, NDPI_PROTOCOL_AMAZON },
  { 0xB9307800 /* 185.48.120.0/22 */, 22, NDPI_PROTOCOL_AMAZON },
  { 0xB98F1000 /* 185.143.16.0/22 */, 22, NDPI_PROTOCOL_AMAZON },
  { 0xC77FE800 /* 199.127.232.0/22 */, 22, NDPI_PROTOCOL_AMAZON },
  { 0xC7FFC000 /* 199.255.192.0/22 */, 22, NDPI_PROTOCOL_AMAZON },
  { 0xCB53DC00 /* 203.83.220.0/22 */, 22, NDPI_PROTOCOL_AMAZON },
  { 0xCCEC8000 /* 204.236.128.0/18*/, 18, NDPI_PROTOCOL_AMAZON },
  { 0xCCECC000 /* 204.236.192.0/18*/, 18, NDPI_PROTOCOL_AMAZON },
  { 0xCCF6A000 /* 204.246.160.0/19*/, 19, NDPI_PROTOCOL_AMAZON },
  { 0xCDFBC000 /* 205.251.192.0/18*/, 18, NDPI_PROTOCOL_AMAZON },
  { 0xCFABA000 /* 207.171.160.0/19*/, 19, NDPI_PROTOCOL_AMAZON },
  { 0xD02FF800 /* 208.47.248.0/23 */, 23, NDPI_PROTOCOL_AMAZON },
  { 0xD1C96000 /* 209.201.96.0/22 */, 22, NDPI_PROTOCOL_AMAZON },
  { 0xD8892000 /* 216.137.32.0/19 */, 19, NDPI_PROTOCOL_AMAZON },
  { 0xD8B6E000 /* 216.182.224.0/20*/, 20, NDPI_PROTOCOL_AMAZON },

  /*
    Netflix Inc. / Netflix Streaming Services Inc.
    origin AS2906, AS55095, AS40027
  */

  { 0x17F60000 /* 23.246.0.0/18 */, 18, NDPI_PROTOCOL_NETFLIX },
  { 0x254DB800 /* 37.77.184.0/21 */, 21, NDPI_PROTOCOL_NETFLIX },
  { 0x26487E00 /* 38.72.126.0/24 */, 24, NDPI_PROTOCOL_NETFLIX },
  { 0x2D390000 /* 45.57.0.0/17 */, 17, NDPI_PROTOCOL_NETFLIX },
  { 0x40788000 /* 64.120.128.0/17 */, 17, NDPI_PROTOCOL_NETFLIX },
  { 0x42C58000 /* 66.197.128.0/17 */, 17, NDPI_PROTOCOL_NETFLIX },
  { 0x4535E000 /* 69.53.224.0/19 */, 19, NDPI_PROTOCOL_NETFLIX },
  { 0x6CAF2000 /* 108.175.32.0/20 */, 20, NDPI_PROTOCOL_NETFLIX },
  { 0xB902DC00 /* 185.2.220.0/22 */, 22, NDPI_PROTOCOL_NETFLIX },
  { 0xB909BC00 /* 185.9.188.0/22 */, 22, NDPI_PROTOCOL_NETFLIX },
  { 0xC0AD4000 /* 192.173.64.0/18 */, 18, NDPI_PROTOCOL_NETFLIX },
  { 0xC6266000 /* 198.38.96.0/19 */, 19, NDPI_PROTOCOL_NETFLIX },
  { 0xC62D3000 /* 198.45.48.0/20 */, 20, NDPI_PROTOCOL_NETFLIX },
  { 0xD194D687 /* 209.148.214.135/21*/, 21, NDPI_PROTOCOL_NETFLIX },

  /*
    Cloudflare, Inc.
    origin AS13335, AS132892, AS203898, AS394536
  */

  { 0x321ff200 /* 50.31.242.0/23 */, 23, NDPI_PROTOCOL_CLOUDFLARE },
  { 0x6715f400 /* 103.21.244.0/22 */, 22, NDPI_PROTOCOL_CLOUDFLARE },
  { 0x6716c800 /* 103.22.200.0/22 */, 22, NDPI_PROTOCOL_CLOUDFLARE },
  { 0x671f0400 /* 103.31.4.0/22 */, 22, NDPI_PROTOCOL_CLOUDFLARE },
  { 0x68100000 /* 104.16.0.0/12 */, 12, NDPI_PROTOCOL_CLOUDFLARE },
  { 0x6CA2C000 /* 108.162.192.0/18*/, 18, NDPI_PROTOCOL_CLOUDFLARE },
  { 0x83004800 /* 131.0.72.0/22 */, 22, NDPI_PROTOCOL_CLOUDFLARE },
  { 0x8D654400 /* 141.101.68.0/24 */, 24, NDPI_PROTOCOL_CLOUDFLARE },
  { 0x8D654500 /* 141.101.69.0/24 */, 24, NDPI_PROTOCOL_CLOUDFLARE },
  { 0x8d656000 /* 141.101.96.0/21 */, 21, NDPI_PROTOCOL_CLOUDFLARE },
  { 0x8d654000 /* 141.101.64.0/20 */, 20, NDPI_PROTOCOL_CLOUDFLARE },
  { 0x8d655000 /* 141.101.80.0/21 */, 21, NDPI_PROTOCOL_CLOUDFLARE },
  { 0x8d655800 /* 141.101.88.0/19 */, 19, NDPI_PROTOCOL_CLOUDFLARE },
  { 0x8d656800 /* 141.101.104.0/21*/, 21, NDPI_PROTOCOL_CLOUDFLARE },
  { 0x8d657000 /* 141.101.112.0/21*/, 21, NDPI_PROTOCOL_CLOUDFLARE },
  { 0x8d657800 /* 141.101.120.0/22 */, 22, NDPI_PROTOCOL_CLOUDFLARE },
  { 0x8d657c00 /* 141.101.124.0/22 */, 22, NDPI_PROTOCOL_CLOUDFLARE },
  { 0xbe5df000 /* 190.93.240.0/20 */, 20, NDPI_PROTOCOL_CLOUDFLARE },
  { 0xA29E0000 /* 162.158.0.0/15 */, 15, NDPI_PROTOCOL_CLOUDFLARE },
  { 0xA2FB5200 /* 162.251.82.0/24 */, 24, NDPI_PROTOCOL_CLOUDFLARE },
  { 0xAC400000 /* 172.64.0.0/13 */, 13, NDPI_PROTOCOL_CLOUDFLARE },
  { 0xADF53000 /* 173.245.48.0/20 */, 20, NDPI_PROTOCOL_CLOUDFLARE },
  { 0xB97A0000 /* 185.122.0.0/22 */, 22, NDPI_PROTOCOL_CLOUDFLARE },
  { 0xBC726000 /* 188.114.96.0/22 */, 22, NDPI_PROTOCOL_CLOUDFLARE },
  { 0xBC726400 /* 188.114.100.0/22 */, 22, NDPI_PROTOCOL_CLOUDFLARE },
  { 0xBC726800 /* 188.114.104.0/24*/, 24, NDPI_PROTOCOL_CLOUDFLARE },
  { 0xBC726900 /* 188.114.105.0/24*/, 24, NDPI_PROTOCOL_CLOUDFLARE },
  { 0xBC726A00 /* 188.114.106.0/24*/, 24, NDPI_PROTOCOL_CLOUDFLARE },
  { 0xBC726B00 /* 188.114.107.0/24*/, 24, NDPI_PROTOCOL_CLOUDFLARE },
  { 0xBC726C00 /* 188.114.108.0/22 */, 22, NDPI_PROTOCOL_CLOUDFLARE },
  { 0xC6298000 /* 198.41.128.0/17 */, 17, NDPI_PROTOCOL_CLOUDFLARE },
  { 0xc5eaf000 /* 197.234.240.0/22 */, 22, NDPI_PROTOCOL_CLOUDFLARE },
  { 0xC71B8000 /* 199.27.128.0/21 */, 21, NDPI_PROTOCOL_CLOUDFLARE },

  /*
    Microsoft 365 (Formerly known as Office 365)
  */
  { 0x0D6B0100 /* 13.107.1.0 */, 24 , NDPI_PROTOCOL_MICROSOFT_365 },
  { 0x0D6B0300 /* 13.107.3.0 */, 24 , NDPI_PROTOCOL_MICROSOFT_365 },
  { 0x0D6B0400 /* 13.107.4.0 */, 24 , NDPI_PROTOCOL_MICROSOFT_365 },
  { 0x0D6B0500 /* 13.107.5.0 */, 24 , NDPI_PROTOCOL_MICROSOFT_365 },
  { 0x0D6B0600 /* 13.107.6.0 */, 24 , NDPI_PROTOCOL_MICROSOFT_365 },
  { 0x0D6B0700 /* 13.107.7.0 */, 24 , NDPI_PROTOCOL_MICROSOFT_365 },
  { 0x0D6B0900 /* 13.107.9.0 */, 24 , NDPI_PROTOCOL_MICROSOFT_365 },
  { 0x0D6B0C00 /* 13.107.12.0 */, 24 , NDPI_PROTOCOL_MICROSOFT_365 },
  { 0x0D6B0D00 /* 13.107.13.0 */, 24 , NDPI_PROTOCOL_MICROSOFT_365 },
  { 0x0D6B0F00 /* 13.107.15.0 */, 24 , NDPI_PROTOCOL_MICROSOFT_365 },
  { 0x0D6B1000 /* 13.107.16.0 */, 24 , NDPI_PROTOCOL_MICROSOFT_365 },

  /*
    OCS GO (Orange Cinéma Séries)
  */

  { 0xB2F8D000 /* 178.248.208.0 */, 21, NDPI_PROTOCOL_OCS },


  /* Teamviewer
   AS43304, AS208187, AS208175
   router1.teamviewer.com... router16.teamviewer.com */
  { 0x25FCE044 /* 37.252.224.68 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x25FCE048 /* 37.252.224.72 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x25FCE04C /* 37.252.224.76 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x25FCE784 /* 37.252.231.132 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x25FCE788 /* 37.252.231.136 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x25FCE864 /* 37.252.232.100 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x25FCE868 /* 37.252.232.104 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x25FCE86C /* 37.252.232.108 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x25FCF664 /* 37.252.246.100 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x25FCF668 /* 37.252.246.104 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x25FCF764 /* 37.252.247.100 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x25FCF768 /* 37.252.247.104 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x25FCF770 /* 37.252.247.112 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x25FCF772 /* 37.252.247.114 */, 32, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x25FCFD64 /* 37.252.253.100 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x25FCFD68 /* 37.252.253.104 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x25FCFEA4 /* 37.252.254.164 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x25FCFEA8 /* 37.252.254.168 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x25FCFEB0 /* 37.252.254.176 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x25FCFEB8 /* 37.252.254.184 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x25FCFEBC /* 37.252.254.188 */, 32, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x25FCFFC4 /* 37.252.255.196 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x25FCFFC8 /* 37.252.255.200 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x25FCFFD0 /* 37.252.255.208 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x25FCFFD2 /* 37.252.255.210 */, 32, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x32751BD8 /* 50.117.27.216 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x44446410 /* 68.68.100.16 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x462634C8 /* 70.38.52.200 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x5E1006A4 /* 94.16.6.164 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x5E1006A8 /* 94.16.6.168 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x5E1006B0 /* 94.16.6.176 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x5E1006B2 /* 94.16.6.178 */, 32, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x6CA399D8 /* 108.163.153.216 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x9EB05602 /* 158.176.86.2 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x9EB05604 /* 158.176.86.4 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x9EB05608 /* 158.176.86.8 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x9EB0560A /* 158.176.86.10 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x9EB0560C /* 158.176.86.12 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x9EB05610 /* 158.176.86.16 */, 32, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x9F085884 /* 159.8.88.132 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x9F085888 /* 159.8.88.136 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x9F085890 /* 159.8.88.144 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x9F085892 /* 159.8.88.146 */, 32, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x9F08E5E2 /* 159.8.229.226 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x9F08E5E4 /* 159.8.229.228 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x9F08E5E8 /* 159.8.229.232 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x9F08E5F0 /* 159.8.229.240 */, 32, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x9F7AB6C4 /* 159.122.182.196 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x9F7AB6C8 /* 159.122.182.200 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x9F7AB6D0 /* 159.122.182.208 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x9F7AB6D2 /* 159.122.182.210 */, 32, NDPI_PROTOCOL_TEAMVIEWER },
  { 0x9F7ABD20 /* 159.122.189.32 */, 27, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xA19C4362 /* 161.156.67.98 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xA19C4364 /* 161.156.67.100 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xA19C4368 /* 161.156.67.104 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xA19C4370 /* 161.156.67.112 */, 32, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xA9334DE2 /* 169.51.77.226 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xA9334DE4 /* 169.51.77.228 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xA9334DE8 /* 169.51.77.232 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xAE8E0AE0 /* 174.142.10.224 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xAE8EEBE8 /* 174.142.235.232 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xAE8EEC78 /* 174.142.236.120 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xB2FF9A84 /* 178.255.154.132 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xB2FF9A88 /* 178.255.154.136 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xB2FF9A90 /* 178.255.154.144 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xB2FF9A92 /* 178.255.154.146 */, 32, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xB2FF9BA4 /* 178.255.155.164 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xB2FF9BA8 /* 178.255.155.168 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xB2FF9BB0 /* 178.255.155.176 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xB2FF9BBC /* 178.255.155.188 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xB2FF9BBE /* 178.255.155.190 */, 32, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xB86B0EA8 /* 184.107.14.168 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xB9BC2000 /* 185.188.32.0 */, 22, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xB9F51C00 /* 185.245.28.0 */, 22, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBC414C84 /* 188.65.76.132 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBC414C88 /* 188.65.76.136 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBC414C8C /* 188.65.76.140 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACC064 /* 188.172.192.100 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACC068 /* 188.172.192.104 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACC06C /* 188.172.192.108 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACC684 /* 188.172.198.132 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACC688 /* 188.172.198.136 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACC690 /* 188.172.198.144 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACC698 /* 188.172.198.152 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACC69C /* 188.172.198.156 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACC69E /* 188.172.198.158 */, 32, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACDB84 /* 188.172.219.132 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACDB88 /* 188.172.219.136 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACDB90 /* 188.172.219.144 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACDB9B /* 188.172.219.155 */, 32, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACDB9C /* 188.172.219.156 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACDB9E /* 188.172.219.158 */, 32, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACDF64 /* 188.172.223.100 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACDF68 /* 188.172.223.104 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACDF70 /* 188.172.223.112 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACDF72 /* 188.172.223.114 */, 32, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACE9A4 /* 188.172.233.164 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACE9A8 /* 188.172.233.168 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACE9B0 /* 188.172.233.176 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACE9B2 /* 188.172.233.178 */, 32, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACE9B4 /* 188.172.233.180 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACE9B8 /* 188.172.233.184 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACEB84 /* 188.172.235.132 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACEB88 /* 188.172.235.136 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACEB90 /* 188.172.235.144 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACEB98 /* 188.172.235.152 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACEB9C /* 188.172.235.156 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACEB9E /* 188.172.235.158 */, 32, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACF584 /* 188.172.245.132 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACF588 /* 188.172.245.136 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACF590 /* 188.172.245.144 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACF592 /* 188.172.245.146 */, 32, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACF6A4 /* 188.172.246.164 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACF6A8 /* 188.172.246.168 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACF6B0 /* 188.172.246.176 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACF6BA /* 188.172.246.186 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACF6BC /* 188.172.246.188 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACF6BE /* 188.172.246.190 */, 32, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACFE84 /* 188.172.254.132 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACFE88 /* 188.172.254.136 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xBCACFE8C /* 188.172.254.140 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xC0AF7958 /* 192.175.121.88 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xC120E000 /* 193.32.224.0 */, 22, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xC13A6400 /* 193.58.100.0 */, 22, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD5E3A264 /* 213.227.162.100 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD5E3A268 /* 213.227.162.104 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD5E3A270 /* 213.227.162.112 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD5E3A27C /* 213.227.162.124 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD5E3A27E /* 213.227.162.126 */, 32, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD5E3A384 /* 213.227.163.132 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD5E3A388 /* 213.227.163.136 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD5E3A390 /* 213.227.163.144 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD5E3A884 /* 213.227.168.132 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD5E3A888 /* 213.227.168.136 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD5E3A890 /* 213.227.168.144 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD5E3B984 /* 213.227.185.132 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD5E3B988 /* 213.227.185.136 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD5E3B98C /* 213.227.185.140 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD5E3BA84 /* 213.227.186.132 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD5E3BA88 /* 213.227.186.136 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD5E3BA90 /* 213.227.186.144 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD5E3BA98 /* 213.227.186.152 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD5E3BA9C /* 213.227.186.156 */, 32, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD9920284 /* 217.146.2.132 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD9920288 /* 217.146.2.136 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD9920484 /* 217.146.4.132 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD9920488 /* 217.146.4.136 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD9920844 /* 217.146.8.68 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD9920848 /* 217.146.8.72 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD992084C /* 217.146.8.76 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD9920D84 /* 217.146.13.132 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD9920D88 /* 217.146.13.136 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD9920D90 /* 217.146.13.144 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD9920D92 /* 217.146.13.146 */, 32, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD9920E84 /* 217.146.14.132 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD9920E88 /* 217.146.14.136 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD9920E8C /* 217.146.14.140 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD9921584 /* 217.146.21.132 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD9921588 /* 217.146.21.136 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD992158C /* 217.146.21.140 */, 31, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD9921784 /* 217.146.23.132 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD9921788 /* 217.146.23.136 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD9921790 /* 217.146.23.144 */, 28, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD99217A0 /* 217.146.23.160 */, 29, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD99217A8 /* 217.146.23.168 */, 30, NDPI_PROTOCOL_TEAMVIEWER },
  { 0xD99217AC /* 217.146.23.172 */, 32, NDPI_PROTOCOL_TEAMVIEWER },

#if 0
  /*
    IFLIX services -by www.vizuamatix.com R&D team
  */
  { 0x344D0000 /* 52.77.0.0 */, 16, NDPI_PROTOCOL_IFLIX },
  { 0x34DC0000 /* 52.220.0.0 */, 16, NDPI_PROTOCOL_IFLIX },
  { 0x344A0000 /* 52.74.0.0 */, 16, NDPI_PROTOCOL_IFLIX },
  { 0x36E69F00 /* 54.230.159.0 */, 24, NDPI_PROTOCOL_IFLIX },
  { 0x36C09C50 /* 54.192.156.80  */, 32, NDPI_PROTOCOL_IFLIX },
  { 0x36FBB6A8 /* 54.251.182.168*/, 32, NDPI_PROTOCOL_IFLIX },
  { 0x36C09600 /* 54.192.150.0  */, 24, NDPI_PROTOCOL_IFLIX },
  { 0x344AC0F7 /* 52.74.192.247  */, 32, NDPI_PROTOCOL_IFLIX },
  { 0x0215E718 /* 2.21.231.24 */, 32, NDPI_PROTOCOL_IFLIX },
#endif

  /*
    Citrix GotoMeeting (AS16815, AS21866)
  */

  { 0xD873D000 /* 216.115.208.0 */, 20, NDPI_PROTOCOL_CITRIX },
  { 0xD8DB7000 /* 216.219.112.0 */, 20, NDPI_PROTOCOL_CITRIX },
  { 0xADC70000 /* 173.199.0.0   */, 18, NDPI_PROTOCOL_CITRIX },

  /*
    Cisco Webex LLC
    origin AS13445
  */

  { 0x0819C000 /* 8.25.192.0/24 */, 24, NDPI_PROTOCOL_WEBEX },
  { 0x3E6DC000 /* 62.109.192.0/18 */, 18, NDPI_PROTOCOL_WEBEX },
  { 0x40446000 /* 64.68.96.0/19 */, 19, NDPI_PROTOCOL_WEBEX },
  { 0x4272A000 /* 66.114.160.0/20 */, 20, NDPI_PROTOCOL_WEBEX },
  { 0x42A32000 /* 66.163.32.0/19 */, 19, NDPI_PROTOCOL_WEBEX },
  { 0x721DC000 /* 114.29.192.0/19 */, 19, NDPI_PROTOCOL_WEBEX },
  { 0xADF30000 /* 173.243.0.0/20 */, 20, NDPI_PROTOCOL_WEBEX },
  { 0xCFB6A000 /* 207.182.160.0/19*/, 19, NDPI_PROTOCOL_WEBEX },
  { 0xD0085100 /* 208.8.81.0/24 */, 24, NDPI_PROTOCOL_WEBEX },
  { 0xD1C5C000 /* 209.197.192.0/19*/, 19, NDPI_PROTOCOL_WEBEX },
  { 0xD204C000 /* 210.4.192.0/20 */, 20, NDPI_PROTOCOL_WEBEX },

  /*
    Viber Media S.à r.l.
    https://whois.arin.net/rest/nets;q=AWS-VIBER-MEDIA?showDetails=true&showARIN=false&showNonArinTopLevelNet=false&ext=netref2
  */

  { 0x0DE61550 /* 13.230.21.80/28 */, 28, NDPI_PROTOCOL_VIBER },
  { 0x0D39B480 /* 13.57.180.128/28 */, 28, NDPI_PROTOCOL_VIBER },
  { 0x012C30400 /* 18.195.4.0/23 */, 23, NDPI_PROTOCOL_VIBER },
  { 0x012C45500 /* 18.196.85.0/25 */, 25, NDPI_PROTOCOL_VIBER },
  { 0x022E8A340 /* 34.232.163.64/28 */, 28, NDPI_PROTOCOL_VIBER },
  { 0x022F67200 /* 34.246.114.0/23 */, 23, NDPI_PROTOCOL_VIBER },
  { 0x3400FC00 /* 52.0.252.0/22 */, 22, NDPI_PROTOCOL_VIBER },
  { 0x3403A746 /* 52.3.167.70/32 */, 32, NDPI_PROTOCOL_VIBER },
  { 0x34162CEB /* 52.22.44.235/32 */, 32, NDPI_PROTOCOL_VIBER },
  { 0x34165F0F /* 52.22.95.15/32 */, 32, NDPI_PROTOCOL_VIBER },
  { 0x3640BFF0 /* 54.64.191.240/28 */, 28, NDPI_PROTOCOL_VIBER },
  { 0x3655545D /* 54.85.84.93/32 */, 32, NDPI_PROTOCOL_VIBER },
  { 0x3655565D /* 54.85.86.93/32 */, 32, NDPI_PROTOCOL_VIBER },
  { 0x36A5FFD0 /* 54.165.255.208/28 */, 28, NDPI_PROTOCOL_VIBER },
  { 0x36A5FFE0 /* 54.165.255.224/27 */, 27, NDPI_PROTOCOL_VIBER },
  { 0x36DBBFA0 /* 54.219.191.160/28 */, 28, NDPI_PROTOCOL_VIBER },
  { 0x36E8FB90 /* 54.232.251.144/28 */, 28, NDPI_PROTOCOL_VIBER },

  /*
    Apple Inc.
    origin AS714, AS6185
  */

  { 0x11000000 /* 17.0.0.0/8       */, 8 , NDPI_PROTOCOL_APPLE },
  { 0xC0233200 /* 192.35.50.0/24 */, 24, NDPI_PROTOCOL_APPLE },
  { 0xC6B71000 /* 198.183.16.0/24 */, 24, NDPI_PROTOCOL_APPLE },
  { 0xC6B71100 /* 198.183.17.0/24 */, 24, NDPI_PROTOCOL_APPLE },
  { 0xCDB4AF00 /* 205.180.175.0/24 */, 24, NDPI_PROTOCOL_APPLE },

  /*
    Dropbox, Inc.
    origin AS19679
  */

  { 0x2D3A4000 /* 45.58.64.0/20 */, 20, NDPI_PROTOCOL_DROPBOX },
  { 0x6CA0A000 /* 108.160.160.0/20 */, 20, NDPI_PROTOCOL_DROPBOX },
  { 0xA27D0000 /* 162.125.0.0/16 */, 16, NDPI_PROTOCOL_DROPBOX },
  { 0xB92D0800 /* 185.45.8.0/22 */, 22, NDPI_PROTOCOL_DROPBOX },
  { 0xC72FD800 /* 199.47.216.0/22 */, 22, NDPI_PROTOCOL_DROPBOX },

  /*
    Skype (Microsoft CDN)
  */
  { 0x9D388740 /* 157.56.135.64 */, 26, NDPI_PROTOCOL_SKYPE },
  { 0x9D38B900 /* 157.56.185.0 */, 26, NDPI_PROTOCOL_SKYPE },
  { 0x9D383400 /* 157.56.52.0 */, 26, NDPI_PROTOCOL_SKYPE },
  { 0x9D383580 /* 157.56.53.128 */, 25, NDPI_PROTOCOL_SKYPE },
  { 0x9D38C600 /* 157.56.198.0 */, 26, NDPI_PROTOCOL_SKYPE },
  { 0x9D3C0000 /* 157.60.0.0 */, 16, NDPI_PROTOCOL_SKYPE },
  { 0x9D360000 /* 157.54.0.0 */, 15, NDPI_PROTOCOL_SKYPE },
  { 0x0D6B0380 /* 13.107.3.128 */, 32, NDPI_PROTOCOL_SKYPE },
  { 0x0D6B0381 /* 13.107.3.129 */, 32, NDPI_PROTOCOL_SKYPE },
  { 0x6FDD4000 /* 111.221.64.0 */, 18, NDPI_PROTOCOL_SKYPE },
  { 0x5BBED800 /* 91.190.216.0 */, 21, NDPI_PROTOCOL_SKYPE },
  { 0x5BBEDA00 /* 91.190.218.0 */, 24, NDPI_PROTOCOL_SKYPE },
  { 0x287F816D /* 40.126.129.109 */, 32, NDPI_PROTOCOL_SKYPE },
  { 0x4237DF00 /* 65.55.223.0 */, 26, NDPI_PROTOCOL_SKYPE },
  { 0x17600000 /* 23.96.0.0 */, 13, NDPI_PROTOCOL_SKYPE },
  { 0x34724A05 /* 52.114.74.5 */, 32, NDPI_PROTOCOL_SKYPE },
  { 0x14B40000 /* 20.180.0.0 */, 14, NDPI_PROTOCOL_SKYPE },
  { 0x14B80000 /* 20.184.0.0 */, 13, NDPI_PROTOCOL_SKYPE },

  /*
    Blizzard Entertainment, Inc
    origin AS57976
  */

  { 0x052AA000 /* 5.42.160.0/19 */, 19, NDPI_PROTOCOL_STARCRAFT },
  { 0x0C81DE00 /* 12.129.222.0/23 */, 23, NDPI_PROTOCOL_STARCRAFT },
  { 0x0C81E400 /* 12.129.228.0/23 */, 23, NDPI_PROTOCOL_STARCRAFT },
  { 0x0C81EC00 /* 12.129.236.0/23 */, 23, NDPI_PROTOCOL_STARCRAFT },
  { 0x0C81FE00 /* 12.129.254.0/23 */, 23, NDPI_PROTOCOL_STARCRAFT },
  { 0x0C82F400 /* 12.130.244.0/22 */, 22, NDPI_PROTOCOL_STARCRAFT },
  { 0x18690000 /* 24.105.0.0/18 */, 18, NDPI_PROTOCOL_STARCRAFT },
  { 0x25F40000 /* 37.244.0.0/18 */, 18, NDPI_PROTOCOL_STARCRAFT },
  { 0x3B992800 /* 59.153.40.0/22 */, 22, NDPI_PROTOCOL_STARCRAFT },
  { 0x3E73F400 /* 62.115.244.0/22 */, 22, NDPI_PROTOCOL_STARCRAFT },
  { 0x50EFD000 /* 80.239.208.0/22 */, 22, NDPI_PROTOCOL_STARCRAFT },
  { 0x67047200 /* 103.4.114.0/23 */, 23, NDPI_PROTOCOL_STARCRAFT },
  { 0x67C62000 /* 103.198.32.0/23 */, 23, NDPI_PROTOCOL_STARCRAFT },
  { 0x89DD4000 /* 137.221.64.0/18 */, 18, NDPI_PROTOCOL_STARCRAFT },
  { 0xB93C7000 /* 185.60.112.0/22 */, 22, NDPI_PROTOCOL_STARCRAFT },
  { 0xC30CF400 /* 195.12.244.0/22 */, 22, NDPI_PROTOCOL_STARCRAFT },
  { 0xC76C2000 /* 199.108.32.0/20 */, 20, NDPI_PROTOCOL_STARCRAFT },
  { 0xC76C3000 /* 199.108.48.0/20 */, 20, NDPI_PROTOCOL_STARCRAFT },
  { 0xCA094200 /* 202.9.66.0/23 */, 23, NDPI_PROTOCOL_STARCRAFT },

  /*
    Google Inc. / Google Switzerland GmbH / Google Ireland Limited
    origin AS15169, AS36384, AS41264, AS43515, AS36039, AS36040, AS36492
  */
  { 0x08063000 /* 8.6.48.0/21 */, 21, NDPI_PROTOCOL_GOOGLE },
  { 0x08080400 /* 8.8.4.0/24 */, 24, NDPI_PROTOCOL_GOOGLE },
  { 0x08080800 /* 8.8.8.0/24 */, 24, NDPI_PROTOCOL_GOOGLE },
  { 0x080FCA00 /* 8.15.202.0/24 */, 24, NDPI_PROTOCOL_GOOGLE },
  { 0x0822D000 /* 8.34.208.0/21 */, 21, NDPI_PROTOCOL_GOOGLE },
  { 0x0822D800 /* 8.34.216.0/21 */, 21, NDPI_PROTOCOL_GOOGLE },
  { 0x0823C000 /* 8.35.192.0/21 */, 21, NDPI_PROTOCOL_GOOGLE },
  { 0x0823C800 /* 8.35.200.0/21 */, 21, NDPI_PROTOCOL_GOOGLE },
  { 0x17EC3000 /* 23.236.48.0/20 */, 20, NDPI_PROTOCOL_GOOGLE },
  { 0x17FB8000 /* 23.251.128.0/19 */, 19, NDPI_PROTOCOL_GOOGLE },
  { 0x23B80000 /* 35.184.0.0/13 */, 13, NDPI_PROTOCOL_GOOGLE },
  { 0x2D79E400 /* 45.121.228.0/24 */, 24, NDPI_PROTOCOL_GOOGLE },
  { 0x2D79E500 /* 45.121.229.0/24 */, 24, NDPI_PROTOCOL_GOOGLE },
  { 0x2D79E600 /* 45.121.230.0/23 */, 23, NDPI_PROTOCOL_GOOGLE },
  { 0x2E1CF700 /* 46.28.247.0/24 */, 24, NDPI_PROTOCOL_GOOGLE },
  { 0x4009E000 /* 64.9.224.0/19 */, 19, NDPI_PROTOCOL_GOOGLE },
  { 0x400F7000 /* 64.15.112.0/20 */, 20, NDPI_PROTOCOL_GOOGLE },
  { 0x40E9A000 /* 64.233.160.0/19 */, 19, NDPI_PROTOCOL_GOOGLE },
  { 0x42660000 /* 66.102.0.0/20 */, 20, NDPI_PROTOCOL_GOOGLE },
  { 0x42F94000 /* 66.249.64.0/19 */, 19, NDPI_PROTOCOL_GOOGLE },
  { 0x46208000 /* 70.32.128.0/19 */, 19, NDPI_PROTOCOL_GOOGLE },
  { 0x480EC000 /* 72.14.192.0/18 */, 18, NDPI_PROTOCOL_GOOGLE },
  { 0x4A721800 /* 74.114.24.0/21 */, 21, NDPI_PROTOCOL_GOOGLE },
  { 0x4A7D0000 /* 74.125.0.0/16 */, 16, NDPI_PROTOCOL_GOOGLE },
  { 0x59CFE000 /* 89.207.224.0/21 */, 21, NDPI_PROTOCOL_GOOGLE },
  { 0x673E4000 /* 103.62.64.0/24 */, 24, NDPI_PROTOCOL_GOOGLE },
  { 0x673E4100 /* 103.62.65.0/24 */, 24, NDPI_PROTOCOL_GOOGLE },
  { 0x673E4200 /* 103.62.66.0/23 */, 23, NDPI_PROTOCOL_GOOGLE },
  { 0x68840000 /* 104.132.0.0/14 */, 14, NDPI_PROTOCOL_GOOGLE },
  { 0x689A0000 /* 104.154.0.0/15 */, 15, NDPI_PROTOCOL_GOOGLE },
  { 0x68C40000 /* 104.196.0.0/14 */, 14, NDPI_PROTOCOL_GOOGLE },
  { 0x68EDA000 /* 104.237.160.0/19*/, 19, NDPI_PROTOCOL_GOOGLE },
  { 0x6BA7A000 /* 107.167.160.0/19*/, 19, NDPI_PROTOCOL_GOOGLE },
  { 0x6BB2C000 /* 107.178.192.0/18*/, 18, NDPI_PROTOCOL_GOOGLE },
  { 0x6C3B5000 /* 108.59.80.0/20 */, 20, NDPI_PROTOCOL_GOOGLE },
  { 0x6CAAC000 /* 108.170.192.0/18*/, 18, NDPI_PROTOCOL_GOOGLE },
  { 0x6CB10000 /* 108.177.0.0/17 */, 17, NDPI_PROTOCOL_GOOGLE },
  { 0x71C56800 /* 113.197.104.0/22 */, 22, NDPI_PROTOCOL_GOOGLE },
  { 0x82D30000 /* 130.211.0.0/16 */, 16, NDPI_PROTOCOL_GOOGLE },
  { 0x8EFA0000 /* 142.250.0.0/15 */, 15, NDPI_PROTOCOL_GOOGLE },
  { 0x92940000 /* 146.148.0.0/17 */, 17, NDPI_PROTOCOL_GOOGLE },
  { 0xA2D89400 /* 162.216.148.0/22 */, 22, NDPI_PROTOCOL_GOOGLE },
  { 0xA2DEB000 /* 162.222.176.0/21*/, 21, NDPI_PROTOCOL_GOOGLE },
  { 0xAC660800 /* 172.102.8.0/21 */, 21, NDPI_PROTOCOL_GOOGLE },
  { 0xAC6E2000 /* 172.110.32.0/21 */, 21, NDPI_PROTOCOL_GOOGLE },
  { 0xACD90000 /* 172.217.0.0/16 */, 16, NDPI_PROTOCOL_GOOGLE },
  { 0xACFD0000 /* 172.253.0.0/16 */, 16, NDPI_PROTOCOL_GOOGLE },
  { 0xADC20000 /* 173.194.0.0/16 */, 16, NDPI_PROTOCOL_GOOGLE },
  { 0xADFF7000 /* 173.255.112.0/20*/, 20, NDPI_PROTOCOL_GOOGLE },
  { 0xB9191C00 /* 185.25.28.0/22 */, 22, NDPI_PROTOCOL_GOOGLE },
  { 0xB9969400 /* 185.150.148.0/22 */, 22, NDPI_PROTOCOL_GOOGLE },
  { 0xC068A000 /* 192.104.160.0/23*/, 23, NDPI_PROTOCOL_GOOGLE },
  { 0xC0771C00 /* 192.119.28.0/24 */, 24, NDPI_PROTOCOL_GOOGLE },
  { 0xC09E1C00 /* 192.158.28.0/22 */, 22, NDPI_PROTOCOL_GOOGLE },
  { 0xC0B20000 /* 192.178.0.0/15 */, 15, NDPI_PROTOCOL_GOOGLE },
  { 0xC1210400 /* 193.33.4.0/24 */, 24, NDPI_PROTOCOL_GOOGLE },
  { 0xC1210500 /* 193.33.5.0/24 */, 24, NDPI_PROTOCOL_GOOGLE },
  { 0xC1C8DE00 /* 193.200.222.0/24*/, 24, NDPI_PROTOCOL_GOOGLE },
  { 0xC27A5000 /* 194.122.80.0/22 */, 22, NDPI_PROTOCOL_GOOGLE },
  { 0xC7C07000 /* 199.192.112.0/22 */, 22, NDPI_PROTOCOL_GOOGLE },
  { 0xC7DFE800 /* 199.223.232.0/21*/, 21, NDPI_PROTOCOL_GOOGLE },
  { 0xCFDFA000 /* 207.223.160.0/20*/, 20, NDPI_PROTOCOL_GOOGLE },
  { 0xD0419800 /* 208.65.152.0/22 */, 22, NDPI_PROTOCOL_GOOGLE },
  { 0xD075E000 /* 208.117.224.0/19*/, 19, NDPI_PROTOCOL_GOOGLE },
  { 0xD1558000 /* 209.85.128.0/17 */, 17, NDPI_PROTOCOL_GOOGLE },
  { 0xD16BB000 /* 209.107.176.0/20*/, 20, NDPI_PROTOCOL_GOOGLE },
  { 0xD83AC000 /* 216.58.192.0/19 */, 19, NDPI_PROTOCOL_GOOGLE },
  { 0xD8495000 /* 216.73.80.0/20 */, 20, NDPI_PROTOCOL_GOOGLE },
  { 0xD8EF2000 /* 216.239.32.0/19 */, 19, NDPI_PROTOCOL_GOOGLE },
  { 0xD8FCDC00 /* 216.252.220.0/22 */, 22, NDPI_PROTOCOL_GOOGLE },

  /*
    Canonical Ltd (Ubuntu)
    origin AS41231z
  */

  { 0x5BBD5800 /* 91.189.88.0/21 */,   21, NDPI_PROTOCOL_UBUNTUONE },
  { 0xA2D52000 /* 162.213.32.0/22 */,  22, NDPI_PROTOCOL_UBUNTUONE },
  { 0xB97DBC00 /* 185.125.188.0/22 */, 22, NDPI_PROTOCOL_UBUNTUONE },

  /*
    Telegram Messenger LLP
    origin: AS62041, AS62014, AS59930
  */

  { 0x5B6C0400 /* 91.108.4.0/22 */, 22, NDPI_PROTOCOL_TELEGRAM },
  { 0x5B6C0800 /* 91.108.8.0/22 */, 22, NDPI_PROTOCOL_TELEGRAM },
  { 0x5B6C0C00 /* 91.108.12.0/22 */, 22, NDPI_PROTOCOL_TELEGRAM },
  { 0x5B6C1000 /* 91.108.16.0/22 */, 22, NDPI_PROTOCOL_TELEGRAM },
  { 0x5B6C1400 /* 91.108.20.0/22 */, 22, NDPI_PROTOCOL_TELEGRAM },
  { 0x5B6C3800 /* 91.108.56.0/22 */, 22, NDPI_PROTOCOL_TELEGRAM },
  { 0x959AA000 /* 149.154.160.0/20*/, 20, NDPI_PROTOCOL_TELEGRAM },

  /*
    BitTorrent
  */

  { 0xB9381424 /* 185.56.20.36/32 */, 32, NDPI_PROTOCOL_BITTORRENT },
  { 0xC0DEED0A /* 192.222.237.10/32 */, 32, NDPI_PROTOCOL_BITTORRENT },
  { 0x4DDEAE14 /* 77.222.174.20/32 */, 32, NDPI_PROTOCOL_BITTORRENT },
  { 0x25779CBD /* 37.119.156.189/32 */, 32, NDPI_PROTOCOL_BITTORRENT },
  { 0x05277C26 /* 5.39.124.38/32 */, 32, NDPI_PROTOCOL_BITTORRENT },
  { 0x4FC0AB43 /* 79.192.171.67/32 */, 32, NDPI_PROTOCOL_BITTORRENT },
  { 0xAC100010 /* 172.16.0.16/32 */, 32, NDPI_PROTOCOL_BITTORRENT },
  { 0xB2A4F550 /* 178.164.245.80/32 */, 32, NDPI_PROTOCOL_BITTORRENT },
  { 0xAE597B3E /* 174.89.123.62/32 */, 32, NDPI_PROTOCOL_BITTORRENT },

  /*
    Ethereum
    curl -s https://raw.githubusercontent.com/ethereum/go-ethereum/master/params/bootnodes.go | grep -v '^/' | grep ':' | cut -d '@' -f 2 | cut -d ':' -f 1
  */
  { 0x128A6C43 /* 18.138.108.67/32 */, 32, NDPI_PROTOCOL_MINING },
  { 0x03D12D4F /* 3.209.45.79/32 */, 32, NDPI_PROTOCOL_MINING },
  { 0x22FF1771 /* 34.255.23.113/32 */, 32, NDPI_PROTOCOL_MINING },
  { 0x239EF497 /* 35.158.244.151/32 */, 32, NDPI_PROTOCOL_MINING },
  { 0x34BBCF1B /* 52.187.207.27/32 */, 32, NDPI_PROTOCOL_MINING },
  { 0xBFEAA2C6 /* 191.234.162.198/32*/, 32, NDPI_PROTOCOL_MINING },
  { 0x34E7A56C /* 52.231.165.108/32 */, 32, NDPI_PROTOCOL_MINING },
  { 0x682AD919 /* 104.42.217.25/32 */, 32, NDPI_PROTOCOL_MINING },
  { 0x050153E2 /* 5.1.83.226/32 */, 32, NDPI_PROTOCOL_MINING },
  { 0x34B0070A /* 52.176.7.10/32 */, 32, NDPI_PROTOCOL_MINING },
  { 0x34B0644D /* 52.176.100.77/32 */, 32, NDPI_PROTOCOL_MINING },
  { 0x34E8F398 /* 52.232.243.152/32 */, 32, NDPI_PROTOCOL_MINING },
  { 0xC051D0DF /* 192.81.208.223/32 */, 32, NDPI_PROTOCOL_MINING },
  { 0x34A92A65 /* 52.169.42.101/32 */, 32, NDPI_PROTOCOL_MINING },
  { 0x34039EB8 /* 52.3.158.184/32 */, 32, NDPI_PROTOCOL_MINING },
  { 0x9F591CD3 /* 159.89.28.211/32 */, 32, NDPI_PROTOCOL_MINING },
  { 0x338D4E35 /* 51.141.78.53/32 */, 32, NDPI_PROTOCOL_MINING },
  { 0x0D5D3689 /* 13.93.54.137/32 */, 32, NDPI_PROTOCOL_MINING },
  { 0x5EED3672 /* 94.237.54.114/32 */, 32, NDPI_PROTOCOL_MINING },
  { 0x34409B93 /* 52.64.155.147/32 */, 32, NDPI_PROTOCOL_MINING },
  { 0xD5BA1052 /* 213.186.16.82/32 */, 32, NDPI_PROTOCOL_MINING },
  { 0x343888C8 /* 52.56.136.200/32 */, 32, NDPI_PROTOCOL_MINING },
  { 0x23B1E2A8 /* 35.177.226.168/32 */, 32, NDPI_PROTOCOL_MINING },
  { 0x287603DF /* 40.118.3.223/32 */, 32, NDPI_PROTOCOL_MINING },
  { 0x287603DF /* 40.118.3.223/32 */, 32, NDPI_PROTOCOL_MINING },
  { 0x287603DF /* 40.118.3.223/32 */, 32, NDPI_PROTOCOL_MINING },

  /*
    Tor
    https://torstatus.rueckgr.at/ip_list_all.php/Tor_ip_list_ALL.csv
    From 16.11.2020

    https://panwdbl.appspot.com/lists/ettor.txt

    Use utils/toripaddr2list.py to convert them
  */

  { 0x012B6CDD /* 1.43.108.221/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x020A2A30 /* 2.10.42.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x020AC110 /* 2.10.193.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x020F24D8 /* 2.15.36.216/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x021F22C8 /* 2.31.34.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x023863D7 /* 2.56.99.215/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0238D5ED /* 2.56.213.237/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0238F1F3 /* 2.56.241.243/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0239ECD7 /* 2.57.236.215/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0239ECD7 /* 2.57.236.215/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0253C8AC /* 2.83.200.172/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x02CA08A9 /* 2.202.8.169/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x02CB9595 /* 2.203.149.149/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x02CDC4FB /* 2.205.196.251/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x02E5C9C5 /* 2.229.201.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x02E6C1C5 /* 2.230.193.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x02E6C1C5 /* 2.230.193.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x02E95BB0 /* 2.233.91.176/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x02F4394C /* 2.244.57.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x02F9566E /* 2.249.86.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x03081289 /* 3.8.18.137/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x030ABEC2 /* 3.10.190.194/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0314B3F9 /* 3.20.179.249/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x035CE1DC /* 3.92.225.220/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0379A741 /* 3.121.167.65/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x037D13E9 /* 3.125.19.233/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x03E173EE /* 3.225.115.238/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05013834 /* 5.1.56.52/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05023698 /* 5.2.54.152/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x050240E9 /* 5.2.64.233/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05024693 /* 5.2.70.147/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05024865 /* 5.2.72.101/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0502486E /* 5.2.72.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05024871 /* 5.2.72.113/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x050248F3 /* 5.2.72.243/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05024D16 /* 5.2.77.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05024D92 /* 5.2.77.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05024E45 /* 5.2.78.69/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05024FB3 /* 5.2.79.179/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05090CD4 /* 5.9.12.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05091202 /* 5.9.18.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x050915F0 /* 5.9.21.240/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05091DB7 /* 5.9.29.183/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x050925A2 /* 5.9.37.162/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x050925D6 /* 5.9.37.214/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05092AE6 /* 5.9.42.230/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05092BD3 /* 5.9.43.211/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05092BD3 /* 5.9.43.211/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05092C1D /* 5.9.44.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05092C1D /* 5.9.44.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0509380C /* 5.9.56.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05093B4E /* 5.9.59.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05093C04 /* 5.9.60.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05094431 /* 5.9.68.49/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0509524C /* 5.9.82.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0509622B /* 5.9.98.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05097442 /* 5.9.116.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05097707 /* 5.9.119.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x050978FA /* 5.9.120.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x050979CF /* 5.9.121.207/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05097C63 /* 5.9.124.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x050989A7 /* 5.9.137.167/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05099C11 /* 5.9.156.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05099E4B /* 5.9.158.75/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05099E4B /* 5.9.158.75/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05099E7B /* 5.9.158.123/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05099E8F /* 5.9.158.143/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x050C5A0D /* 5.12.90.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x050C5A0D /* 5.12.90.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x050DEE9D /* 5.13.238.157/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0513A267 /* 5.19.162.103/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0513B825 /* 5.19.184.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0522B71D /* 5.34.183.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05273CF3 /* 5.39.60.243/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05274802 /* 5.39.72.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05274814 /* 5.39.72.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05274D0A /* 5.39.77.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05274E28 /* 5.39.78.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05275087 /* 5.39.80.135/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05275087 /* 5.39.80.135/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05275166 /* 5.39.81.102/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x052756CB /* 5.39.86.203/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0527577C /* 5.39.87.124/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05275F5F /* 5.39.95.95/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0527B9A4 /* 5.39.185.164/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0527D8A0 /* 5.39.216.160/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x052C65BE /* 5.44.101.190/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x052D6F95 /* 5.45.111.149/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05336A6C /* 5.51.106.108/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0538BD51 /* 5.56.189.81/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0538C6E1 /* 5.56.198.225/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0539F33B /* 5.57.243.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0547EF41 /* 5.71.239.65/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x054F4F85 /* 5.79.79.133/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x054F5535 /* 5.79.85.53/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x054F6D30 /* 5.79.109.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0550CD31 /* 5.80.205.49/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05532D83 /* 5.83.45.131/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x056506EC /* 5.101.6.236/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05653316 /* 5.101.51.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05673D6F /* 5.103.61.111/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05678444 /* 5.103.132.68/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05684EC4 /* 5.104.78.196/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x058426E7 /* 5.132.38.231/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05856DDE /* 5.133.109.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0585B1D1 /* 5.133.177.209/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05861F94 /* 5.134.31.148/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0587001A /* 5.135.0.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05874191 /* 5.135.65.145/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05877322 /* 5.135.115.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05879C0C /* 5.135.156.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05879EA2 /* 5.135.158.162/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0587A231 /* 5.135.162.49/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0587B026 /* 5.135.176.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0587B16B /* 5.135.177.107/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0587B5D5 /* 5.135.181.213/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0587BA49 /* 5.135.186.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0587BB05 /* 5.135.187.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0587C70D /* 5.135.199.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x058F5301 /* 5.143.83.1/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0590381D /* 5.144.56.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05937923 /* 5.147.121.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0593F89E /* 5.147.248.158/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0596DD89 /* 5.150.221.137/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x059AAEF1 /* 5.154.174.241/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05A6E0BB /* 5.166.224.187/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05AC828B /* 5.172.130.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05B53263 /* 5.181.50.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05B53333 /* 5.181.51.51/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05B53334 /* 5.181.51.52/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05B6D377 /* 5.182.211.119/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05BBE749 /* 5.187.231.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05BC6C45 /* 5.188.108.69/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05BC6C4B /* 5.188.108.75/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05BC6C52 /* 5.188.108.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05BCE8FC /* 5.188.232.252/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05BD8E76 /* 5.189.142.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05BD9A51 /* 5.189.154.81/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05BD9B27 /* 5.189.155.39/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05BDA432 /* 5.189.164.50/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05BDA4E6 /* 5.189.164.230/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05BDA9BE /* 5.189.169.190/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05BDAA03 /* 5.189.170.3/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05BDB53D /* 5.189.181.61/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05C41740 /* 5.196.23.64/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05C43A60 /* 5.196.58.96/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05C44489 /* 5.196.68.137/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05C44718 /* 5.196.71.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05C449B8 /* 5.196.73.184/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05C45811 /* 5.196.88.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05C782BC /* 5.199.130.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05C785C1 /* 5.199.133.193/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05C78EEC /* 5.199.142.236/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05C7AE88 /* 5.199.174.136/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05C7AEC5 /* 5.199.174.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05C7AED2 /* 5.199.174.210/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05C7AED9 /* 5.199.174.217/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05C7AEDB /* 5.199.174.219/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05C7AEE5 /* 5.199.174.229/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05CEE040 /* 5.206.224.64/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05E481DF /* 5.228.129.223/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05E4AE54 /* 5.228.174.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05E79E0B /* 5.231.158.11/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05F991A4 /* 5.249.145.164/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05F994B6 /* 5.249.148.182/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05FC980A /* 5.252.152.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05FCA2ED /* 5.252.162.237/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05FCB348 /* 5.252.179.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x05FE426F /* 5.254.66.111/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x080FB3B6 /* 8.15.179.182/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x081A158F /* 8.26.21.143/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x082A4C44 /* 8.42.76.68/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x08D05AD5 /* 8.208.90.213/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x08D14F7D /* 8.209.79.125/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x08D15DA0 /* 8.209.93.160/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x08D15E55 /* 8.209.94.85/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x08D290AA /* 8.210.144.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0C1C5A7D /* 12.28.90.125/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0CEB97C8 /* 12.235.151.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0D30111F /* 13.48.17.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0D35AC6A /* 13.53.172.106/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0D42C113 /* 13.66.193.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0D43B99C /* 13.67.185.156/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0D7C1282 /* 13.124.18.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0DD320A5 /* 13.211.32.165/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0DE59832 /* 13.229.152.50/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0DE83666 /* 13.232.54.102/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0EC9740E /* 14.201.116.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0FBC6B6B /* 15.188.107.107/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x0FECCD62 /* 15.236.205.98/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x12125211 /* 18.18.82.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1212F811 /* 18.18.248.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1212F828 /* 18.18.248.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x121BC5FC /* 18.27.197.252/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x121BC5FC /* 18.27.197.252/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x12859E42 /* 18.133.158.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1286F657 /* 18.134.246.87/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x12A2993B /* 18.162.153.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x12B49A73 /* 18.180.154.115/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x12BCDA78 /* 18.188.218.120/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x12C52376 /* 18.197.35.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x12CC1475 /* 18.204.20.117/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x12CDA3B7 /* 18.205.163.183/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x12DC1473 /* 18.220.20.115/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x12DFA4F5 /* 18.223.164.245/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1751425A /* 23.81.66.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17582536 /* 23.88.37.54/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17582537 /* 23.88.37.55/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1758253D /* 23.88.37.61/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1758253E /* 23.88.37.62/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1758253F /* 23.88.37.63/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17582540 /* 23.88.37.64/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x175825E1 /* 23.88.37.225/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x175825E2 /* 23.88.37.226/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x175825E3 /* 23.88.37.227/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x175825E4 /* 23.88.37.228/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x175825E5 /* 23.88.37.229/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x175904FA /* 23.89.4.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x175904FB /* 23.89.4.251/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x175904FC /* 23.89.4.252/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x175904FD /* 23.89.4.253/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x175C13E6 /* 23.92.19.230/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x175C1DCC /* 23.92.29.204/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x175C1FFA /* 23.92.31.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1768516A /* 23.104.81.106/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x176C314F /* 23.108.49.79/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x176C4F6E /* 23.108.79.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x176C4F71 /* 23.108.79.113/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1778B673 /* 23.120.182.115/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1778B673 /* 23.120.182.115/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1778B67B /* 23.120.182.123/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1778B67C /* 23.120.182.124/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1778B67D /* 23.120.182.125/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17814064 /* 23.129.64.100/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140B4 /* 23.129.64.180/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140B5 /* 23.129.64.181/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140B6 /* 23.129.64.182/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140B7 /* 23.129.64.183/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140B8 /* 23.129.64.184/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140B9 /* 23.129.64.185/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140BA /* 23.129.64.186/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140BB /* 23.129.64.187/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140BC /* 23.129.64.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140BD /* 23.129.64.189/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140BE /* 23.129.64.190/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140BF /* 23.129.64.191/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140C0 /* 23.129.64.192/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140C1 /* 23.129.64.193/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140C2 /* 23.129.64.194/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140C3 /* 23.129.64.195/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140C4 /* 23.129.64.196/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140C5 /* 23.129.64.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140C8 /* 23.129.64.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140C9 /* 23.129.64.201/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140CA /* 23.129.64.202/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140CB /* 23.129.64.203/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140CC /* 23.129.64.204/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140CD /* 23.129.64.205/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140CE /* 23.129.64.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140CF /* 23.129.64.207/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140D0 /* 23.129.64.208/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140D1 /* 23.129.64.209/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140D2 /* 23.129.64.210/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140D3 /* 23.129.64.211/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140D4 /* 23.129.64.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140D5 /* 23.129.64.213/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140D6 /* 23.129.64.214/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140D7 /* 23.129.64.215/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140D8 /* 23.129.64.216/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178140D9 /* 23.129.64.217/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x178DF0CE /* 23.141.240.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x179AA006 /* 23.154.160.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x179AA008 /* 23.154.160.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17A0D0F5 /* 23.160.208.245/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17A0D0F5 /* 23.160.208.245/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17A0D0F6 /* 23.160.208.246/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17A0D0F6 /* 23.160.208.246/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17A0D0F7 /* 23.160.208.247/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17A0D0F7 /* 23.160.208.247/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17A0D0F8 /* 23.160.208.248/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17A0D0F8 /* 23.160.208.248/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17A0D0F9 /* 23.160.208.249/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17A0D0F9 /* 23.160.208.249/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17A0D0FA /* 23.160.208.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17A0D0FA /* 23.160.208.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17E3C767 /* 23.227.199.103/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17ED1B34 /* 23.237.27.52/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17ED228A /* 23.237.34.138/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17ED89F4 /* 23.237.137.244/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17EDB27A /* 23.237.178.122/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17EF095C /* 23.239.9.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17EF11B3 /* 23.239.17.179/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17EF16F8 /* 23.239.22.248/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17EF7165 /* 23.239.113.101/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17FD392A /* 23.253.57.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x17FEE188 /* 23.254.225.136/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1812C27C /* 24.18.194.124/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1834F299 /* 24.52.242.153/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x183B2D9D /* 24.59.45.157/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x183D0ABF /* 24.61.10.191/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x18501AC8 /* 24.80.26.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x18865C89 /* 24.134.92.137/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x188676F5 /* 24.134.118.245/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1886EA11 /* 24.134.234.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1886EA11 /* 24.134.234.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1896CCE1 /* 24.150.204.225/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x18970133 /* 24.151.1.51/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x189AB9A9 /* 24.154.185.169/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x18BAB0BD /* 24.186.176.189/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x18BEC2BA /* 24.190.194.186/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x18CBF4A4 /* 24.203.244.164/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x18D13EBB /* 24.209.62.187/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x18FD6F62 /* 24.253.111.98/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1B689533 /* 27.104.149.51/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1B6F5428 /* 27.111.84.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1B7A3B56 /* 27.122.59.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1B7A3B64 /* 27.122.59.100/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1BFC900C /* 27.252.144.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1BFF4BC6 /* 27.255.75.198/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1BFF4D45 /* 27.255.77.69/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F064647 /* 31.6.70.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F073DBA /* 31.7.61.186/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F073DBB /* 31.7.61.187/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F073DBC /* 31.7.61.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F073DBD /* 31.7.61.189/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F073DBE /* 31.7.61.190/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F0DBC2B /* 31.13.188.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F0DC3F8 /* 31.13.195.248/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F0E28AF /* 31.14.40.175/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F108794 /* 31.16.135.148/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F10D3CD /* 31.16.211.205/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F18089F /* 31.24.8.159/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F1C0C8E /* 31.28.12.142/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F1CA8AE /* 31.28.168.174/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F1D2BDB /* 31.29.43.219/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F1DDE9C /* 31.29.222.156/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F1F4818 /* 31.31.72.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F1F49DE /* 31.31.73.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F1F4A2F /* 31.31.74.47/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F1F4C7B /* 31.31.76.123/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F1F4DB0 /* 31.31.77.176/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F2B9E0B /* 31.43.158.11/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F34EFE3 /* 31.52.239.227/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F7F226C /* 31.127.34.108/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F830211 /* 31.131.2.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F830213 /* 31.131.2.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F8304AB /* 31.131.4.171/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1F921F82 /* 31.146.31.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FA4B05F /* 31.164.176.95/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FB31A2B /* 31.179.26.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FB8C698 /* 31.184.198.152/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FB8C6B7 /* 31.184.198.183/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FB8DAB4 /* 31.184.218.180/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FC18B0E /* 31.193.139.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FC90E33 /* 31.201.14.51/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FC9101E /* 31.201.16.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FC9A4C5 /* 31.201.164.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FCF5931 /* 31.207.89.49/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FCF594C /* 31.207.89.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FD69018 /* 31.214.144.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FD690AF /* 31.214.144.175/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FDC00BA /* 31.220.0.186/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FDC00CA /* 31.220.0.202/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FDC00CB /* 31.220.0.203/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FDC00F9 /* 31.220.0.249/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FDC01A9 /* 31.220.1.169/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FDC01AA /* 31.220.1.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FDC01E9 /* 31.220.1.233/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FDC0264 /* 31.220.2.100/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FDC026B /* 31.220.2.107/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FDC026C /* 31.220.2.108/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FDC0284 /* 31.220.2.132/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FDC02DE /* 31.220.2.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FDC02DF /* 31.220.2.223/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FDC28A3 /* 31.220.40.163/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FDC28EC /* 31.220.40.236/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FDC28ED /* 31.220.40.237/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FDC28EE /* 31.220.40.238/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FDC28EF /* 31.220.40.239/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FDC28F0 /* 31.220.40.240/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x1FDC28F1 /* 31.220.40.241/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x224CFDD3 /* 34.76.253.211/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x225E5E65 /* 34.94.94.101/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x22D1D6D3 /* 34.209.214.211/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x22DD4C96 /* 34.221.76.150/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x22FEC793 /* 34.254.199.147/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x238B8DCE /* 35.139.141.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x238B8DCE /* 35.139.141.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x239D18F8 /* 35.157.24.248/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x23AA4DE0 /* 35.170.77.224/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x23B647D1 /* 35.182.71.209/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x23B8EC03 /* 35.184.236.3/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x23C60189 /* 35.198.1.137/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x23C75596 /* 35.199.85.150/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x23D0A933 /* 35.208.169.51/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x23E4A117 /* 35.228.161.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x23F4422A /* 35.244.66.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2437C967 /* 36.55.201.103/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2437E791 /* 36.55.231.145/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x24E49107 /* 36.228.145.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2508ECB8 /* 37.8.236.184/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2509E7C3 /* 37.9.231.195/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x250EEFCD /* 37.14.239.205/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2518913D /* 37.24.145.61/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x251C9A44 /* 37.28.154.68/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25236BEE /* 37.35.107.238/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x253054C1 /* 37.48.84.193/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2530741A /* 37.48.116.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2530782F /* 37.48.120.47/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x253078C4 /* 37.48.120.196/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2531E683 /* 37.49.230.131/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x253B253B /* 37.59.37.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x253B4CFC /* 37.59.76.252/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x253B4CFD /* 37.59.76.253/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x253B4CFE /* 37.59.76.254/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x253B4CFF /* 37.59.76.255/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x253DCCF8 /* 37.61.204.248/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2561B974 /* 37.97.185.116/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2561FDB0 /* 37.97.253.176/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x256E4215 /* 37.110.66.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25723E58 /* 37.114.62.88/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25744145 /* 37.116.65.69/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2578902F /* 37.120.144.47/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2578922A /* 37.120.146.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2578A795 /* 37.120.167.149/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2578A7C8 /* 37.120.167.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2578A9FC /* 37.120.169.252/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2578ABBC /* 37.120.171.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2578ABE6 /* 37.120.171.230/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2578ADAD /* 37.120.173.173/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2578ADAD /* 37.120.173.173/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2578AEF9 /* 37.120.174.249/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2578B27C /* 37.120.178.124/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2578B3A9 /* 37.120.179.169/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2578B852 /* 37.120.184.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2578BB68 /* 37.120.187.104/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2578BD0A /* 37.120.189.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2578BE06 /* 37.120.190.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2578BE06 /* 37.120.190.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2578BEA0 /* 37.120.190.160/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2578BEA0 /* 37.120.190.160/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x257AD0DC /* 37.122.208.220/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2586C3CA /* 37.134.195.202/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2586C3CA /* 37.134.195.202/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x258AE518 /* 37.138.229.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x258AE518 /* 37.138.229.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x258B0868 /* 37.139.8.104/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x258B16B4 /* 37.139.22.180/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x258F7609 /* 37.143.118.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2591409F /* 37.145.64.159/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25939B05 /* 37.147.155.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2599010A /* 37.153.1.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x259910AA /* 37.153.16.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x259DC353 /* 37.157.195.83/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x259DC357 /* 37.157.195.87/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x259DFE13 /* 37.157.254.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x259DFE25 /* 37.157.254.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x259DFE71 /* 37.157.254.113/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x259DFE72 /* 37.157.254.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x259DFF23 /* 37.157.255.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x259DFF72 /* 37.157.255.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x259DFF76 /* 37.157.255.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB011D /* 37.187.1.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB024C /* 37.187.2.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB02E6 /* 37.187.2.230/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB0C64 /* 37.187.12.100/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB102B /* 37.187.16.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB1143 /* 37.187.17.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB14A4 /* 37.187.20.164/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB1514 /* 37.187.21.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB1531 /* 37.187.21.49/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB1599 /* 37.187.21.153/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB17E8 /* 37.187.23.232/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB6054 /* 37.187.96.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB60B7 /* 37.187.96.183/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB6223 /* 37.187.98.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB62B9 /* 37.187.98.185/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB666C /* 37.187.102.108/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB6736 /* 37.187.103.54/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB686F /* 37.187.104.111/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB6968 /* 37.187.105.104/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB69CF /* 37.187.105.207/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB6B5B /* 37.187.107.91/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB71DA /* 37.187.113.218/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB7247 /* 37.187.114.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB757B /* 37.187.117.123/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB7622 /* 37.187.118.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB7696 /* 37.187.118.150/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB7825 /* 37.187.120.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB7A08 /* 37.187.122.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB7A65 /* 37.187.122.101/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BB7FDC /* 37.187.127.220/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BBCD72 /* 37.187.205.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BFC093 /* 37.191.192.147/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BFC093 /* 37.191.192.147/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BFC1A6 /* 37.191.193.166/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BFC1A6 /* 37.191.193.166/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BFC1ED /* 37.191.193.237/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BFC1ED /* 37.191.193.237/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BFC31C /* 37.191.195.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BFC31C /* 37.191.195.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BFC46B /* 37.191.196.107/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BFC46B /* 37.191.196.107/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BFC75F /* 37.191.199.95/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BFC75F /* 37.191.199.95/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BFC777 /* 37.191.199.119/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BFC777 /* 37.191.199.119/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BFCEC5 /* 37.191.206.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BFCEC5 /* 37.191.206.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25BFF581 /* 37.191.245.129/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25C863FB /* 37.200.99.251/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25C989CF /* 37.201.137.207/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25C98BAE /* 37.201.139.174/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25C9AD3B /* 37.201.173.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25C9ADB1 /* 37.201.173.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25CD08BF /* 37.205.8.191/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25CD0983 /* 37.205.9.131/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25DAF11C /* 37.218.241.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25DAF1CB /* 37.218.241.203/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25DAF21A /* 37.218.242.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25DAF254 /* 37.218.242.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25DAF291 /* 37.218.242.145/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25DAF2D9 /* 37.218.242.217/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25DC24F0 /* 37.220.36.240/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25DDC12C /* 37.221.193.44/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25DDC313 /* 37.221.195.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25DDC317 /* 37.221.195.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25DDC41F /* 37.221.196.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25DDC672 /* 37.221.198.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25DDC672 /* 37.221.198.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25DF4DF0 /* 37.223.77.240/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25E48102 /* 37.228.129.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25E48105 /* 37.228.129.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25E4811D /* 37.228.129.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25E48135 /* 37.228.129.53/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25EB30F7 /* 37.235.48.247/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25EB318A /* 37.235.49.138/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25F7318B /* 37.247.49.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25FCB957 /* 37.252.185.87/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25FCB9E5 /* 37.252.185.229/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25FCBB6F /* 37.252.187.111/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25FCBB81 /* 37.252.187.129/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25FCBC10 /* 37.252.188.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25FCBC65 /* 37.252.188.101/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25FCBC8C /* 37.252.188.140/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25FCBCB4 /* 37.252.188.180/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25FCBEB0 /* 37.252.190.176/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25FCBF29 /* 37.252.191.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x25FCBFBE /* 37.252.191.190/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2616110D /* 38.22.17.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2627C04E /* 38.39.192.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2644254D /* 38.68.37.77/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x26448705 /* 38.68.135.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x26661429 /* 38.102.20.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2691C86A /* 38.145.200.106/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2691C86B /* 38.145.200.107/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2691C86C /* 38.145.200.108/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2691C86D /* 38.145.200.109/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2691C86E /* 38.145.200.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2691C86F /* 38.145.200.111/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2691C870 /* 38.145.200.112/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x26937AFA /* 38.147.122.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x26937AFB /* 38.147.122.251/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x26937AFC /* 38.147.122.252/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x26937AFD /* 38.147.122.253/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x26937AFE /* 38.147.122.254/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x284494D9 /* 40.68.148.217/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x28716D0E /* 40.113.109.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x28739EA0 /* 40.115.158.160/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x287AA530 /* 40.122.165.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x29D04709 /* 41.208.71.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x29D7F232 /* 41.215.242.50/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2BE77234 /* 43.231.114.52/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2BFB9F90 /* 43.251.159.144/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2BFC250E /* 43.252.37.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2C891938 /* 44.137.25.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2CE23569 /* 44.226.53.105/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D093E6E /* 45.9.62.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D09941F /* 45.9.148.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D099426 /* 45.9.148.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D099429 /* 45.9.148.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D09942B /* 45.9.148.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D09942F /* 45.9.148.47/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D09943E /* 45.9.148.62/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D0994CD /* 45.9.148.205/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D0994D4 /* 45.9.148.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D09FA87 /* 45.9.250.135/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D09FA88 /* 45.9.250.136/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D0B1278 /* 45.11.18.120/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D0CCE6A /* 45.12.206.106/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D0E9688 /* 45.14.150.136/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D0F1048 /* 45.15.16.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D0F10AC /* 45.15.16.172/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D0F1184 /* 45.15.17.132/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D144301 /* 45.20.67.1/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D14D2A1 /* 45.20.210.161/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D1BCBC2 /* 45.27.203.194/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D20F01F /* 45.32.240.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D210C9E /* 45.33.12.158/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D2111AA /* 45.33.17.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D211BD2 /* 45.33.27.210/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D211D4C /* 45.33.29.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D212AEE /* 45.33.42.238/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D212CDE /* 45.33.44.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D212E65 /* 45.33.46.101/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D212FDA /* 45.33.47.218/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D213347 /* 45.33.51.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D214DDA /* 45.33.77.218/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D216908 /* 45.33.105.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D217278 /* 45.33.114.120/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D217C62 /* 45.33.124.98/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D21C6C9 /* 45.33.198.201/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D23689F /* 45.35.104.159/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D23C022 /* 45.35.192.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D3722FC /* 45.55.34.252/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D37F0E1 /* 45.55.240.225/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D384670 /* 45.56.70.112/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D384DE6 /* 45.56.77.230/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D3859B6 /* 45.56.89.182/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D385AB0 /* 45.56.90.176/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D385FC7 /* 45.56.95.199/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D386750 /* 45.56.103.80/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D3ED54E /* 45.62.213.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D3EE2AA /* 45.62.226.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D3EE6D8 /* 45.62.230.216/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D3EEB19 /* 45.62.235.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D3EEB70 /* 45.62.235.112/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D3EEC75 /* 45.62.236.117/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D3EECC5 /* 45.62.236.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D3EEF6D /* 45.62.239.109/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D3EF44E /* 45.62.244.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D3EF49A /* 45.62.244.154/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D3EF6BA /* 45.62.246.186/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D3EF7E1 /* 45.62.247.225/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D3F0760 /* 45.63.7.96/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D3F0EE1 /* 45.63.14.225/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D3F7468 /* 45.63.116.104/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D42212D /* 45.66.33.45/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D422323 /* 45.66.35.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D429C10 /* 45.66.156.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D429C67 /* 45.66.156.103/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D429C68 /* 45.66.156.104/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D429C70 /* 45.66.156.112/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D429C74 /* 45.66.156.116/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D429C93 /* 45.66.156.147/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D429C9E /* 45.66.156.158/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D429CA6 /* 45.66.156.166/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D429CA7 /* 45.66.156.167/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D429CA8 /* 45.66.156.168/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D429CA9 /* 45.66.156.169/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D429CB0 /* 45.66.156.176/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D429CBD /* 45.66.156.189/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D429CC2 /* 45.66.156.194/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D429CC3 /* 45.66.156.195/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D429CC6 /* 45.66.156.198/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D429CC8 /* 45.66.156.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D429D0A /* 45.66.157.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D429D64 /* 45.66.157.100/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4337CF /* 45.67.55.207/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D43595A /* 45.67.89.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D43DB0D /* 45.67.219.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4C0ACF /* 45.76.10.207/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4C175B /* 45.76.23.91/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4C2BED /* 45.76.43.237/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4C5656 /* 45.76.86.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4C72A0 /* 45.76.114.160/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4C739F /* 45.76.115.159/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4C93E3 /* 45.76.147.227/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4CB133 /* 45.76.177.51/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4D2DFA /* 45.77.45.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4D34B1 /* 45.77.52.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4DC427 /* 45.77.196.39/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4DE231 /* 45.77.226.49/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4DF0B7 /* 45.77.240.183/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F0E8D /* 45.79.14.141/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F1814 /* 45.79.24.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F279C /* 45.79.39.156/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F2961 /* 45.79.41.97/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F2981 /* 45.79.41.129/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F3328 /* 45.79.51.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F3515 /* 45.79.53.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F4693 /* 45.79.70.147/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F46DB /* 45.79.70.219/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F4916 /* 45.79.73.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F4C19 /* 45.79.76.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F4C59 /* 45.79.76.89/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F4CAE /* 45.79.76.174/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F5913 /* 45.79.89.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F5985 /* 45.79.89.133/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F5B7E /* 45.79.91.126/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F5C5E /* 45.79.92.94/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F5FD3 /* 45.79.95.211/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F5FF4 /* 45.79.95.244/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F5FF6 /* 45.79.95.246/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F6C82 /* 45.79.108.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F6D37 /* 45.79.109.55/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F70E1 /* 45.79.112.225/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F7961 /* 45.79.121.97/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F7AB5 /* 45.79.122.181/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F7C09 /* 45.79.124.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F7C79 /* 45.79.124.121/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F7CD0 /* 45.79.124.208/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F7CEA /* 45.79.124.234/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F7E4C /* 45.79.126.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F8A08 /* 45.79.138.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F8AAB /* 45.79.138.171/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F90DE /* 45.79.144.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F9D67 /* 45.79.157.103/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4F9F34 /* 45.79.159.52/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4FB599 /* 45.79.181.153/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4FB5E4 /* 45.79.181.228/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4FC215 /* 45.79.194.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4FC59B /* 45.79.197.155/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4FC743 /* 45.79.199.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4FCEDC /* 45.79.206.220/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4FDACD /* 45.79.218.205/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4FDE0D /* 45.79.222.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4FDFA4 /* 45.79.223.164/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4FEE43 /* 45.79.238.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D4FFCAF /* 45.79.252.175/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D51075F /* 45.81.7.95/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D52A754 /* 45.82.167.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D54FD1C /* 45.84.253.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D54FD1C /* 45.84.253.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D5640D2 /* 45.86.64.210/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D572B6C /* 45.87.43.108/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D58B7AD /* 45.88.183.173/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D58B7AD /* 45.88.183.173/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D5A0578 /* 45.90.5.120/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D5A3A37 /* 45.90.58.55/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D5A8D6A /* 45.90.141.106/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D5B6512 /* 45.91.101.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D5B65E3 /* 45.91.101.227/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D5CEEF6 /* 45.92.238.246/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D5FEB56 /* 45.95.235.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D5FEBC5 /* 45.95.235.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D728204 /* 45.114.130.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D77CBAA /* 45.119.203.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D7B7665 /* 45.123.118.101/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D7C3584 /* 45.124.53.132/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D7D412D /* 45.125.65.45/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D7D4176 /* 45.125.65.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D7DA63A /* 45.125.166.58/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D803DAA /* 45.128.61.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D8085CE /* 45.128.133.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D8085F2 /* 45.128.133.242/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D810374 /* 45.129.3.116/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D81601E /* 45.129.96.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D81B7EF /* 45.129.183.239/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D81B7EF /* 45.129.183.239/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D84F425 /* 45.132.244.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D84F626 /* 45.132.246.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D85C023 /* 45.133.192.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D85C027 /* 45.133.192.39/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D899B38 /* 45.137.155.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D899B40 /* 45.137.155.64/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D899B72 /* 45.137.155.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D8CAABB /* 45.140.170.187/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D8D9C6B /* 45.141.156.107/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D8D9D32 /* 45.141.157.50/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D8D9DE2 /* 45.141.157.226/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D8D9F3F /* 45.141.159.63/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D8EB310 /* 45.142.179.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D8EB3A1 /* 45.142.179.161/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D8EB3A1 /* 45.142.179.161/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D8F8B31 /* 45.143.139.49/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D93E6C5 /* 45.147.230.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D964037 /* 45.150.64.55/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D97A70A /* 45.151.167.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D97A70A /* 45.151.167.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D99A002 /* 45.153.160.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D99A081 /* 45.153.160.129/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D99A082 /* 45.153.160.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D99F040 /* 45.153.240.64/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9A23D2 /* 45.154.35.210/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9A23D3 /* 45.154.35.211/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9A23D4 /* 45.154.35.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9A23D5 /* 45.154.35.213/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9A23D6 /* 45.154.35.214/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9A23D7 /* 45.154.35.215/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9A23D8 /* 45.154.35.216/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9A23D9 /* 45.154.35.217/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9A23DA /* 45.154.35.218/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9A23DB /* 45.154.35.219/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9A23DC /* 45.154.35.220/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9A23DD /* 45.154.35.221/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9A23DE /* 45.154.35.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9A23EB /* 45.154.35.235/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9A23EC /* 45.154.35.236/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9AA892 /* 45.154.168.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9AA893 /* 45.154.168.147/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9AA8C9 /* 45.154.168.201/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9AFF42 /* 45.154.255.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9AFF43 /* 45.154.255.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9AFF44 /* 45.154.255.68/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9AFF45 /* 45.154.255.69/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9AFF46 /* 45.154.255.70/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9AFF47 /* 45.154.255.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9AFF48 /* 45.154.255.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9AFF49 /* 45.154.255.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9AFF4A /* 45.154.255.74/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9AFF4B /* 45.154.255.75/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9AFF93 /* 45.154.255.147/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9B2AF0 /* 45.155.42.240/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9BADC6 /* 45.155.173.198/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9C1609 /* 45.156.22.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9C1614 /* 45.156.22.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9C163B /* 45.156.22.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9C1670 /* 45.156.22.112/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9C16E8 /* 45.156.22.232/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9C1785 /* 45.156.23.133/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9C17AF /* 45.156.23.175/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9C17E0 /* 45.156.23.224/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9C1830 /* 45.156.24.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9C1841 /* 45.156.24.65/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9C1863 /* 45.156.24.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9C1887 /* 45.156.24.135/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9C18A5 /* 45.156.24.165/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9C18C6 /* 45.156.24.198/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2D9EC79B /* 45.158.199.155/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2DAD8229 /* 45.173.130.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2DB2B561 /* 45.178.181.97/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2DE884C1 /* 45.232.132.193/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2DF95A1A /* 45.249.90.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E040B79 /* 46.4.11.121/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E0420B8 /* 46.4.32.184/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E0420B8 /* 46.4.32.184/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E0422F2 /* 46.4.34.242/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E04313E /* 46.4.49.62/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E0437B1 /* 46.4.55.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E044E94 /* 46.4.78.148/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E04585C /* 46.4.88.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E0466FE /* 46.4.102.254/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E047349 /* 46.4.115.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E047AAD /* 46.4.122.173/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E047BB6 /* 46.4.123.182/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E047CA5 /* 46.4.124.165/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E049051 /* 46.4.144.81/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E04AE34 /* 46.4.174.52/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E04B030 /* 46.4.176.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E04B768 /* 46.4.183.104/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E04D964 /* 46.4.217.100/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E04E968 /* 46.4.233.104/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E113FD6 /* 46.17.63.214/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E138D52 /* 46.19.141.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E138D53 /* 46.19.141.83/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E138D54 /* 46.19.141.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E138D55 /* 46.19.141.85/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E138D56 /* 46.19.141.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E138F8B /* 46.19.143.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E142374 /* 46.20.35.116/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E159313 /* 46.21.147.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E1618ED /* 46.22.24.237/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E166874 /* 46.22.104.116/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E16D4E6 /* 46.22.212.230/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E174851 /* 46.23.72.81/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E1C6C3F /* 46.28.108.63/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E1C6DE7 /* 46.28.109.231/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E1C6EF4 /* 46.28.110.244/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E1CCF6B /* 46.28.207.107/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E1DA3E1 /* 46.29.163.225/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E1DF8EE /* 46.29.248.238/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E1DFA1B /* 46.29.250.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E24264C /* 46.36.38.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E242786 /* 46.36.39.134/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E2630E1 /* 46.38.48.225/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E263312 /* 46.38.51.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E26EB0E /* 46.38.235.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E26ECFA /* 46.38.236.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E26EDDD /* 46.38.237.221/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E26F220 /* 46.38.242.32/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E26FB07 /* 46.38.251.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E26FDA1 /* 46.38.253.161/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E26FEDF /* 46.38.254.223/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E26FFA5 /* 46.38.255.165/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E276109 /* 46.39.97.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E27B73C /* 46.39.183.60/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E27FEBD /* 46.39.254.189/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E29891C /* 46.41.137.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E29944B /* 46.41.148.75/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E2B0F59 /* 46.43.15.89/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E3B4158 /* 46.59.65.88/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E3B4414 /* 46.59.68.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E3BC476 /* 46.59.196.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E3BC476 /* 46.59.196.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E481F74 /* 46.72.31.116/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E48CD03 /* 46.72.205.3/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E50E696 /* 46.80.230.150/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E510D13 /* 46.81.13.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E5A2BEB /* 46.90.43.235/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E656B8B /* 46.101.107.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E65A5C5 /* 46.101.165.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E65B2BE /* 46.101.178.190/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E65B7A0 /* 46.101.183.160/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E65C0E6 /* 46.101.192.230/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E693799 /* 46.105.55.153/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E6979E4 /* 46.105.121.228/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E69E36D /* 46.105.227.109/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E7D2089 /* 46.125.32.137/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E7EA0D0 /* 46.126.160.208/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E7EA1CD /* 46.126.161.205/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E80082E /* 46.128.8.46/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E8AF3EF /* 46.138.243.239/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E8B6FBD /* 46.139.111.189/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E8E12EE /* 46.142.18.238/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2E90A6FA /* 46.144.166.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA12865 /* 46.161.40.101/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA34CAA /* 46.163.76.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA4F2DA /* 46.164.242.218/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA593A8 /* 46.165.147.168/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA5BA31 /* 46.165.186.49/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA5D641 /* 46.165.214.65/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA5DDCF /* 46.165.221.207/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA5E605 /* 46.165.230.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA5F59A /* 46.165.245.154/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA5FAE0 /* 46.165.250.224/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA5FDB4 /* 46.165.253.180/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA5FDC7 /* 46.165.253.199/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA5FE28 /* 46.165.254.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA680AD /* 46.166.128.173/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6819C /* 46.166.129.156/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA68B6F /* 46.166.139.111/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA697D9 /* 46.166.151.217/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6A014 /* 46.166.160.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6A115 /* 46.166.161.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6A11A /* 46.166.161.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6A12E /* 46.166.161.46/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6A132 /* 46.166.161.50/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6A142 /* 46.166.161.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6A14B /* 46.166.161.75/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6A14F /* 46.166.161.79/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6A1A6 /* 46.166.161.166/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6A1B5 /* 46.166.161.181/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6A1B9 /* 46.166.161.185/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6A1BD /* 46.166.161.189/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6AD04 /* 46.166.173.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6AD05 /* 46.166.173.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6AD1D /* 46.166.173.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6AD2D /* 46.166.173.45/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6AD9A /* 46.166.173.154/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6AD9B /* 46.166.173.155/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6ADA1 /* 46.166.173.161/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6ADA9 /* 46.166.173.169/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6ADAE /* 46.166.173.174/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6ADB0 /* 46.166.173.176/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6ADC3 /* 46.166.173.195/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6ADC9 /* 46.166.173.201/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6AF10 /* 46.166.175.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6AF1D /* 46.166.175.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6B614 /* 46.166.182.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA6BB4D /* 46.166.187.77/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA7F438 /* 46.167.244.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA7F439 /* 46.167.244.57/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA7F43A /* 46.167.244.58/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA7F43B /* 46.167.244.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EA7F43C /* 46.167.244.60/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EADDA6F /* 46.173.218.111/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EB612F5 /* 46.182.18.245/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EB615F8 /* 46.182.21.248/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EB66ABE /* 46.182.106.190/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EB7773A /* 46.183.119.58/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EBC0640 /* 46.188.6.64/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EBC0640 /* 46.188.6.64/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EC2BFAF /* 46.194.191.175/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EC2BFAF /* 46.194.191.175/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EDFD205 /* 46.223.210.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EDFD205 /* 46.223.210.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EDFE538 /* 46.223.229.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EE3435C /* 46.227.67.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EE34365 /* 46.227.67.101/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EE3446A /* 46.227.68.106/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EE53776 /* 46.229.55.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EE75DD8 /* 46.231.93.216/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EE8F850 /* 46.232.248.80/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EE8F8F3 /* 46.232.248.243/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EE8F98A /* 46.232.249.138/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EE8F98A /* 46.232.249.138/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EE8FA33 /* 46.232.250.51/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EE8FB1D /* 46.232.251.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EE8FB1D /* 46.232.251.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EE8FBBF /* 46.232.251.191/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EEBB65B /* 46.235.182.91/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EF4E962 /* 46.244.233.98/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EF6235E /* 46.246.35.94/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EF67E3E /* 46.246.126.62/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EF9256D /* 46.249.37.109/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2EF93B71 /* 46.249.59.113/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2F3123F2 /* 47.49.35.242/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2F343B64 /* 47.52.59.100/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2F352B48 /* 47.53.43.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2F38554F /* 47.56.85.79/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2F385E63 /* 47.56.94.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2F385E9F /* 47.56.94.159/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2F38C023 /* 47.56.192.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2F38C5D7 /* 47.56.197.215/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2F38C5F6 /* 47.56.197.246/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2F38C698 /* 47.56.198.152/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2F38D41B /* 47.56.212.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2F38E925 /* 47.56.233.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2F84095E /* 47.132.9.94/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2F84A1C2 /* 47.132.161.194/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2F904514 /* 47.144.69.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2F97960D /* 47.151.150.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2F98C7A7 /* 47.152.199.167/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2FB8302E /* 47.184.48.46/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2FBE56FC /* 47.190.86.252/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2FF494C5 /* 47.244.148.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2FFC1AF0 /* 47.252.26.240/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2FFE196B /* 47.254.25.107/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2FFE835D /* 47.254.131.93/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2FFE8608 /* 47.254.134.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2FFE8698 /* 47.254.134.152/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2FFE9217 /* 47.254.146.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2FFE98F2 /* 47.254.152.242/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x2FFEACEA /* 47.254.172.234/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x310C0661 /* 49.12.6.97/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x310C0A27 /* 49.12.10.39/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x310C2CDE /* 49.12.44.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x310C5292 /* 49.12.82.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x310C5DF0 /* 49.12.93.240/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x310C73D2 /* 49.12.115.210/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x31326BDD /* 49.50.107.221/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x31CD990E /* 49.205.153.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x31D4A626 /* 49.212.166.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3207014C /* 50.7.1.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3207081D /* 50.7.8.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x32074AAA /* 50.7.74.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x32074AAA /* 50.7.74.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x32074AAB /* 50.7.74.171/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x32074AAB /* 50.7.74.171/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x32074AAC /* 50.7.74.172/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x32074AAC /* 50.7.74.172/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x32074AAD /* 50.7.74.173/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x32074AAD /* 50.7.74.173/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x32074AAE /* 50.7.74.174/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x32074AAE /* 50.7.74.174/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x32077343 /* 50.7.115.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3207743A /* 50.7.116.58/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x32077573 /* 50.7.117.115/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3207972F /* 50.7.151.47/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x32079757 /* 50.7.151.87/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3207B222 /* 50.7.178.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3207B292 /* 50.7.178.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3207B3CA /* 50.7.179.202/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3207BA26 /* 50.7.186.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3207F8A2 /* 50.7.248.162/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3215B72E /* 50.21.183.46/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x321FFC1C /* 50.31.252.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3227AF58 /* 50.39.175.88/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3235724F /* 50.53.114.79/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3241AD3F /* 50.65.173.63/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3248794F /* 50.72.121.79/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x32532107 /* 50.83.33.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x327402E9 /* 50.116.2.233/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x32740C24 /* 50.116.12.36/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3274258D /* 50.116.37.141/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x32742F8B /* 50.116.47.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3274334E /* 50.116.51.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x32C13BC1 /* 50.193.59.193/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x32C18F2A /* 50.193.143.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x32C50BBC /* 50.197.11.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x32C50BBD /* 50.197.11.189/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x32ECC9DA /* 50.236.201.218/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x32FEDA25 /* 50.254.218.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F005C /* 51.15.0.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F00AA /* 51.15.0.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F00AA /* 51.15.0.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F0756 /* 51.15.7.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F0998 /* 51.15.9.152/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F12A3 /* 51.15.18.163/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F1B0D /* 51.15.27.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F228A /* 51.15.34.138/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F22A5 /* 51.15.34.165/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F24B7 /* 51.15.36.183/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F25B9 /* 51.15.37.185/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F2741 /* 51.15.39.65/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F2AAC /* 51.15.42.172/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F2BCD /* 51.15.43.205/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F2C9D /* 51.15.44.157/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F2CFB /* 51.15.44.251/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F2D34 /* 51.15.45.52/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F2E0F /* 51.15.46.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F2F11 /* 51.15.47.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F2F8B /* 51.15.47.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F3224 /* 51.15.50.36/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F3410 /* 51.15.52.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F3675 /* 51.15.54.117/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F3AD4 /* 51.15.58.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F3B0F /* 51.15.59.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F3C5D /* 51.15.60.93/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F3E82 /* 51.15.62.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F41F3 /* 51.15.65.243/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F489F /* 51.15.72.159/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F4961 /* 51.15.73.97/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F4A82 /* 51.15.74.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F4B78 /* 51.15.75.120/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F4C38 /* 51.15.76.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F4DF4 /* 51.15.77.244/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F4E00 /* 51.15.78.0/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F5007 /* 51.15.80.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F500E /* 51.15.80.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F5194 /* 51.15.81.148/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F550D /* 51.15.85.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F5914 /* 51.15.89.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F59DA /* 51.15.89.218/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F5B07 /* 51.15.91.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F5B4E /* 51.15.91.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F5BD9 /* 51.15.91.217/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F62F0 /* 51.15.98.240/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F63B6 /* 51.15.99.182/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F7013 /* 51.15.112.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F714F /* 51.15.113.79/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F7154 /* 51.15.113.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F7155 /* 51.15.113.85/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F73D9 /* 51.15.115.217/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F760A /* 51.15.118.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F7A67 /* 51.15.122.103/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F7AEA /* 51.15.122.234/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F7C01 /* 51.15.124.1/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F8736 /* 51.15.135.54/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F8DC1 /* 51.15.141.193/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F8E00 /* 51.15.142.0/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F96E4 /* 51.15.150.228/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330F96E4 /* 51.15.150.228/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330FAD7D /* 51.15.173.125/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330FADD3 /* 51.15.173.211/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330FAE2F /* 51.15.174.47/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330FAE49 /* 51.15.174.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330FB194 /* 51.15.177.148/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330FB668 /* 51.15.182.104/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330FB9C9 /* 51.15.185.201/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330FBBD1 /* 51.15.187.209/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330FBDD1 /* 51.15.189.209/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330FBE6D /* 51.15.190.109/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330FCE48 /* 51.15.206.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330FDB16 /* 51.15.219.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330FDBE1 /* 51.15.219.225/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330FDCAB /* 51.15.220.171/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330FDFC7 /* 51.15.223.199/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330FE1D8 /* 51.15.225.216/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330FE4DE /* 51.15.228.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330FE627 /* 51.15.230.39/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330FE813 /* 51.15.232.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330FEA88 /* 51.15.234.136/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330FEBD3 /* 51.15.235.211/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330FF316 /* 51.15.243.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330FF6AA /* 51.15.246.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330FF951 /* 51.15.249.81/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330FF989 /* 51.15.249.137/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x330FFBA6 /* 51.15.251.166/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x332633C2 /* 51.38.51.194/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33263630 /* 51.38.54.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33264088 /* 51.38.64.136/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x332641A0 /* 51.38.65.160/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x332645D2 /* 51.38.69.210/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33265004 /* 51.38.80.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33265029 /* 51.38.80.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33265072 /* 51.38.80.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33265085 /* 51.38.80.133/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x332650ED /* 51.38.80.237/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33265127 /* 51.38.81.39/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33265157 /* 51.38.81.87/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3326516D /* 51.38.81.109/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x332651D3 /* 51.38.81.211/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33265208 /* 51.38.82.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33265272 /* 51.38.82.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33265360 /* 51.38.83.96/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33265AC5 /* 51.38.90.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33266205 /* 51.38.98.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33266B75 /* 51.38.107.117/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33266B7A /* 51.38.107.122/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x332673BF /* 51.38.115.191/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33268668 /* 51.38.134.104/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33269360 /* 51.38.147.96/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3326A2E8 /* 51.38.162.232/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3326A49D /* 51.38.164.157/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3326A49D /* 51.38.164.157/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3326E95D /* 51.38.233.93/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334405CD /* 51.68.5.205/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33441C8D /* 51.68.28.141/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33446AA2 /* 51.68.106.162/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3344882C /* 51.68.136.44/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33448BBA /* 51.68.139.186/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33448C5E /* 51.68.140.94/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33448FD4 /* 51.68.143.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33448FD4 /* 51.68.143.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33449B55 /* 51.68.155.85/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33449B6C /* 51.68.155.108/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33449B8F /* 51.68.155.143/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3344AA4A /* 51.68.170.74/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3344AAF7 /* 51.68.170.247/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3344B61E /* 51.68.182.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3344B98D /* 51.68.185.141/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3344BA3B /* 51.68.186.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3344C5AE /* 51.68.197.174/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3344C5DC /* 51.68.197.220/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3344CDB5 /* 51.68.205.181/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3344D42C /* 51.68.212.44/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3344D449 /* 51.68.212.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3344D4A8 /* 51.68.212.168/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3344D520 /* 51.68.213.32/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3344D5F7 /* 51.68.213.247/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3344D70D /* 51.68.215.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3344D7AE /* 51.68.215.174/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3344D7F9 /* 51.68.215.249/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3344E6AD /* 51.68.230.173/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B2E23 /* 51.75.46.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B3476 /* 51.75.52.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B3654 /* 51.75.54.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B3658 /* 51.75.54.88/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B3DC2 /* 51.75.61.194/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B4015 /* 51.75.64.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B4017 /* 51.75.64.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B4054 /* 51.75.64.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B40BB /* 51.75.64.187/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B40BB /* 51.75.64.187/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B4166 /* 51.75.65.102/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B441C /* 51.75.68.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B46F6 /* 51.75.70.246/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B476C /* 51.75.71.108/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B4B12 /* 51.75.75.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B4BCA /* 51.75.75.202/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B52A6 /* 51.75.82.166/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B5572 /* 51.75.85.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B7FC8 /* 51.75.127.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B81CC /* 51.75.129.204/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B8F91 /* 51.75.143.145/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B8F92 /* 51.75.143.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B8F96 /* 51.75.143.150/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B8FF1 /* 51.75.143.241/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B902B /* 51.75.144.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B9911 /* 51.75.153.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334B9913 /* 51.75.153.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334BA237 /* 51.75.162.55/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334BA3C0 /* 51.75.163.192/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334BA3F9 /* 51.75.163.249/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334BA790 /* 51.75.167.144/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334BAB88 /* 51.75.171.136/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334BC2DE /* 51.75.194.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334BC809 /* 51.75.200.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334BCE0C /* 51.75.206.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334BCE0C /* 51.75.206.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334BE59C /* 51.75.229.156/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334BF6CF /* 51.75.246.207/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334BF7F3 /* 51.75.247.243/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334BFE3F /* 51.75.254.63/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334D0FF0 /* 51.77.15.240/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334D235A /* 51.77.35.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334D27FF /* 51.77.39.255/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334D32E5 /* 51.77.50.229/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334D34D8 /* 51.77.52.216/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334D3A90 /* 51.77.58.144/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334D3A90 /* 51.77.58.144/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334D6C21 /* 51.77.108.33/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334D6F43 /* 51.77.111.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334D88F1 /* 51.77.136.241/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334D9522 /* 51.77.149.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334D9EDA /* 51.77.158.218/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334DCA29 /* 51.77.202.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334DFBC0 /* 51.77.251.192/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334F16E0 /* 51.79.22.224/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334F3327 /* 51.79.51.39/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334F332A /* 51.79.51.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334F336F /* 51.79.51.111/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334F3586 /* 51.79.53.134/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334F358B /* 51.79.53.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334F3591 /* 51.79.53.145/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334F3592 /* 51.79.53.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334F42C4 /* 51.79.66.196/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334F4688 /* 51.79.70.136/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334F4A6A /* 51.79.74.106/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334F4ACD /* 51.79.74.205/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334F56AD /* 51.79.86.173/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334F56AE /* 51.79.86.174/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334F56AF /* 51.79.86.175/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334F56B1 /* 51.79.86.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334F56B4 /* 51.79.86.180/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334F56B5 /* 51.79.86.181/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x334F9E45 /* 51.79.158.69/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x335120F1 /* 51.81.32.241/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33512347 /* 51.81.35.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33517515 /* 51.81.117.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33532528 /* 51.83.37.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33538154 /* 51.83.129.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33538154 /* 51.83.129.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3353832A /* 51.83.131.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33538404 /* 51.83.132.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33538555 /* 51.83.133.85/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3353BBC9 /* 51.83.187.201/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3353BBC9 /* 51.83.187.201/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3353CB79 /* 51.83.203.121/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3353D9DD /* 51.83.217.221/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3353ED3B /* 51.83.237.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3353FE99 /* 51.83.254.153/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33590628 /* 51.89.6.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3359174A /* 51.89.23.74/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3359174A /* 51.89.23.74/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3359179D /* 51.89.23.157/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33596441 /* 51.89.100.65/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33597E16 /* 51.89.126.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33597E18 /* 51.89.126.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33598F98 /* 51.89.143.152/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33598F99 /* 51.89.143.153/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33598F9B /* 51.89.143.155/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33598F9D /* 51.89.143.157/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33598F9E /* 51.89.143.158/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33598F9F /* 51.89.143.159/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3359941E /* 51.89.148.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x335994A9 /* 51.89.148.169/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3359989E /* 51.89.152.158/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3359A459 /* 51.89.164.89/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3359A45C /* 51.89.164.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3359A4CD /* 51.89.164.205/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3359A55A /* 51.89.165.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3359A5C5 /* 51.89.165.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3359A642 /* 51.89.166.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3359A643 /* 51.89.166.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3359A66C /* 51.89.166.108/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3359C872 /* 51.89.200.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x335B087D /* 51.91.8.125/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x335B49C2 /* 51.91.73.194/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x335B4DDB /* 51.91.77.219/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x335B79FF /* 51.91.121.255/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339A273A /* 51.154.39.58/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339A3560 /* 51.154.53.96/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339A3C22 /* 51.154.60.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339AC349 /* 51.154.195.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E41F3 /* 51.158.65.243/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E4576 /* 51.158.69.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E4C77 /* 51.158.76.119/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E4E1B /* 51.158.78.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E4FC6 /* 51.158.79.198/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E6F9D /* 51.158.111.157/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E7762 /* 51.158.119.98/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E925D /* 51.158.146.93/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E9292 /* 51.158.146.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E9298 /* 51.158.146.152/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E92F0 /* 51.158.146.240/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E9319 /* 51.158.147.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E931A /* 51.158.147.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E9324 /* 51.158.147.36/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E9338 /* 51.158.147.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E9349 /* 51.158.147.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E938E /* 51.158.147.142/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E9390 /* 51.158.147.144/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E93C7 /* 51.158.147.199/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E9480 /* 51.158.148.128/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E9480 /* 51.158.148.128/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E94E6 /* 51.158.148.230/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E94E6 /* 51.158.148.230/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E9857 /* 51.158.152.87/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E985A /* 51.158.152.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E985D /* 51.158.152.93/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E9887 /* 51.158.152.135/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E98D5 /* 51.158.152.213/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E9A70 /* 51.158.154.112/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339E9A7A /* 51.158.154.122/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339EA533 /* 51.158.165.51/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339EA5D4 /* 51.158.165.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339EA6E6 /* 51.158.166.230/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339EAA1C /* 51.158.170.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339EAB23 /* 51.158.171.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339EAD89 /* 51.158.173.137/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339EB4F6 /* 51.158.180.246/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339EBB6E /* 51.158.187.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339F2283 /* 51.159.34.131/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339F3980 /* 51.159.57.128/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339F3B66 /* 51.159.59.102/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339F3BAE /* 51.159.59.174/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339F3BB8 /* 51.159.59.184/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339F4387 /* 51.159.67.135/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x339FA94A /* 51.159.169.74/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33A10BE4 /* 51.161.11.228/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33A12114 /* 51.161.33.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33A12371 /* 51.161.35.113/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33A12BEB /* 51.161.43.235/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33A12BEC /* 51.161.43.236/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33AE0F12 /* 51.174.15.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33AEC34E /* 51.174.195.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33AF7943 /* 51.175.121.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33AFF5A2 /* 51.175.245.162/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33B21180 /* 51.178.17.128/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33B25119 /* 51.178.81.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33B252C9 /* 51.178.82.201/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33B25390 /* 51.178.83.144/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33B25689 /* 51.178.86.137/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33C3298E /* 51.195.41.142/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33C32AE2 /* 51.195.42.226/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33C32C0A /* 51.195.44.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33C33772 /* 51.195.55.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33C36738 /* 51.195.103.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33C388BE /* 51.195.136.190/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33C39412 /* 51.195.148.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33C39412 /* 51.195.148.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33C3A6A0 /* 51.195.166.160/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33C3A6A1 /* 51.195.166.161/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33C3C8B5 /* 51.195.200.181/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D22296 /* 51.210.34.150/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2273C /* 51.210.39.60/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2507F /* 51.210.80.127/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F20C /* 51.210.242.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F21B /* 51.210.242.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F21E /* 51.210.242.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F22C /* 51.210.242.44/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F22D /* 51.210.242.45/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F236 /* 51.210.242.54/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F239 /* 51.210.242.57/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F247 /* 51.210.242.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F253 /* 51.210.242.83/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F264 /* 51.210.242.100/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F265 /* 51.210.242.101/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F266 /* 51.210.242.102/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F26A /* 51.210.242.106/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F272 /* 51.210.242.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F275 /* 51.210.242.117/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F280 /* 51.210.242.128/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F281 /* 51.210.242.129/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F282 /* 51.210.242.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F283 /* 51.210.242.131/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F285 /* 51.210.242.133/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F287 /* 51.210.242.135/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F288 /* 51.210.242.136/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F28F /* 51.210.242.143/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F290 /* 51.210.242.144/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F2A0 /* 51.210.242.160/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F2A9 /* 51.210.242.169/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F2AF /* 51.210.242.175/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F2B0 /* 51.210.242.176/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F2B1 /* 51.210.242.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F2B6 /* 51.210.242.182/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F2C0 /* 51.210.242.192/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F2C7 /* 51.210.242.199/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F2C8 /* 51.210.242.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F2D0 /* 51.210.242.208/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F2D4 /* 51.210.242.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F2D5 /* 51.210.242.213/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F2D8 /* 51.210.242.216/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F2F2 /* 51.210.242.242/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F2F4 /* 51.210.242.244/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F3AD /* 51.210.243.173/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F3B9 /* 51.210.243.185/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F3C4 /* 51.210.243.196/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F3C8 /* 51.210.243.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F3CE /* 51.210.243.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33D2F64E /* 51.210.246.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33DE0D18 /* 51.222.13.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33DE1371 /* 51.222.19.113/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33FE2397 /* 51.254.35.151/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33FE2D2B /* 51.254.45.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33FE305D /* 51.254.48.93/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33FE60D0 /* 51.254.96.208/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33FE7286 /* 51.254.114.134/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33FE8806 /* 51.254.136.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33FE88C3 /* 51.254.136.195/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33FF276E /* 51.255.39.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33FF2D90 /* 51.255.45.144/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33FF6A55 /* 51.255.106.85/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x33FF96B1 /* 51.255.150.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3405BBCD /* 52.5.187.205/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x34084499 /* 52.8.68.153/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x340A368F /* 52.10.54.143/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x342F5B96 /* 52.47.91.150/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3434E60D /* 52.52.230.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3435F238 /* 52.53.242.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x343F8694 /* 52.63.134.148/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x345BCC23 /* 52.91.204.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x347771C3 /* 52.119.113.195/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x348D2159 /* 52.141.33.89/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x348F9D5C /* 52.143.157.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x34A5813C /* 52.165.129.60/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x34CD0FEF /* 52.205.15.239/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x34D65EA3 /* 52.214.94.163/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x34E70B22 /* 52.231.11.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x362467DF /* 54.36.103.223/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x362467E7 /* 54.36.103.231/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x36246CA2 /* 54.36.108.162/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x362470EA /* 54.36.112.234/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x362470ED /* 54.36.112.237/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x362470EF /* 54.36.112.239/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x362470F1 /* 54.36.112.241/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x362470F4 /* 54.36.112.244/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3624789C /* 54.36.120.156/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3624A5AA /* 54.36.165.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3624A656 /* 54.36.166.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3624AC20 /* 54.36.172.32/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3624B730 /* 54.36.183.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3624E3F7 /* 54.36.227.247/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3624EDA3 /* 54.36.237.163/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3624EECE /* 54.36.238.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x362510F1 /* 54.37.16.241/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3625133C /* 54.37.19.60/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x36251341 /* 54.37.19.65/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x36251346 /* 54.37.19.70/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x36251351 /* 54.37.19.81/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x36251353 /* 54.37.19.83/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x36251354 /* 54.37.19.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x36251358 /* 54.37.19.88/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3625136C /* 54.37.19.108/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x36251395 /* 54.37.19.149/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x36258A68 /* 54.37.138.104/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x36258B76 /* 54.37.139.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3625C89B /* 54.37.200.155/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3625C89D /* 54.37.200.157/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3625CF25 /* 54.37.207.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3625CF52 /* 54.37.207.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3625CF54 /* 54.37.207.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3625E516 /* 54.37.229.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3625E83D /* 54.37.232.61/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3625E873 /* 54.37.232.115/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3625EA42 /* 54.37.234.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3626163D /* 54.38.22.61/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3626242C /* 54.38.36.44/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x36263465 /* 54.38.52.101/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x36263489 /* 54.38.52.137/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x36263489 /* 54.38.52.137/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x36263704 /* 54.38.55.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x362651E7 /* 54.38.81.231/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3626BB36 /* 54.38.187.54/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3626D00D /* 54.38.208.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3626DB85 /* 54.38.219.133/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3626DBF8 /* 54.38.219.248/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3626DBF9 /* 54.38.219.249/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3626DBFA /* 54.38.219.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3626DBFB /* 54.38.219.251/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x36271049 /* 54.39.16.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3627321C /* 54.39.50.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x36275EA2 /* 54.39.94.162/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3627B03C /* 54.39.176.60/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3627CACA /* 54.39.202.202/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x36434BD9 /* 54.67.75.217/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x365AEA7A /* 54.90.234.122/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x365D3C91 /* 54.93.60.145/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x365D4D46 /* 54.93.77.70/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3699F91A /* 54.153.249.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x369FE1DB /* 54.159.225.219/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x36A50625 /* 54.165.6.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x36B46A83 /* 54.180.106.131/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x36B7C9FF /* 54.183.201.255/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x36FB578F /* 54.251.87.143/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3A096E13 /* 58.9.110.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3B666F4B /* 59.102.111.75/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3B737FD0 /* 59.115.127.208/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3C8B7BDE /* 60.139.123.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3CF130C2 /* 60.241.48.194/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3D1B9613 /* 61.27.150.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3D5C16EB /* 61.92.22.235/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3DF58AD9 /* 61.245.138.217/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E04074E /* 62.4.7.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E040F54 /* 62.4.15.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E0C7674 /* 62.12.118.116/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E1F0526 /* 62.31.5.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E2A8AA2 /* 62.42.138.162/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E36B176 /* 62.54.177.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E3FFEDD /* 62.63.254.221/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E416AA3 /* 62.65.106.163/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E4852DE /* 62.72.82.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E4B8ED7 /* 62.75.142.215/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E4B9BE5 /* 62.75.155.229/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E4EC204 /* 62.78.194.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E4EC454 /* 62.78.196.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E50E331 /* 62.80.227.49/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E669444 /* 62.102.148.68/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E669444 /* 62.102.148.68/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E669445 /* 62.102.148.69/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E6D0473 /* 62.109.4.115/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E6D0A96 /* 62.109.10.150/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E6D14FD /* 62.109.20.253/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E700A9A /* 62.112.10.154/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E71D16D /* 62.113.209.109/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E71D16E /* 62.113.209.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E71D372 /* 62.113.211.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E71D8AD /* 62.113.216.173/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E71D8B1 /* 62.113.216.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E71E37C /* 62.113.227.124/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E859D8B /* 62.133.157.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E8D2496 /* 62.141.36.150/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E8D2645 /* 62.141.38.69/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E8D27A0 /* 62.141.39.160/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E8D30AF /* 62.141.48.175/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E8D30B1 /* 62.141.48.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E8D335A /* 62.141.51.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E8FC099 /* 62.143.192.153/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E8FDA0C /* 62.143.218.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3E9502BC /* 62.149.2.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3EA803D4 /* 62.168.3.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3EAB85FA /* 62.171.133.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3EAB89A9 /* 62.171.137.169/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3EAB8E03 /* 62.171.142.3/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3EAB909B /* 62.171.144.155/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3EAB9125 /* 62.171.145.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3EAB9FA4 /* 62.171.159.164/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3EABA574 /* 62.171.165.116/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3EABB406 /* 62.171.180.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3EABBA42 /* 62.171.186.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3EABBD53 /* 62.171.189.83/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3EABBF3F /* 62.171.191.63/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3EAD8B9D /* 62.173.139.157/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3EB201A0 /* 62.178.1.160/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3EB26980 /* 62.178.105.128/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3EB2C382 /* 62.178.195.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3EC37614 /* 62.195.118.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3EC5CFB6 /* 62.197.207.182/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3ED209B2 /* 62.210.9.178/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3ED22552 /* 62.210.37.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3ED24896 /* 62.210.72.150/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3ED253CF /* 62.210.83.207/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3ED253CF /* 62.210.83.207/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3ED2560F /* 62.210.86.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3ED25909 /* 62.210.89.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3ED263EE /* 62.210.99.238/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3ED2692E /* 62.210.105.46/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3ED2692E /* 62.210.105.46/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3ED26974 /* 62.210.105.116/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3ED26D30 /* 62.210.109.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3ED27B18 /* 62.210.123.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3ED27D82 /* 62.210.125.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3ED29461 /* 62.210.148.97/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3ED2B1BD /* 62.210.177.189/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3ED2B577 /* 62.210.181.119/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3ED2CDE4 /* 62.210.205.228/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3ED2CF90 /* 62.210.207.144/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3ED2CF90 /* 62.210.207.144/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3ED2D9CF /* 62.210.217.207/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3ED2F492 /* 62.210.244.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3ED8361D /* 62.216.54.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3EE0CADA /* 62.224.202.218/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3EE3EF20 /* 62.227.239.32/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3EEBC277 /* 62.235.194.119/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3EF08287 /* 62.240.130.135/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3EFB594A /* 62.251.89.74/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3F8C1ECD /* 63.140.30.205/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3F8F35B6 /* 63.143.53.182/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x3FE374A2 /* 63.227.116.162/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4004AF21 /* 64.4.175.33/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x401B17B1 /* 64.27.23.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x402AB3E3 /* 64.42.179.227/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x402AB3ED /* 64.42.179.237/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x404AA0DD /* 64.74.160.221/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x404AA0F7 /* 64.74.160.247/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x404F9884 /* 64.79.152.132/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4053A72D /* 64.83.167.45/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x405ED487 /* 64.94.212.135/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x406273D1 /* 64.98.115.209/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4071201D /* 64.113.32.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4089AE78 /* 64.137.174.120/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4089AF41 /* 64.137.175.65/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4089B068 /* 64.137.176.104/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4089B78E /* 64.137.183.142/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x40C9EA06 /* 64.201.234.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x40E10E6E /* 64.225.14.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x40E127BC /* 64.225.39.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x40E17014 /* 64.225.112.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x40E339B5 /* 64.227.57.181/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x40E345B1 /* 64.227.69.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x40E360A9 /* 64.227.96.169/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x40E36480 /* 64.227.100.128/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x40E368F9 /* 64.227.104.249/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x40E36A99 /* 64.227.106.153/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x40EA6DA0 /* 64.234.109.160/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4118F2F4 /* 65.24.242.244/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4131140A /* 65.49.20.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4131140A /* 65.49.20.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4131140B /* 65.49.20.11/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4131140B /* 65.49.20.11/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4131140C /* 65.49.20.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4131140C /* 65.49.20.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4132CB05 /* 65.50.203.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x415E60E3 /* 65.94.96.227/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x41B57BFE /* 65.181.123.254/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x41B7DA59 /* 65.183.218.89/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4217E387 /* 66.23.227.135/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4237431C /* 66.55.67.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4246CCAF /* 66.70.204.175/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4246CFA8 /* 66.70.207.168/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4246D314 /* 66.70.211.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4246DEF0 /* 66.70.222.240/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4246E4A8 /* 66.70.228.168/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4246E4AE /* 66.70.228.174/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4246F76B /* 66.70.247.107/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x42554AE2 /* 66.85.74.226/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x42555C0F /* 66.85.92.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x426CBD0F /* 66.108.189.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x426F0214 /* 66.111.2.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x426F0283 /* 66.111.2.131/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4292C121 /* 66.146.193.33/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4298B30B /* 66.152.179.11/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x42AFD0F8 /* 66.175.208.248/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x42AFD851 /* 66.175.216.81/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x42AFDECE /* 66.175.222.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x42B7AD1D /* 66.183.173.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x42CE0052 /* 66.206.0.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x42CE008A /* 66.206.0.138/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x42CE041A /* 66.206.4.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x42D04080 /* 66.208.64.128/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x42D3C526 /* 66.211.197.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x42E433CF /* 66.228.51.207/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x42E43A5F /* 66.228.58.95/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x42E43B6A /* 66.228.59.106/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x42E6E6E6 /* 66.230.230.230/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x430750D4 /* 67.7.80.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x43A3810F /* 67.163.129.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x43A3876A /* 67.163.135.106/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x43A5094A /* 67.165.9.74/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x43AA8C53 /* 67.170.140.83/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x43C62510 /* 67.198.37.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x43E14B7D /* 67.225.75.125/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x43F96BC3 /* 67.249.107.195/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x440070A2 /* 68.0.112.162/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x440EB1C4 /* 68.14.177.196/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x44343F61 /* 68.52.63.97/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4442F16F /* 68.66.241.111/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4443201F /* 68.67.32.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x44432020 /* 68.67.32.32/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x44432021 /* 68.67.32.33/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x44432022 /* 68.67.32.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4444832B /* 68.68.131.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4445A691 /* 68.69.166.145/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x448378A5 /* 68.131.120.165/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x448E317A /* 68.142.49.122/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4494F65B /* 68.148.246.91/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x44952BE2 /* 68.149.43.226/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x44A0F2D6 /* 68.160.242.214/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x44B72E15 /* 68.183.46.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x44B78D6F /* 68.183.141.111/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x44B79169 /* 68.183.145.105/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x44B7A3D7 /* 68.183.163.215/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x44B7B659 /* 68.183.182.89/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x44B7B8AE /* 68.183.184.174/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x44B7C2F2 /* 68.183.194.242/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x44B7CC18 /* 68.183.204.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x44B7E682 /* 68.183.230.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x44C4B384 /* 68.196.179.132/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4504EA51 /* 69.4.234.81/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x450B6F25 /* 69.11.111.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x450ED2CA /* 69.14.210.202/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x451ED72A /* 69.30.215.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x453EA2B2 /* 69.62.162.178/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x453ED467 /* 69.62.212.103/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x45402E1B /* 69.64.46.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4546DDFE /* 69.70.221.254/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4577BADD /* 69.119.186.221/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x457CC8FA /* 69.124.200.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x458E9677 /* 69.142.150.119/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x45929385 /* 69.146.147.133/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x45A2656E /* 69.162.101.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x45A4C20A /* 69.164.194.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x45A4D28E /* 69.164.210.142/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x45A4D312 /* 69.164.211.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x45A4DD41 /* 69.164.221.65/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x45A4DD4E /* 69.164.221.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x45A4DE97 /* 69.164.222.151/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x45AE93F1 /* 69.174.147.241/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x45C3810D /* 69.195.129.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x45C3929E /* 69.195.146.158/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x45FB8817 /* 69.251.136.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x462C581F /* 70.44.88.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4633ADF6 /* 70.51.173.246/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x46397C03 /* 70.57.124.3/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x463F6AE6 /* 70.63.106.230/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x463FAA56 /* 70.63.170.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x464487BB /* 70.68.135.187/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4659739D /* 70.89.115.157/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4660C44D /* 70.96.196.77/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x467775CA /* 70.119.117.202/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x46787EAC /* 70.120.126.172/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x46ADFBDA /* 70.173.251.218/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x46B16F15 /* 70.177.111.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x47139041 /* 71.19.144.65/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x47139059 /* 71.19.144.89/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4713906A /* 71.19.144.106/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x471390B8 /* 71.19.144.184/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4713940C /* 71.19.148.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x47139A06 /* 71.19.154.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x47139A54 /* 71.19.154.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x47139B79 /* 71.19.155.121/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x47139D7F /* 71.19.157.127/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4713FBDA /* 71.19.251.218/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x473CC014 /* 71.60.192.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4758DAAB /* 71.88.218.171/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x475D4C7D /* 71.93.76.125/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x47692C2D /* 71.105.44.45/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4769768F /* 71.105.118.143/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4769B563 /* 71.105.181.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x477238D0 /* 71.114.56.208/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x47730F3B /* 71.115.15.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4773CCE5 /* 71.115.204.229/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x47788B8B /* 71.120.139.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x477E8290 /* 71.126.130.144/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x477FA820 /* 71.127.168.32/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x477FB39E /* 71.127.179.158/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x477FB6AF /* 71.127.182.175/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x47832772 /* 71.131.39.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4787C826 /* 71.135.200.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x478B2A3A /* 71.139.42.58/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x47AE697E /* 71.174.105.126/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x47B69B90 /* 71.182.155.144/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x47B72DC8 /* 71.183.45.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x47BB65AE /* 71.187.101.174/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x47BFC3B0 /* 71.191.195.176/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x47DAA60F /* 71.218.166.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x47DAA60F /* 71.218.166.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x47E77383 /* 71.231.115.131/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x47EED083 /* 71.238.208.131/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x47F4A6D4 /* 71.244.166.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x47F8A418 /* 71.248.164.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x47FC89F6 /* 71.252.137.246/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x480548E3 /* 72.5.72.227/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x480EB1A4 /* 72.14.177.164/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x484A44B1 /* 72.74.68.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x48550F13 /* 72.85.15.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x485920C4 /* 72.89.32.196/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x48C08A76 /* 72.192.138.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x48CD20CE /* 72.205.32.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x48DF7615 /* 72.223.118.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x48EA9B15 /* 72.234.155.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x492AA0FF /* 73.42.160.255/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x495A1463 /* 73.90.20.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4974005C /* 73.116.0.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4980CC27 /* 73.128.204.39/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x49855BC5 /* 73.133.91.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x49879A67 /* 73.135.154.103/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x49879A67 /* 73.135.154.103/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4994F68B /* 73.148.246.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x49A727A8 /* 73.167.39.168/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x49AAC3D9 /* 73.170.195.217/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x49B48F77 /* 73.180.143.119/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x49B54350 /* 73.181.67.80/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x49C910C4 /* 73.201.16.196/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x49CA042A /* 73.202.4.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x49D9CBFC /* 73.217.203.252/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x49E108A4 /* 73.225.8.164/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4A522FC2 /* 74.82.47.194/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4A530292 /* 74.83.2.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4A5B1502 /* 74.91.21.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4A6F19B1 /* 74.111.25.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4A6F19B1 /* 74.111.25.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4A74BA78 /* 74.116.186.120/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4A79BF6A /* 74.121.191.106/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4A79BFB2 /* 74.121.191.178/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4ACFE68E /* 74.207.230.142/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4ACFE7BA /* 74.207.231.186/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4ACFF207 /* 74.207.242.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4AD07840 /* 74.208.120.64/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4AD7344D /* 74.215.52.77/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4B4B6666 /* 75.75.102.102/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4B57AD17 /* 75.87.173.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4B7F0F49 /* 75.127.15.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4BB02D57 /* 75.176.45.87/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4BB810FB /* 75.184.16.251/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4C0E97AE /* 76.14.151.174/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4C1328B7 /* 76.19.40.183/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4C159C02 /* 76.21.156.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4C463ED2 /* 76.70.62.210/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4C4806D1 /* 76.72.6.209/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4C48AB29 /* 76.72.171.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4C5C8879 /* 76.92.136.121/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4CA7461D /* 76.167.70.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4CA7D57F /* 76.167.213.127/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4CA95C7A /* 76.169.92.122/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4CB67239 /* 76.182.114.57/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4CC0678D /* 76.192.103.141/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D004149 /* 77.0.65.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D018415 /* 77.1.132.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D01F481 /* 77.1.244.129/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D030016 /* 77.3.0.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D0469EC /* 77.4.105.236/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D065494 /* 77.6.84.148/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D0878C2 /* 77.8.120.194/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D089181 /* 77.8.145.129/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D0A1CFC /* 77.10.28.252/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D0AF178 /* 77.10.241.120/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D0B0908 /* 77.11.9.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D0B2DBC /* 77.11.45.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D0BDD85 /* 77.11.221.133/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D142565 /* 77.20.37.101/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D1473C1 /* 77.20.115.193/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D1496C9 /* 77.20.150.201/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D152892 /* 77.21.40.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D16BAB8 /* 77.22.186.184/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D17DC7D /* 77.23.220.125/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D258C17 /* 77.37.140.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D258EB3 /* 77.37.142.179/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D25A012 /* 77.37.160.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D25EE96 /* 77.37.238.150/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D25EE96 /* 77.37.238.150/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D2F7436 /* 77.47.116.54/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D30C804 /* 77.48.200.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D325406 /* 77.50.84.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D36C9BA /* 77.54.201.186/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D37D26F /* 77.55.210.111/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D37DCFA /* 77.55.220.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D39809A /* 77.57.128.154/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D3A68CB /* 77.58.104.203/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D3AFA6E /* 77.58.250.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D4407E9 /* 77.68.7.233/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D4409C6 /* 77.68.9.198/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D445814 /* 77.68.88.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D445E6A /* 77.68.94.106/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D447DB0 /* 77.68.125.176/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D447DCE /* 77.68.125.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D461C26 /* 77.70.28.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D463FDC /* 77.70.63.220/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D494027 /* 77.73.64.39/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D49403C /* 77.73.64.60/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D4A602B /* 77.74.96.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D518B84 /* 77.81.139.132/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D51F748 /* 77.81.247.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D6D74E0 /* 77.109.116.224/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D6DBF8C /* 77.109.191.140/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D787140 /* 77.120.113.64/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D799D1F /* 77.121.157.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D7B2A94 /* 77.123.42.148/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D7B2A94 /* 77.123.42.148/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D7B9B2D /* 77.123.155.45/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D8BB9E0 /* 77.139.185.224/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4D8CD1C0 /* 77.140.209.192/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4DA2E549 /* 77.162.229.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4DB33463 /* 77.179.52.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4DB40556 /* 77.180.5.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4DB6BEBC /* 77.182.190.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4DB6C25D /* 77.182.194.93/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4DBD168E /* 77.189.22.142/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4DBF0CBF /* 77.191.12.191/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4DBF3B6F /* 77.191.59.111/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4DBF4A92 /* 77.191.74.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4DE7B8BC /* 77.231.184.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4DF7B5A2 /* 77.247.181.162/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4DF7B5A3 /* 77.247.181.163/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4DF7B5A3 /* 77.247.181.163/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4DF7B5A4 /* 77.247.181.164/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4DF7B5A5 /* 77.247.181.165/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4DF7B5A5 /* 77.247.181.165/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4DF7B5A6 /* 77.247.181.166/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4DFAE3CA /* 77.250.227.202/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E0DC777 /* 78.13.199.119/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E0E6D9A /* 78.14.109.154/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E1F40C9 /* 78.31.64.201/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E1F415C /* 78.31.65.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E20E79B /* 78.32.231.155/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E234699 /* 78.35.70.153/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E239051 /* 78.35.144.81/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E24C592 /* 78.36.197.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E28D956 /* 78.40.217.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2A08E5 /* 78.42.8.229/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2D65C7 /* 78.45.101.199/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2E26FA /* 78.46.38.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2E350B /* 78.46.53.11/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2E3ACC /* 78.46.58.204/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2E3F71 /* 78.46.63.113/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2E40F5 /* 78.46.64.245/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2E55D8 /* 78.46.85.216/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2E62CF /* 78.46.98.207/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2E63AA /* 78.46.99.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2E6870 /* 78.46.104.112/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2E7836 /* 78.46.120.54/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2EA266 /* 78.46.162.102/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2EA27B /* 78.46.162.123/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2EAE48 /* 78.46.174.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2EB157 /* 78.46.177.87/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2EC0E9 /* 78.46.192.233/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2EC1D7 /* 78.46.193.215/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2EC9A8 /* 78.46.201.168/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2ECB12 /* 78.46.203.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2ED170 /* 78.46.209.112/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2ED9D6 /* 78.46.217.214/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2F0BE0 /* 78.47.11.224/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2F0E63 /* 78.47.14.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2F126E /* 78.47.18.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2F14D4 /* 78.47.20.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2F2BFD /* 78.47.43.253/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2F751C /* 78.47.117.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2F799E /* 78.47.121.158/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2F86C4 /* 78.47.134.196/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2FDD47 /* 78.47.221.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E2FE20C /* 78.47.226.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E31A3C3 /* 78.49.163.195/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E3613DB /* 78.54.19.219/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E3F9EDC /* 78.63.158.220/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E5188E2 /* 78.81.136.226/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E52B402 /* 78.82.180.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E52F3BB /* 78.82.243.187/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E5C6CD1 /* 78.92.108.209/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E5E078E /* 78.94.7.142/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E5E4AEC /* 78.94.74.236/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E5E8DB4 /* 78.94.141.180/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E5E8DCA /* 78.94.141.202/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E5EBA85 /* 78.94.186.133/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E5EFDFD /* 78.94.253.253/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E6BED35 /* 78.107.237.53/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E6BEFD5 /* 78.107.239.213/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E6BEFFD /* 78.107.239.253/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E6C6F70 /* 78.108.111.112/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E6C6F7F /* 78.108.111.127/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E6CD87F /* 78.108.216.127/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E81A575 /* 78.129.165.117/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E81A576 /* 78.129.165.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E81A578 /* 78.129.165.120/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E81A585 /* 78.129.165.133/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E81B410 /* 78.129.180.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E81BA1C /* 78.129.186.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E81C136 /* 78.129.193.54/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E82806A /* 78.130.128.106/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E829169 /* 78.130.145.105/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E82A0C7 /* 78.130.160.199/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E8B03A8 /* 78.139.3.168/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E8B7228 /* 78.139.114.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E9F6355 /* 78.159.99.85/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4E9F679F /* 78.159.103.159/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4EC2251D /* 78.194.37.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4EC23B76 /* 78.194.59.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4EC29E8D /* 78.194.158.141/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4EE0AFDE /* 78.224.175.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F113E81 /* 79.17.62.129/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F1586D5 /* 79.21.134.213/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F2B2DF3 /* 79.43.45.243/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F3532E1 /* 79.53.50.225/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F475C13 /* 79.71.92.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F6F0F83 /* 79.111.15.131/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F71B143 /* 79.113.177.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F7776CE /* 79.119.118.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F777F95 /* 79.119.127.149/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F7C070B /* 79.124.7.11/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F7C3CAE /* 79.124.60.174/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F852443 /* 79.133.36.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F852444 /* 79.133.36.68/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F852445 /* 79.133.36.69/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F86EB5D /* 79.134.235.93/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F86EBF3 /* 79.134.235.243/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F86EBFD /* 79.134.235.253/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F889972 /* 79.136.153.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F894FA7 /* 79.137.79.167/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F8C2975 /* 79.140.41.117/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F8C2976 /* 79.140.41.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F8FB1C0 /* 79.143.177.192/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F8FB5DD /* 79.143.181.221/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F8FB72C /* 79.143.183.44/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F8FB745 /* 79.143.183.69/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F8FBA11 /* 79.143.186.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F9164B7 /* 79.145.100.183/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F9164B7 /* 79.145.100.183/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4F9F034A /* 79.159.3.74/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4FAC1CCD /* 79.172.28.205/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4FACC120 /* 79.172.193.32/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4FC4152B /* 79.196.21.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4FC43E4C /* 79.196.62.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4FC4F751 /* 79.196.247.81/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4FC5FE4C /* 79.197.254.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4FC8D2CA /* 79.200.210.202/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4FC92109 /* 79.201.33.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4FCC0390 /* 79.204.3.144/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4FCCBD2D /* 79.204.189.45/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4FD0ABAB /* 79.208.171.171/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4FD2D168 /* 79.210.209.104/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4FD6E842 /* 79.214.232.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4FDD59ED /* 79.221.89.237/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4FE65860 /* 79.230.88.96/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4FECAB61 /* 79.236.171.97/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4FF8FA7F /* 79.248.250.127/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4FF9B69D /* 79.249.182.157/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4FFBCB33 /* 79.251.203.51/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x4FFE064D /* 79.254.6.77/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5002C8C5 /* 80.2.200.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5003ECA8 /* 80.3.236.168/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x503CF5EA /* 80.60.245.234/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5042870D /* 80.66.135.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5042877B /* 80.66.135.123/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5043ACA2 /* 80.67.172.162/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50478AC3 /* 80.71.138.195/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50482BFA /* 80.72.43.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x504F1707 /* 80.79.23.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x505246E3 /* 80.82.70.227/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50555448 /* 80.85.84.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50559A3B /* 80.85.154.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50581740 /* 80.88.23.64/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5059E40F /* 80.89.228.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x505A2719 /* 80.90.39.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x505F1DD4 /* 80.95.29.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50640FBA /* 80.100.15.186/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50644561 /* 80.100.69.97/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50649D29 /* 80.100.157.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x506CCB1D /* 80.108.203.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x506E230F /* 80.110.35.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x507090E9 /* 80.112.144.233/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5074B98B /* 80.116.185.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x507F7460 /* 80.127.116.96/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x507F763A /* 80.127.118.58/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x507F890E /* 80.127.137.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x507F9804 /* 80.127.152.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x507FFC96 /* 80.127.252.150/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50811BC0 /* 80.129.27.192/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5090A498 /* 80.144.164.152/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5090D363 /* 80.144.211.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5093219D /* 80.147.33.157/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50C37AA6 /* 80.195.122.166/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50D096B9 /* 80.208.150.185/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50D0D20D /* 80.208.210.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50D0D752 /* 80.208.215.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50D1D915 /* 80.209.217.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50D24A9B /* 80.210.74.155/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50D3352C /* 80.211.53.44/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50D335D2 /* 80.211.53.210/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50D35A6A /* 80.211.90.106/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50D382F1 /* 80.211.130.241/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50D396B1 /* 80.211.150.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50D3C097 /* 80.211.192.151/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50D3D348 /* 80.211.211.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50D3DAC9 /* 80.211.218.201/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50D4A308 /* 80.212.163.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50DB7C3B /* 80.219.124.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50DB88D8 /* 80.219.136.216/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50DD2B67 /* 80.221.43.103/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50DD3D95 /* 80.221.61.149/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50EB229B /* 80.235.34.155/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50F13CCF /* 80.241.60.207/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50F1D556 /* 80.241.213.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50F1D666 /* 80.241.214.102/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50F1D725 /* 80.241.215.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50F1D934 /* 80.241.217.52/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50F1DC39 /* 80.241.220.57/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50FA0412 /* 80.250.4.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50FD5C47 /* 80.253.92.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50FD5EFC /* 80.253.94.252/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x50FF00B4 /* 80.255.0.180/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5100E203 /* 81.0.226.3/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x510469E4 /* 81.4.105.228/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51046D3F /* 81.4.109.63/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51062850 /* 81.6.40.80/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x510628C1 /* 81.6.40.193/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51062BA7 /* 81.6.43.167/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51062BFC /* 81.6.43.252/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x510705BB /* 81.7.5.187/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51070A56 /* 81.7.10.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51070AC1 /* 81.7.10.193/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51070BFD /* 81.7.11.253/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51070E1F /* 81.7.14.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51070EFD /* 81.7.14.253/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x510710B1 /* 81.7.16.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x510710B6 /* 81.7.16.182/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51071207 /* 81.7.18.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51071261 /* 81.7.18.97/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x510AD006 /* 81.10.208.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5110211E /* 81.16.33.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5110211F /* 81.16.33.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51102120 /* 81.16.33.32/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51102121 /* 81.16.33.33/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51102123 /* 81.16.33.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51111092 /* 81.17.16.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51111093 /* 81.17.16.147/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51111094 /* 81.17.16.148/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51111095 /* 81.17.16.149/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51111096 /* 81.17.16.150/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51111182 /* 81.17.17.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51111183 /* 81.17.17.131/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5111133A /* 81.17.19.58/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51111E21 /* 81.17.30.33/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51111E2C /* 81.17.30.44/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51111E30 /* 81.17.30.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51113C18 /* 81.17.60.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5113074B /* 81.19.7.75/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51148F8A /* 81.20.143.138/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5116FF92 /* 81.22.255.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x511CCED8 /* 81.28.206.216/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x511D866E /* 81.29.134.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x511E9E79 /* 81.30.158.121/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51233F22 /* 81.35.63.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51245237 /* 81.36.82.55/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5125660C /* 81.37.102.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51313467 /* 81.49.52.103/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5153258A /* 81.83.37.138/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x515AB4A1 /* 81.90.180.161/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x515F3444 /* 81.95.52.68/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5161E5C8 /* 81.97.229.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x516FBA3A /* 81.111.186.58/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51A1A38C /* 81.161.163.140/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51A7E8D5 /* 81.167.232.213/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51A988CE /* 81.169.136.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51A98CA0 /* 81.169.140.160/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51A98F92 /* 81.169.143.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51A9A758 /* 81.169.167.88/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51A9B41C /* 81.169.180.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51A9C4EF /* 81.169.196.239/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51A9DB66 /* 81.169.219.102/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51A9E879 /* 81.169.232.121/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51A9EB9A /* 81.169.235.154/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51A9FEB8 /* 81.169.254.184/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51A9FF7D /* 81.169.255.125/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51AA8E9D /* 81.170.142.157/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51AA8F4B /* 81.170.143.75/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51AA9B06 /* 81.170.155.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51AAF432 /* 81.170.244.50/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51AEE712 /* 81.174.231.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51B62832 /* 81.182.40.50/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51B64F1D /* 81.182.79.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51C6E5A6 /* 81.198.229.166/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51C9C9A9 /* 81.201.201.169/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x51EDCEE0 /* 81.237.206.224/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x520724C8 /* 82.7.36.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x520724C8 /* 82.7.36.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5214A469 /* 82.20.164.105/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5215B01F /* 82.21.176.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52239F01 /* 82.35.159.1/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5236B928 /* 82.54.185.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x523963D6 /* 82.57.99.214/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52400974 /* 82.64.9.116/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x524014AB /* 82.64.20.171/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x524045CA /* 82.64.69.202/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x524071D3 /* 82.64.113.211/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52407545 /* 82.64.117.69/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x524088F0 /* 82.64.136.240/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x524098F7 /* 82.64.152.247/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5240A3BC /* 82.64.163.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5240BD75 /* 82.64.189.117/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5240C519 /* 82.64.197.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5240EE54 /* 82.64.238.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5240EF26 /* 82.64.239.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52411D79 /* 82.65.29.121/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5241760F /* 82.65.118.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52417D72 /* 82.65.125.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52417D72 /* 82.65.125.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52419636 /* 82.65.150.54/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5241AD69 /* 82.65.173.105/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5243B44D /* 82.67.180.77/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5243CD30 /* 82.67.205.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5243D421 /* 82.67.212.33/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x524431E3 /* 82.68.49.227/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52452F72 /* 82.69.47.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52483064 /* 82.72.48.100/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x524DEE06 /* 82.77.238.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x525EFBE3 /* 82.94.251.227/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x525F6B33 /* 82.95.107.51/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52678C57 /* 82.103.140.87/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52747803 /* 82.116.120.3/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52761150 /* 82.118.17.80/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5276153B /* 82.118.21.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52761720 /* 82.118.23.32/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5276F267 /* 82.118.242.103/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5276F293 /* 82.118.242.147/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52810804 /* 82.129.8.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5283409A /* 82.131.64.154/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52913B7F /* 82.145.59.127/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x529226B5 /* 82.146.38.181/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52922F11 /* 82.146.47.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5295E377 /* 82.149.227.119/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5295E37B /* 82.149.227.123/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5295E37C /* 82.149.227.124/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5295E37E /* 82.149.227.126/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5295E3EC /* 82.149.227.236/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x529E6443 /* 82.158.100.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52A1321E /* 82.161.50.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52A1321E /* 82.161.50.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52A1D257 /* 82.161.210.87/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52A4EF9A /* 82.164.239.154/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52A514A1 /* 82.165.20.161/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52A543DE /* 82.165.67.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52A544A5 /* 82.165.68.165/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52A54641 /* 82.165.70.65/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52A54961 /* 82.165.73.97/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52A56748 /* 82.165.103.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52A573A6 /* 82.165.115.166/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52A57ADE /* 82.165.122.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52A5CEC4 /* 82.165.206.196/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52A9823D /* 82.169.130.61/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52B55B76 /* 82.181.91.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52B568CA /* 82.181.104.202/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52B7192F /* 82.183.25.47/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52C05E7D /* 82.192.94.125/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52C4080D /* 82.196.8.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52C40B0A /* 82.196.11.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52C5D71E /* 82.197.215.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52C5DAD4 /* 82.197.218.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52CFCA1C /* 82.207.202.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52CFCF0A /* 82.207.207.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52CFD03D /* 82.207.208.61/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52D1364A /* 82.209.54.74/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52D4AA4F /* 82.212.170.79/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52D5E32E /* 82.213.227.46/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52D9E52D /* 82.217.229.45/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52DD69C6 /* 82.221.105.198/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52DD80BF /* 82.221.128.191/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52DD8305 /* 82.221.131.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52DD8347 /* 82.221.131.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52DD8366 /* 82.221.131.102/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52DD8BBE /* 82.221.139.190/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52DD8D60 /* 82.221.141.96/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52DF0B55 /* 82.223.11.85/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52DF0EF5 /* 82.223.14.245/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52DF11A4 /* 82.223.17.164/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52DF37BB /* 82.223.55.187/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52DFCD85 /* 82.223.205.133/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52F35D46 /* 82.243.93.70/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52FB2188 /* 82.251.33.136/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52FB4A69 /* 82.251.74.105/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52FBA7C0 /* 82.251.167.192/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52FE7C06 /* 82.254.124.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x52FE93E3 /* 82.254.147.227/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x530F1DC6 /* 83.15.29.198/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5327BD14 /* 83.39.189.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x532C933F /* 83.44.147.63/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53448302 /* 83.68.131.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x534484B5 /* 83.68.132.181/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x534E78E3 /* 83.78.120.227/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5360D53F /* 83.96.213.63/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53611427 /* 83.97.20.39/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53611464 /* 83.97.20.100/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53611485 /* 83.97.20.133/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x536114F8 /* 83.97.20.248/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53637E95 /* 83.99.126.149/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53637E95 /* 83.99.126.149/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53637E95 /* 83.99.126.149/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53861C4B /* 83.134.28.75/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x538693C8 /* 83.134.147.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53875A88 /* 83.135.90.136/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x538782B0 /* 83.135.130.176/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5387D301 /* 83.135.211.1/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5387EC1B /* 83.135.236.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5387EC1B /* 83.135.236.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53886A88 /* 83.136.106.136/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53886ADF /* 83.136.106.223/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53886B72 /* 83.136.107.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53A2B243 /* 83.162.178.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53A2E669 /* 83.162.230.105/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53CD50F4 /* 83.205.80.244/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53D10979 /* 83.209.9.121/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53D109E9 /* 83.209.9.233/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53D13523 /* 83.209.53.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53D448BD /* 83.212.72.189/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53D44B0A /* 83.212.75.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53D46078 /* 83.212.96.120/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53D46344 /* 83.212.99.68/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53D46464 /* 83.212.100.100/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53D46672 /* 83.212.102.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53D46781 /* 83.212.103.129/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53D46785 /* 83.212.103.133/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53D4682D /* 83.212.104.45/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53D46B80 /* 83.212.107.128/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53D772B2 /* 83.215.114.178/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53DCAD15 /* 83.220.173.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53DCAE50 /* 83.220.174.80/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53E2815A /* 83.226.129.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53E2815A /* 83.226.129.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53E29C13 /* 83.226.156.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53E45D4C /* 83.228.93.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53F344C2 /* 83.243.68.194/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53F5D538 /* 83.245.213.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53FBBF68 /* 83.251.191.104/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53FC044D /* 83.252.4.77/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53FE1E57 /* 83.254.30.87/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x53FE1E57 /* 83.254.30.87/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5403F8D2 /* 84.3.248.210/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x542681C7 /* 84.38.129.199/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x542681C8 /* 84.38.129.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5427706E /* 84.39.112.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5427F142 /* 84.39.241.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54287046 /* 84.40.112.70/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x542E2C9A /* 84.46.44.154/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5435C0F3 /* 84.53.192.243/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5435E176 /* 84.53.225.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x543BDE5C /* 84.59.222.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x543D6987 /* 84.61.105.135/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x543E6F4F /* 84.62.111.79/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x543F3229 /* 84.63.50.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5447C0F7 /* 84.71.192.247/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x544FD10C /* 84.79.209.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54523B39 /* 84.82.59.57/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54546D27 /* 84.84.109.39/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5465B311 /* 84.101.179.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5471B335 /* 84.113.179.53/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54727686 /* 84.114.118.134/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5476A13F /* 84.118.161.63/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5477D63C /* 84.119.214.60/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5483FC11 /* 84.131.252.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x548663CD /* 84.134.99.205/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54876BAB /* 84.135.107.171/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54906F91 /* 84.144.111.145/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54921212 /* 84.146.18.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5492F239 /* 84.146.242.57/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x549A98D5 /* 84.154.152.213/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x549D14E2 /* 84.157.20.226/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54A1B12F /* 84.161.177.47/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54A8749C /* 84.168.116.156/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54A9ECA2 /* 84.169.236.162/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54AA4D43 /* 84.170.77.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54ACD887 /* 84.172.216.135/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54AE8691 /* 84.174.134.145/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54B2E8FB /* 84.178.232.251/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54B2E8FB /* 84.178.232.251/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54B63FD4 /* 84.182.63.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54B6B7C6 /* 84.182.183.198/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54B8EBE7 /* 84.184.235.231/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54B8EF75 /* 84.184.239.117/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54C2427C /* 84.194.66.124/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54C2829B /* 84.194.130.155/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54C66627 /* 84.198.102.39/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54C6709A /* 84.198.112.154/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54CA5051 /* 84.202.80.81/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54D18B00 /* 84.209.139.0/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54D29742 /* 84.210.151.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54D51030 /* 84.213.16.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54D550D6 /* 84.213.80.214/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54E208A8 /* 84.226.8.168/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54E2D8EE /* 84.226.216.238/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54EC01B5 /* 84.236.1.181/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54EC0636 /* 84.236.6.54/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54EF9969 /* 84.239.153.105/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54F03CEA /* 84.240.60.234/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54F50A18 /* 84.245.10.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x54FABBCA /* 84.250.187.202/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55007D82 /* 85.0.125.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x550191E3 /* 85.1.145.227/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5501BDE5 /* 85.1.189.229/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5502D2F7 /* 85.2.210.247/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x550ACB47 /* 85.10.203.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x550AF0FA /* 85.10.240.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x551158AE /* 85.17.88.174/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55117F81 /* 85.17.127.129/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55172CAF /* 85.23.44.175/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55192B1F /* 85.25.43.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55192C8D /* 85.25.44.141/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55199F41 /* 85.25.159.65/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5519D5D3 /* 85.25.213.211/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x551A721A /* 85.26.114.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5549CF54 /* 85.73.207.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5555F2D0 /* 85.85.242.208/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x555B99A3 /* 85.91.153.163/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x555C6C4C /* 85.92.108.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x555D118F /* 85.93.17.143/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x555DDACC /* 85.93.218.204/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x555DEE89 /* 85.93.238.137/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55728A27 /* 85.114.138.39/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5577526C /* 85.119.82.108/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5577528E /* 85.119.82.142/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55775297 /* 85.119.82.151/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x557FA25C /* 85.127.162.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5583101D /* 85.131.16.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x558FD68F /* 85.143.214.143/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55912AC8 /* 85.145.42.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x559191C9 /* 85.145.145.201/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55954732 /* 85.149.71.50/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x559FEDD2 /* 85.159.237.210/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55A3354B /* 85.163.53.75/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55A5B515 /* 85.165.181.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55A69D0A /* 85.166.157.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55A7263F /* 85.167.38.63/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55A77098 /* 85.167.112.152/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55BBB8BE /* 85.187.184.190/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55BFF918 /* 85.191.249.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55C2EE83 /* 85.194.238.131/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55C3D097 /* 85.195.208.151/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55C3E6AA /* 85.195.230.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55C3E846 /* 85.195.232.70/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55C3E846 /* 85.195.232.70/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55C3EBF8 /* 85.195.235.248/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55C3EE64 /* 85.195.238.100/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55C3F276 /* 85.195.242.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55C3FD3B /* 85.195.253.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55C52CDA /* 85.197.44.218/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55CC4A8B /* 85.204.74.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55CC79DB /* 85.204.121.219/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D090A4 /* 85.208.144.164/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D0930C /* 85.208.147.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D13248 /* 85.209.50.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D19D03 /* 85.209.157.3/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D19D1A /* 85.209.157.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D19D1B /* 85.209.157.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D19D1C /* 85.209.157.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D19E2C /* 85.209.158.44/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D19E73 /* 85.209.158.115/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D19EC7 /* 85.209.158.199/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D19ED1 /* 85.209.158.209/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D19ED2 /* 85.209.158.210/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D19EDC /* 85.209.158.220/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D19EDD /* 85.209.158.221/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D409F9 /* 85.212.9.249/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D4266D /* 85.212.38.109/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D44522 /* 85.212.69.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D473F5 /* 85.212.115.245/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D4F54F /* 85.212.245.79/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D61345 /* 85.214.19.69/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D64016 /* 85.214.64.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D65F5E /* 85.214.95.94/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D661CE /* 85.214.97.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D66427 /* 85.214.100.39/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D667FB /* 85.214.103.251/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D6700C /* 85.214.112.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D675B9 /* 85.214.117.185/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D68D83 /* 85.214.141.131/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D69810 /* 85.214.152.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D69C1C /* 85.214.156.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D6A031 /* 85.214.160.49/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D6A17E /* 85.214.161.126/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D6C4B2 /* 85.214.196.178/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D6DDAF /* 85.214.221.175/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D6F40D /* 85.214.244.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D6FD6B /* 85.214.253.107/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D758F4 /* 85.215.88.244/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55D9AAB5 /* 85.217.170.181/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55E23089 /* 85.226.48.137/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55E27B5B /* 85.226.123.91/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55E47E50 /* 85.228.126.80/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55E4ADF0 /* 85.228.173.240/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55E4ADF0 /* 85.228.173.240/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55E4E816 /* 85.228.232.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55E58329 /* 85.229.131.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55E5899D /* 85.229.137.157/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55EB4292 /* 85.235.66.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55EBFA58 /* 85.235.250.88/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55EF2A36 /* 85.239.42.54/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55F16ACB /* 85.241.106.203/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55F48D3C /* 85.244.141.60/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55F8E3A3 /* 85.248.227.163/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55F8E3A4 /* 85.248.227.164/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55F8E3A5 /* 85.248.227.165/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55FBFF2C /* 85.251.255.44/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x55FBFF2C /* 85.251.255.44/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5600BC31 /* 86.0.188.49/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x560E518D /* 86.14.81.141/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5611B54E /* 86.17.181.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x56388588 /* 86.56.133.136/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x563B1526 /* 86.59.21.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x563B15A3 /* 86.59.21.163/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x563B7346 /* 86.59.115.70/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x56498F2B /* 86.73.143.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x564B56A9 /* 86.75.86.169/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x56506CE4 /* 86.80.108.228/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x565820C7 /* 86.88.32.199/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5667BDE4 /* 86.103.189.228/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5668C234 /* 86.104.194.52/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x56690585 /* 86.105.5.133/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5669D482 /* 86.105.212.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x566BBB36 /* 86.107.187.54/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x566BBB36 /* 86.107.187.54/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x56730FF8 /* 86.115.15.248/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x567B34BC /* 86.123.52.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x567FFFE2 /* 86.127.255.226/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x56834107 /* 86.131.65.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5685E5C1 /* 86.133.229.193/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x568F1912 /* 86.143.25.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x56C0ED10 /* 86.192.237.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x56CECBE6 /* 86.206.203.230/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x56EE1E35 /* 86.238.30.53/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x56EEA67F /* 86.238.166.127/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x56F28BD8 /* 86.242.139.216/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x56F340E8 /* 86.243.64.232/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x56F47463 /* 86.244.116.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x56FEB49E /* 86.254.180.158/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x570F65C7 /* 87.15.101.199/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x573D5CC4 /* 87.61.92.196/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57478A1F /* 87.71.138.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x574849E7 /* 87.72.73.231/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x574B621C /* 87.75.98.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x575C1553 /* 87.92.21.83/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x575C1F23 /* 87.92.31.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5762B905 /* 87.98.185.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5764993B /* 87.100.153.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5764FBAB /* 87.100.251.171/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5767F1CA /* 87.103.241.202/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57685465 /* 87.104.84.101/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x576AC138 /* 87.106.193.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x576EEDAB /* 87.110.237.171/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5776609A /* 87.118.96.154/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57766E71 /* 87.118.110.113/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57767088 /* 87.118.112.136/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5776740C /* 87.118.116.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5776745A /* 87.118.116.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57767467 /* 87.118.116.103/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x577674E5 /* 87.118.116.229/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57767A1E /* 87.118.122.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57767A33 /* 87.118.122.51/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x577824D2 /* 87.120.36.210/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x577824D4 /* 87.120.36.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5778254F /* 87.120.37.79/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5778FE62 /* 87.120.254.98/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5778FE69 /* 87.120.254.105/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5778FE72 /* 87.120.254.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5779342F /* 87.121.52.47/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5779622B /* 87.121.98.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x577A2867 /* 87.122.40.103/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x577A6789 /* 87.122.103.137/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x577AD4DA /* 87.122.212.218/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x577B28DC /* 87.123.40.220/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x577B4552 /* 87.123.69.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x577B7129 /* 87.123.113.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x577B9E2A /* 87.123.158.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x577BE249 /* 87.123.226.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x577BE3B2 /* 87.123.227.178/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x577BE634 /* 87.123.230.52/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x578B21D9 /* 87.139.33.217/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x578C4951 /* 87.140.73.81/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x578ECD09 /* 87.142.205.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5791A573 /* 87.145.165.115/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57928C62 /* 87.146.140.98/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5799CC33 /* 87.153.204.51/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x579AD531 /* 87.154.213.49/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57A0FBA4 /* 87.160.251.164/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57A6461C /* 87.166.70.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57A8BDF8 /* 87.168.189.248/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57AC6DB2 /* 87.172.109.178/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57AD00B3 /* 87.173.0.179/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57AE7205 /* 87.174.114.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57B14CBC /* 87.177.76.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57B4B4BA /* 87.180.180.186/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57B529FB /* 87.181.41.251/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57B553F4 /* 87.181.83.244/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57B6E7BF /* 87.182.231.191/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57B8EE53 /* 87.184.238.83/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57BCC9B8 /* 87.188.201.184/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57BD18EA /* 87.189.24.234/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57C1D00E /* 87.193.208.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57DABAD3 /* 87.218.186.211/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57DC1CAA /* 87.220.28.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57E73063 /* 87.231.48.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57ECC217 /* 87.236.194.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57ECC3FD /* 87.236.195.253/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57EFCC6F /* 87.239.204.111/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57F557DC /* 87.245.87.220/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57F56464 /* 87.245.100.100/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57F80729 /* 87.248.7.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x57F80729 /* 87.248.7.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5806EB56 /* 88.6.235.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5817F414 /* 88.23.244.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x581B7D9A /* 88.27.125.154/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58421ACE /* 88.66.26.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5842F773 /* 88.66.247.115/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5843FA34 /* 88.67.250.52/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x584AEEAF /* 88.74.238.175/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58501456 /* 88.80.20.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x585666A3 /* 88.86.102.163/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58567363 /* 88.86.115.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58581D87 /* 88.88.29.135/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5858E0F8 /* 88.88.224.248/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58630432 /* 88.99.4.50/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58631FBA /* 88.99.31.186/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58632040 /* 88.99.32.64/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58633DC9 /* 88.99.61.201/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58634C0A /* 88.99.76.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58635609 /* 88.99.86.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58635D50 /* 88.99.93.80/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x586361D6 /* 88.99.97.214/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5863B0B4 /* 88.99.176.180/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5863D96E /* 88.99.217.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58713A69 /* 88.113.58.105/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x587316F4 /* 88.115.22.244/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58733DFF /* 88.115.61.255/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x587539BC /* 88.117.57.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58825176 /* 88.130.81.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5882B32D /* 88.130.179.45/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x589770DC /* 88.151.112.220/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x589770DD /* 88.151.112.221/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x589986CD /* 88.153.134.205/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58C60AFA /* 88.198.10.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58C60C42 /* 88.198.12.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58C60EBE /* 88.198.14.190/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58C6182F /* 88.198.24.47/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58C623BC /* 88.198.35.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58C63454 /* 88.198.52.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58C64658 /* 88.198.70.88/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58C64689 /* 88.198.70.137/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58C65B4A /* 88.198.91.74/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58C65BF2 /* 88.198.91.242/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58C66521 /* 88.198.101.33/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58C67019 /* 88.198.112.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58C690B5 /* 88.198.144.181/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58C69657 /* 88.198.150.87/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58C6CF30 /* 88.198.207.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58C6CFDE /* 88.198.207.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58D0794E /* 88.208.121.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58D15D79 /* 88.209.93.121/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58D60974 /* 88.214.9.116/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58D972C8 /* 88.217.114.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58D98CDE /* 88.217.140.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58D98F35 /* 88.217.143.53/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58DA5C6D /* 88.218.92.109/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58DA5C7E /* 88.218.92.126/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58DA5C91 /* 88.218.92.145/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58DA5C92 /* 88.218.92.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x58DA5C93 /* 88.218.92.147/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x590C90AC /* 89.12.144.172/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x590C911D /* 89.12.145.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x590E9F21 /* 89.14.159.33/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5916605A /* 89.22.96.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5919210D /* 89.25.33.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x591B3B4B /* 89.27.59.75/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x591BF81D /* 89.27.248.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x591F393A /* 89.31.57.58/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5921F672 /* 89.33.246.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59221B18 /* 89.34.27.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59221B25 /* 89.34.27.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59221B2B /* 89.34.27.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59221B30 /* 89.34.27.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59221B31 /* 89.34.27.49/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59221B3B /* 89.34.27.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59221B95 /* 89.34.27.149/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x592327B9 /* 89.35.39.185/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5924DA7F /* 89.36.218.127/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x592769E4 /* 89.39.105.228/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59280DD9 /* 89.40.13.217/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59288F94 /* 89.40.143.148/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5928B56B /* 89.40.181.107/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x592E6447 /* 89.46.100.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x594A54D5 /* 89.74.84.213/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x594E1098 /* 89.78.16.152/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5966C9F1 /* 89.102.201.241/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x596B394F /* 89.107.57.79/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59900C11 /* 89.144.12.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59987A1A /* 89.152.122.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59A11A4E /* 89.161.26.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59A38019 /* 89.163.128.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59A3801A /* 89.163.128.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59A3801C /* 89.163.128.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59A3801D /* 89.163.128.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59A38F08 /* 89.163.143.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59A38F08 /* 89.163.143.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59A3CCFE /* 89.163.204.254/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59A3CCFE /* 89.163.204.254/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59A3D80B /* 89.163.216.11/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59A3DC70 /* 89.163.220.112/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59A3E021 /* 89.163.224.33/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59A3E03B /* 89.163.224.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59A3E040 /* 89.163.224.64/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59A3E0AF /* 89.163.224.175/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59A3E0BB /* 89.163.224.187/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59A3E0FA /* 89.163.224.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59A3E107 /* 89.163.225.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59A3E173 /* 89.163.225.115/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59A3E191 /* 89.163.225.145/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59B56F8F /* 89.181.111.143/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59BB8F1F /* 89.187.143.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59BB8F51 /* 89.187.143.81/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59BFD901 /* 89.191.217.1/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59D9D20D /* 89.217.210.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59DF6479 /* 89.223.100.121/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59E92B4A /* 89.233.43.74/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59EA9DFE /* 89.234.157.254/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59EA9DFE /* 89.234.157.254/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59EC7064 /* 89.236.112.100/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59EE4B40 /* 89.238.75.64/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59EFD47C /* 89.239.212.124/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59F4A374 /* 89.244.163.116/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59F4EF99 /* 89.244.239.153/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59F50737 /* 89.245.7.55/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59F57E49 /* 89.245.126.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59F5C5C8 /* 89.245.197.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59F777EC /* 89.247.119.236/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59F94199 /* 89.249.65.153/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x59F941F9 /* 89.249.65.249/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5A017F74 /* 90.1.127.116/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5A03C987 /* 90.3.201.135/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5A03C987 /* 90.3.201.135/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5A41E34D /* 90.65.227.77/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5A703906 /* 90.112.57.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5A74F58F /* 90.116.245.143/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5A925A41 /* 90.146.90.65/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5A92B0DD /* 90.146.176.221/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5A9B0506 /* 90.155.5.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5ABB1379 /* 90.187.19.121/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5ABB34E9 /* 90.187.52.233/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5ABB34E9 /* 90.187.52.233/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5ABBFEAD /* 90.187.254.173/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5ABE62B1 /* 90.190.98.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5AD3AEFB /* 90.211.174.251/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5AD87F56 /* 90.216.127.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5AE07BBC /* 90.224.123.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5AE14147 /* 90.225.65.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5AE74B05 /* 90.231.75.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5AFB3BA8 /* 90.251.59.168/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5AFFF47F /* 90.255.244.127/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B0776A2 /* 91.7.118.162/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B0AF6A9 /* 91.10.246.169/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B0D3560 /* 91.13.53.96/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B0E45C5 /* 91.14.69.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B0F1F9B /* 91.15.31.155/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B13E316 /* 91.19.227.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B21E7F1 /* 91.33.231.241/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B2625F2 /* 91.38.37.242/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B2741DA /* 91.39.65.218/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B2B34BF /* 91.43.52.191/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B2FDB6E /* 91.47.219.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B34EAB0 /* 91.52.234.176/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B369C2B /* 91.54.156.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B3DEF9F /* 91.61.239.159/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B3E12DF /* 91.62.18.223/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B3EC75A /* 91.62.199.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B3F2D6D /* 91.63.45.109/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B400614 /* 91.64.6.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B40AD93 /* 91.64.173.147/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B40B428 /* 91.64.180.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B420128 /* 91.66.1.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B425D0E /* 91.66.93.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B42A619 /* 91.66.166.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B43CC54 /* 91.67.204.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B4DA8BA /* 91.77.168.186/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B59555B /* 91.89.85.91/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B59BCD7 /* 91.89.188.215/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B5C6D2B /* 91.92.109.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B6D1594 /* 91.109.21.148/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B6D1595 /* 91.109.21.149/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B6D8CC5 /* 91.109.140.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B7913C3 /* 91.121.19.195/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B791E73 /* 91.121.30.115/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B79349C /* 91.121.52.156/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B794CCF /* 91.121.76.207/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B795219 /* 91.121.82.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B795284 /* 91.121.82.132/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B79563B /* 91.121.86.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B798FC7 /* 91.121.143.199/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B799341 /* 91.121.147.65/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B79A006 /* 91.121.160.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B7A640D /* 91.122.100.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B843C09 /* 91.132.60.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B84907D /* 91.132.144.125/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B8491F5 /* 91.132.145.245/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B849287 /* 91.132.146.135/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B8493A8 /* 91.132.147.168/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B868963 /* 91.134.137.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B869386 /* 91.134.147.134/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B88A437 /* 91.136.164.55/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B893E0F /* 91.137.62.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B893EF0 /* 91.137.62.240/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B8F50E6 /* 91.143.80.230/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B8F51D4 /* 91.143.81.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B8F5364 /* 91.143.83.100/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B8F5534 /* 91.143.85.52/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B8F5788 /* 91.143.87.136/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B8F5802 /* 91.143.88.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B8F583E /* 91.143.88.62/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B91526F /* 91.145.82.111/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B917B16 /* 91.145.123.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B927903 /* 91.146.121.3/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B948D75 /* 91.148.141.117/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B975D2E /* 91.151.93.46/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5B9BF1E1 /* 91.155.241.225/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BA685DC /* 91.166.133.220/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BA8A612 /* 91.168.166.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BADCAC3 /* 91.173.202.195/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BAEEAC9 /* 91.174.234.201/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BAFCDA6 /* 91.175.205.166/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BC06709 /* 91.192.103.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BC0670A /* 91.192.103.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BC0670B /* 91.192.103.11/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BC0670F /* 91.192.103.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BC06710 /* 91.192.103.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BC06711 /* 91.192.103.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BC06718 /* 91.192.103.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BC06719 /* 91.192.103.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BC0671A /* 91.192.103.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BC06721 /* 91.192.103.33/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BC06722 /* 91.192.103.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BC0E092 /* 91.192.224.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BC25459 /* 91.194.84.89/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BC36386 /* 91.195.99.134/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BC36388 /* 91.195.99.136/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BC7DF08 /* 91.199.223.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BC7DF09 /* 91.199.223.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BC7DF15 /* 91.199.223.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BC7DF16 /* 91.199.223.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BC7DF17 /* 91.199.223.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BC9411D /* 91.201.65.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BC9415B /* 91.201.65.91/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BCB0592 /* 91.203.5.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BCB05A5 /* 91.203.5.165/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BCB90C2 /* 91.203.144.194/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BCB9172 /* 91.203.145.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BCB9174 /* 91.203.145.116/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BCB927E /* 91.203.146.126/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BCC06C3 /* 91.204.6.195/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BCC2D8E /* 91.204.45.142/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BCF3C30 /* 91.207.60.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BD0B854 /* 91.208.184.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BD0B87B /* 91.208.184.123/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BD50859 /* 91.213.8.89/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BD50882 /* 91.213.8.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BD5E93C /* 91.213.233.60/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BD5E98A /* 91.213.233.138/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BD6A945 /* 91.214.169.69/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BDB1CD3 /* 91.219.28.211/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BDBEC1F /* 91.219.236.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BDBEC53 /* 91.219.236.83/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BDBED16 /* 91.219.237.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BDBED75 /* 91.219.237.117/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BDBEE78 /* 91.219.238.120/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BDBEE94 /* 91.219.238.148/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BDBEECF /* 91.219.238.207/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BDBEEDD /* 91.219.238.221/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BDBEEE2 /* 91.219.238.226/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BDBEF5C /* 91.219.239.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BDC9164 /* 91.220.145.100/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BDCDC05 /* 91.220.220.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BDF529A /* 91.223.82.154/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BDF52C5 /* 91.223.82.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BE434BA /* 91.228.52.186/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BE43556 /* 91.228.53.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BE54C7C /* 91.229.76.124/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BE9741D /* 91.233.116.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BE97433 /* 91.233.116.51/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BE97477 /* 91.233.116.119/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BEA1337 /* 91.234.19.55/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BEC7457 /* 91.236.116.87/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BF054C0 /* 91.240.84.192/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BF0E5C3 /* 91.240.229.195/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BF332EF /* 91.243.50.239/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BF4B555 /* 91.244.181.85/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BFA5134 /* 91.250.81.52/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BFA629E /* 91.250.98.158/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BFAF20C /* 91.250.242.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BFAF278 /* 91.250.242.120/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BFAF2FA /* 91.250.242.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BFAF2FB /* 91.250.242.251/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5BFAF2FC /* 91.250.242.252/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C04D342 /* 92.4.211.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C202553 /* 92.32.37.83/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C228352 /* 92.34.131.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C2284C6 /* 92.34.132.198/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C228A73 /* 92.34.138.115/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C230417 /* 92.35.4.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C23183C /* 92.35.24.60/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C23242A /* 92.35.36.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C23A770 /* 92.35.167.112/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C26A315 /* 92.38.163.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C26A353 /* 92.38.163.83/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C2A2F20 /* 92.42.47.32/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C2A8869 /* 92.42.136.105/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C326996 /* 92.50.105.150/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C3383BB /* 92.51.131.187/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C399C3E /* 92.57.156.62/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C3C2499 /* 92.60.36.153/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C3C2569 /* 92.60.37.105/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C3F6854 /* 92.63.104.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C4AF162 /* 92.74.241.98/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C5C2133 /* 92.92.33.51/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C642562 /* 92.100.37.98/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C6F04B1 /* 92.111.4.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C74818A /* 92.116.129.138/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C756494 /* 92.117.100.148/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C756C5A /* 92.117.108.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C756C5A /* 92.117.108.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C75A921 /* 92.117.169.33/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C75B724 /* 92.117.183.36/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C75E3F5 /* 92.117.227.245/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C75EAD2 /* 92.117.234.210/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5C76C18C /* 92.118.193.140/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5CC9867F /* 92.201.134.127/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5CCA1682 /* 92.202.22.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5CD1B1C5 /* 92.209.177.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5CDA72D1 /* 92.218.114.209/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5CDC008B /* 92.220.0.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5CDE4A3A /* 92.222.74.58/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5CDE544C /* 92.222.84.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5CDE5C0A /* 92.222.92.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5CDE67C3 /* 92.222.103.195/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5CDEAC38 /* 92.222.172.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5CDEB40A /* 92.222.180.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5CDEDD31 /* 92.222.221.49/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5CDF48A8 /* 92.223.72.168/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5CDF4F78 /* 92.223.79.120/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5CDF5D90 /* 92.223.93.144/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5CDF5D91 /* 92.223.93.145/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5CDF5DFA /* 92.223.93.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5CDF6975 /* 92.223.105.117/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5CDF69AE /* 92.223.105.174/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5CDF6D31 /* 92.223.109.49/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5CE8D820 /* 92.232.216.32/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5CF300B3 /* 92.243.0.179/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5CF41F1C /* 92.244.31.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5CF98F77 /* 92.249.143.119/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5CF98F77 /* 92.249.143.119/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5CFFCF59 /* 92.255.207.89/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D08EFD0 /* 93.8.239.208/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D19B3EC /* 93.25.179.236/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D1F0DA3 /* 93.31.13.163/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D28075E /* 93.40.7.94/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D299575 /* 93.41.149.117/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D2BD2C7 /* 93.43.210.199/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D387516 /* 93.56.117.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D484F40 /* 93.72.79.64/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D523152 /* 93.82.49.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D5AC323 /* 93.90.195.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D5AC8B5 /* 93.90.200.181/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D5CCDF8 /* 93.92.205.248/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D5D2EB4 /* 93.93.46.180/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D5F580D /* 93.95.88.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D5F64A6 /* 93.95.100.166/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D5F64AA /* 93.95.100.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D5F64CA /* 93.95.100.202/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D679093 /* 93.103.144.147/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D686A78 /* 93.104.106.120/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D68AF22 /* 93.104.175.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D68D13D /* 93.104.209.61/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D68D502 /* 93.104.213.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D68D570 /* 93.104.213.112/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D68F4B3 /* 93.104.244.179/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D6B7818 /* 93.107.120.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D6C23E8 /* 93.108.35.232/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D731AB5 /* 93.115.26.181/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D73548F /* 93.115.84.143/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D735604 /* 93.115.86.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D735606 /* 93.115.86.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D735608 /* 93.115.86.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D735609 /* 93.115.86.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D735B42 /* 93.115.91.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D735F26 /* 93.115.95.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D73600F /* 93.115.96.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D7361F2 /* 93.115.97.242/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D73F1C2 /* 93.115.241.194/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5D7FE716 /* 93.127.231.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DA0C726 /* 93.160.199.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DABD0C2 /* 93.171.208.194/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DAE5D85 /* 93.174.93.133/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DAE5F10 /* 93.174.95.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DB1407B /* 93.177.64.123/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DB14347 /* 93.177.67.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DB49A5E /* 93.180.154.94/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DB49D9A /* 93.180.157.154/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DB4B2D8 /* 93.180.178.216/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DBAC156 /* 93.186.193.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DBACA20 /* 93.186.202.32/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DBCA191 /* 93.188.161.145/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DBE8D1A /* 93.190.141.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DBE8E92 /* 93.190.142.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DBE8F29 /* 93.190.143.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DC450A8 /* 93.196.80.168/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DC6D1C4 /* 93.198.209.196/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DCABA23 /* 93.202.186.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DCEE927 /* 93.206.233.39/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DD20679 /* 93.210.6.121/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DD3EA1F /* 93.211.234.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DD4CA3A /* 93.212.202.58/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DD6F061 /* 93.214.240.97/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DD790A7 /* 93.215.144.167/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DDA5F5E /* 93.218.95.94/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DE395C0 /* 93.227.149.192/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DE5BBB5 /* 93.229.187.181/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DE75619 /* 93.231.86.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DEADBFE /* 93.234.219.254/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DEC330C /* 93.236.51.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5DEC5E67 /* 93.236.94.103/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E1072FE /* 94.16.114.254/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E10737B /* 94.16.115.123/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E107489 /* 94.16.116.137/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E107489 /* 94.16.116.137/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E107617 /* 94.16.118.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E107617 /* 94.16.118.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E1076FA /* 94.16.118.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E1076FA /* 94.16.118.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E107914 /* 94.16.121.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E10795B /* 94.16.121.91/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E10796F /* 94.16.121.111/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E107A3D /* 94.16.122.61/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E107A41 /* 94.16.122.65/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E107ADE /* 94.16.122.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E107B43 /* 94.16.123.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E107BA9 /* 94.16.123.169/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E108FC8 /* 94.16.143.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E13D94C /* 94.19.217.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E144A56 /* 94.20.74.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E15CDDD /* 94.21.205.221/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E17113A /* 94.23.17.58/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E171DCC /* 94.23.29.204/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E179651 /* 94.23.150.81/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E17C286 /* 94.23.194.134/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E17C363 /* 94.23.195.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E17D69C /* 94.23.214.156/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E17DE48 /* 94.23.222.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E17F72A /* 94.23.247.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E17F89E /* 94.23.248.158/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E1A49A2 /* 94.26.73.162/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E1A49A2 /* 94.26.73.162/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E20420F /* 94.32.66.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E204230 /* 94.32.66.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E415939 /* 94.65.89.57/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E4BC2DD /* 94.75.194.221/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E4F9D4E /* 94.79.157.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E64061B /* 94.100.6.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E640647 /* 94.100.6.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E640648 /* 94.100.6.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E641CB3 /* 94.100.28.179/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E66334E /* 94.102.51.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E71D317 /* 94.113.211.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E729BF2 /* 94.114.155.242/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E820AFB /* 94.130.10.251/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E822864 /* 94.130.40.100/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E823932 /* 94.130.57.50/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E823A63 /* 94.130.58.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E8245AB /* 94.130.69.171/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E826CD6 /* 94.130.108.214/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E82810F /* 94.130.129.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E82AB3F /* 94.130.171.63/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E82B4DC /* 94.130.180.220/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E82B568 /* 94.130.181.104/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E82B70D /* 94.130.183.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E82BB91 /* 94.130.187.145/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E82C8A7 /* 94.130.200.167/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E82F66A /* 94.130.246.106/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E86286C /* 94.134.40.108/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E8C723E /* 94.140.114.62/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E8C724A /* 94.140.114.74/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E8C726F /* 94.140.114.111/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E8C72B1 /* 94.140.114.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E8C72BE /* 94.140.114.190/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E8C72FF /* 94.140.114.255/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E8C7310 /* 94.140.115.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E8C7372 /* 94.140.115.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E8C7372 /* 94.140.115.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E8C7419 /* 94.140.116.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E8C74A7 /* 94.140.116.167/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E8C7882 /* 94.140.120.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E8EF18A /* 94.142.241.138/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E8EF1C2 /* 94.142.241.194/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E8EF1C2 /* 94.142.241.194/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E8EF1E2 /* 94.142.241.226/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E8EF410 /* 94.142.244.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E8EF410 /* 94.142.244.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E9A9F60 /* 94.154.159.96/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E9B312F /* 94.155.49.47/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E9C4D18 /* 94.156.77.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E9C800A /* 94.156.128.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E9CAF78 /* 94.156.175.120/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5E9EF5A1 /* 94.158.245.161/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5EB0F2A4 /* 94.176.242.164/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5EC7D587 /* 94.199.213.135/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5EC7D6E5 /* 94.199.214.229/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5ED464E0 /* 94.212.100.224/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5EDBBD69 /* 94.219.189.105/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5EDC3292 /* 94.220.50.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5EE188A4 /* 94.225.136.164/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5EE20662 /* 94.226.6.98/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5EE24C33 /* 94.226.76.51/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5EE6D093 /* 94.230.208.147/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5EE6D093 /* 94.230.208.147/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5EE6D094 /* 94.230.208.148/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5EF23C16 /* 94.242.60.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5EF9C0CB /* 94.249.192.203/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5EFE4A86 /* 94.254.74.134/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F196BF3 /* 95.25.107.243/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F2A66C3 /* 95.42.102.195/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F432637 /* 95.67.38.55/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F48CB44 /* 95.72.203.68/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F4F19BE /* 95.79.25.190/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F500ADE /* 95.80.10.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F548C24 /* 95.84.140.36/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F5508E2 /* 95.85.8.226/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F5A624D /* 95.90.98.77/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F5B0138 /* 95.91.1.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F5BACD9 /* 95.91.172.217/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F6698DF /* 95.102.152.223/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F69CE5A /* 95.105.206.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F6D7A34 /* 95.109.122.52/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F6E9210 /* 95.110.146.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F6FE6B2 /* 95.111.230.178/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F6FFCE6 /* 95.111.252.230/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F6FFE09 /* 95.111.254.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F704ADE /* 95.112.74.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F7209D3 /* 95.114.9.211/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F802BA4 /* 95.128.43.164/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F8166CB /* 95.129.102.203/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F851545 /* 95.133.21.69/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F8D230F /* 95.141.35.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F8D247F /* 95.141.36.127/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F8D5392 /* 95.141.83.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F8D5392 /* 95.141.83.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F8D539B /* 95.141.83.155/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F8D539B /* 95.141.83.155/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F8EA13F /* 95.142.161.63/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F8FACD6 /* 95.143.172.214/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F8FC17D /* 95.143.193.125/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F991F08 /* 95.153.31.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F991F0C /* 95.153.31.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F991F1A /* 95.153.31.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F9A1849 /* 95.154.24.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F9A19A7 /* 95.154.25.167/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F9AC21F /* 95.154.194.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5F9C5F08 /* 95.156.95.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FA428A9 /* 95.164.40.169/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FA43196 /* 95.164.49.150/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FA58D2B /* 95.165.141.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FA58F70 /* 95.165.143.112/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FA5940C /* 95.165.148.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FA5A685 /* 95.165.166.133/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FA8AA2B /* 95.168.170.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FAAE130 /* 95.170.225.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FACEB4A /* 95.172.235.74/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FB3CBCE /* 95.179.203.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FB3D625 /* 95.179.214.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FB3F758 /* 95.179.247.88/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FB7337E /* 95.183.51.126/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FBDEAD6 /* 95.189.234.214/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FC484DE /* 95.196.132.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD0C38E /* 95.208.195.142/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD376C2 /* 95.211.118.194/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD38817 /* 95.211.136.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD38A07 /* 95.211.138.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD38A33 /* 95.211.138.51/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD3D248 /* 95.211.210.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD3E6D3 /* 95.211.230.211/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD72D8A /* 95.215.45.138/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD72DBC /* 95.215.45.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD801A1 /* 95.216.1.161/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD801FB /* 95.216.1.251/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD803A6 /* 95.216.3.166/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD803AB /* 95.216.3.171/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD80ECE /* 95.216.14.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD80ECE /* 95.216.14.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD80EDE /* 95.216.14.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD80EDE /* 95.216.14.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD80F10 /* 95.216.15.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD813CE /* 95.216.19.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD813CE /* 95.216.19.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD813CF /* 95.216.19.207/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD813CF /* 95.216.19.207/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD81548 /* 95.216.21.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD81B69 /* 95.216.27.105/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD8211E /* 95.216.33.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD8213A /* 95.216.33.58/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD82354 /* 95.216.35.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD86237 /* 95.216.98.55/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD8639C /* 95.216.99.156/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD865F7 /* 95.216.101.247/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD86B94 /* 95.216.107.148/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD87355 /* 95.216.115.85/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD87355 /* 95.216.115.85/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD873AD /* 95.216.115.173/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD88822 /* 95.216.136.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD8882E /* 95.216.136.46/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD88987 /* 95.216.137.135/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD88A10 /* 95.216.138.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD88C9F /* 95.216.140.159/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD88CEF /* 95.216.140.239/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD88D13 /* 95.216.141.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD89071 /* 95.216.144.113/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD89101 /* 95.216.145.1/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD8917F /* 95.216.145.127/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD89275 /* 95.216.146.117/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD894A8 /* 95.216.148.168/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD894EA /* 95.216.148.234/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD895A1 /* 95.216.149.161/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD89A09 /* 95.216.154.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD89A87 /* 95.216.154.135/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD89A8B /* 95.216.154.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD89BBF /* 95.216.155.191/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD89F46 /* 95.216.159.70/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD8A066 /* 95.216.160.102/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD8A885 /* 95.216.168.133/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD8AA44 /* 95.216.170.68/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD8B235 /* 95.216.178.53/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD8B50F /* 95.216.181.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD8BB5B /* 95.216.187.91/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD8C016 /* 95.216.192.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD8C127 /* 95.216.193.39/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD8C177 /* 95.216.193.119/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD8C552 /* 95.216.197.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD8C59B /* 95.216.197.155/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD8C6FC /* 95.216.198.252/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD8C9A1 /* 95.216.201.161/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD8D1C1 /* 95.216.209.193/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD8D351 /* 95.216.211.81/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD8DA9F /* 95.216.218.159/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD9008B /* 95.217.0.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD90090 /* 95.217.0.144/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD9065E /* 95.217.6.94/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD90E11 /* 95.217.14.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD90E69 /* 95.217.14.105/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD90F11 /* 95.217.15.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD90F7D /* 95.217.15.125/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD910CE /* 95.217.16.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD910D4 /* 95.217.16.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD91602 /* 95.217.22.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD9173C /* 95.217.23.60/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD92A32 /* 95.217.42.50/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD92A5E /* 95.217.42.94/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD93E04 /* 95.217.62.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD94E54 /* 95.217.78.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD9618A /* 95.217.97.138/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD9618A /* 95.217.97.138/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD98417 /* 95.217.132.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD98559 /* 95.217.133.89/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD98737 /* 95.217.135.55/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD9A224 /* 95.217.162.36/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD9A46A /* 95.217.164.106/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD9A51B /* 95.217.165.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD9A798 /* 95.217.167.152/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD9B4D8 /* 95.217.180.216/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD9B715 /* 95.217.183.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD9B7C8 /* 95.217.183.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD9BD5E /* 95.217.189.94/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD9BFA6 /* 95.217.191.166/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD9C5CC /* 95.217.197.204/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD9C5CD /* 95.217.197.205/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD9CB85 /* 95.217.203.133/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD9CEEB /* 95.217.206.235/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD9DF36 /* 95.217.223.54/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD9EE0C /* 95.217.238.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FD9F8A9 /* 95.217.248.169/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FDE897C /* 95.222.137.124/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FDF2E38 /* 95.223.46.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FF6E512 /* 95.246.229.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x5FFB0B1E /* 95.251.11.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x602B5268 /* 96.43.82.104/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x604144C1 /* 96.65.68.193/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x60420F93 /* 96.66.15.147/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x607E69DB /* 96.126.105.219/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x60EE5541 /* 96.238.85.65/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x60FD4E6C /* 96.253.78.108/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x60FF9424 /* 96.255.148.36/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x60FFD124 /* 96.255.209.36/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6145DA26 /* 97.69.218.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x614AEDC4 /* 97.74.237.196/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x61576D71 /* 97.87.109.113/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x615A9FEB /* 97.90.159.235/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x615A9FEB /* 97.90.159.235/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x615DCA16 /* 97.93.202.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6167026E /* 97.103.2.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x616B8418 /* 97.107.132.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x616B8B1C /* 97.107.139.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x616B8B6C /* 97.107.139.108/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x616B8D82 /* 97.107.141.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x61749E70 /* 97.116.158.112/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6177D68F /* 97.119.214.143/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x622540B4 /* 98.37.64.180/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6280ACB1 /* 98.128.172.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6280AD01 /* 98.128.173.1/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6280BA76 /* 98.128.186.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6280C064 /* 98.128.192.100/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x62A52E3E /* 98.165.46.62/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x62AED70D /* 98.174.215.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x62C14538 /* 98.193.69.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x62D97CEF /* 98.217.124.239/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x62DCF8EB /* 98.220.248.235/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x62E19D4E /* 98.225.157.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x62EABDD8 /* 98.234.189.216/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x62EADE04 /* 98.234.222.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x637AC9F4 /* 99.122.201.244/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x63832D8F /* 99.131.45.143/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6395D743 /* 99.149.215.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6395F855 /* 99.149.248.85/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6396E515 /* 99.150.229.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x63A37A45 /* 99.163.122.69/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x63B00FA9 /* 99.176.15.169/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x63C03A63 /* 99.192.58.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x63C7887E /* 99.199.136.126/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x63F1A0BD /* 99.241.160.189/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x64012697 /* 100.1.38.151/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6402B670 /* 100.2.182.112/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6408EA61 /* 100.8.234.97/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x640E17D0 /* 100.14.23.208/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x640E9FFE /* 100.14.159.254/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x640F8B7B /* 100.15.139.123/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x640FF937 /* 100.15.249.55/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x64214059 /* 100.33.64.89/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x65377D0A /* 101.55.125.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x65635AAB /* 101.99.90.171/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x656490AE /* 101.100.144.174/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x6564A07A /* 101.100.160.122/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x65719392 /* 101.113.147.146/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x66827051 /* 102.130.112.81/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x67033C43 /* 103.3.60.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x67033EA8 /* 103.3.62.168/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x67094C5C /* 103.9.76.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x67101AA0 /* 103.16.26.160/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x671C345D /* 103.28.52.93/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x671C358A /* 103.28.53.138/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x671FFB70 /* 103.31.251.112/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x67234A4A /* 103.35.74.74/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x67389C2E /* 103.56.156.46/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x67494120 /* 103.73.65.32/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x674943C6 /* 103.73.67.198/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x674BBE0B /* 103.75.190.11/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x67662E39 /* 103.102.46.57/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x67882BB7 /* 103.136.43.183/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x67C7A1A6 /* 103.199.161.166/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x67C8D242 /* 103.200.210.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x67D0DC7A /* 103.208.220.122/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x67D0DCE2 /* 103.208.220.226/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x67D44676 /* 103.212.70.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x67E4359B /* 103.228.53.155/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x67E68E0A /* 103.230.142.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x67E68E17 /* 103.230.142.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x67EADCC3 /* 103.234.220.195/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x67EADCC5 /* 103.234.220.197/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x67ECC958 /* 103.236.201.88/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x67ECC96E /* 103.236.201.110/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x67F0E6A3 /* 103.240.230.163/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x67F91CC3 /* 103.249.28.195/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x67FD2962 /* 103.253.41.98/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6825C166 /* 104.37.193.102/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6825FB7C /* 104.37.251.124/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68391D2C /* 104.57.29.44/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6839E71A /* 104.57.231.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6839E71A /* 104.57.231.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6839E71B /* 104.57.231.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6839E71B /* 104.57.231.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68830BD6 /* 104.131.11.214/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68834746 /* 104.131.71.70/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6883483D /* 104.131.72.61/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68836C07 /* 104.131.108.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6883CE17 /* 104.131.206.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6895805E /* 104.149.128.94/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x689582DA /* 104.149.130.218/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x68958B2A /* 104.149.139.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68958D42 /* 104.149.141.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68958D42 /* 104.149.141.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6898BDD6 /* 104.152.189.214/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x689DE603 /* 104.157.230.3/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68A02880 /* 104.160.40.128/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68AB7112 /* 104.171.113.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68AC4A54 /* 104.172.74.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68B9CACF /* 104.185.202.207/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x68C2E4F0 /* 104.194.228.240/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x68C2EB68 /* 104.194.235.104/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x68C42B80 /* 104.196.43.128/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68C8142E /* 104.200.20.46/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68C81520 /* 104.200.21.32/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68CB5DBA /* 104.203.93.186/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68CEED17 /* 104.206.237.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68CEED18 /* 104.206.237.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68CF92D0 /* 104.207.146.208/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x68CF9565 /* 104.207.149.101/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x68DA3F48 /* 104.218.63.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68DA3F49 /* 104.218.63.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68DA3F4A /* 104.218.63.74/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68DA3F4B /* 104.218.63.75/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68DA3F4C /* 104.218.63.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68DBFA94 /* 104.219.250.148/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x68DF2D96 /* 104.223.45.150/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68DF5E42 /* 104.223.94.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68EC3410 /* 104.236.52.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68EC575A /* 104.236.87.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68EC97A0 /* 104.236.151.160/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x68ED850A /* 104.237.133.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68ED8BEE /* 104.237.139.238/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x68ED9086 /* 104.237.144.134/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x68ED97DD /* 104.237.151.221/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x68ED98F5 /* 104.237.152.245/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x68ED9A9C /* 104.237.154.156/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x68EEA76F /* 104.238.167.111/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x68EEBC62 /* 104.238.188.98/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44849 /* 104.244.72.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F4485E /* 104.244.72.94/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44863 /* 104.244.72.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44873 /* 104.244.72.115/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44898 /* 104.244.72.152/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F448A4 /* 104.244.72.164/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F448BC /* 104.244.72.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F448EF /* 104.244.72.239/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F448F6 /* 104.244.72.246/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F4490D /* 104.244.73.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F4490D /* 104.244.73.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F4492B /* 104.244.73.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F4495D /* 104.244.73.93/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F4495D /* 104.244.73.93/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F4497E /* 104.244.73.126/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F449C1 /* 104.244.73.193/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44A1C /* 104.244.74.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44A39 /* 104.244.74.57/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44A61 /* 104.244.74.97/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44A79 /* 104.244.74.121/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44A79 /* 104.244.74.121/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44B10 /* 104.244.75.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44B9B /* 104.244.75.155/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44C0D /* 104.244.76.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44C18 /* 104.244.76.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44C27 /* 104.244.76.39/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44C45 /* 104.244.76.69/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44CAA /* 104.244.76.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44CB8 /* 104.244.76.184/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44CF5 /* 104.244.76.245/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44D5F /* 104.244.77.95/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44D6F /* 104.244.77.111/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44D9E /* 104.244.77.158/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44DC7 /* 104.244.77.199/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44DFA /* 104.244.77.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44E43 /* 104.244.78.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44EE7 /* 104.244.78.231/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44EE9 /* 104.244.78.233/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44F19 /* 104.244.79.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F44F4B /* 104.244.79.75/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F81B25 /* 104.248.27.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F85870 /* 104.248.88.112/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x68F876F1 /* 104.248.118.241/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x68F89738 /* 104.248.151.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6A46EF13 /* 106.70.239.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6B9624A2 /* 107.150.36.162/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6B982396 /* 107.152.35.150/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6B982396 /* 107.152.35.150/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6B9823A7 /* 107.152.35.167/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6B9826BA /* 107.152.38.186/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6B982942 /* 107.152.41.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6B9829CC /* 107.152.41.204/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6B982FCC /* 107.152.47.204/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6BAADBBC /* 107.170.219.188/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x6BAC2AEC /* 107.172.42.236/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6BACE318 /* 107.172.227.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6BAEF466 /* 107.174.244.102/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x6BAF9349 /* 107.175.147.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6BB4EFA4 /* 107.180.239.164/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x6BB6E127 /* 107.182.225.39/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6BBD0A1B /* 107.189.10.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6BBD0A28 /* 107.189.10.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6BBD0A2A /* 107.189.10.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6BBD0A46 /* 107.189.10.70/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6BBD0A5D /* 107.189.10.93/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6BBD0A77 /* 107.189.10.119/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6BBD0A9D /* 107.189.10.157/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6BBD0AB9 /* 107.189.10.185/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6BBD0AF3 /* 107.189.10.243/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6BBD0AF5 /* 107.189.10.245/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6BBD0AF6 /* 107.189.10.246/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6BBD0AFB /* 107.189.10.251/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6BBD0B50 /* 107.189.11.80/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6BBD0B7B /* 107.189.11.123/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6BBD0B99 /* 107.189.11.153/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6BBD0B99 /* 107.189.11.153/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6BBE2F34 /* 107.190.47.52/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6BBF64AE /* 107.191.100.174/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x6C0E3F48 /* 108.14.63.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6C0E5218 /* 108.14.82.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6C101D58 /* 108.16.29.88/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6C102D52 /* 108.16.45.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6C1CA777 /* 108.28.167.119/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6C1DD7B9 /* 108.29.215.185/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6C27E593 /* 108.39.229.147/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6C35D09D /* 108.53.208.157/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6C38B44B /* 108.56.180.75/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6C38B44B /* 108.56.180.75/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6C38EF71 /* 108.56.239.113/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6C3D60E6 /* 108.61.96.230/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6C3D6395 /* 108.61.99.149/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6C3DA08F /* 108.61.160.143/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6C3DA686 /* 108.61.166.134/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6C3E7B5C /* 108.62.123.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6CA185BD /* 108.161.133.189/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x6CA18BB7 /* 108.161.139.183/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x6CA6DE63 /* 108.166.222.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6CAC76FB /* 108.172.118.251/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x6CC5E833 /* 108.197.232.51/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6CCE4CF2 /* 108.206.76.242/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6CFB5D86 /* 108.251.93.134/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D0898AD /* 109.8.152.173/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D30011C /* 109.48.1.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D31C240 /* 109.49.194.64/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D33EE5F /* 109.51.238.95/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D3FF837 /* 109.63.248.55/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D44BF84 /* 109.68.191.132/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D44BF9F /* 109.68.191.159/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D454311 /* 109.69.67.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D466401 /* 109.70.100.1/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D466402 /* 109.70.100.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D466403 /* 109.70.100.3/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D466404 /* 109.70.100.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D466405 /* 109.70.100.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D466406 /* 109.70.100.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D466407 /* 109.70.100.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D466408 /* 109.70.100.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D466409 /* 109.70.100.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D46640A /* 109.70.100.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D46640B /* 109.70.100.11/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D46640C /* 109.70.100.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D46640D /* 109.70.100.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D46640E /* 109.70.100.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D46640F /* 109.70.100.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D466410 /* 109.70.100.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D466411 /* 109.70.100.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D466412 /* 109.70.100.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D466413 /* 109.70.100.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D466414 /* 109.70.100.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D466415 /* 109.70.100.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D466416 /* 109.70.100.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D466417 /* 109.70.100.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D466418 /* 109.70.100.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D466419 /* 109.70.100.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D46641A /* 109.70.100.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D46641B /* 109.70.100.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D46641C /* 109.70.100.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D46641D /* 109.70.100.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D46641E /* 109.70.100.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D4ACB47 /* 109.74.203.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D4ACBE8 /* 109.74.203.232/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D4ACE15 /* 109.74.206.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D571994 /* 109.87.25.148/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D5BD4D5 /* 109.91.212.213/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D5CB65B /* 109.92.182.91/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D64588C /* 109.100.88.140/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D696DA2 /* 109.105.109.162/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x6D6A395B /* 109.106.57.91/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D6B239A /* 109.107.35.154/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D7B505E /* 109.123.80.94/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D884FF4 /* 109.136.79.244/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6D8887C1 /* 109.136.135.193/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x6DA921A3 /* 109.169.33.163/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6DC0457A /* 109.192.69.122/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6DC14C53 /* 109.193.76.83/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6DC1985E /* 109.193.152.94/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6DC28D34 /* 109.194.141.52/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6DC6A9F0 /* 109.198.169.240/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x6DC98564 /* 109.201.133.100/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x6DC98E35 /* 109.201.142.53/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6DCA67AA /* 109.202.103.170/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x6DCA67AA /* 109.202.103.170/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x6DCAC47D /* 109.202.196.125/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x6DCE83DC /* 109.206.131.220/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x6DDCEF35 /* 109.220.239.53/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6DE4BA4A /* 109.228.186.74/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6DE5D206 /* 109.229.210.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6DEB4334 /* 109.235.67.52/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6DEC530B /* 109.236.83.11/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6DEC5448 /* 109.236.84.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6DEC5652 /* 109.236.86.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6DEC566D /* 109.236.86.109/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6DEC5AD1 /* 109.236.90.209/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6DEE0B06 /* 109.238.11.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6DEE0BB9 /* 109.238.11.185/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6DF1A78A /* 109.241.167.138/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x6DF8904D /* 109.248.144.77/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6DF8959A /* 109.248.149.154/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x6DF895A7 /* 109.248.149.167/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x6DF895A8 /* 109.248.149.168/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x6DF895A9 /* 109.248.149.169/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x6DFAF9DA /* 109.250.249.218/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x6DFB3713 /* 109.251.55.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6E042F8B /* 110.4.47.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6E2042C1 /* 110.32.66.193/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6E8DDFC2 /* 110.141.223.194/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x6F45317A /* 111.69.49.122/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6F45317C /* 111.69.49.124/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6F61B3F2 /* 111.97.179.242/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x6FF1A164 /* 111.241.161.100/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x70C7DBC0 /* 112.199.219.192/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x71141F2D /* 113.20.31.45/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x71A1348A /* 113.161.52.138/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x71D294AC /* 113.210.148.172/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x71FF5C6D /* 113.255.92.109/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x7217A450 /* 114.23.164.80/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x7217CF55 /* 114.23.207.85/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x726C3AC9 /* 114.108.58.201/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x73400794 /* 115.64.7.148/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x7345B6EB /* 115.69.182.235/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x7346A729 /* 115.70.167.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x73927FE0 /* 115.146.127.224/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x73A3F2B1 /* 115.163.242.177/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x7431F284 /* 116.49.242.132/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x7453260F /* 116.83.38.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x747E10D4 /* 116.126.16.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x74CA09DA /* 116.202.9.218/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x74CA0E50 /* 116.202.14.80/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x74CA15D9 /* 116.202.21.217/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x74CA670A /* 116.202.103.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x74CA828A /* 116.202.130.138/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x74CA9BDF /* 116.202.155.223/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x74CAB394 /* 116.202.179.148/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x74CAC13C /* 116.202.193.60/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x74CAD09D /* 116.202.208.157/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x74CAEE6A /* 116.202.238.106/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x74CB1656 /* 116.203.22.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x74CB2F5C /* 116.203.47.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x74CB32B6 /* 116.203.50.182/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x74CB40D4 /* 116.203.64.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x74CB75DC /* 116.203.117.220/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x74CB8386 /* 116.203.131.134/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x74CB8C4A /* 116.203.140.74/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x74CB9FB0 /* 116.203.159.176/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x74CBDB74 /* 116.203.219.116/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x74CBEAF6 /* 116.203.234.246/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x74CBF9A5 /* 116.203.249.165/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x74F05F7A /* 116.240.95.122/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x75F1D135 /* 117.241.209.53/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x767F6C88 /* 118.127.108.136/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x76A34AA0 /* 118.163.74.160/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x773B624C /* 119.59.98.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x773B6EC0 /* 119.59.110.192/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x77690B48 /* 119.105.11.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x77A1648A /* 119.161.100.138/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x784AF24C /* 120.74.242.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x794A1A90 /* 121.74.26.144/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x795738E2 /* 121.87.56.226/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x7963E40E /* 121.99.228.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x7963F20B /* 121.99.242.11/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x7976C1E1 /* 121.118.193.225/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x799F0ACD /* 121.159.10.205/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x79A2B649 /* 121.162.182.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x79C81A2E /* 121.200.26.46/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x79D09052 /* 121.208.144.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x7B1E808A /* 123.30.128.138/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x7BC28E7B /* 123.194.142.123/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x7BE3E05D /* 123.227.224.93/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x7BFF3E89 /* 123.255.62.137/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x7C6D01CF /* 124.109.1.207/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x7C9657C6 /* 124.150.87.198/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x7CBEA9FC /* 124.190.169.252/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x7CF4101C /* 124.244.16.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x7DD4D9C5 /* 125.212.217.197/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x7DD4DC3C /* 125.212.220.60/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x7DD4F183 /* 125.212.241.131/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x7E0F94A0 /* 126.15.148.160/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x801F000D /* 128.31.0.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x801F0022 /* 128.31.0.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x801F003D /* 128.31.0.61/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8027081D /* 128.39.8.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x80C72C2F /* 128.199.44.47/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x80C737CF /* 128.199.55.207/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x80C78407 /* 128.199.132.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x80C785BA /* 128.199.133.186/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x80C792BA /* 128.199.146.186/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x80C7D59D /* 128.199.213.157/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x80C7E5CA /* 128.199.229.202/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x80C7E838 /* 128.199.232.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x80C7F5FC /* 128.199.245.252/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x80D002E9 /* 128.208.2.233/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x80E8123A /* 128.232.18.58/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x810D838C /* 129.13.131.140/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8115BB0A /* 129.21.187.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x81610722 /* 129.97.7.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8192823F /* 129.146.130.63/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x81E8852B /* 129.232.133.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x81E88677 /* 129.232.134.119/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x81F2DB55 /* 129.242.219.85/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x823D3261 /* 130.61.50.97/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x823D33B7 /* 130.61.51.183/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x823D7DF1 /* 130.61.125.241/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x823DB9ED /* 130.61.185.237/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x823F4E5F /* 130.63.78.95/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x82599539 /* 130.89.149.57/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x82950E1F /* 130.149.14.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x829550C7 /* 130.149.80.199/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x82B433F2 /* 130.180.51.242/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x82B43F96 /* 130.180.63.150/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x82B45992 /* 130.180.89.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x82B46FC2 /* 130.180.111.194/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x82C10F31 /* 130.193.15.49/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x82C10FBA /* 130.193.15.186/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x82CCA103 /* 130.204.161.3/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x82E1F45A /* 130.225.244.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x82E1F45A /* 130.225.244.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x82FF4E02 /* 130.255.78.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x82FF4EE8 /* 130.255.78.232/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x839960DA /* 131.153.96.218/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x83BC28BC /* 131.188.40.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x83BC28BD /* 131.188.40.189/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x83FF0430 /* 131.255.4.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x83FF0460 /* 131.255.4.96/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8491312A /* 132.145.49.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x849161BF /* 132.145.97.191/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x84917F11 /* 132.145.127.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x84917F11 /* 132.145.127.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x84F83B48 /* 132.248.59.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x84F8F105 /* 132.248.241.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x84F8F105 /* 132.248.241.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x84FCBAB9 /* 132.252.186.185/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x86030A79 /* 134.3.10.121/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x86039253 /* 134.3.146.83/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x86651C73 /* 134.101.28.115/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8665C824 /* 134.101.200.36/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x866679A2 /* 134.102.121.162/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8666C865 /* 134.102.200.101/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x867720D0 /* 134.119.32.208/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x86772487 /* 134.119.36.135/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x867A3690 /* 134.122.54.144/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8682ACE5 /* 134.130.172.229/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x86D145CE /* 134.209.69.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x86D14E81 /* 134.209.78.129/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x86D19666 /* 134.209.150.102/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x86D19F4A /* 134.209.159.74/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x86D1A863 /* 134.209.168.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x86F96A15 /* 134.249.106.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x86F9E7CF /* 134.249.231.207/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x86FFE86C /* 134.255.232.108/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x86FFF771 /* 134.255.247.113/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x86FFFC29 /* 134.255.252.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8713733F /* 135.19.115.63/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x87B4650F /* 135.180.101.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x87B4650F /* 135.180.101.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x87B4A2FD /* 135.180.162.253/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x87B51A00 /* 135.181.26.0/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x87B51EB1 /* 135.181.30.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x87B524A6 /* 135.181.36.166/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x87B52571 /* 135.181.37.113/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x87B52926 /* 135.181.41.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x87B529CE /* 135.181.41.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x87B52D2A /* 135.181.45.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x87B543CC /* 135.181.67.204/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x87B543D2 /* 135.181.67.210/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x87B56238 /* 135.181.98.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x87B563B3 /* 135.181.99.179/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x87B56A4E /* 135.181.106.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x87B56AE6 /* 135.181.106.230/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x87B590E6 /* 135.181.144.230/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x88189DD2 /* 136.24.157.210/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x881B528B /* 136.27.82.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x881B528B /* 136.27.82.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x882240EC /* 136.34.64.236/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8825666F /* 136.37.102.111/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8825666F /* 136.37.102.111/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8825C5B2 /* 136.37.197.178/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x883109B6 /* 136.49.9.182/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x88372390 /* 136.55.35.144/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8839ACAD /* 136.57.172.173/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8839BDDA /* 136.57.189.218/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8890D7B4 /* 136.144.215.180/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x88F3020D /* 136.243.2.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x88F3048B /* 136.243.4.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x88F3048B /* 136.243.4.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x88F30812 /* 136.243.8.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x88F327B9 /* 136.243.39.185/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x88F341F7 /* 136.243.65.247/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x88F345F3 /* 136.243.69.243/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x88F352BC /* 136.243.82.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x88F3832E /* 136.243.131.46/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x88F39552 /* 136.243.149.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x88F39CBB /* 136.243.156.187/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x88F3B094 /* 136.243.176.148/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x88F3B185 /* 136.243.177.133/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x88F3E506 /* 136.243.229.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x88F451C5 /* 136.244.81.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8932130B /* 137.50.19.11/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x893BB9B3 /* 137.59.185.179/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x894A2019 /* 137.74.32.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x894A201A /* 137.74.32.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x894A201B /* 137.74.32.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x894A201C /* 137.74.32.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x894A3D7D /* 137.74.61.125/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x894A55C2 /* 137.74.85.194/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x894A55D9 /* 137.74.85.217/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x894A6B9D /* 137.74.107.157/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x894A6BA7 /* 137.74.107.167/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x894A6BA9 /* 137.74.107.169/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x894A74D6 /* 137.74.116.214/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x894AA9F1 /* 137.74.169.241/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x89C141E0 /* 137.193.65.224/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x89DC3EF3 /* 137.220.62.243/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x89DC5E7C /* 137.220.94.124/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8A3B1128 /* 138.59.17.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8A3B1269 /* 138.59.18.105/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8A3B126A /* 138.59.18.106/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8A3B126E /* 138.59.18.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8A3B1311 /* 138.59.19.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8A4409B8 /* 138.68.9.184/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8A44505B /* 138.68.80.91/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8A44ACB0 /* 138.68.172.176/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8A75942D /* 138.117.148.45/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8A80F2B6 /* 138.128.242.182/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8AC590BF /* 138.197.144.191/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8AC5946C /* 138.197.148.108/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8AC5969F /* 138.197.150.159/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8AC59892 /* 138.197.152.146/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8AC5A65C /* 138.197.166.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8AC5A829 /* 138.197.168.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8AC5AB58 /* 138.197.171.88/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8AC5ADE8 /* 138.197.173.232/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8AC5CF9B /* 138.197.207.155/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8AC5D59A /* 138.197.213.154/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8AC91305 /* 138.201.19.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8AC91C83 /* 138.201.28.131/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8AC92306 /* 138.201.35.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8AC95726 /* 138.201.87.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8AC95CB7 /* 138.201.92.183/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8AC97A37 /* 138.201.122.55/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8AC98422 /* 138.201.132.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8AC98FBA /* 138.201.143.186/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8AC9A90C /* 138.201.169.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8AC9C49C /* 138.201.196.156/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8AC9FA21 /* 138.201.250.33/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8AC9FE53 /* 138.201.254.83/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8AC9FFF5 /* 138.201.255.245/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8B05B106 /* 139.5.177.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B1C26DF /* 139.28.38.223/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B3B0006 /* 139.59.0.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B3B0886 /* 139.59.8.134/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B3B0FDA /* 139.59.15.218/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B3B1005 /* 139.59.16.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B3B15F9 /* 139.59.21.249/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B3B2438 /* 139.59.36.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B3B2438 /* 139.59.36.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B3B2DF2 /* 139.59.45.242/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B3B3813 /* 139.59.56.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B3B3A6D /* 139.59.58.109/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B3B3DFD /* 139.59.61.253/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B3B4310 /* 139.59.67.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B3B4356 /* 139.59.67.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B3B4E71 /* 139.59.78.113/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B3B5E12 /* 139.59.94.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B3BE800 /* 139.59.232.0/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B63611A /* 139.99.97.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B6362BF /* 139.99.98.191/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B637882 /* 139.99.120.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B638596 /* 139.99.133.150/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B63861B /* 139.99.134.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B638B8F /* 139.99.139.143/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B63AB33 /* 139.99.171.51/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B63AB33 /* 139.99.171.51/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B63AC0B /* 139.99.172.11/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B63B219 /* 139.99.178.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B63DA03 /* 139.99.218.3/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8B63EE11 /* 139.99.238.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA202E7 /* 139.162.2.231/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA2060A /* 139.162.6.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA2072A /* 139.162.7.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA20A48 /* 139.162.10.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA20ABE /* 139.162.10.190/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA20BF8 /* 139.162.11.248/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA20DC5 /* 139.162.13.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA20FD0 /* 139.162.15.208/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA213E9 /* 139.162.19.233/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA21EF7 /* 139.162.30.247/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA22339 /* 139.162.35.57/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA2298C /* 139.162.41.140/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA22FB8 /* 139.162.47.184/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA23537 /* 139.162.53.55/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA23B86 /* 139.162.59.134/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA23F7D /* 139.162.63.125/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA242F6 /* 139.162.66.246/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA2519C /* 139.162.81.156/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA2706F /* 139.162.112.111/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA27130 /* 139.162.113.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA2752B /* 139.162.117.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA280FB /* 139.162.128.251/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA28E1B /* 139.162.142.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA28E78 /* 139.162.142.120/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA29756 /* 139.162.151.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA2A2EE /* 139.162.162.238/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA2BFF3 /* 139.162.191.243/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA2C345 /* 139.162.195.69/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA2C9EE /* 139.162.201.238/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA2D2FC /* 139.162.210.252/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA2E81C /* 139.162.232.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8BA2F578 /* 139.162.245.120/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8BB2042A /* 139.178.4.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8BB26C3F /* 139.178.108.63/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8CBA94C0 /* 140.186.148.192/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8CEE3948 /* 140.238.57.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8CEE3948 /* 140.238.57.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8CEE46C1 /* 140.238.70.193/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8CEEA8D6 /* 140.238.168.214/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8CEEDBDE /* 140.238.219.222/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8CEEE45F /* 140.238.228.95/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8CEEFEEC /* 140.238.254.236/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8D0EDCB1 /* 141.14.220.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8D142145 /* 141.20.33.69/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8D146721 /* 141.20.103.33/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8D467DE8 /* 141.70.125.232/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8D620957 /* 141.98.9.87/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8D62884F /* 141.98.136.79/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8D62D77B /* 141.98.215.123/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8D69433A /* 141.105.67.58/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8D88D640 /* 141.136.214.64/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8DC11559 /* 141.193.21.89/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8DC11563 /* 141.193.21.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8DFFA1A6 /* 141.255.161.166/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8DFFA1A7 /* 141.255.161.167/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8DFFA566 /* 141.255.165.102/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8DFFA68E /* 141.255.166.142/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8DFFA696 /* 141.255.166.150/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8DFFA6BD /* 141.255.166.189/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8E04D018 /* 142.4.208.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E04D11F /* 142.4.209.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E04D12D /* 142.4.209.45/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E04D1C8 /* 142.4.209.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E04D41F /* 142.4.212.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E04D50C /* 142.4.213.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E04D51C /* 142.4.213.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E04D55A /* 142.4.213.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E04D570 /* 142.4.213.112/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E04D5B8 /* 142.4.213.184/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E04D5D5 /* 142.4.213.213/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E04D6C3 /* 142.4.214.195/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E04D726 /* 142.4.215.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E04D72B /* 142.4.215.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E04D72C /* 142.4.215.44/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E04D72D /* 142.4.215.45/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E0BC95A /* 142.11.201.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E2C8550 /* 142.44.133.80/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E2C8B0C /* 142.44.139.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E2C9C83 /* 142.44.156.131/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E2CA323 /* 142.44.163.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E2CCD50 /* 142.44.205.80/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E2CDB33 /* 142.44.219.51/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E2CF385 /* 142.44.243.133/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E2CF5A5 /* 142.44.245.165/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E2CF69C /* 142.44.246.156/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E2CF766 /* 142.44.247.102/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E5D9BBD /* 142.93.155.189/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E5DA9C5 /* 142.93.169.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E5DBE66 /* 142.93.190.102/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E5DD672 /* 142.93.214.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8E5DE8A5 /* 142.93.232.165/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8EA22D1A /* 142.162.45.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8F6A4923 /* 143.106.73.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8F6BE578 /* 143.107.229.120/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8F6BE5D2 /* 143.107.229.210/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8F6E9492 /* 143.110.148.146/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8F6E9C18 /* 143.110.156.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8F6E9C47 /* 143.110.156.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x8FB26F78 /* 143.178.111.120/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x8FCAA14B /* 143.202.161.75/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x90026CC4 /* 144.2.108.196/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x904C1882 /* 144.76.24.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x904C1B3A /* 144.76.27.58/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x904C1EA7 /* 144.76.30.167/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x904C25F2 /* 144.76.37.242/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x904C2A8F /* 144.76.42.143/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x904C39B7 /* 144.76.57.183/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x904C4B89 /* 144.76.75.137/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x904C4E3C /* 144.76.78.60/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x904C6B5E /* 144.76.107.94/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x904C7656 /* 144.76.118.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x904C7709 /* 144.76.119.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x904CA588 /* 144.76.165.136/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x904CA824 /* 144.76.168.36/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x904CAA14 /* 144.76.170.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x904CADB4 /* 144.76.173.180/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x904CAFCD /* 144.76.175.205/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x904CC45C /* 144.76.196.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x904CC850 /* 144.76.200.80/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x904CCA9E /* 144.76.202.158/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x904CD8FC /* 144.76.216.252/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x904CEC0E /* 144.76.236.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x904CEC0E /* 144.76.236.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x904CEC1B /* 144.76.236.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x904CEC1B /* 144.76.236.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x905B4DB3 /* 144.91.77.179/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x905B5C63 /* 144.91.92.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x905B65C7 /* 144.91.101.199/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x905B68F2 /* 144.91.104.242/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x905B7095 /* 144.91.112.149/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x905B7095 /* 144.91.112.149/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x905B79E6 /* 144.91.121.230/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x905B7D0F /* 144.91.125.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x905B7DEF /* 144.91.125.239/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x90A8A41A /* 144.168.164.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x90AC7602 /* 144.172.118.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x90AC7602 /* 144.172.118.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x90AC7603 /* 144.172.118.3/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x90AC7603 /* 144.172.118.3/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x90AC99A5 /* 144.172.153.165/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x90CA0FA1 /* 144.202.15.161/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x90CA31AB /* 144.202.49.171/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x90CA3FF3 /* 144.202.63.243/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x90CA66F9 /* 144.202.102.249/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x90CA74FA /* 144.202.116.250/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x90D904A6 /* 144.217.4.166/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x90D90788 /* 144.217.7.136/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x90D93CD3 /* 144.217.60.211/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x90D93CD3 /* 144.217.60.211/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x90D93CEF /* 144.217.60.239/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x90D93CEF /* 144.217.60.239/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x90D94B6E /* 144.217.75.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x90D95050 /* 144.217.80.80/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x90D9571C /* 144.217.87.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x90D95CD7 /* 144.217.92.215/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x90D95F0C /* 144.217.95.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x90D9A105 /* 144.217.161.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x90D9F58C /* 144.217.245.140/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x90D9F591 /* 144.217.245.145/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x91DC000F /* 145.220.0.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF00CC /* 145.239.0.204/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF0161 /* 145.239.1.97/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF07A8 /* 145.239.7.168/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF07A9 /* 145.239.7.169/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF07AA /* 145.239.7.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF4C5F /* 145.239.76.95/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF513A /* 145.239.81.58/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF5266 /* 145.239.82.102/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF5266 /* 145.239.82.102/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF528E /* 145.239.82.142/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF528E /* 145.239.82.142/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF5293 /* 145.239.82.147/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF5293 /* 145.239.82.147/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF52A8 /* 145.239.82.168/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF52A8 /* 145.239.82.168/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF52E5 /* 145.239.82.229/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF52E5 /* 145.239.82.229/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF52E7 /* 145.239.82.231/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF54AC /* 145.239.84.172/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF54AC /* 145.239.84.172/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF5965 /* 145.239.89.101/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF5B25 /* 145.239.91.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF5BA3 /* 145.239.91.163/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF5C1A /* 145.239.92.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF5C1A /* 145.239.92.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF5F0F /* 145.239.95.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF76F3 /* 145.239.118.243/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x91EF9EEA /* 145.239.158.234/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x91EFBB1A /* 145.239.187.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x91F96A63 /* 145.249.106.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x92002849 /* 146.0.40.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x92004882 /* 146.0.72.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x92004D32 /* 146.0.77.50/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x923B9607 /* 146.59.150.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x923B9B1B /* 146.59.155.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x923B9EE4 /* 146.59.158.228/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x923BE1C2 /* 146.59.225.194/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x923BE1C3 /* 146.59.225.195/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x923C7BA4 /* 146.60.123.164/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x92B9B024 /* 146.185.176.36/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x92B9BDC5 /* 146.185.189.197/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x92B9FD65 /* 146.185.253.101/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x92E470FC /* 146.228.112.252/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x934EEDB9 /* 147.78.237.185/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x935C5843 /* 147.92.88.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x93870426 /* 147.135.4.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x93870444 /* 147.135.4.68/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x93870645 /* 147.135.6.69/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x93874E9D /* 147.135.78.157/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9387693E /* 147.135.105.62/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9387708B /* 147.135.112.139/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x93877262 /* 147.135.114.98/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x938772F5 /* 147.135.114.245/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x9387D1EA /* 147.135.209.234/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x938B889C /* 147.139.136.156/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x938BA140 /* 147.139.161.64/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x943FB4A1 /* 148.63.180.161/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x94FB0AAB /* 148.251.10.171/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x94FB0B15 /* 148.251.11.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x94FB1668 /* 148.251.22.104/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x94FB29EB /* 148.251.41.235/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x94FB335E /* 148.251.51.94/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x94FB37F6 /* 148.251.55.246/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x94FB4399 /* 148.251.67.153/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x94FB43AA /* 148.251.67.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x94FB4BF7 /* 148.251.75.247/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x94FB5110 /* 148.251.81.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x94FB7D75 /* 148.251.125.117/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x94FB9B6C /* 148.251.155.108/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x94FBBEE5 /* 148.251.190.229/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x94FBBFFC /* 148.251.191.252/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x94FBC0A0 /* 148.251.192.160/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x94FBD3D3 /* 148.251.211.211/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x94FBEDDB /* 148.251.237.219/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x951C3FC3 /* 149.28.63.195/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x951CAEEA /* 149.28.174.234/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x951CB795 /* 149.28.183.149/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x951CF568 /* 149.28.245.104/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x952209E5 /* 149.34.9.229/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x95221B89 /* 149.34.27.137/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x95382C2F /* 149.56.44.47/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x95382DC8 /* 149.56.45.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x95385ED8 /* 149.56.94.216/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x95385ED9 /* 149.56.94.217/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x95385EDA /* 149.56.94.218/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x95385EDB /* 149.56.94.219/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x953862D8 /* 149.56.98.216/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9538651F /* 149.56.101.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9538829D /* 149.56.130.157/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x95389D77 /* 149.56.157.119/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9538B938 /* 149.56.185.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9538B938 /* 149.56.185.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9538C816 /* 149.56.200.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9538C81C /* 149.56.200.28/32  */ , 32, NDPI_PROTOCOL_TOR },
  { 0x9538E98E /* 149.56.233.142/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9538F2C5 /* 149.56.242.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x959A4332 /* 149.154.67.50/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x959A9879 /* 149.154.152.121/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x959A9D50 /* 149.154.157.80/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x959A9F57 /* 149.154.159.87/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x959A9FAC /* 149.154.159.172/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x95CA3D06 /* 149.202.61.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x95CA5B5A /* 149.202.91.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x95CABE0E /* 149.202.190.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x95CAD0CB /* 149.202.208.203/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x95CAEECC /* 149.202.238.204/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x95CAEECC /* 149.202.238.204/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x95D29696 /* 149.210.150.150/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x95D2CD43 /* 149.210.205.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x95E096CB /* 149.224.150.203/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x965FB1D1 /* 150.95.177.209/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x966B4BBA /* 150.107.75.186/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x966B4C0D /* 150.107.76.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9688B9B1 /* 150.136.185.177/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x9714A2E2 /* 151.20.162.226/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9718797B /* 151.24.121.123/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9749E008 /* 151.73.224.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x97502A67 /* 151.80.42.103/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x97502CB1 /* 151.80.44.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x977F344F /* 151.127.52.79/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x97B11C7A /* 151.177.28.122/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x97B11C7A /* 151.177.28.122/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x97ECDA43 /* 151.236.218.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x97ECDA6B /* 151.236.218.107/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x97EDB96E /* 151.237.185.110/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x97EDB986 /* 151.237.185.134/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x984360B9 /* 152.67.96.185/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x985968CE /* 152.89.104.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x98596975 /* 152.89.105.117/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x98596A93 /* 152.89.106.147/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9859A04C /* 152.89.160.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9859D3F6 /* 152.89.211.246/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9859F4FB /* 152.89.244.251/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x986189ED /* 152.97.137.237/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x98732E84 /* 152.115.46.132/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x995C7EEA /* 153.92.126.234/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x995C7FEF /* 153.92.127.239/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x99782A89 /* 153.120.42.137/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x997E805E /* 153.126.128.94/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x997ECCCC /* 153.126.204.204/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x997F27C4 /* 153.127.39.196/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x99F2CA02 /* 153.242.202.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9A032836 /* 154.3.40.54/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9A23AFE1 /* 154.35.175.225/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9A3903D6 /* 154.57.3.214/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9A3B7048 /* 154.59.112.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9B043F69 /* 155.4.63.105/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9B04460A /* 155.4.70.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9B046E25 /* 155.4.110.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9B620505 /* 155.98.5.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9B620505 /* 155.98.5.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9B620506 /* 155.98.5.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9B620506 /* 155.98.5.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9B8A8F1C /* 155.138.143.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9D1616FE /* 157.22.22.254/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9D6117B1 /* 157.97.23.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9D838DA7 /* 157.131.141.167/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x9D838DA7 /* 157.131.141.167/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x9D839AF1 /* 157.131.154.241/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x9DA13946 /* 157.161.57.70/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9DE649AE /* 157.230.73.174/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9DE67078 /* 157.230.112.120/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x9DE6BE44 /* 157.230.190.68/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9DE73042 /* 157.231.48.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9DF51A34 /* 157.245.26.52/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9DF56516 /* 157.245.101.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9DF5B80D /* 157.245.184.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9E336046 /* 158.51.96.70/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9E3AAD4E /* 158.58.173.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9E4500F6 /* 158.69.0.246/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9E4521DB /* 158.69.33.219/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9E4523E3 /* 158.69.35.227/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9E452486 /* 158.69.36.134/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9E45248E /* 158.69.36.142/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9E4524AB /* 158.69.36.171/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9E453F36 /* 158.69.63.54/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9E45660B /* 158.69.102.11/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9E45660E /* 158.69.102.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9E456669 /* 158.69.102.105/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9E4566D3 /* 158.69.102.211/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9E4566E1 /* 158.69.102.225/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9E45C92F /* 158.69.201.47/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9E45CC24 /* 158.69.204.36/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9E45CD5C /* 158.69.205.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9E45CDF7 /* 158.69.205.247/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9E45CFD8 /* 158.69.207.216/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9E45D922 /* 158.69.217.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9E45DA4E /* 158.69.218.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9E658B56 /* 158.101.139.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9E65A8E1 /* 158.101.168.225/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x9E65B7E7 /* 158.101.183.231/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x9E8CCAD5 /* 158.140.202.213/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x9E8CCE4B /* 158.140.206.75/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9EAE7130 /* 158.174.113.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9EAE7130 /* 158.174.113.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9EAE7276 /* 158.174.114.118/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x9EAE918B /* 158.174.145.139/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x9EFF0170 /* 158.255.1.112/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9EFF06F2 /* 158.255.6.242/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9EFF073D /* 158.255.7.61/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9EFFD4B2 /* 158.255.212.178/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x9EFFD729 /* 158.255.215.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9EFFD7C1 /* 158.255.215.193/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x9F4102CC /* 159.65.2.204/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9F410ABD /* 159.65.10.189/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9F411086 /* 159.65.16.134/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9F4502EF /* 159.69.2.239/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9F450C80 /* 159.69.12.128/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9F4515C4 /* 159.69.21.196/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9F452403 /* 159.69.36.3/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9F45262C /* 159.69.38.44/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9F45265D /* 159.69.38.93/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9F4555DC /* 159.69.85.220/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9F456FB3 /* 159.69.111.179/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9F45726E /* 159.69.114.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9F459351 /* 159.69.147.81/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9F4598D0 /* 159.69.152.208/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9F45B8AC /* 159.69.184.172/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9F45CF14 /* 159.69.207.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9F590E78 /* 159.89.14.120/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9F598AA2 /* 159.89.138.162/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9F599505 /* 159.89.149.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9F59ABB4 /* 159.89.171.180/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9F59AE09 /* 159.89.174.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9F59CDB8 /* 159.89.205.184/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9F932C6E /* 159.147.44.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9F94BAC4 /* 159.148.186.196/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0x9FCB1633 /* 159.203.22.51/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9FCB1B05 /* 159.203.27.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9FCB1DF0 /* 159.203.29.240/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0x9FCB5558 /* 159.203.85.88/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA01492EF /* 160.20.146.239/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA077F918 /* 160.119.249.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA077F9DE /* 160.119.249.222/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA077F9DF /* 160.119.249.223/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA077F9EF /* 160.119.249.239/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA077F9F0 /* 160.119.249.240/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA077FD67 /* 160.119.253.103/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA077FD72 /* 160.119.253.114/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA0CAA2BA /* 160.202.162.186/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA12314ED /* 161.35.20.237/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA123572D /* 161.35.87.45/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA1235B29 /* 161.35.91.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA123736D /* 161.35.115.109/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA123E176 /* 161.35.225.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA135A068 /* 161.53.160.104/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA161436A /* 161.97.67.106/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA1614689 /* 161.97.70.137/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA16167ED /* 161.97.103.237/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA16175FC /* 161.97.117.252/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2C895DD /* 162.200.149.221/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA2CFCE70 /* 162.207.206.112/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA2D49E52 /* 162.212.158.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2D49E52 /* 162.212.158.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2D503DD /* 162.213.3.221/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2DDD9F1 /* 162.221.217.241/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA2E23846 /* 162.226.56.70/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2EDCF35 /* 162.237.207.53/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F348C6 /* 162.243.72.198/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F3C2CB /* 162.243.194.203/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F4506F /* 162.244.80.111/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F45080 /* 162.244.80.128/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F4508D /* 162.244.80.141/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F450BE /* 162.244.80.190/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F748C7 /* 162.247.72.199/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F749C0 /* 162.247.73.192/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F74A07 /* 162.247.74.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F74A1B /* 162.247.74.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F74A4A /* 162.247.74.74/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F74AC8 /* 162.247.74.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F74AC9 /* 162.247.74.201/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F74ACA /* 162.247.74.202/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F74ACC /* 162.247.74.204/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F74ACE /* 162.247.74.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F74AD5 /* 162.247.74.213/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F74AD8 /* 162.247.74.216/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F74AD9 /* 162.247.74.217/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F80408 /* 162.248.4.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F8A00F /* 162.248.160.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F8A11A /* 162.248.161.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F8A11C /* 162.248.161.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F8A11E /* 162.248.161.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F8A11F /* 162.248.161.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F8A121 /* 162.248.161.33/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F8A122 /* 162.248.161.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F8A123 /* 162.248.161.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F8A124 /* 162.248.161.36/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F8A125 /* 162.248.161.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2F8A126 /* 162.248.161.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2FABF0F /* 162.250.191.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2FABF0F /* 162.250.191.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA2FF54F8 /* 162.255.84.248/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA31611D3 /* 163.22.17.211/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA32CAD25 /* 163.44.173.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA37BF423 /* 163.123.244.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA39E0DB1 /* 163.158.13.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC07E9 /* 163.172.7.233/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC0EDD /* 163.172.14.221/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC1575 /* 163.172.21.117/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC1976 /* 163.172.25.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC19AE /* 163.172.25.174/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC1BE0 /* 163.172.27.224/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC1C76 /* 163.172.28.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC1D1E /* 163.172.29.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC1D22 /* 163.172.29.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC2324 /* 163.172.35.36/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC2474 /* 163.172.36.116/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC29E4 /* 163.172.41.228/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC2A34 /* 163.172.42.52/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC2B51 /* 163.172.43.81/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC2B6D /* 163.172.43.109/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC2B6D /* 163.172.43.109/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC2F22 /* 163.172.47.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC30EE /* 163.172.48.238/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC315C /* 163.172.49.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC315C /* 163.172.49.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC35C9 /* 163.172.53.201/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC3A02 /* 163.172.58.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC3C19 /* 163.172.60.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC3C19 /* 163.172.60.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC3F7A /* 163.172.63.122/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC44DE /* 163.172.68.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC45A6 /* 163.172.69.166/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC48FA /* 163.172.72.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC494E /* 163.172.73.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC5485 /* 163.172.84.133/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC5A80 /* 163.172.90.128/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC5E77 /* 163.172.94.119/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC5E90 /* 163.172.94.144/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC5F84 /* 163.172.95.132/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC60DE /* 163.172.96.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC81EE /* 163.172.129.238/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC887D /* 163.172.136.125/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC8B68 /* 163.172.139.104/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC8D0A /* 163.172.141.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC8E5C /* 163.172.142.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC9335 /* 163.172.147.53/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC97CE /* 163.172.151.206/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC9AA2 /* 163.172.154.162/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA3AC9DD5 /* 163.172.157.213/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA3ACA9FD /* 163.172.169.253/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA3ACB31F /* 163.172.179.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3ACB61A /* 163.172.182.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3ACB636 /* 163.172.182.54/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3ACB693 /* 163.172.182.147/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA3ACB820 /* 163.172.184.32/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3ACB8F3 /* 163.172.184.243/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA3ACC235 /* 163.172.194.53/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3ACD236 /* 163.172.210.54/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA3ACD380 /* 163.172.211.128/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA3ACD3D2 /* 163.172.211.210/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA3ACD562 /* 163.172.213.98/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA434F9D5 /* 164.52.249.213/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA4446A5E /* 164.68.106.94/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA4446BDE /* 164.68.107.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA4446C3B /* 164.68.108.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA44D85DC /* 164.77.133.220/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA48409C7 /* 164.132.9.199/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA484431B /* 164.132.67.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA484E21E /* 164.132.226.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA4A08105 /* 164.160.129.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA5162DB4 /* 165.22.45.180/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA5163997 /* 165.22.57.151/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA516D465 /* 165.22.212.101/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA516D48D /* 165.22.212.141/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA516E6A4 /* 165.22.230.164/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA516ECFB /* 165.22.236.251/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA5781F92 /* 165.120.31.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA5A9CD7F /* 165.169.205.127/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA5E31FFA /* 165.227.31.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA5E32071 /* 165.227.32.113/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA5E322F0 /* 165.227.34.240/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA5E32FA9 /* 165.227.47.169/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA5E331BC /* 165.227.49.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA5E36BC6 /* 165.227.107.198/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA5E3A13C /* 165.227.161.60/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA5E3A13E /* 165.227.161.62/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA5E3AE96 /* 165.227.174.150/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA5E3D81F /* 165.227.216.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA646CF02 /* 166.70.207.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA7478DF3 /* 167.71.141.243/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA747DB7C /* 167.71.219.124/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA747EA9C /* 167.71.234.156/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA75642A8 /* 167.86.66.168/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA7565E6B /* 167.86.94.107/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA756643B /* 167.86.100.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA756660C /* 167.86.102.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA7566EFE /* 167.86.110.254/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA7567046 /* 167.86.112.70/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA75672F4 /* 167.86.114.244/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA7567F82 /* 167.86.127.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA7580786 /* 167.88.7.134/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA758A1D1 /* 167.88.161.209/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA7722D71 /* 167.114.45.113/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA7726713 /* 167.114.103.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA7729098 /* 167.114.144.152/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA772AA9C /* 167.114.170.156/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA772F470 /* 167.114.244.112/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA7AC7D7B /* 167.172.125.123/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA7ACEDCB /* 167.172.237.203/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA7B34EFC /* 167.179.78.252/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA7B3778F /* 167.179.119.143/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA7B3A53C /* 167.179.165.60/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA7E0E749 /* 167.224.231.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA8773BB9 /* 168.119.59.185/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA8779ED0 /* 168.119.158.208/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA877A147 /* 168.119.161.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xA877A7F2 /* 168.119.167.242/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xA8EB431E /* 168.235.67.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAA27DA03 /* 170.39.218.3/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAA34AEBB /* 170.52.174.187/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAA4BA202 /* 170.75.162.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAA4BA274 /* 170.75.162.116/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAA4BA329 /* 170.75.163.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAA4BA36E /* 170.75.163.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAA4BA37F /* 170.75.163.127/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAA4BA38B /* 170.75.163.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAA4BA390 /* 170.75.163.144/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAA4BA3D2 /* 170.75.163.210/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAA4BA3DB /* 170.75.163.219/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAA4BA402 /* 170.75.164.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAA4BA425 /* 170.75.164.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAA4BA428 /* 170.75.164.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAA4BA46E /* 170.75.164.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAA4BA48D /* 170.75.164.141/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAA4BA48F /* 170.75.164.143/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAA4BA4A0 /* 170.75.164.160/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAA4BA4BC /* 170.75.164.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAA4BA4C9 /* 170.75.164.201/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAA4BA4D7 /* 170.75.164.215/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAA4BA8CD /* 170.75.168.205/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAA4BA8DA /* 170.75.168.218/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAA4BA906 /* 170.75.169.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAA4BAFC6 /* 170.75.175.198/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAA4BAFD1 /* 170.75.175.209/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAAEF578B /* 170.239.87.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAB19C109 /* 171.25.193.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAB19C114 /* 171.25.193.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAB19C119 /* 171.25.193.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAB19C14D /* 171.25.193.77/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAB19C14E /* 171.25.193.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAB19C18B /* 171.25.193.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xABF421BD /* 171.244.33.189/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC49317D /* 172.73.49.125/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC51B12C /* 172.81.177.44/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC51B156 /* 172.81.177.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC51B1DA /* 172.81.177.218/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC51B21D /* 172.81.178.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC51B245 /* 172.81.178.69/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC51B29B /* 172.81.178.155/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC51B29F /* 172.81.178.159/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC51B2C3 /* 172.81.178.195/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC51B2C8 /* 172.81.178.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC51B2E1 /* 172.81.178.225/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC51B2FF /* 172.81.178.255/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC51B320 /* 172.81.179.32/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC51B3D2 /* 172.81.179.210/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC51B40A /* 172.81.180.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC51B411 /* 172.81.180.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC51B50E /* 172.81.181.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC51B5FE /* 172.81.181.254/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC51B63C /* 172.81.182.60/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC51B692 /* 172.81.182.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC51B6A1 /* 172.81.182.161/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC51B6AA /* 172.81.182.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC51B6B9 /* 172.81.182.185/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC51B6F2 /* 172.81.182.242/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC51B700 /* 172.81.183.0/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC51B708 /* 172.81.183.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC51B786 /* 172.81.183.134/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC568B94 /* 172.86.139.148/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC56900F /* 172.86.144.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC56903B /* 172.86.144.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC59AA87 /* 172.89.170.135/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC5E0E3B /* 172.94.14.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC61CA5B /* 172.97.202.91/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC62C12B /* 172.98.193.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC62C13E /* 172.98.193.62/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC67A4CE /* 172.103.164.206/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC6804F1 /* 172.104.4.241/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC680D4D /* 172.104.13.77/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC681BD8 /* 172.104.27.216/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC68231B /* 172.104.35.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC6824AA /* 172.104.36.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC68318C /* 172.104.49.140/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC6842BC /* 172.104.66.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC684CF2 /* 172.104.76.242/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC684EC5 /* 172.104.78.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC684FDE /* 172.104.79.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC68552B /* 172.104.85.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC68567A /* 172.104.86.122/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC6857FA /* 172.104.87.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC68582B /* 172.104.88.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC685F52 /* 172.104.95.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC68654C /* 172.104.101.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC686D2F /* 172.104.109.47/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC686F5E /* 172.104.111.94/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC687E6D /* 172.104.126.109/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC688326 /* 172.104.131.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC688889 /* 172.104.136.137/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC688A89 /* 172.104.138.137/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC6894DB /* 172.104.148.219/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC689D41 /* 172.104.157.65/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC68A726 /* 172.104.167.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC68AA52 /* 172.104.170.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC68B167 /* 172.104.177.103/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC68B3D2 /* 172.104.179.210/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC68B3DC /* 172.104.179.220/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC68B7E2 /* 172.104.183.226/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC68BBBC /* 172.104.187.188/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC68BFEA /* 172.104.191.234/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC68CEF9 /* 172.104.206.249/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC68D0BE /* 172.104.208.190/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC68E3B6 /* 172.104.227.182/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC68F90A /* 172.104.249.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC690499 /* 172.105.4.153/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC6908F7 /* 172.105.8.247/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC691337 /* 172.105.19.55/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC6916EC /* 172.105.22.236/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC6918B6 /* 172.105.24.182/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69191E /* 172.105.25.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC691D07 /* 172.105.29.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC692391 /* 172.105.35.145/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC6923F9 /* 172.105.35.249/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69256E /* 172.105.37.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC6929BB /* 172.105.41.187/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC692A73 /* 172.105.42.115/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69306F /* 172.105.48.111/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69342F /* 172.105.52.47/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69377D /* 172.105.55.125/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC6939EA /* 172.105.57.234/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC693B6E /* 172.105.59.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC693DD4 /* 172.105.61.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC693F0A /* 172.105.63.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69412D /* 172.105.65.45/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC695DC4 /* 172.105.93.196/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC695FD4 /* 172.105.95.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC6962D9 /* 172.105.98.217/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC6968E7 /* 172.105.104.231/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC6969EC /* 172.105.105.236/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC696ACD /* 172.105.106.205/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC696EBD /* 172.105.110.189/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC697487 /* 172.105.116.135/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC6974E6 /* 172.105.116.230/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC6978A2 /* 172.105.120.162/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC697AA1 /* 172.105.122.161/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC697F97 /* 172.105.127.151/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69971E /* 172.105.151.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69A3D3 /* 172.105.163.211/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69A3DE /* 172.105.163.222/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69A997 /* 172.105.169.151/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69AA2B /* 172.105.170.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69AB49 /* 172.105.171.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69AB8D /* 172.105.171.141/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69ADC6 /* 172.105.173.198/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69AE8D /* 172.105.174.141/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69AF92 /* 172.105.175.146/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69B1BC /* 172.105.177.188/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69B7F4 /* 172.105.183.244/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69B928 /* 172.105.185.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69B956 /* 172.105.185.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69B996 /* 172.105.185.150/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69BA2A /* 172.105.186.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69BA62 /* 172.105.186.98/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69BA6C /* 172.105.186.108/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69BB17 /* 172.105.187.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69BC16 /* 172.105.188.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69C080 /* 172.105.192.128/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69C20E /* 172.105.194.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69C51B /* 172.105.197.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69C593 /* 172.105.197.147/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69C711 /* 172.105.199.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69C79B /* 172.105.199.155/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69CC20 /* 172.105.204.32/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69CF2A /* 172.105.207.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69D6A2 /* 172.105.214.162/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69E711 /* 172.105.231.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69EC44 /* 172.105.236.68/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69F275 /* 172.105.242.117/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAC69F642 /* 172.105.246.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC6A0043 /* 172.106.0.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC6B5C12 /* 172.107.92.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAC6BC986 /* 172.107.201.134/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xACF18C1A /* 172.241.140.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xACF515D7 /* 172.245.21.215/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAD4048F7 /* 173.64.72.247/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAD4296D1 /* 173.66.150.209/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAD491C90 /* 173.73.28.144/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAD49238B /* 173.73.35.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAD4B273D /* 173.75.39.61/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAD525355 /* 173.82.83.85/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xADA0B4BD /* 173.160.180.189/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xADD4C0A2 /* 173.212.192.162/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xADD4C266 /* 173.212.194.102/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xADD4C8F1 /* 173.212.200.241/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xADD4D10A /* 173.212.209.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xADD4D9F7 /* 173.212.217.247/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xADD4DAA5 /* 173.212.218.165/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xADD4DB31 /* 173.212.219.49/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xADD4DD0A /* 173.212.221.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xADD4DE6D /* 173.212.222.109/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xADD4E7E4 /* 173.212.231.228/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xADD4ED10 /* 173.212.237.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xADD4EF4E /* 173.212.239.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xADD4EF4E /* 173.212.239.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xADD4F15D /* 173.212.241.93/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xADD4F26E /* 173.212.242.110/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xADD4FDAC /* 173.212.253.172/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xADD4FEC0 /* 173.212.254.192/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xADD711B3 /* 173.215.17.179/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xADE680E8 /* 173.230.128.232/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xADE6895B /* 173.230.137.91/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xADE68A20 /* 173.230.138.32/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xADE6996D /* 173.230.153.109/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xADE69A5A /* 173.230.154.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xADEF4FCB /* 173.239.79.203/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xADF4D105 /* 173.244.209.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xADF902E0 /* 173.249.2.224/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xADF90798 /* 173.249.7.152/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xADF90871 /* 173.249.8.113/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xADF91D89 /* 173.249.29.137/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xADF91E77 /* 173.249.30.119/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xADF93056 /* 173.249.48.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xADF9393D /* 173.249.57.61/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xADF939FD /* 173.249.57.253/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xADF93A1E /* 173.249.58.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xADF93FE3 /* 173.249.63.227/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xADFF8C1B /* 173.255.140.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xADFFCD71 /* 173.255.205.113/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xADFFD0F8 /* 173.255.208.248/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xADFFE486 /* 173.255.228.134/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xADFFF2B8 /* 173.255.242.184/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xADFFF574 /* 173.255.245.116/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xADFFF9EA /* 173.255.249.234/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xADFFFACB /* 173.255.250.203/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xADFFFADB /* 173.255.250.219/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xADFFFFE4 /* 173.255.255.228/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAE361A5B /* 174.54.26.91/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAE590695 /* 174.89.6.149/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAE59ECA1 /* 174.89.236.161/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAE5C7E8D /* 174.92.126.141/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAE5D1AB9 /* 174.93.26.185/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAE5D54BC /* 174.93.84.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAE605D7D /* 174.96.93.125/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAE7FA9E9 /* 174.127.169.233/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAE886272 /* 174.136.98.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAE8A2CF2 /* 174.138.44.242/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAE8A3B64 /* 174.138.59.100/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAE8CE376 /* 174.140.227.118/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xAE8DC829 /* 174.141.200.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAE8DC829 /* 174.141.200.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xAF84249A /* 175.132.36.154/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB0090162 /* 176.9.1.98/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB00901D3 /* 176.9.1.211/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB0090D85 /* 176.9.13.133/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB0091170 /* 176.9.17.112/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB009256F /* 176.9.37.111/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB00927C4 /* 176.9.39.196/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB0092843 /* 176.9.40.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB0092883 /* 176.9.40.131/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB00932F0 /* 176.9.50.240/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB00935CA /* 176.9.53.202/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB009460C /* 176.9.70.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB0094B6E /* 176.9.75.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB009542D /* 176.9.84.45/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB00962E4 /* 176.9.98.228/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB00972FC /* 176.9.114.252/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB0097649 /* 176.9.118.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB0097728 /* 176.9.119.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB0097B7A /* 176.9.123.122/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB009896E /* 176.9.137.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB0099414 /* 176.9.148.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB0099AF7 /* 176.9.154.247/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB0099CCA /* 176.9.156.202/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB009D00C /* 176.9.208.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB00A63C8 /* 176.10.99.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB00A63C9 /* 176.10.99.201/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB00A63CA /* 176.10.99.202/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB00A63CB /* 176.10.99.203/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB00A63CC /* 176.10.99.204/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB00A63CD /* 176.10.99.205/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB00A63CE /* 176.10.99.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB00A63CF /* 176.10.99.207/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB00A63D0 /* 176.10.99.208/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB00A63D1 /* 176.10.99.209/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB00A63D2 /* 176.10.99.210/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB00A68F0 /* 176.10.104.240/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB00A68F0 /* 176.10.104.240/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB00A6BB4 /* 176.10.107.180/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB014C4E0 /* 176.20.196.224/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB01F2395 /* 176.31.35.149/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB01F6796 /* 176.31.103.150/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB01F749B /* 176.31.116.155/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB01FA359 /* 176.31.163.89/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB01FB41D /* 176.31.180.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB01FD356 /* 176.31.211.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB02475B9 /* 176.36.117.185/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB02496F6 /* 176.36.150.246/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB026B1D0 /* 176.38.177.208/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB035168E /* 176.53.22.142/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB0355A1A /* 176.53.90.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB0394FF9 /* 176.57.79.249/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB03A6462 /* 176.58.100.98/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB03A6E42 /* 176.58.110.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB03A799F /* 176.58.121.159/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB03A79B1 /* 176.58.121.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB043AAC0 /* 176.67.170.192/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB04ADAAF /* 176.74.218.175/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB0543F52 /* 176.84.63.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB06AC987 /* 176.106.201.135/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB06BB01F /* 176.107.176.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB06BB393 /* 176.107.179.147/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB06BBB97 /* 176.107.187.151/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB072F82F /* 176.114.248.47/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB0746831 /* 176.116.104.49/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB074C0D7 /* 176.116.192.215/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB0795133 /* 176.121.81.51/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB07B0440 /* 176.123.4.64/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB07B0504 /* 176.123.5.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB07B05C1 /* 176.123.5.193/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB07B05E3 /* 176.123.5.227/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB07B05FA /* 176.123.5.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB07B060A /* 176.123.6.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB07B060D /* 176.123.6.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB07B0629 /* 176.123.6.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB07B0766 /* 176.123.7.102/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB07B0791 /* 176.123.7.145/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB07B07B5 /* 176.123.7.181/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB07B07C5 /* 176.123.7.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB07B0856 /* 176.123.8.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB07B08E8 /* 176.123.8.232/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB09E7A54 /* 176.158.122.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB09EEC66 /* 176.158.236.102/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB0A51CA5 /* 176.165.28.165/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB0C121EB /* 176.193.33.235/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB0C1F809 /* 176.193.248.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB0C6DA61 /* 176.198.218.97/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB0C6DA61 /* 176.198.218.97/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB0C6DBA5 /* 176.198.219.165/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB0DF8D6A /* 176.223.141.106/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB1CBE630 /* 177.203.230.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB1CD9AED /* 177.205.154.237/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB20B8B69 /* 178.11.139.105/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AA0D /* 178.17.170.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AA17 /* 178.17.170.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AA4D /* 178.17.170.77/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AA58 /* 178.17.170.88/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AA5B /* 178.17.170.91/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AA67 /* 178.17.170.103/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AA70 /* 178.17.170.112/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AA74 /* 178.17.170.116/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AA87 /* 178.17.170.135/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AA95 /* 178.17.170.149/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AAA4 /* 178.17.170.164/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AAA9 /* 178.17.170.169/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AAB2 /* 178.17.170.178/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AB05 /* 178.17.171.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AB19 /* 178.17.171.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AB27 /* 178.17.171.39/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AB37 /* 178.17.171.55/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AB4E /* 178.17.171.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AB52 /* 178.17.171.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AB66 /* 178.17.171.102/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AB73 /* 178.17.171.115/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AB7C /* 178.17.171.124/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211ABC5 /* 178.17.171.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AD1A /* 178.17.173.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AE02 /* 178.17.174.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AE0A /* 178.17.174.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AE0D /* 178.17.174.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AE0E /* 178.17.174.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AE44 /* 178.17.174.68/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AE4F /* 178.17.174.79/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AEA4 /* 178.17.174.164/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AEC4 /* 178.17.174.196/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AEC6 /* 178.17.174.198/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AED3 /* 178.17.174.211/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AEE0 /* 178.17.174.224/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AEE8 /* 178.17.174.232/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AEEF /* 178.17.174.239/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB211AEF2 /* 178.17.174.242/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2125EF7 /* 178.18.94.247/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB213607D /* 178.19.96.125/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2143710 /* 178.20.55.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2143712 /* 178.20.55.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB21A8727 /* 178.26.135.39/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB21AB69F /* 178.26.182.159/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB21B5873 /* 178.27.88.115/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB21B5873 /* 178.27.88.115/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB21B7B09 /* 178.27.123.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB220BD58 /* 178.32.189.88/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB220DC3D /* 178.32.220.61/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB220DF57 /* 178.32.223.87/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB221B7FB /* 178.33.183.251/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB224C1DF /* 178.36.193.223/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2267025 /* 178.38.112.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2271503 /* 178.39.21.3/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB227C793 /* 178.39.199.147/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB23E18D4 /* 178.62.24.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB23E56CE /* 178.62.86.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB23E5EF3 /* 178.62.94.243/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB23E6B7D /* 178.62.107.125/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB23EFBB8 /* 178.62.251.184/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB23EFC52 /* 178.62.252.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB23F12DF /* 178.63.18.223/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB23F137E /* 178.63.19.126/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB23F190A /* 178.63.25.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB23F1B52 /* 178.63.27.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB23F28BD /* 178.63.40.189/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB23F28C5 /* 178.63.40.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB23F444E /* 178.63.68.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB23F45FE /* 178.63.69.254/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB23F4818 /* 178.63.72.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB23F550E /* 178.63.85.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB23F57A5 /* 178.63.87.165/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB23F6122 /* 178.63.97.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB23F8A11 /* 178.63.138.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB23FAC0D /* 178.63.172.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB23FAC0E /* 178.63.172.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249D276 /* 178.73.210.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC09 /* 178.73.220.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC0A /* 178.73.220.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC0B /* 178.73.220.11/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC0C /* 178.73.220.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC0D /* 178.73.220.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC0E /* 178.73.220.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC0F /* 178.73.220.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC10 /* 178.73.220.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC11 /* 178.73.220.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC12 /* 178.73.220.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC13 /* 178.73.220.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC14 /* 178.73.220.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC16 /* 178.73.220.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC17 /* 178.73.220.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC18 /* 178.73.220.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC19 /* 178.73.220.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC1A /* 178.73.220.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC1B /* 178.73.220.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC1C /* 178.73.220.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC1D /* 178.73.220.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC1E /* 178.73.220.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC1F /* 178.73.220.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC20 /* 178.73.220.32/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC21 /* 178.73.220.33/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC22 /* 178.73.220.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC23 /* 178.73.220.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC24 /* 178.73.220.36/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC25 /* 178.73.220.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC26 /* 178.73.220.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC27 /* 178.73.220.39/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC28 /* 178.73.220.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB249DC29 /* 178.73.220.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB24EC9C0 /* 178.78.201.192/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB24EF1B6 /* 178.78.241.182/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB24F83F7 /* 178.79.131.247/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB24F86C4 /* 178.79.134.196/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB24FA1B1 /* 178.79.161.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB24FA3AA /* 178.79.163.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB24FA9C1 /* 178.79.169.193/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB24FB63F /* 178.79.182.63/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB252D7DB /* 178.82.215.219/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB252F104 /* 178.82.241.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2538128 /* 178.83.129.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB253AB53 /* 178.83.171.83/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2542ED0 /* 178.84.46.208/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2800908 /* 178.128.9.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2805D52 /* 178.128.93.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2807282 /* 178.128.114.130/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB2807334 /* 178.128.115.52/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2807E3D /* 178.128.126.61/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB280ECFA /* 178.128.236.250/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB280EF81 /* 178.128.239.129/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB280F732 /* 178.128.247.50/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB280F988 /* 178.128.249.136/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB2840006 /* 178.132.0.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2844E94 /* 178.132.78.148/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB28E7E15 /* 178.142.126.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB297C893 /* 178.151.200.147/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB297C893 /* 178.151.200.147/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB29D5BD3 /* 178.157.91.211/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2A2C2D2 /* 178.162.194.210/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB2A2C742 /* 178.162.199.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2A548B1 /* 178.165.72.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2AA0A08 /* 178.170.10.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2AA2A70 /* 178.170.42.112/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2AEACAD /* 178.174.172.173/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB2AF80B2 /* 178.175.128.178/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB2AF83C2 /* 178.175.131.194/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB2AF9494 /* 178.175.148.148/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB2AF94E0 /* 178.175.148.224/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB2BD88CB /* 178.189.136.203/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB2C3CEC3 /* 178.195.206.195/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB2C3CEC3 /* 178.195.206.195/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB2C9D8EF /* 178.201.216.239/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB2D12EAD /* 178.209.46.173/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2D32D12 /* 178.211.45.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2EEE061 /* 178.238.224.97/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2EFB049 /* 178.239.176.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2FA9DB1 /* 178.250.157.177/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB2FE0758 /* 178.254.7.88/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2FE0919 /* 178.254.9.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2FE120F /* 178.254.18.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2FE1297 /* 178.254.18.151/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2FE149F /* 178.254.20.159/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2FE1615 /* 178.254.22.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2FE1E42 /* 178.254.30.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2FE1E56 /* 178.254.30.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2FE1F7D /* 178.254.31.125/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2FE1FEE /* 178.254.31.238/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2FE2363 /* 178.254.35.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2FE289E /* 178.254.40.158/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB2FE2D40 /* 178.254.45.64/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB3190811 /* 179.25.8.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB32B86BC /* 179.43.134.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB32B92E6 /* 179.43.146.230/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB32B9789 /* 179.43.151.137/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB32B9CD6 /* 179.43.156.214/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB32B9EB0 /* 179.43.158.176/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB32BA0EA /* 179.43.160.234/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB32BA0EB /* 179.43.160.235/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB32BA0EC /* 179.43.160.236/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB32BA0ED /* 179.43.160.237/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB32BA0EE /* 179.43.160.238/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB32BA7E2 /* 179.43.167.226/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB32BA7E3 /* 179.43.167.227/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB32BA7E4 /* 179.43.167.228/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB32BA7E5 /* 179.43.167.229/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB32BA7E6 /* 179.43.167.230/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB32BA90E /* 179.43.169.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB32BA914 /* 179.43.169.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB32BA915 /* 179.43.169.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB32BBCCE /* 179.43.188.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB330FBBC /* 179.48.251.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB3910B8C /* 179.145.11.140/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB3BE71DB /* 179.190.113.219/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB3DA5DBD /* 179.218.93.189/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB4349D2A /* 180.52.157.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB4957D8A /* 180.149.125.138/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB496188D /* 180.150.24.141/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB496E263 /* 180.150.226.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB4D648A5 /* 180.214.72.165/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB4F37056 /* 180.243.112.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB4FC5A07 /* 180.252.90.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB574E6DA /* 181.116.230.218/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB5771E1A /* 181.119.30.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB6ABE944 /* 182.171.233.68/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB7594668 /* 183.89.70.104/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB760B209 /* 183.96.178.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB7B36EFD /* 183.179.110.253/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB838D75F /* 184.56.215.95/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB84BF76B /* 184.75.247.107/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB8699232 /* 184.105.146.50/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB869DC18 /* 184.105.220.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB869DDF8 /* 184.105.221.248/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB869DDF9 /* 184.105.221.249/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB899B1AC /* 184.153.177.172/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9021F08 /* 185.2.31.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9022B54 /* 185.2.43.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9022B57 /* 185.2.43.87/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9025229 /* 185.2.82.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9048487 /* 185.4.132.135/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9048494 /* 185.4.132.148/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB90484B7 /* 185.4.132.183/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9048668 /* 185.4.134.104/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9048668 /* 185.4.134.104/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB904874C /* 185.4.135.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB904874C /* 185.4.135.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9048787 /* 185.4.135.135/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB904879D /* 185.4.135.157/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9083F26 /* 185.8.63.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB908A585 /* 185.8.165.133/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB908EC83 /* 185.8.236.131/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB90A1029 /* 185.10.16.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB90A106C /* 185.10.16.108/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB90A4416 /* 185.10.68.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB90A4442 /* 185.10.68.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB90A44CD /* 185.10.68.205/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB90A44FE /* 185.10.68.254/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB90B925F /* 185.11.146.95/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB90BA776 /* 185.11.167.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB90C06EA /* 185.12.6.234/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB90C2D72 /* 185.12.45.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB90C2D73 /* 185.12.45.115/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB90C2D74 /* 185.12.45.116/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB90C2D75 /* 185.12.45.117/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB90C2D76 /* 185.12.45.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB90E1E39 /* 185.14.30.57/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB90F5C40 /* 185.15.92.64/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB90F5C42 /* 185.15.92.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB90FF6F3 /* 185.15.246.243/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB911B284 /* 185.17.178.132/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB911B865 /* 185.17.184.101/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9156432 /* 185.21.100.50/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB915D8C4 /* 185.21.216.196/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB915D8C5 /* 185.21.216.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB915D8C6 /* 185.21.216.198/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB915D8C6 /* 185.21.216.198/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB915D914 /* 185.21.217.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB915D920 /* 185.21.217.32/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB915D920 /* 185.21.217.32/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB915D921 /* 185.21.217.33/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB915D921 /* 185.21.217.33/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB916AC28 /* 185.22.172.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB916AC6A /* 185.22.172.106/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB916AC6A /* 185.22.172.106/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB916AD7A /* 185.22.173.122/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB916AE2E /* 185.22.174.46/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB916AE77 /* 185.22.174.119/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB91932C7 /* 185.25.50.199/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB91932C7 /* 185.25.50.199/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB91932D8 /* 185.25.50.216/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9193378 /* 185.25.51.120/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB91933CA /* 185.25.51.202/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB91933CA /* 185.25.51.202/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB91A9CDF /* 185.26.156.223/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB91B7F76 /* 185.27.127.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB91C6513 /* 185.28.101.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB91F88F4 /* 185.31.136.244/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB920DDC9 /* 185.32.221.201/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB920DEAB /* 185.32.222.171/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB920DEAC /* 185.32.222.172/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB920DEAD /* 185.32.222.173/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB920DEED /* 185.32.222.237/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB920DEED /* 185.32.222.237/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9222102 /* 185.34.33.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB923C8FA /* 185.35.200.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB923CADE /* 185.35.202.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB926AF47 /* 185.38.175.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB926AF48 /* 185.38.175.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB927721B /* 185.39.114.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9299A82 /* 185.41.154.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB92AAACB /* 185.42.170.203/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9334CB2 /* 185.51.76.178/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB933861A /* 185.51.134.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9358170 /* 185.53.129.112/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB93583CB /* 185.53.131.203/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB938AB5E /* 185.56.171.94/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB93D9479 /* 185.61.148.121/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB93D94E1 /* 185.61.148.225/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB93FFD82 /* 185.63.253.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB94186AF /* 185.65.134.175/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB94186AF /* 185.65.134.175/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB941CD0A /* 185.65.205.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB941CD62 /* 185.65.205.98/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB941CE9A /* 185.65.206.154/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB942FA28 /* 185.66.250.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9435272 /* 185.67.82.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB948F418 /* 185.72.244.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB948F425 /* 185.72.244.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB948F791 /* 185.72.247.145/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB949DC08 /* 185.73.220.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB949F0CD /* 185.73.240.205/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB94ABE3C /* 185.74.190.60/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB94D8123 /* 185.77.129.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9501E66 /* 185.80.30.102/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB950DE9E /* 185.80.222.158/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB950DEA4 /* 185.80.222.164/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9527E1E /* 185.82.126.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9527E64 /* 185.82.126.100/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9527EBE /* 185.82.126.190/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9527EEE /* 185.82.126.238/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9527EF9 /* 185.82.126.249/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9527F07 /* 185.82.127.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9527F0B /* 185.82.127.11/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9527F30 /* 185.82.127.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB952D927 /* 185.82.217.39/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB952DB55 /* 185.82.219.85/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB952DB6D /* 185.82.219.109/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB95451F0 /* 185.84.81.240/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB95605DF /* 185.86.5.223/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB956944F /* 185.86.148.79/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB956945A /* 185.86.148.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB956963A /* 185.86.150.58/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9569685 /* 185.86.150.133/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB95697A8 /* 185.86.151.168/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB95A3C49 /* 185.90.60.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB95A3DDA /* 185.90.61.218/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB95A3DDB /* 185.90.61.219/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB95A3DDC /* 185.90.61.220/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB95A3DDE /* 185.90.61.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB95A3DDF /* 185.90.61.223/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB95A3DE0 /* 185.90.61.224/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB95EC0D1 /* 185.94.192.209/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9612022 /* 185.97.32.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB96302B2 /* 185.99.2.178/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9645455 /* 185.100.84.85/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9645455 /* 185.100.84.85/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB96454D4 /* 185.100.84.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB96454FB /* 185.100.84.251/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB964553D /* 185.100.85.61/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9645565 /* 185.100.85.101/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9645584 /* 185.100.85.132/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9645680 /* 185.100.86.128/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB964569A /* 185.100.86.154/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB96456B6 /* 185.100.86.182/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9645729 /* 185.100.87.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9645729 /* 185.100.87.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB964573D /* 185.100.87.61/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB964573D /* 185.100.87.61/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB96457CE /* 185.100.87.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB96457CF /* 185.100.87.207/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB96457F0 /* 185.100.87.240/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB96457F1 /* 185.100.87.241/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB96457F2 /* 185.100.87.242/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB96457F3 /* 185.100.87.243/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB96457F4 /* 185.100.87.244/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB96457FB /* 185.100.87.251/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB96523BD /* 185.101.35.189/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9676E0E /* 185.103.110.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9676E90 /* 185.103.110.144/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9676EF8 /* 185.103.110.248/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9678713 /* 185.103.135.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB96B2FAB /* 185.107.47.171/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB96B2FD7 /* 185.107.47.215/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB96B46CA /* 185.107.70.202/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB96B4729 /* 185.107.71.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB96B5301 /* 185.107.83.1/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB96C8172 /* 185.108.129.114/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB96D40BF /* 185.109.64.191/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB96D5B7E /* 185.109.91.126/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB96EB8AC /* 185.110.184.172/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9705232 /* 185.112.82.50/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB970900B /* 185.112.144.11/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9709082 /* 185.112.144.130/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB970929B /* 185.112.146.155/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB97092B3 /* 185.112.146.179/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9709D87 /* 185.112.157.135/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9718C14 /* 185.113.140.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9718C9B /* 185.113.140.155/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9718F56 /* 185.113.143.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9718F57 /* 185.113.143.87/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9718F59 /* 185.113.143.89/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9718F5B /* 185.113.143.91/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9755244 /* 185.117.82.68/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9755247 /* 185.117.82.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB97559A8 /* 185.117.89.168/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB975763B /* 185.117.118.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9757684 /* 185.117.118.132/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB975D709 /* 185.117.215.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB976441F /* 185.118.68.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9764420 /* 185.118.68.32/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9764421 /* 185.118.68.33/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9764422 /* 185.118.68.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9764423 /* 185.118.68.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9764424 /* 185.118.68.36/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9764425 /* 185.118.68.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9764426 /* 185.118.68.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9764427 /* 185.118.68.39/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9764428 /* 185.118.68.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB976A429 /* 185.118.164.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB976FBCD /* 185.118.251.205/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9784D75 /* 185.120.77.117/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9794510 /* 185.121.69.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9794528 /* 185.121.69.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9794529 /* 185.121.69.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB979452A /* 185.121.69.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB97D213A /* 185.125.33.58/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB97DCEBA /* 185.125.206.186/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB97DD942 /* 185.125.217.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9802952 /* 185.128.41.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB980D67D /* 185.128.214.125/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9813C83 /* 185.129.60.131/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9813E3E /* 185.129.62.62/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9822C6C /* 185.130.44.108/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9861C4F /* 185.134.28.79/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB98C3503 /* 185.140.53.3/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB98C3504 /* 185.140.53.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB98C3506 /* 185.140.53.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB98C3507 /* 185.140.53.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB98C3508 /* 185.140.53.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB98C3509 /* 185.140.53.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB98C350A /* 185.140.53.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB98EEF31 /* 185.142.239.49/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB990CFEB /* 185.144.207.235/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB991824D /* 185.145.130.77/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9929DC4 /* 185.146.157.196/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB992E482 /* 185.146.228.130/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB992E482 /* 185.146.228.130/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB992E483 /* 185.146.228.131/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB992E483 /* 185.146.228.131/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9930A30 /* 185.147.10.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967501 /* 185.150.117.1/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967502 /* 185.150.117.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB996750C /* 185.150.117.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB996750D /* 185.150.117.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB996750F /* 185.150.117.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967510 /* 185.150.117.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967511 /* 185.150.117.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967512 /* 185.150.117.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967513 /* 185.150.117.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967516 /* 185.150.117.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967517 /* 185.150.117.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967519 /* 185.150.117.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB996751D /* 185.150.117.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB996751E /* 185.150.117.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB996751F /* 185.150.117.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967520 /* 185.150.117.32/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967521 /* 185.150.117.33/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB996752D /* 185.150.117.45/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB996753E /* 185.150.117.62/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB996753F /* 185.150.117.63/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967544 /* 185.150.117.68/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967546 /* 185.150.117.70/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB996754B /* 185.150.117.75/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967561 /* 185.150.117.97/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967565 /* 185.150.117.101/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967566 /* 185.150.117.102/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB996756B /* 185.150.117.107/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB996756C /* 185.150.117.108/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967575 /* 185.150.117.117/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967576 /* 185.150.117.118/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967577 /* 185.150.117.119/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967578 /* 185.150.117.120/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967579 /* 185.150.117.121/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB996757A /* 185.150.117.122/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB996757B /* 185.150.117.123/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB996757C /* 185.150.117.124/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB996757D /* 185.150.117.125/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB996757E /* 185.150.117.126/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99675C0 /* 185.150.117.192/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99675C2 /* 185.150.117.194/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99675C3 /* 185.150.117.195/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99675C5 /* 185.150.117.197/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99675C8 /* 185.150.117.200/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99675CA /* 185.150.117.202/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99675CB /* 185.150.117.203/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99675CC /* 185.150.117.204/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99675CD /* 185.150.117.205/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99675CE /* 185.150.117.206/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99675CF /* 185.150.117.207/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99675D0 /* 185.150.117.208/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99675DB /* 185.150.117.219/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99675DE /* 185.150.117.222/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99675DF /* 185.150.117.223/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99675E2 /* 185.150.117.226/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99675EA /* 185.150.117.234/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99675F2 /* 185.150.117.242/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99675F4 /* 185.150.117.244/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99675F5 /* 185.150.117.245/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99675F8 /* 185.150.117.248/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99675F9 /* 185.150.117.249/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99675FA /* 185.150.117.250/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99675FB /* 185.150.117.251/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99675FC /* 185.150.117.252/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99675FD /* 185.150.117.253/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967784 /* 185.150.119.132/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967786 /* 185.150.119.134/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967787 /* 185.150.119.135/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967788 /* 185.150.119.136/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967789 /* 185.150.119.137/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB996778C /* 185.150.119.140/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB996778D /* 185.150.119.141/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9967799 /* 185.150.119.153/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB996779D /* 185.150.119.157/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB996779F /* 185.150.119.159/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99677A3 /* 185.150.119.163/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB996A21B /* 185.150.162.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB99A9ABB /* 185.154.154.187/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB99CAD94 /* 185.156.173.148/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9A1D19F /* 185.161.209.159/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9A2F97E /* 185.162.249.126/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9A2FB1C /* 185.162.251.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9A2FB1C /* 185.162.251.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9A2FB5E /* 185.162.251.94/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9A2FBF9 /* 185.162.251.249/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9A32D6B /* 185.163.45.107/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9A32DD4 /* 185.163.45.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9A32DF7 /* 185.163.45.247/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9A32DFD /* 185.163.45.253/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9A32E8A /* 185.163.46.138/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9A37593 /* 185.163.117.147/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9A376E2 /* 185.163.118.226/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9A5449A /* 185.165.68.154/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9A5A84D /* 185.165.168.77/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9A5A8A8 /* 185.165.168.168/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9A5A8E5 /* 185.165.168.229/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9A5A98A /* 185.165.169.138/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9A5A9DE /* 185.165.169.222/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9A5AB0E /* 185.165.171.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9A5F07E /* 185.165.240.126/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9A5F205 /* 185.165.242.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9A7A0DB /* 185.167.160.219/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9AA711C /* 185.170.113.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9AA711C /* 185.170.113.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9AA7165 /* 185.170.113.101/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9AA7219 /* 185.170.114.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9ADB199 /* 185.173.177.153/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9ADEB22 /* 185.173.235.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9AF3878 /* 185.175.56.120/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9B17F22 /* 185.177.127.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9B17F23 /* 185.177.127.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9B19721 /* 185.177.151.33/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9B1972A /* 185.177.151.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9B53CB5 /* 185.181.60.181/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9B5A0D8 /* 185.181.160.216/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9B5E54D /* 185.181.229.77/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9B79F63 /* 185.183.159.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9B79F63 /* 185.183.159.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9B945D4 /* 185.185.69.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9B9AA1B /* 185.185.170.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9BA4DE9 /* 185.186.77.233/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9BA4E78 /* 185.186.78.120/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9BA4F9F /* 185.186.79.159/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9BD32FD /* 185.189.50.253/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9BD70A2 /* 185.189.112.162/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9BDB78F /* 185.189.183.143/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9BFCCFE /* 185.191.204.254/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9C17FA7 /* 185.193.127.167/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9C2EFDC /* 185.194.239.220/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9C3ED18 /* 185.195.237.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9C3ED19 /* 185.195.237.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9C3ED75 /* 185.195.237.117/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9C3ED76 /* 185.195.237.118/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9C3ED7B /* 185.195.237.123/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9C402FB /* 185.196.2.251/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9C61A95 /* 185.198.26.149/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9C638AF /* 185.198.56.175/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9CB761B /* 185.203.118.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9CB7787 /* 185.203.119.135/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9CC01EF /* 185.204.1.239/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9CDBB45 /* 185.205.187.69/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9CDD123 /* 185.205.209.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9CDD285 /* 185.205.210.133/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9CDD2F5 /* 185.205.210.245/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9CFCD95 /* 185.207.205.149/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9CFD3CA /* 185.207.211.202/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9D3132B /* 185.211.19.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9D480EC /* 185.212.128.236/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9D48122 /* 185.212.129.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9D4956F /* 185.212.149.111/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9D4957D /* 185.212.149.125/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9D51467 /* 185.213.20.103/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9D51468 /* 185.213.20.104/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9D51469 /* 185.213.20.105/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9D5146A /* 185.213.20.106/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9D5146B /* 185.213.20.107/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9D514D5 /* 185.213.20.213/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9D514F7 /* 185.213.20.247/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9D59BA9 /* 185.213.155.169/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9D59BA9 /* 185.213.155.169/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9D82082 /* 185.216.32.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9D90055 /* 185.217.0.85/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9D90060 /* 185.217.0.96/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9D95D5C /* 185.217.93.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9D95F19 /* 185.217.95.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC64F0 /* 185.220.100.240/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC64F0 /* 185.220.100.240/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC64F1 /* 185.220.100.241/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC64F1 /* 185.220.100.241/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC64F2 /* 185.220.100.242/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC64F2 /* 185.220.100.242/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC64F3 /* 185.220.100.243/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC64F3 /* 185.220.100.243/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC64FC /* 185.220.100.252/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC64FC /* 185.220.100.252/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC64FD /* 185.220.100.253/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC64FD /* 185.220.100.253/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC64FE /* 185.220.100.254/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC64FE /* 185.220.100.254/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC64FF /* 185.220.100.255/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC64FF /* 185.220.100.255/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6501 /* 185.220.101.1/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6501 /* 185.220.101.1/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6502 /* 185.220.101.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6502 /* 185.220.101.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6503 /* 185.220.101.3/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6504 /* 185.220.101.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6504 /* 185.220.101.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6505 /* 185.220.101.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6505 /* 185.220.101.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6506 /* 185.220.101.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6506 /* 185.220.101.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6507 /* 185.220.101.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6507 /* 185.220.101.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6508 /* 185.220.101.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6508 /* 185.220.101.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6509 /* 185.220.101.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6509 /* 185.220.101.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC650A /* 185.220.101.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC650A /* 185.220.101.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC650B /* 185.220.101.11/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC650B /* 185.220.101.11/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC650C /* 185.220.101.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC650C /* 185.220.101.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC650D /* 185.220.101.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC650D /* 185.220.101.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC650E /* 185.220.101.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC650E /* 185.220.101.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC650F /* 185.220.101.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC650F /* 185.220.101.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6510 /* 185.220.101.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6510 /* 185.220.101.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6511 /* 185.220.101.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6511 /* 185.220.101.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6512 /* 185.220.101.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6512 /* 185.220.101.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6513 /* 185.220.101.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6513 /* 185.220.101.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6514 /* 185.220.101.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6514 /* 185.220.101.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6515 /* 185.220.101.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6515 /* 185.220.101.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6517 /* 185.220.101.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6581 /* 185.220.101.129/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6581 /* 185.220.101.129/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6582 /* 185.220.101.130/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6582 /* 185.220.101.130/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6583 /* 185.220.101.131/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6583 /* 185.220.101.131/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6584 /* 185.220.101.132/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6584 /* 185.220.101.132/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6585 /* 185.220.101.133/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6585 /* 185.220.101.133/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6586 /* 185.220.101.134/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6586 /* 185.220.101.134/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6587 /* 185.220.101.135/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6587 /* 185.220.101.135/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6588 /* 185.220.101.136/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6588 /* 185.220.101.136/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6589 /* 185.220.101.137/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6589 /* 185.220.101.137/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC658A /* 185.220.101.138/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC658A /* 185.220.101.138/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC658B /* 185.220.101.139/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC658B /* 185.220.101.139/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC658C /* 185.220.101.140/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC658C /* 185.220.101.140/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC658D /* 185.220.101.141/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC658D /* 185.220.101.141/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC658E /* 185.220.101.142/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC658E /* 185.220.101.142/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC658F /* 185.220.101.143/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC658F /* 185.220.101.143/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6590 /* 185.220.101.144/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6590 /* 185.220.101.144/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6591 /* 185.220.101.145/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6591 /* 185.220.101.145/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6592 /* 185.220.101.146/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6592 /* 185.220.101.146/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6593 /* 185.220.101.147/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6593 /* 185.220.101.147/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6594 /* 185.220.101.148/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6594 /* 185.220.101.148/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6595 /* 185.220.101.149/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6595 /* 185.220.101.149/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6596 /* 185.220.101.150/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6596 /* 185.220.101.150/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6597 /* 185.220.101.151/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65C1 /* 185.220.101.193/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65C1 /* 185.220.101.193/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65C2 /* 185.220.101.194/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65C2 /* 185.220.101.194/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65C3 /* 185.220.101.195/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65C3 /* 185.220.101.195/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65C4 /* 185.220.101.196/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65C4 /* 185.220.101.196/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65C5 /* 185.220.101.197/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65C5 /* 185.220.101.197/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65C6 /* 185.220.101.198/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65C6 /* 185.220.101.198/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65C7 /* 185.220.101.199/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65C7 /* 185.220.101.199/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65C8 /* 185.220.101.200/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65C8 /* 185.220.101.200/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65C9 /* 185.220.101.201/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65C9 /* 185.220.101.201/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65CA /* 185.220.101.202/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65CA /* 185.220.101.202/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65CB /* 185.220.101.203/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65CB /* 185.220.101.203/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65CC /* 185.220.101.204/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65CC /* 185.220.101.204/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65CD /* 185.220.101.205/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65CD /* 185.220.101.205/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65CE /* 185.220.101.206/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65CE /* 185.220.101.206/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65CF /* 185.220.101.207/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65D0 /* 185.220.101.208/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65D0 /* 185.220.101.208/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65D1 /* 185.220.101.209/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65D1 /* 185.220.101.209/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65D2 /* 185.220.101.210/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65D2 /* 185.220.101.210/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65D3 /* 185.220.101.211/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65D3 /* 185.220.101.211/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65D4 /* 185.220.101.212/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65D4 /* 185.220.101.212/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65D5 /* 185.220.101.213/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65D5 /* 185.220.101.213/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65D6 /* 185.220.101.214/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65D6 /* 185.220.101.214/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65D7 /* 185.220.101.215/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65D7 /* 185.220.101.215/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65D8 /* 185.220.101.216/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65D8 /* 185.220.101.216/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65D9 /* 185.220.101.217/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65DA /* 185.220.101.218/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65DA /* 185.220.101.218/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65DB /* 185.220.101.219/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65DB /* 185.220.101.219/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC65DC /* 185.220.101.220/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6604 /* 185.220.102.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6604 /* 185.220.102.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6606 /* 185.220.102.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6606 /* 185.220.102.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6607 /* 185.220.102.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6607 /* 185.220.102.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6608 /* 185.220.102.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6608 /* 185.220.102.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66F0 /* 185.220.102.240/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66F0 /* 185.220.102.240/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66F1 /* 185.220.102.241/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66F1 /* 185.220.102.241/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66F2 /* 185.220.102.242/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66F2 /* 185.220.102.242/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66F3 /* 185.220.102.243/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66F3 /* 185.220.102.243/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66F4 /* 185.220.102.244/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66F4 /* 185.220.102.244/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66F5 /* 185.220.102.245/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66F5 /* 185.220.102.245/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66F6 /* 185.220.102.246/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66F6 /* 185.220.102.246/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66F7 /* 185.220.102.247/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66F7 /* 185.220.102.247/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66F8 /* 185.220.102.248/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66F8 /* 185.220.102.248/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66F9 /* 185.220.102.249/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66F9 /* 185.220.102.249/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66FA /* 185.220.102.250/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66FA /* 185.220.102.250/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66FB /* 185.220.102.251/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66FB /* 185.220.102.251/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66FC /* 185.220.102.252/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66FC /* 185.220.102.252/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66FD /* 185.220.102.253/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66FD /* 185.220.102.253/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66FE /* 185.220.102.254/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC66FE /* 185.220.102.254/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6704 /* 185.220.103.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6705 /* 185.220.103.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6706 /* 185.220.103.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6707 /* 185.220.103.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6708 /* 185.220.103.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DC6709 /* 185.220.103.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DECA0C /* 185.222.202.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DECA68 /* 185.222.202.104/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DECA6B /* 185.222.202.107/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9DECA85 /* 185.222.202.133/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E11103 /* 185.225.17.3/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E111AD /* 185.225.17.173/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E113E6 /* 185.225.19.230/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E1453B /* 185.225.69.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E1453C /* 185.225.69.60/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E1455A /* 185.225.69.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E1455B /* 185.225.69.91/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E3444E /* 185.227.68.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E34452 /* 185.227.68.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E3448C /* 185.227.68.140/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E344AF /* 185.227.68.175/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E34BFA /* 185.227.75.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E35207 /* 185.227.82.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E35238 /* 185.227.82.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E3523F /* 185.227.82.63/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E48AFC /* 185.228.138.252/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E48B66 /* 185.228.139.102/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E56D9B /* 185.229.109.155/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E919A2 /* 185.233.25.162/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E96417 /* 185.233.100.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E968AC /* 185.233.104.172/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E9693D /* 185.233.105.61/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E96A22 /* 185.233.106.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E96B65 /* 185.233.107.101/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E96B65 /* 185.233.107.101/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E96B6E /* 185.233.107.110/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E96B6E /* 185.233.107.110/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E9BA92 /* 185.233.186.146/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E9FC0E /* 185.233.252.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9E9FC0E /* 185.233.252.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9ECCA3A /* 185.236.202.58/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9ECCBCB /* 185.236.203.203/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9EE8020 /* 185.238.128.32/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9EE8109 /* 185.238.129.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9EE8119 /* 185.238.129.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9EE814C /* 185.238.129.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9EFEE1B /* 185.239.238.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9F271E0 /* 185.242.113.224/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9F271F2 /* 185.242.113.242/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9F2B448 /* 185.242.180.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9F30996 /* 185.243.9.150/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9F3D917 /* 185.243.217.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9F4275B /* 185.244.39.91/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9F48015 /* 185.244.128.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9F494ED /* 185.244.148.237/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9F4C077 /* 185.244.192.119/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9F4C09B /* 185.244.192.155/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9F4C18D /* 185.244.193.141/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9F68082 /* 185.246.128.130/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9F680A1 /* 185.246.128.161/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9F69816 /* 185.246.152.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9F6B6C5 /* 185.246.182.197/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9F8978F /* 185.248.151.143/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xB9F8A015 /* 185.248.160.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9F8A041 /* 185.248.160.65/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xB9FBA54A /* 185.251.165.74/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBA78FAD9 /* 186.120.250.217/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xBAD1BAA3 /* 186.209.186.163/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xBB3F6418 /* 187.63.100.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBB70154E /* 187.112.21.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBB70154E /* 187.112.21.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBB795C67 /* 187.121.92.103/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBBD6C7D2 /* 187.214.199.210/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xBBD6C7D2 /* 187.214.199.210/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xBBF5A516 /* 187.245.165.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC196EE0 /* 188.25.110.224/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC1B3216 /* 188.27.50.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC2821D9 /* 188.40.33.217/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC282973 /* 188.40.41.115/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC283156 /* 188.40.49.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC286345 /* 188.40.99.69/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC286B7E /* 188.40.107.126/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC2880F6 /* 188.40.128.246/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC2893B1 /* 188.40.147.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC289F7A /* 188.40.159.122/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC28A61D /* 188.40.166.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC28EE90 /* 188.40.238.144/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC3DCF79 /* 188.61.207.121/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC3E6D92 /* 188.62.109.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC3EBCB8 /* 188.62.188.184/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC44241C /* 188.68.36.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC44242E /* 188.68.36.46/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC4424D1 /* 188.68.36.209/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC442587 /* 188.68.37.135/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC442977 /* 188.68.41.119/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC442A53 /* 188.68.42.83/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC442BC0 /* 188.68.43.192/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC442BDA /* 188.68.43.218/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC442D48 /* 188.68.45.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC442DB4 /* 188.68.45.180/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC442EA4 /* 188.68.46.164/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC442EF5 /* 188.68.46.245/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC44355C /* 188.68.53.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC44355C /* 188.68.53.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC443732 /* 188.68.55.50/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC443732 /* 188.68.55.50/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC44E053 /* 188.68.224.83/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC4CFFA9 /* 188.76.255.169/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC528030 /* 188.82.128.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC52C517 /* 188.82.197.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC5DE919 /* 188.93.233.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC615AC3 /* 188.97.90.195/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC6B794A /* 188.107.121.74/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC728CE9 /* 188.114.140.233/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xBC728CE9 /* 188.114.140.233/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xBC76AC33 /* 188.118.172.51/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC78EA1A /* 188.120.234.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC78EB75 /* 188.120.235.117/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xBC7E5326 /* 188.126.83.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC7F1525 /* 188.127.21.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC7F453C /* 188.127.69.60/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC7FAFDB /* 188.127.175.219/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xBC7FC52A /* 188.127.197.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC7FE266 /* 188.127.226.102/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xBC865364 /* 188.134.83.100/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC8A2195 /* 188.138.33.149/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC8A21E9 /* 188.138.33.233/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC8A480A /* 188.138.72.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC8A4B65 /* 188.138.75.101/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC8A6662 /* 188.138.102.98/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC8A703C /* 188.138.112.60/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC8D3D53 /* 188.141.61.83/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC97CA5F /* 188.151.202.95/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC9A9107 /* 188.154.145.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBC9AA8FB /* 188.154.168.251/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xBCA50642 /* 188.165.6.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCA52AB5 /* 188.165.42.181/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCA5B409 /* 188.165.180.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCA5C098 /* 188.165.192.152/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xBCA5D3A4 /* 188.165.211.164/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xBCA5D498 /* 188.165.212.152/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xBCA5DC22 /* 188.165.220.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCA5DC22 /* 188.165.220.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCA5FF54 /* 188.165.255.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCA6085B /* 188.166.8.91/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCA60898 /* 188.166.8.152/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCA6210F /* 188.166.33.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCA626EF /* 188.166.38.239/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCA65788 /* 188.166.87.136/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCA65BC2 /* 188.166.91.194/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCA65DA3 /* 188.166.93.163/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCA674F6 /* 188.166.116.246/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xBCA8225A /* 188.168.34.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCADAA10 /* 188.173.170.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCBE6DFA /* 188.190.109.250/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xBCC0C833 /* 188.192.200.51/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCC18662 /* 188.193.134.98/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCC36CBA /* 188.195.108.186/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xBCD1341F /* 188.209.52.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCD51A59 /* 188.213.26.89/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCD51F7D /* 188.213.31.125/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCD5316D /* 188.213.49.109/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCD531B0 /* 188.213.49.176/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCD58639 /* 188.213.134.57/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCD66892 /* 188.214.104.146/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xBCD6804E /* 188.214.128.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCD6809D /* 188.214.128.157/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xBCD680B5 /* 188.214.128.181/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xBCD68431 /* 188.214.132.49/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCDA2F05 /* 188.218.47.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCE26BCB /* 188.226.107.203/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xBCE2940F /* 188.226.148.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCE298D2 /* 188.226.152.210/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xBCE29AB4 /* 188.226.154.180/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xBCE2DDF3 /* 188.226.221.243/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xBCE2DE13 /* 188.226.222.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCE3CE65 /* 188.227.206.101/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xBCEFBF17 /* 188.239.191.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCF0D214 /* 188.240.210.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCF0D232 /* 188.240.210.50/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCF2343B /* 188.242.52.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCF42B19 /* 188.244.43.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCFA44E9 /* 188.250.68.233/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBCFF0EB6 /* 188.255.14.182/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBD4E1AB6 /* 189.78.26.182/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBD54152C /* 189.84.21.44/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBD671ECA /* 189.103.30.202/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBD841464 /* 189.132.20.100/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBDA4179A /* 189.164.23.154/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBE0285E3 /* 190.2.133.227/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBE029107 /* 190.2.145.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBE02925A /* 190.2.146.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBE0A0832 /* 190.10.8.50/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBE0A0844 /* 190.10.8.68/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBE0A0898 /* 190.10.8.152/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBE0A08A6 /* 190.10.8.166/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBE2C53F0 /* 190.44.83.240/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBE61A58D /* 190.97.165.141/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBE658421 /* 190.101.132.33/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBE82963F /* 190.130.150.63/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBEA30FB9 /* 190.163.15.185/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBEA4E609 /* 190.164.230.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBED80288 /* 190.216.2.136/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBEF6DB68 /* 190.246.219.104/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xBF5C7544 /* 191.92.117.68/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBF60D082 /* 191.96.208.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xBFFCCC62 /* 191.252.204.98/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC0008056 /* 192.0.128.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC003941B /* 192.3.148.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC021C118 /* 192.33.193.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC02250B0 /* 192.34.80.176/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC0242621 /* 192.36.38.33/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC0249BD9 /* 192.36.155.217/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC02A7166 /* 192.42.113.102/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC02A7365 /* 192.42.115.101/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC02A7366 /* 192.42.115.102/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC02A740D /* 192.42.116.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC02A740E /* 192.42.116.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC02A740F /* 192.42.116.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC02A7410 /* 192.42.116.16/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC02A7411 /* 192.42.116.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC02A7412 /* 192.42.116.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC02A7413 /* 192.42.116.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC02A7414 /* 192.42.116.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC02A7416 /* 192.42.116.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC02A7417 /* 192.42.116.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC02A7418 /* 192.42.116.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC02A7419 /* 192.42.116.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC02A741A /* 192.42.116.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC02A741B /* 192.42.116.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC02A741C /* 192.42.116.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC02A74A1 /* 192.42.116.161/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC02AFDC2 /* 192.42.253.194/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC02C1E28 /* 192.44.30.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC034A747 /* 192.52.167.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC0503100 /* 192.80.49.0/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC0571C1C /* 192.87.28.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC0571C52 /* 192.87.28.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC05C0620 /* 192.92.6.32/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC05F1B8F /* 192.95.27.143/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC060D8D6 /* 192.96.216.214/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC06305DD /* 192.99.5.221/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC06309C7 /* 192.99.9.199/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC0630B28 /* 192.99.11.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC0630BB1 /* 192.99.11.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC0632230 /* 192.99.34.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC063235B /* 192.99.35.91/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC0632A22 /* 192.99.42.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC0632BAB /* 192.99.43.171/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC0634511 /* 192.99.69.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC06397AA /* 192.99.151.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC0639832 /* 192.99.152.50/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC063DC72 /* 192.99.220.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC063FA95 /* 192.99.250.149/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC0776C72 /* 192.119.108.114/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC0792C1A /* 192.121.44.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC07CFA53 /* 192.124.250.83/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC090257F /* 192.144.37.127/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC0912DBE /* 192.145.45.190/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC0912EF7 /* 192.145.46.247/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC09B556A /* 192.155.85.106/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC09DEC6C /* 192.157.236.108/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC0A066A4 /* 192.160.102.164/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC0A066A5 /* 192.160.102.165/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC0A066A6 /* 192.160.102.166/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC0A066A8 /* 192.160.102.168/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC0A066A9 /* 192.160.102.169/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC0A066AA /* 192.160.102.170/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC0A28D35 /* 192.162.141.53/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC0A4330E /* 192.164.51.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC0A6F58A /* 192.166.245.138/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC0A6F5B0 /* 192.166.245.176/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC0B880B4 /* 192.184.128.180/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC0BB6ABE /* 192.187.106.190/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC0C3500A /* 192.195.80.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC0C3538A /* 192.195.83.138/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC0C3538B /* 192.195.83.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC0D2CECB /* 192.210.206.203/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC0DEB2BD /* 192.222.178.189/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC0DEF814 /* 192.222.248.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC0FAEC82 /* 192.250.236.130/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC0FE4F8A /* 192.254.79.138/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC100D52A /* 193.0.213.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC10B722B /* 193.11.114.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC10B722D /* 193.11.114.45/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC10B722E /* 193.11.114.46/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC10B7245 /* 193.11.114.69/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC10BA4F3 /* 193.11.164.243/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC10BA6C4 /* 193.11.166.196/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC113A715 /* 193.19.167.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC116855C /* 193.22.133.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC11964B4 /* 193.25.100.180/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC11D23CD /* 193.29.35.205/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC11D3967 /* 193.29.57.103/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC11E7B46 /* 193.30.123.70/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC11E7B71 /* 193.30.123.113/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC11E7BB0 /* 193.30.123.176/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC11F189A /* 193.31.24.154/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC11F1B5D /* 193.31.27.93/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1207EA1 /* 193.32.126.161/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1207EA1 /* 193.32.126.161/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1207ED7 /* 193.32.126.215/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC120F987 /* 193.32.249.135/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC12474EA /* 193.36.116.234/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC125D505 /* 193.37.213.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC12A9C6A /* 193.42.156.106/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC13F3A4C /* 193.63.58.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1462879 /* 193.70.40.121/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1462B4C /* 193.70.43.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC14649F2 /* 193.70.73.242/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC14670A5 /* 193.70.112.165/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC14DB639 /* 193.77.182.57/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1514658 /* 193.81.70.88/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC154BE36 /* 193.84.190.54/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC168DC23 /* 193.104.220.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC168DC5E /* 193.104.220.94/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1694950 /* 193.105.73.80/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC16A1F02 /* 193.106.31.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC16AA669 /* 193.106.166.105/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC16AA669 /* 193.106.166.105/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC16C7529 /* 193.108.117.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC16C7529 /* 193.108.117.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC16C753B /* 193.108.117.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC16C7567 /* 193.108.117.103/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC16C75D1 /* 193.108.117.209/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC16F1A25 /* 193.111.26.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC16F73D2 /* 193.111.115.210/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC17A62A5 /* 193.122.98.165/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1870ADB /* 193.135.10.219/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC18A7603 /* 193.138.118.3/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC194449F /* 193.148.68.159/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1944604 /* 193.148.70.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC196161B /* 193.150.22.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1998470 /* 193.153.132.112/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC19F43D1 /* 193.159.67.209/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1A99142 /* 193.169.145.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1A991C2 /* 193.169.145.194/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC1A991CA /* 193.169.145.202/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC1B055B7 /* 193.176.85.183/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1B63D09 /* 193.182.61.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1B66FB6 /* 193.182.111.182/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC1B69035 /* 193.182.144.53/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1B762E0 /* 193.183.98.224/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1BBAD04 /* 193.187.173.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1BEA835 /* 193.190.168.53/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1DA761E /* 193.218.118.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1DA765A /* 193.218.118.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1DA765F /* 193.218.118.95/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1DA765F /* 193.218.118.95/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1DA7664 /* 193.218.118.100/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC1DA767D /* 193.218.118.125/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC1DA7687 /* 193.218.118.135/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC1DA7691 /* 193.218.118.145/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC1DA769B /* 193.218.118.155/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC1DA769C /* 193.218.118.156/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC1DA76EB /* 193.218.118.235/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC1DA76EB /* 193.218.118.235/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC1DA76F0 /* 193.218.118.240/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC1E0A32B /* 193.224.163.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1E99A5F /* 193.233.154.95/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1EA0F37 /* 193.234.15.55/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1EA0F38 /* 193.234.15.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1EA0F39 /* 193.234.15.57/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1EA0F3A /* 193.234.15.58/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1EA0F3B /* 193.234.15.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1EA0F3C /* 193.234.15.60/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1EA0F3D /* 193.234.15.61/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1EA0F3E /* 193.234.15.62/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1EAE13E /* 193.234.225.62/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1EAE143 /* 193.234.225.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC1EFE865 /* 193.239.232.101/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC1EFE866 /* 193.239.232.102/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC205603C /* 194.5.96.60/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC205F982 /* 194.5.249.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC205F9DB /* 194.5.249.219/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC205F9F7 /* 194.5.249.247/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC209AD6B /* 194.9.173.107/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC20FE73B /* 194.15.231.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC222845A /* 194.34.132.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC2277F28 /* 194.39.127.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC2370D31 /* 194.55.13.49/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC2370D32 /* 194.55.13.50/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC2370FDE /* 194.55.15.222/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC23BCE36 /* 194.59.206.54/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC23BCFC6 /* 194.59.207.198/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC23EFA76 /* 194.62.250.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC2477E4C /* 194.71.126.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC258690D /* 194.88.105.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC258691E /* 194.88.105.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC2588F42 /* 194.88.143.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC26DC18E /* 194.109.193.142/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC26E7128 /* 194.110.113.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC27CFAD4 /* 194.124.250.212/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC27CFAD5 /* 194.124.250.213/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC27EAF9D /* 194.126.175.157/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC291960F /* 194.145.150.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC2BBCF2D /* 194.187.207.45/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC2BBF974 /* 194.187.249.116/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC2BFEE85 /* 194.191.238.133/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC2EC871A /* 194.236.135.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC327F7A4 /* 195.39.247.164/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC328B522 /* 195.40.181.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC343BFD2 /* 195.67.191.210/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC343BFD2 /* 195.67.191.210/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3474454 /* 195.71.68.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC350971E /* 195.80.151.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC371C763 /* 195.113.199.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC37411A1 /* 195.116.17.161/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC37AB5F2 /* 195.122.181.242/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC37BD107 /* 195.123.209.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC37BD15B /* 195.123.209.91/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC37BD15B /* 195.123.209.91/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC37BD190 /* 195.123.209.144/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC37BD29E /* 195.123.210.158/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC37BD471 /* 195.123.212.113/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC37BD483 /* 195.123.212.131/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC37BD4E4 /* 195.123.212.228/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC37BD50F /* 195.123.213.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC37BD5C5 /* 195.123.213.197/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC37BD690 /* 195.123.214.144/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC37BE170 /* 195.123.225.112/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC37BE25C /* 195.123.226.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC37BE36B /* 195.123.227.107/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC37BEEA4 /* 195.123.238.164/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC37BF58D /* 195.123.245.141/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC37BF64D /* 195.123.246.77/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC37BF728 /* 195.123.247.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC380645C /* 195.128.100.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC387C286 /* 195.135.194.134/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC39015B6 /* 195.144.21.182/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC39015DB /* 195.144.21.219/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3947CC7 /* 195.148.124.199/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC39A1CC8 /* 195.154.28.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC39A69AA /* 195.154.105.170/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC39A69F1 /* 195.154.105.241/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC39A6A58 /* 195.154.106.88/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC39A6B0C /* 195.154.107.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC39A70E4 /* 195.154.112.228/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC39A77CB /* 195.154.119.203/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC39A8571 /* 195.154.133.113/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC39A857C /* 195.154.133.124/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC39A9C05 /* 195.154.156.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC39AA46F /* 195.154.164.111/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC39AB303 /* 195.154.179.3/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC39AB673 /* 195.154.182.115/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC39AD15B /* 195.154.209.91/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC39AE287 /* 195.154.226.135/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC39AE9B7 /* 195.154.233.183/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC39AEBBE /* 195.154.235.190/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC39AED93 /* 195.154.237.147/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC39AEDB3 /* 195.154.237.179/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC39AF007 /* 195.154.240.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC39AF091 /* 195.154.240.145/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC39AF17D /* 195.154.241.125/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC39AFAEF /* 195.154.250.239/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC39AFBBF /* 195.154.251.191/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC39AFC58 /* 195.154.252.88/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC39AFC97 /* 195.154.252.151/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC39AFDE2 /* 195.154.253.226/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC39AFF77 /* 195.154.255.119/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC39AFFAE /* 195.154.255.174/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC3A97DE2 /* 195.169.125.226/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC3B00313 /* 195.176.3.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3B00313 /* 195.176.3.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3B00314 /* 195.176.3.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3B00314 /* 195.176.3.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3B00317 /* 195.176.3.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3B00317 /* 195.176.3.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3B00318 /* 195.176.3.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3B00318 /* 195.176.3.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6028 /* 195.189.96.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6040 /* 195.189.96.64/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6043 /* 195.189.96.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6044 /* 195.189.96.68/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6045 /* 195.189.96.69/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6046 /* 195.189.96.70/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6047 /* 195.189.96.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6049 /* 195.189.96.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD604A /* 195.189.96.74/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD604B /* 195.189.96.75/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD604C /* 195.189.96.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD604D /* 195.189.96.77/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD604F /* 195.189.96.79/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6050 /* 195.189.96.80/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6051 /* 195.189.96.81/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6056 /* 195.189.96.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD605D /* 195.189.96.93/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD605E /* 195.189.96.94/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD605F /* 195.189.96.95/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6094 /* 195.189.96.148/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6300 /* 195.189.99.0/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6302 /* 195.189.99.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6304 /* 195.189.99.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6306 /* 195.189.99.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6308 /* 195.189.99.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6309 /* 195.189.99.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD630A /* 195.189.99.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD630C /* 195.189.99.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD630D /* 195.189.99.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD631F /* 195.189.99.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6321 /* 195.189.99.33/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6324 /* 195.189.99.36/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6325 /* 195.189.99.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6327 /* 195.189.99.39/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6340 /* 195.189.99.64/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6341 /* 195.189.99.65/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6342 /* 195.189.99.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6343 /* 195.189.99.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD634B /* 195.189.99.75/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD634C /* 195.189.99.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD634D /* 195.189.99.77/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD634E /* 195.189.99.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD634F /* 195.189.99.79/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6351 /* 195.189.99.81/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6352 /* 195.189.99.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6353 /* 195.189.99.83/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6355 /* 195.189.99.85/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6356 /* 195.189.99.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6368 /* 195.189.99.104/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6369 /* 195.189.99.105/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6379 /* 195.189.99.121/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD637A /* 195.189.99.122/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD637F /* 195.189.99.127/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6382 /* 195.189.99.130/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6388 /* 195.189.99.136/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6393 /* 195.189.99.147/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6394 /* 195.189.99.148/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6395 /* 195.189.99.149/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6396 /* 195.189.99.150/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3BD6397 /* 195.189.99.151/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3C90925 /* 195.201.9.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3C91452 /* 195.201.20.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3C9154B /* 195.201.21.75/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3C916EA /* 195.201.22.234/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3C91AAF /* 195.201.26.175/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3C91DFC /* 195.201.29.252/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3C921D8 /* 195.201.33.216/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3C9274E /* 195.201.39.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3C93EEF /* 195.201.62.239/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3C95E71 /* 195.201.94.113/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3C9673B /* 195.201.103.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3C971C1 /* 195.201.113.193/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC3C98DA6 /* 195.201.141.166/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC3C99000 /* 195.201.144.0/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3C9A854 /* 195.201.168.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3C9A854 /* 195.201.168.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3C9A86F /* 195.201.168.111/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC3C9A86F /* 195.201.168.111/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC3C9DCE6 /* 195.201.220.230/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC3C9E258 /* 195.201.226.88/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3CE69D9 /* 195.206.105.217/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC3CE69E3 /* 195.206.105.227/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC3D38FDF /* 195.211.143.223/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC3E61626 /* 195.230.22.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3E617C3 /* 195.230.23.195/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3E617C4 /* 195.230.23.196/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3E6A853 /* 195.230.168.83/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3EA9856 /* 195.234.152.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC3FBFCE2 /* 195.251.252.226/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC3FE86C2 /* 195.254.134.194/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC3FE874C /* 195.254.135.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC55184AB /* 197.81.132.171/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC60D36B8 /* 198.13.54.184/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC610460A /* 198.16.70.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6105C9D /* 198.16.92.157/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6106D1F /* 198.16.109.31/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC61B4033 /* 198.27.64.51/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC61B51C0 /* 198.27.81.192/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC62E8A28 /* 198.46.138.40/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC62EF824 /* 198.46.248.36/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC63280ED /* 198.50.128.237/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6329E8C /* 198.50.158.140/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC632BF5F /* 198.50.191.95/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC632C48A /* 198.50.196.138/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC632EE80 /* 198.50.238.128/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6368046 /* 198.54.128.70/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC63A672F /* 198.58.103.47/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC63A6B35 /* 198.58.107.53/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC63A744F /* 198.58.116.79/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC63A7A4B /* 198.58.122.75/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC63A7D72 /* 198.58.125.114/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC647500A /* 198.71.80.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6475312 /* 198.71.83.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6487B6D /* 198.72.123.109/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC64A3379 /* 198.74.51.121/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC64A3442 /* 198.74.52.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC64A3939 /* 198.74.57.57/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC64A3D33 /* 198.74.61.51/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC654D267 /* 198.84.210.103/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6609B03 /* 198.96.155.3/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6609B09 /* 198.96.155.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6623120 /* 198.98.49.32/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC66231B2 /* 198.98.49.178/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6623270 /* 198.98.50.112/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC662339C /* 198.98.51.156/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC662344B /* 198.98.52.75/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6623477 /* 198.98.52.119/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC662349B /* 198.98.52.155/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6623599 /* 198.98.53.153/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6623669 /* 198.98.54.105/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC66236AA /* 198.98.54.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC66239EA /* 198.98.57.234/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6623A42 /* 198.98.58.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6623BC5 /* 198.98.59.197/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6623C5A /* 198.98.60.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6623E38 /* 198.98.62.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6649014 /* 198.100.144.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6649159 /* 198.100.145.89/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC66492B3 /* 198.100.146.179/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC6649463 /* 198.100.148.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC664946A /* 198.100.148.106/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC664948C /* 198.100.148.140/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC66494CD /* 198.100.148.205/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC66494E5 /* 198.100.148.229/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC664954D /* 198.100.149.77/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC69078B1 /* 198.144.120.177/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC69078B1 /* 198.144.120.177/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC69078EA /* 198.144.120.234/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC69078EA /* 198.144.120.234/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC690795D /* 198.144.121.93/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC690795D /* 198.144.121.93/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6B49609 /* 198.180.150.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6C7640A /* 198.199.100.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6C77079 /* 198.199.112.121/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC6C77686 /* 198.199.118.134/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC6D3224D /* 198.211.34.77/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6D36767 /* 198.211.103.103/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC6F531BF /* 198.245.49.191/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6F532AF /* 198.245.50.175/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6F532D0 /* 198.245.50.208/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6F53C15 /* 198.245.60.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6F53C6D /* 198.245.60.109/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6F53C8D /* 198.245.60.141/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6F53D4F /* 198.245.61.79/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6F53DAB /* 198.245.61.171/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6F53DC4 /* 198.245.61.196/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6F53E7A /* 198.245.62.122/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6F53EB8 /* 198.245.62.184/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6F53F41 /* 198.245.63.65/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6FB4490 /* 198.251.68.144/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6FB50FC /* 198.251.80.252/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6FB5349 /* 198.251.83.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6FB53C1 /* 198.251.83.193/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6FB53F8 /* 198.251.83.248/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6FB57E2 /* 198.251.87.226/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6FB591D /* 198.251.89.29/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6FB5950 /* 198.251.89.80/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6FB5963 /* 198.251.89.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6FB59C6 /* 198.251.89.198/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC6FF700A /* 198.255.112.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC70FFAD2 /* 199.15.250.210/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC713E27B /* 199.19.226.123/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC724DFBC /* 199.36.223.188/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC73A518C /* 199.58.81.140/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7737246 /* 199.115.114.70/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7A73B5F /* 199.167.59.95/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7B8D70B /* 199.184.215.11/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7B8F6FA /* 199.184.246.250/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7C01423 /* 199.192.20.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7C01977 /* 199.192.25.119/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7C3906F /* 199.195.144.111/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7C3F913 /* 199.195.249.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7C3F952 /* 199.195.249.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7C3FA4D /* 199.195.250.77/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7C3FA94 /* 199.195.250.148/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7C3FAAA /* 199.195.250.170/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7C3FB54 /* 199.195.251.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7C3FB6E /* 199.195.251.110/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7C3FE51 /* 199.195.254.81/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7C3FE51 /* 199.195.254.81/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7DF7C67 /* 199.223.124.103/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E640 /* 199.249.230.64/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E641 /* 199.249.230.65/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E642 /* 199.249.230.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E643 /* 199.249.230.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E644 /* 199.249.230.68/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E645 /* 199.249.230.69/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E646 /* 199.249.230.70/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E647 /* 199.249.230.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E648 /* 199.249.230.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E649 /* 199.249.230.73/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E64A /* 199.249.230.74/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E64B /* 199.249.230.75/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E64C /* 199.249.230.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E64D /* 199.249.230.77/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E64E /* 199.249.230.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E64F /* 199.249.230.79/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E650 /* 199.249.230.80/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E651 /* 199.249.230.81/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E652 /* 199.249.230.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E653 /* 199.249.230.83/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E654 /* 199.249.230.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E655 /* 199.249.230.85/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E656 /* 199.249.230.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E657 /* 199.249.230.87/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E658 /* 199.249.230.88/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E659 /* 199.249.230.89/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E664 /* 199.249.230.100/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E665 /* 199.249.230.101/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E666 /* 199.249.230.102/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E667 /* 199.249.230.103/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E668 /* 199.249.230.104/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E669 /* 199.249.230.105/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E66A /* 199.249.230.106/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E66C /* 199.249.230.108/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E66E /* 199.249.230.110/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E670 /* 199.249.230.112/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E672 /* 199.249.230.114/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E673 /* 199.249.230.115/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E674 /* 199.249.230.116/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E675 /* 199.249.230.117/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E676 /* 199.249.230.118/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E677 /* 199.249.230.119/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E678 /* 199.249.230.120/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E679 /* 199.249.230.121/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E67A /* 199.249.230.122/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E67B /* 199.249.230.123/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E68C /* 199.249.230.140/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E68D /* 199.249.230.141/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E68E /* 199.249.230.142/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E68F /* 199.249.230.143/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E690 /* 199.249.230.144/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E691 /* 199.249.230.145/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E692 /* 199.249.230.146/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E693 /* 199.249.230.147/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E694 /* 199.249.230.148/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E695 /* 199.249.230.149/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E696 /* 199.249.230.150/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E697 /* 199.249.230.151/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E698 /* 199.249.230.152/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E699 /* 199.249.230.153/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E69A /* 199.249.230.154/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E69B /* 199.249.230.155/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E69C /* 199.249.230.156/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E69D /* 199.249.230.157/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E69E /* 199.249.230.158/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E69F /* 199.249.230.159/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6A0 /* 199.249.230.160/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6A1 /* 199.249.230.161/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6A2 /* 199.249.230.162/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6A3 /* 199.249.230.163/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6A4 /* 199.249.230.164/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6A5 /* 199.249.230.165/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6A6 /* 199.249.230.166/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6A7 /* 199.249.230.167/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6A8 /* 199.249.230.168/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6A9 /* 199.249.230.169/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6AA /* 199.249.230.170/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6AB /* 199.249.230.171/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6AC /* 199.249.230.172/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6AE /* 199.249.230.174/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6AF /* 199.249.230.175/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6B1 /* 199.249.230.177/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6B2 /* 199.249.230.178/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6B4 /* 199.249.230.180/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6B5 /* 199.249.230.181/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6B6 /* 199.249.230.182/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6B7 /* 199.249.230.183/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6B8 /* 199.249.230.184/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6B9 /* 199.249.230.185/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6BA /* 199.249.230.186/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6BB /* 199.249.230.187/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6BC /* 199.249.230.188/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC7F9E6BD /* 199.249.230.189/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC826E8F8 /* 200.38.232.248/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC862861B /* 200.98.134.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC862884C /* 200.98.136.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC87AB502 /* 200.122.181.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC87AB565 /* 200.122.181.101/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xC8CB138C /* 200.203.19.140/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC9502D74 /* 201.80.45.116/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC9C41196 /* 201.196.17.150/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC9CB732F /* 201.203.115.47/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC9D62A8F /* 201.214.42.143/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xC9D7DE5C /* 201.215.222.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCA57A347 /* 202.87.163.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCA9DB1E0 /* 202.157.177.224/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xCAA5E4A1 /* 202.165.228.161/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xCAA5E4E1 /* 202.165.228.225/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xCAB679DF /* 202.182.121.223/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xCAB67B25 /* 202.182.123.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCAB67F7F /* 202.182.127.127/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xCABBE92B /* 202.187.233.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCAEF26F9 /* 202.239.38.249/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCB331B6C /* 203.51.27.108/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCB7AC273 /* 203.122.194.115/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xCB7B6CE9 /* 203.123.108.233/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xCB7B74D7 /* 203.123.116.215/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xCB811B57 /* 203.129.27.87/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCB845FAA /* 203.132.95.170/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCB8AC7E9 /* 203.138.199.233/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xCBBA4562 /* 203.186.69.98/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCBD56907 /* 203.213.105.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCBDA058D /* 203.218.5.141/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCC0B3283 /* 204.11.50.131/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCC0DA46B /* 204.13.164.107/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCC0DA476 /* 204.13.164.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCC0F4EF9 /* 204.15.78.249/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCC11382A /* 204.17.56.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCC11382A /* 204.17.56.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCC1B3C93 /* 204.27.60.147/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCC2C519E /* 204.44.81.158/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCC53CC8F /* 204.83.204.143/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCC55BF08 /* 204.85.191.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCC55BF09 /* 204.85.191.9/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCCC21D04 /* 204.194.29.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCCE4932A /* 204.228.147.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCDB9747E /* 205.185.116.126/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xCDB9747E /* 205.185.116.126/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xCDB97595 /* 205.185.117.149/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xCDB97766 /* 205.185.119.102/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xCDB977DE /* 205.185.119.222/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xCDB97B60 /* 205.185.123.96/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCDB97C04 /* 205.185.124.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCDB97CA4 /* 205.185.124.164/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xCDB97CC8 /* 205.185.124.200/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xCDB97DD8 /* 205.185.125.216/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xCDB97EB1 /* 205.185.126.177/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xCDB97FD9 /* 205.185.127.217/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xCDC93F30 /* 205.201.63.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCE2876E5 /* 206.40.118.229/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCE374A00 /* 206.55.74.0/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCE374A01 /* 206.55.74.1/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCE3FE590 /* 206.63.229.144/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCE4A2134 /* 206.74.33.52/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCE7D2CCC /* 206.125.44.204/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCEAE76CF /* 206.174.118.207/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xCEBD950D /* 206.189.149.13/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCEC0FC7B /* 206.192.252.123/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xCF058D22 /* 207.5.141.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCF5152EE /* 207.81.82.238/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCF5152EE /* 207.81.82.238/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCF60EECF /* 207.96.238.207/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCF9463A0 /* 207.148.99.160/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCF9911F4 /* 207.153.17.244/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCF9AC0B7 /* 207.154.192.183/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xCF9AD903 /* 207.154.217.3/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCFB4C658 /* 207.180.198.88/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCFB4C6CD /* 207.180.198.205/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xCFB4DDDC /* 207.180.221.220/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xCFB4E011 /* 207.180.224.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCFB4E66D /* 207.180.230.109/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xCFB4EAE7 /* 207.180.234.231/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xCFB4FB0B /* 207.180.251.11/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCFC046FA /* 207.192.70.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCFE5419B /* 207.229.65.155/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCFF44623 /* 207.244.70.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCFF44BC6 /* 207.244.75.198/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xCFF658D6 /* 207.246.88.214/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD0013EF0 /* 208.1.62.240/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD0440481 /* 208.68.4.129/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD0440781 /* 208.68.7.129/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD059D3D0 /* 208.89.211.208/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD05EF21A /* 208.94.242.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD0618D08 /* 208.97.141.8/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD06B6E69 /* 208.107.110.105/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD07187A2 /* 208.113.135.162/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD071C867 /* 208.113.200.103/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD12C72B2 /* 209.44.114.178/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD12C7ADD /* 209.44.122.221/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD133BC30 /* 209.51.188.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD13AA024 /* 209.58.160.36/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD13AA08A /* 209.58.160.138/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD13AB45A /* 209.58.180.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD13BAD1A /* 209.59.173.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD15AE005 /* 209.90.224.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD15F30A3 /* 209.95.48.163/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD161AD30 /* 209.97.173.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD17E4CF9 /* 209.126.76.249/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD17E678C /* 209.126.103.140/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D2135 /* 209.141.33.53/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D225F /* 209.141.34.95/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D231B /* 209.141.35.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D2441 /* 209.141.36.65/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D2499 /* 209.141.36.153/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D2622 /* 209.141.38.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D266C /* 209.141.38.108/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D26A3 /* 209.141.38.163/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D282E /* 209.141.40.46/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D2967 /* 209.141.41.103/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D2B42 /* 209.141.43.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D2DAD /* 209.141.45.173/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D2DB3 /* 209.141.45.179/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D2DB7 /* 209.141.45.183/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D2DBD /* 209.141.45.189/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D2DBD /* 209.141.45.189/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D2E26 /* 209.141.46.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D2E2F /* 209.141.46.47/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D2E39 /* 209.141.46.57/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D2EAF /* 209.141.46.175/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D32B2 /* 209.141.50.178/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D340B /* 209.141.52.11/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D350A /* 209.141.53.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D3514 /* 209.141.53.20/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D35B8 /* 209.141.53.184/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D3699 /* 209.141.54.153/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D3699 /* 209.141.54.153/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D36A8 /* 209.141.54.168/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D36C3 /* 209.141.54.195/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D36C3 /* 209.141.54.195/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D3A32 /* 209.141.58.50/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD18D3B9D /* 209.141.59.157/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD1942E53 /* 209.148.46.83/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD1B46734 /* 209.180.103.52/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD1B6D912 /* 209.182.217.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD1DE1176 /* 209.222.17.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD1DE65FB /* 209.222.101.251/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD1DE65FB /* 209.222.101.251/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD1EC4B04 /* 209.236.75.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD1FA02FE /* 209.250.2.254/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD1FAEBC5 /* 209.250.235.197/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD1FAEE12 /* 209.250.238.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD28B224A /* 210.139.34.74/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD28C0A18 /* 210.140.10.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD28C0A23 /* 210.140.10.35/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD407D934 /* 212.7.217.52/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD408F3E5 /* 212.8.243.229/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD408FA4F /* 212.8.250.79/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD40E6C1E /* 212.14.108.30/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD410AA9E /* 212.16.170.158/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD411664D /* 212.17.102.77/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD4154206 /* 212.21.66.6/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD418648A /* 212.24.100.138/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD420F0A5 /* 212.32.240.165/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD42FE33A /* 212.47.227.58/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD42FE347 /* 212.47.227.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD42FE502 /* 212.47.229.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD42FE504 /* 212.47.229.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD42FE90E /* 212.47.233.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD42FE956 /* 212.47.233.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD42FE956 /* 212.47.233.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD42FE9FA /* 212.47.233.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD42FEA30 /* 212.47.234.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD42FEAD4 /* 212.47.234.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD42FED7F /* 212.47.237.127/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD42FF426 /* 212.47.244.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD42FFD0C /* 212.47.253.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD42FFEEC /* 212.47.254.236/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD433838F /* 212.51.131.143/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD4338604 /* 212.51.134.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD433890A /* 212.51.137.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD4338D5C /* 212.51.141.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD4338D5C /* 212.51.141.92/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD433952B /* 212.51.149.43/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD433954C /* 212.51.149.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD433954C /* 212.51.149.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD43397FA /* 212.51.151.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD4339905 /* 212.51.153.5/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD43C05DC /* 212.60.5.220/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD43C7BA1 /* 212.60.123.161/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD445A67A /* 212.69.166.122/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD44AE912 /* 212.74.233.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD44AE913 /* 212.74.233.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD44AE916 /* 212.74.233.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD4533DDA /* 212.83.61.218/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD4539A21 /* 212.83.154.33/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD4539A21 /* 212.83.154.33/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD453A63E /* 212.83.166.62/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD459E1F2 /* 212.89.225.242/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD45C8A3D /* 212.92.138.61/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD460228F /* 212.96.34.143/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD4673D11 /* 212.103.61.17/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD46DC501 /* 212.109.197.1/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD46F28B1 /* 212.111.40.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD46F298F /* 212.111.41.143/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD4726E8F /* 212.114.110.143/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD4810454 /* 212.129.4.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD48105DB /* 212.129.5.219/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD481208E /* 212.129.32.142/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD4813EE8 /* 212.129.62.232/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD4930D5A /* 212.147.13.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD49F4FE4 /* 212.159.79.228/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD4A2099E /* 212.162.9.158/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD4A22ABA /* 212.162.42.186/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD4A22AEE /* 212.162.42.238/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD4A81F6F /* 212.168.31.111/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD4BA4726 /* 212.186.71.38/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD4BADA4A /* 212.186.218.74/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD4E30889 /* 212.227.8.137/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD4E3A4C5 /* 212.227.164.197/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD4E3A5FB /* 212.227.165.251/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD4E3C885 /* 212.227.200.133/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD4E3CC52 /* 212.227.204.82/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD4E3CC73 /* 212.227.204.115/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD4E81D65 /* 212.232.29.101/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD4ED60A2 /* 212.237.96.162/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD4ED64FA /* 212.237.100.250/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD5031868 /* 213.3.24.104/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5204155 /* 213.32.65.85/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5205A0F /* 213.32.90.15/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD523BF27 /* 213.35.191.39/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD52F3098 /* 213.47.48.152/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD53DD736 /* 213.61.215.54/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD540416A /* 213.64.65.106/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD541C42F /* 213.65.196.47/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5426BFA /* 213.66.107.250/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5496083 /* 213.73.96.131/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD550661B /* 213.80.102.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD55F9516 /* 213.95.149.22/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD56DA030 /* 213.109.160.48/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD571027E /* 213.113.2.126/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5856219 /* 213.133.98.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD58845ED /* 213.136.69.237/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5884E68 /* 213.136.78.104/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5885159 /* 213.136.81.89/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5885E0A /* 213.136.94.10/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD58A66D1 /* 213.138.102.209/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD58BCE64 /* 213.139.206.100/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD58C4258 /* 213.140.66.88/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD58D81F6 /* 213.141.129.246/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD58D8AAE /* 213.141.138.174/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD5908E18 /* 213.144.142.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5908E1C /* 213.144.142.28/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5909CC0 /* 213.144.156.192/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD592BC31 /* 213.146.188.49/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD598A81B /* 213.152.168.27/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5A346EA /* 213.163.70.234/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5A7F2B7 /* 213.167.242.183/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD5A99497 /* 213.169.148.151/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD5ADA168 /* 213.173.161.104/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD5B21A29 /* 213.178.26.41/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5B73054 /* 213.183.48.84/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5B7388C /* 213.183.56.140/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5B73C15 /* 213.183.60.21/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5B73F24 /* 213.183.63.36/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5C3695F /* 213.195.105.95/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5C37258 /* 213.195.114.88/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5C6432E /* 213.198.67.46/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5CAD42A /* 213.202.212.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5D32B8B /* 213.211.43.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5DB25CD /* 213.219.37.205/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5DCDC3C /* 213.220.220.60/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5E2444D /* 213.226.68.77/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5E38581 /* 213.227.133.129/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD5EFD5BE /* 213.239.213.190/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD5EFD7DD /* 213.239.215.221/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD5EFD8DE /* 213.239.216.222/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD5EFD944 /* 213.239.217.68/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5EFDAC3 /* 213.239.218.195/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD5F38A13 /* 213.243.138.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5F3B51A /* 213.243.181.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD5FBEEA0 /* 213.251.238.160/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD5FCF5CA /* 213.252.245.202/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD5FCF743 /* 213.252.247.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD80900E7 /* 216.9.0.231/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD80AF792 /* 216.10.247.146/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD80F630E /* 216.15.99.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD8116390 /* 216.17.99.144/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD818F222 /* 216.24.242.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD83A167C /* 216.58.22.124/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD847D847 /* 216.71.216.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD87FAD4E /* 216.127.173.78/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD896415E /* 216.150.65.94/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD8BAFA35 /* 216.186.250.53/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD8C54CED /* 216.197.76.237/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD8D0CACE /* 216.208.202.206/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD8DA860C /* 216.218.134.12/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD8EDC638 /* 216.237.198.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD8EF5A13 /* 216.239.90.19/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD8EFAEAB /* 216.239.174.171/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD8F44A2A /* 216.244.74.42/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD8F44CE2 /* 216.244.76.226/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD8F44FA2 /* 216.244.79.162/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD8F4551A /* 216.244.85.26/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD8F964CE /* 216.249.100.206/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD90CCBF2 /* 217.12.203.242/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD90CD2D2 /* 217.12.210.210/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD90CDD4B /* 217.12.221.75/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD90CDD6E /* 217.12.221.110/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD90CDD83 /* 217.12.221.131/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD90CDFC8 /* 217.12.223.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD90CDFE1 /* 217.12.223.225/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD90CDFE3 /* 217.12.223.227/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9131304 /* 217.19.19.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9148248 /* 217.20.130.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9170802 /* 217.23.8.2/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9170FC8 /* 217.23.15.200/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD918E795 /* 217.24.231.149/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD94E1C25 /* 217.78.28.37/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD94FB235 /* 217.79.178.53/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD94FB235 /* 217.79.178.53/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD94FB3B1 /* 217.79.179.177/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD94FB517 /* 217.79.181.23/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD94FB55A /* 217.79.181.90/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD94FB848 /* 217.79.184.72/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD94FBE19 /* 217.79.190.25/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD95151AC /* 217.81.81.172/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD95151AC /* 217.81.81.172/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9526462 /* 217.82.100.98/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD953664F /* 217.83.102.79/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9550839 /* 217.85.8.57/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9571FB7 /* 217.87.31.183/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD95CAF58 /* 217.92.175.88/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD95EF280 /* 217.94.242.128/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9708307 /* 217.112.131.7/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9708318 /* 217.112.131.24/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9708362 /* 217.112.131.98/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9737F22 /* 217.115.127.34/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD97856BA /* 217.120.86.186/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9886138 /* 217.136.97.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9908AF9 /* 217.144.138.249/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD996EF69 /* 217.150.239.105/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD99B03F5 /* 217.155.3.245/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD99B2876 /* 217.155.40.118/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9A00D35 /* 217.160.13.53/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9A00DAD /* 217.160.13.173/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9A01CEE /* 217.160.28.238/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9A01DD4 /* 217.160.29.212/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9A028C2 /* 217.160.40.194/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9A0392F /* 217.160.57.47/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9A039C2 /* 217.160.57.194/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9A03B27 /* 217.160.59.39/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9A08D34 /* 217.160.141.52/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9A0FAA6 /* 217.160.250.166/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD9A0FB3F /* 217.160.251.63/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9A0FF71 /* 217.160.255.113/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD9A0FFD9 /* 217.160.255.217/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD9AACC7E /* 217.170.204.126/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD9AACD0E /* 217.170.205.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9AACD71 /* 217.170.205.113/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD9AACE8A /* 217.170.206.138/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD9AACE92 /* 217.170.206.146/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD9AACEC0 /* 217.170.206.192/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD9ACB404 /* 217.172.180.4/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9B64BB5 /* 217.182.75.181/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9B64C42 /* 217.182.76.66/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9B64C63 /* 217.182.76.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9B64EB4 /* 217.182.78.180/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9B64EB4 /* 217.182.78.180/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9B65E3A /* 217.182.94.58/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9B65FDD /* 217.182.95.221/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9B6C0D9 /* 217.182.192.217/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD9B6C441 /* 217.182.196.65/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9B6C443 /* 217.182.196.67/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9B6C444 /* 217.182.196.68/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9B6C446 /* 217.182.196.70/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9B6C447 /* 217.182.196.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9B6C64C /* 217.182.198.76/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9B6C650 /* 217.182.198.80/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9B6C65F /* 217.182.198.95/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9B6E239 /* 217.182.226.57/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9B6E23B /* 217.182.226.59/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9C556AD /* 217.197.86.173/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9C7CFFA /* 217.199.207.250/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD9D240FE /* 217.210.64.254/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9E4BA64 /* 217.228.186.100/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD9E99B56 /* 217.233.155.86/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9E9E6E5 /* 217.233.230.229/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD9ED7D2C /* 217.237.125.44/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9F1E5AA /* 217.241.229.170/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD9F60ACD /* 217.246.10.205/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9F688B3 /* 217.246.136.179/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xD9F7B403 /* 217.247.180.3/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xD9FCBB0E /* 217.252.187.14/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xDABA9063 /* 218.186.144.99/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xDADDC72D /* 218.221.199.45/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xDB5B6E83 /* 219.91.110.131/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xDB792B8D /* 219.121.43.141/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xDC86E112 /* 220.134.225.18/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xDC945C2E /* 220.148.92.46/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xDCE91C47 /* 220.233.28.71/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xDCE9B2C7 /* 220.233.178.199/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xDD71325B /* 221.113.50.91/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xDD7999B8 /* 221.121.153.184/32*/, 32, NDPI_PROTOCOL_TOR },
  { 0xDEEFFA38 /* 222.239.250.56/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xDF105A8B /* 223.16.90.139/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xDF1945CE /* 223.25.69.206/32 */, 32, NDPI_PROTOCOL_TOR },
  { 0xDF1945CE /* 223.25.69.206/32 */, 32, NDPI_PROTOCOL_TOR },

  /*
    Twitch Interactive Inc.
    origin AS46489
  */

  { 0x17A00000 /* 23.160.0.0/24 */, 24, NDPI_PROTOCOL_TWITCH },
  { 0x2D718000 /* 45.113.128.0/22 */, 22, NDPI_PROTOCOL_TWITCH },
  { 0x34DFC000 /* 52.223.192.0/20 */, 20, NDPI_PROTOCOL_TWITCH },
  { 0x34DFD000 /* 52.223.208.0/21 */, 21, NDPI_PROTOCOL_TWITCH },
  { 0x34DFD800 /* 52.223.216.0/21 */, 21, NDPI_PROTOCOL_TWITCH },
  { 0x34DFE000 /* 52.223.224.0/20 */, 20, NDPI_PROTOCOL_TWITCH },
  { 0x34DFF000 /* 52.223.240.0/20 */, 20, NDPI_PROTOCOL_TWITCH },
  { 0x67353000 /* 103.53.48.0/22 */, 22, NDPI_PROTOCOL_TWITCH },
  { 0xB92ACC00 /* 185.42.204.0/22 */, 22, NDPI_PROTOCOL_TWITCH },
  { 0xC0104000 /* 192.16.64.0/21 */, 21, NDPI_PROTOCOL_TWITCH },
  { 0xC06CEF00 /* 192.108.239.0/24*/, 24, NDPI_PROTOCOL_TWITCH },
  { 0xC709F800 /* 199.9.248.0/21 */, 21, NDPI_PROTOCOL_TWITCH },

  /*
    AnchorFree, Inc. (Hotspot Shield)
    origin AS26642
  */

  { 0x2E102200 /* 46.16.34.0/24 */, 24, NDPI_PROTOCOL_HOTSPOT_SHIELD },
  { 0x2E102300 /* 46.16.35.0/24 */, 24, NDPI_PROTOCOL_HOTSPOT_SHIELD },
  { 0x32752D00 /* 50.117.45.0/24 */, 24, NDPI_PROTOCOL_HOTSPOT_SHIELD },
  { 0x3F8DC600 /* 63.141.198.0/23 */, 23, NDPI_PROTOCOL_HOTSPOT_SHIELD },
  { 0x4A730100 /* 74.115.1.0/24 */, 24, NDPI_PROTOCOL_HOTSPOT_SHIELD },
  { 0x4A730500 /* 74.115.5.0/24 */, 24, NDPI_PROTOCOL_HOTSPOT_SHIELD },
  { 0x4A730600 /* 74.115.6.0/24 */, 24, NDPI_PROTOCOL_HOTSPOT_SHIELD },
  { 0x55EDC500 /* 85.237.197.0/24 */, 24, NDPI_PROTOCOL_HOTSPOT_SHIELD },
  { 0x55EDDE00 /* 85.237.222.0/24 */, 24, NDPI_PROTOCOL_HOTSPOT_SHIELD },
  { 0xC62F7300 /* 198.47.115.0/24 */, 24, NDPI_PROTOCOL_HOTSPOT_SHIELD },
  { 0xC6906800 /* 198.144.104.0/24*/, 24, NDPI_PROTOCOL_HOTSPOT_SHIELD },
  { 0xC7FFD700 /* 199.255.215.0/24*/, 24, NDPI_PROTOCOL_HOTSPOT_SHIELD },
  { 0xCC0E4A00 /* 204.14.74.0/24 */, 24, NDPI_PROTOCOL_HOTSPOT_SHIELD },
  { 0xCC0E4C00 /* 204.14.76.0/24 */, 24, NDPI_PROTOCOL_HOTSPOT_SHIELD },
  { 0xCC0E4D00 /* 204.14.77.0/24 */, 24, NDPI_PROTOCOL_HOTSPOT_SHIELD },
  { 0xCC0E4E00 /* 204.14.78.0/24 */, 24, NDPI_PROTOCOL_HOTSPOT_SHIELD },
  { 0xCDA42000 /* 205.164.32.0/24 */, 24, NDPI_PROTOCOL_HOTSPOT_SHIELD },
  { 0xD1498400 /* 209.73.132.0/24 */, 24, NDPI_PROTOCOL_HOTSPOT_SHIELD },
  { 0xD1499700 /* 209.73.151.0/24 */, 24, NDPI_PROTOCOL_HOTSPOT_SHIELD },
  { 0xD8AC8E00 /* 216.172.142.0/24*/, 24, NDPI_PROTOCOL_HOTSPOT_SHIELD },

  /*
    GitHub, Inc.
    origin AS36459
  */

  { 0xC01EFC00 /* 192.30.252.0/22 */, 22, NDPI_PROTOCOL_GITHUB },

  /*
    Valve Corporation (Steam)
    origin AS32590
  */

  { 0x2D79B800 /* 45.121.184.0/22 */, 22, NDPI_PROTOCOL_STEAM },
  { 0x670A7C00 /* 103.10.124.0/23 */, 23, NDPI_PROTOCOL_STEAM },
  { 0x671C3600 /* 103.28.54.0/23 */, 23, NDPI_PROTOCOL_STEAM },
  { 0x8F899200 /* 143.137.146.0/24*/, 24, NDPI_PROTOCOL_STEAM },
  { 0x92429800 /* 146.66.152.0/21 */, 21, NDPI_PROTOCOL_STEAM },
  { 0x99FE5600 /* 153.254.86.0/24 */, 24, NDPI_PROTOCOL_STEAM },
  { 0x9B85E000 /* 155.133.224.0/19*/, 19, NDPI_PROTOCOL_STEAM },
  { 0xA2FEC000 /* 162.254.192.0/21*/, 21, NDPI_PROTOCOL_STEAM },
  { 0xB919B400 /* 185.25.180.0/22 */, 22, NDPI_PROTOCOL_STEAM },
  { 0xBED87900 /* 190.216.121.0/24*/, 24, NDPI_PROTOCOL_STEAM },
  { 0xBED92100 /* 190.217.33.0/24 */, 24, NDPI_PROTOCOL_STEAM },
  { 0xC0456000 /* 192.69.96.0/22 */, 22, NDPI_PROTOCOL_STEAM },
  { 0xCDB9C200 /* 205.185.194.0/24*/, 24, NDPI_PROTOCOL_STEAM },
  { 0xCDC40600 /* 205.196.6.0/24 */, 24, NDPI_PROTOCOL_STEAM },
  { 0xD040C800 /* 208.64.200.0/24 */, 24, NDPI_PROTOCOL_STEAM },
  { 0xD040C900 /* 208.64.201.0/22 */, 24, NDPI_PROTOCOL_STEAM },
  { 0xD04EA400 /* 208.78.164.0/22 */, 22, NDPI_PROTOCOL_STEAM },

  /* Zoom video conference app. */
  { 0x03501480 /* 3.80.20.128/25 */, 25, NDPI_PROTOCOL_ZOOM },
  { 0x03787900 /* 3.120.121.0/25 */, 25, NDPI_PROTOCOL_ZOOM },
  { 0x03682280 /* 3.104.34.128/25 */, 25, NDPI_PROTOCOL_ZOOM },
  { 0x03D04800 /* 3.208.72.0/25 */, 25, NDPI_PROTOCOL_ZOOM },
  { 0x03D3F100 /* 3.211.241.0/25 */, 25, NDPI_PROTOCOL_ZOOM },
  { 0x04227D80 /* 4.34.125.128/25 */, 25, NDPI_PROTOCOL_ZOOM },
  { 0x04234080 /* 4.35.64.128/25 */, 25, NDPI_PROTOCOL_ZOOM },
  { 0x08058000 /* 8.5.128.0/23 */, 25, NDPI_PROTOCOL_ZOOM },
  { 0x0D340680 /* 13.52.6.128/25 */, 25, NDPI_PROTOCOL_ZOOM },
  { 0x0D349200 /* 13.52.146.0/25 */, 25, NDPI_PROTOCOL_ZOOM },
  { 0x0D726AA6 /* 13.114.106.166/32 */, 32, NDPI_PROTOCOL_ZOOM },
  { 0x12CD5D80 /* 18.205.93.128/25 */, 25, NDPI_PROTOCOL_ZOOM },
  { 0x32EFCA00 /* 50.239.202.0/23 */, 25, NDPI_PROTOCOL_ZOOM },
  { 0x32EFCC00 /* 50.239.204.0/24 */, 24, NDPI_PROTOCOL_ZOOM },
  { 0x343D6480 /* 52.61.100.128/25 */, 25, NDPI_PROTOCOL_ZOOM },
  { 0x34519780 /* 52.81.151.128/25 */, 25, NDPI_PROTOCOL_ZOOM },
  { 0x34C56115 /* 52.197.97.21/32 */, 32, NDPI_PROTOCOL_ZOOM },
  { 0x34CA3EC0 /* 52.202.62.192/26 */, 26, NDPI_PROTOCOL_ZOOM },
  { 0x34D7A800 /* 52.215.168.0/25 */, 25, NDPI_PROTOCOL_ZOOM },
  { 0x40454A00 /* 64.69.74.0/24 */, 24, NDPI_PROTOCOL_ZOOM },
  { 0x407D3E00 /* 64.125.62.0/24 */, 24, NDPI_PROTOCOL_ZOOM },
  { 0x40D39000 /* 64.211.144.0/24 */, 24, NDPI_PROTOCOL_ZOOM },
  { 0x41279800 /* 65.39.152.0/24 */, 24, NDPI_PROTOCOL_ZOOM },
  { 0x45AE3900 /* 69.174.57.0/24 */, 24, NDPI_PROTOCOL_ZOOM },
  { 0x45AE6C00 /* 69.174.108.0/22 */, 22, NDPI_PROTOCOL_ZOOM },
  { 0x634F1400 /* 99.79.20.0/25 */, 25, NDPI_PROTOCOL_ZOOM },
  { 0x677AA600 /* 103.122.166.0/23 */, 23, NDPI_PROTOCOL_ZOOM },
  { 0x6D5EA000 /* 109.94.160.0/24 */, 24, NDPI_PROTOCOL_ZOOM },
  { 0x736E9AC0 /* 115.110.154.192/26*/, 26, NDPI_PROTOCOL_ZOOM },
  { 0x737238C0 /* 115.114.56.192/26 */, 26, NDPI_PROTOCOL_ZOOM },
  { 0x73727300 /* 115.114.115.0/26 */, 26, NDPI_PROTOCOL_ZOOM },
  { 0x73728300 /* 115.114.131.0/26 */, 26, NDPI_PROTOCOL_ZOOM },
  { 0x781D9400 /* 120.29.148.0/24 */, 24, NDPI_PROTOCOL_ZOOM },
  { 0xA0013880 /* 160.1.56.128/25 */, 25, NDPI_PROTOCOL_ZOOM },
  { 0xA1C78800 /* 161.199.136.0/22 */, 22, NDPI_PROTOCOL_ZOOM },
  { 0xA20CE800 /* 162.12.232.0/22 */, 22, NDPI_PROTOCOL_ZOOM },
  { 0xA2FF2400 /* 162.255.36.0/22 */, 22, NDPI_PROTOCOL_ZOOM },
  { 0xA5FE5800 /* 165.254.88.0/23 */, 23, NDPI_PROTOCOL_ZOOM },
  { 0xC0CC0C00 /* 192.204.12.0/22 */, 22, NDPI_PROTOCOL_ZOOM },
  { 0xCAB1CF80 /* 202.177.207.128/27*/, 27, NDPI_PROTOCOL_ZOOM },
  { 0xCAB1D560 /* 202.177.213.96/27 */, 27, NDPI_PROTOCOL_ZOOM },
  { 0xCC506800 /* 204.80.104.0/21 */, 21, NDPI_PROTOCOL_ZOOM },
  { 0xCC8D1C00 /* 204.141.28.0/22 */, 22, NDPI_PROTOCOL_ZOOM },
  { 0xCFE28400 /* 207.226.132.0/24 */, 24, NDPI_PROTOCOL_ZOOM },
  { 0xD109D300 /* 209.9.211.0/24 */, 24, NDPI_PROTOCOL_ZOOM },
  { 0xD109D700 /* 209.9.215.0/24 */, 24, NDPI_PROTOCOL_ZOOM },
  { 0xD2393700 /* 210.57.55.0/24 */, 24, NDPI_PROTOCOL_ZOOM },
  { 0xD5139000 /* 213.19.144.0/24 */, 24, NDPI_PROTOCOL_ZOOM },
  { 0xD5139900 /* 213.19.153.0/24 */, 24, NDPI_PROTOCOL_ZOOM },
  { 0xD5F48C00 /* 213.244.140.0/24 */, 24, NDPI_PROTOCOL_ZOOM },
  { 0xDD7A5840 /* 221.122.88.64/27 */, 27, NDPI_PROTOCOL_ZOOM },
  { 0xDD7A5880 /* 221.122.88.128/25 */, 25, NDPI_PROTOCOL_ZOOM },
  { 0xDD7A5980 /* 221.122.89.128/25 */, 25, NDPI_PROTOCOL_ZOOM },
  /* 2620:123:2000::/44 IPV6 */

  /* PS_VUE IP address */
  { 0x08F8DA14 /* 8.248.218.20/32 */, 32, NDPI_PROTOCOL_PS_VUE },
  { 0x08FA6E14 /* 8.250.110.20/32 */, 32, NDPI_PROTOCOL_PS_VUE },
  { 0x08FC028B /* 8.252.2.139/32 */, 32, NDPI_PROTOCOL_PS_VUE },
  { 0x08FD6803 /* 8.253.104.3/32 */, 32, NDPI_PROTOCOL_PS_VUE },
  { 0x08FE6813 /* 8.253.104.19/32 */, 32, NDPI_PROTOCOL_PS_VUE },
  { 0x08FE8C0F /* 8.253.140.15/32 */, 32, NDPI_PROTOCOL_PS_VUE },
  { 0x08FE8C10 /* 8.253.140.16/32 */, 32, NDPI_PROTOCOL_PS_VUE },
  { 0x08FE8C77 /* 8.253.140.119/32 */, 32, NDPI_PROTOCOL_PS_VUE },
  { 0x08FC8CA8 /* 8.253.140.168/32 */, 32, NDPI_PROTOCOL_PS_VUE },
  { 0x08FC8CA9 /* 8.253.140.169/32 */, 32, NDPI_PROTOCOL_PS_VUE },
  { 0x4318881E /* 67.24.136.30/32   */, 32, NDPI_PROTOCOL_PS_VUE },
  { 0x431889FE /* 67.24.137.254/32  */, 32, NDPI_PROTOCOL_PS_VUE },
  { 0x43188DFE /* 67.24.141.254/32  */, 32, NDPI_PROTOCOL_PS_VUE },
  { 0x43188E1E /* 67.24.142.30/32   */, 32, NDPI_PROTOCOL_PS_VUE },
  { 0x4318901E /* 67.24.144.30/32   */, 32, NDPI_PROTOCOL_PS_VUE },
  { 0x4318921E /* 67.24.146.30/32   */, 32, NDPI_PROTOCOL_PS_VUE },
  { 0x43189630 /* 67.24.150.30/32   */, 32, NDPI_PROTOCOL_PS_VUE },
  { 0xA2D83A20 /* 162.216.58.32/32  */, 32, NDPI_PROTOCOL_PS_VUE },
  { 0xA2D83A2B /* 162.216.58.43/32  */, 32, NDPI_PROTOCOL_PS_VUE },
  { 0xA2D83A39 /* 162.216.58.57/32  */, 32, NDPI_PROTOCOL_PS_VUE },
  { 0xA2D83A40 /* 162.216.58.64/32  */, 32, NDPI_PROTOCOL_PS_VUE },
  { 0xA2D83A48 /* 162.216.58.72/32  */, 32, NDPI_PROTOCOL_PS_VUE },
  { 0xA2D83A51 /* 162.216.58.81/32  */, 32, NDPI_PROTOCOL_PS_VUE },
  { 0xA7CE74AA /* 167.206.116.170/32*/, 32, NDPI_PROTOCOL_PS_VUE },
  { 0xA7CEDA60 /* 167.206.218.96/32 */, 32, NDPI_PROTOCOL_PS_VUE },
  { 0xA7CEDA72 /* 167.206.218.114/32*/, 32, NDPI_PROTOCOL_PS_VUE },
  { 0xA7CEDA7B /* 167.206.218.123/32*/, 32, NDPI_PROTOCOL_PS_VUE },
  { 0xA7CEDA82 /* 167.206.218.130/32*/, 32, NDPI_PROTOCOL_PS_VUE },
  { 0xA7CEDA8A /* 167.206.218.138/32*/, 32, NDPI_PROTOCOL_PS_VUE },

  /* Bloomberg */
  { 0xD086A100 /* 208.134.161.0/24 */, 24, NDPI_PROTOCOL_BLOOMBERG },
  { 0xCDB7F600 /* 205.183.246.0/24 */, 24, NDPI_PROTOCOL_BLOOMBERG },
  { 0xC769B000 /* 199.105.176.0/21 */, 21, NDPI_PROTOCOL_BLOOMBERG },
  { 0xC769B800 /* 199.105.184.0/23 */, 23, NDPI_PROTOCOL_BLOOMBERG },
  { 0x45B80000 /* 69.184.0.0/13 */,    13, NDPI_PROTOCOL_BLOOMBERG },
  { 0xA02B0000 /* 160.43.0.0/16 */,    24, NDPI_PROTOCOL_BLOOMBERG },
  { 0xCE9C3500 /* 206.156.53.0/24 */,  24, NDPI_PROTOCOL_BLOOMBERG },
  { 0xCDD87000 /* 205.216.112.0/24 */, 24, NDPI_PROTOCOL_BLOOMBERG },
  { 0xD0163800 /* 208.22.56.0/24 */,   24, NDPI_PROTOCOL_BLOOMBERG },
  { 0xD0163900 /* 208.22.57.0/24 */,   24, NDPI_PROTOCOL_BLOOMBERG },
  { 0x45BFC000 /* 69.191.192.0/18 */,  18, NDPI_PROTOCOL_BLOOMBERG },

  /* AnyDesk */
  { 0x3353EF8E /* 51.83.239.142/31 */, 31, NDPI_PROTOCOL_ANYDESK },
  { 0x3353EF90 /* 51.83.239.144/31 */, 31, NDPI_PROTOCOL_ANYDESK },
  { 0x3353EEC8 /* 51.83.238.200/29 */, 29, NDPI_PROTOCOL_ANYDESK },
  { 0x3353EED0 /* 51.83.238.208/29 */, 29, NDPI_PROTOCOL_ANYDESK },
  { 0x3353EED8 /* 51.83.238.216/30 */, 30, NDPI_PROTOCOL_ANYDESK },
  { 0x3353EEDC /* 51.83.238.220/31 */, 31, NDPI_PROTOCOL_ANYDESK },

  /*
     Microsoft

     [JSON] https://endpoints.office.com/endpoints/worldwide?clientrequestid=b10c5ed1-bad1-445f-b386-b919946339a7
     [HTML] https://docs.microsoft.com/en-us/office365/enterprise/urls-and-ip-address-ranges
  */
 { 0x0D6B0698 /* 13.107.6.152/31 */, 31, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x0D6B120A /* 13.107.18.10/31 */, 31, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x0D6B8000 /* 13.107.128.0/22 */, 22, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x1767A000 /* 23.103.160.0/20 */, 20, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x28600000 /* 40.96.0.0/13 */, 13, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x28680000 /* 40.104.0.0/15 */, 15, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x34600000 /* 52.96.0.0/14 */, 14, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x83FD21D7 /* 131.253.33.215/32*/, 32, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x84F50000 /* 132.245.0.0/16 */, 16, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x96AB2000 /* 150.171.32.0/22 */, 22, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0xBFEA8C00 /* 191.234.140.0/22 */, 22, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0xCC4FC5D7 /* 204.79.197.215/32*/, 32, NDPI_PROTOCOL_MICROSOFT_365 },
 
 { 0x285C0000 /* 40.92.0.0/15 */, 15, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x286B0000 /* 40.107.0.0/16 */, 16, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x34640000 /* 52.100.0.0/14 */, 14, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x34EE4E58 /* 52.238.78.88/32 */, 32, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x682F0000 /* 104.47.0.0/17 */, 17, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x285C0000 /* 40.92.0.0/15 */, 15, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x286B0000 /* 40.107.0.0/16 */, 16, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x34640000 /* 52.100.0.0/14 */, 14, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x682F0000 /* 104.47.0.0/17 */, 17, NDPI_PROTOCOL_MICROSOFT_365 },
  /* ** */
 { 0x0D6B8800 /* 13.107.136.0/22 */, 22, NDPI_PROTOCOL_MS_ONE_DRIVE },
 { 0x286C8000 /* 40.108.128.0/17 */, 17, NDPI_PROTOCOL_MS_ONE_DRIVE },
 { 0x34680000 /* 52.104.0.0/14 */, 14, NDPI_PROTOCOL_MS_ONE_DRIVE },
 { 0x68928000 /* 104.146.128.0/17 */, 17, NDPI_PROTOCOL_MS_ONE_DRIVE },
 { 0x96AB2800 /* 150.171.40.0/22 */, 22, NDPI_PROTOCOL_MS_ONE_DRIVE },
  /* ** */
 { 0x0D6B4000 /* 13.107.64.0/18 */, 18, NDPI_PROTOCOL_SKYPE },
 { 0x34700000 /* 52.112.0.0/14 */, 14, NDPI_PROTOCOL_SKYPE },
 { 0x34780000 /* 52.120.0.0/14 */, 14, NDPI_PROTOCOL_SKYPE },
 { 0x34EE778D /* 52.238.119.141/32 */, 32, NDPI_PROTOCOL_SKYPE },
 { 0x34F4A0CF /* 52.244.160.207/32 */, 32, NDPI_PROTOCOL_SKYPE },

  /* ** */
 { 0x0D6B06AB /* 13.107.6.171/32 */, 32, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x0D6B8C06 /* 13.107.140.6/32 */, 32, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x346C0000 /* 52.108.0.0/14 */, 14, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x34EE6A74 /* 52.238.106.116/32 */, 32, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x34F796BF /* 52.247.150.191/32 */, 32, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x0D6A0480 /* 13.106.4.128/25 */, 25, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x0D6A3800 /* 13.106.56.0/25 */, 25, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x14BE8000 /* 20.190.128.0/18 */, 18, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x287E0000 /* 40.126.0.0/18 */, 18, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x4136AA80 /* 65.54.170.128/25 */, 25, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x682CDA80 /* 104.44.218.128/25 */, 25, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x682CFE80 /* 104.44.254.128/25 */, 25, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x682CFF00 /* 104.44.255.0/25 */, 25, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x86AA4300 /* 134.170.67.0/25 */, 25, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x86AAAC80 /* 134.170.172.128/25 */, 25, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x9D372D80 /* 157.55.45.128/25 */, 25, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x9D378200 /* 157.55.130.0/25 */, 25, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x9D379100 /* 157.55.145.0/25 */, 25, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x9D379B00 /* 157.55.155.0/25 */, 25, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x9D37E3C0 /* 157.55.227.192/26 */, 26, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0xBFE80280 /* 191.232.2.128/25 */, 25, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x0D507D16 /* 13.80.125.22/32 */, 32, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x0D5B5BF3 /* 13.91.91.243/32 */, 32, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x0D6B069C /* 13.107.6.156/31 */, 31, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x0D6B07BE /* 13.107.7.190/31 */, 31, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x0D6B099C /* 13.107.9.156/31 */, 31, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x28519C9A /* 40.81.156.154/32 */, 32, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x285ADAC6 /* 40.90.218.198/32 */, 32, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x346C0000 /* 52.108.0.0/14 */, 14, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x34AE38B4 /* 52.174.56.180/32 */, 32, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x34B74B3E /* 52.183.75.62/32 */, 32, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x34B8A552 /* 52.184.165.82/32 */, 32, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x682AE65B /* 104.42.230.91/32 */, 32, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x9D379100 /* 157.55.145.0/25 */, 25, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x9D379B00 /* 157.55.155.0/25 */, 25, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x9D37E3C0 /* 157.55.227.192/26 */, 26, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x0D507D16 /* 13.80.125.22/32 */, 32, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x0D5B5BF3 /* 13.91.91.243/32 */, 32, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x0D6B069C /* 13.107.6.156/31 */, 31, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x0D6B07BE /* 13.107.7.190/31 */, 31, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x0D6B099C /* 13.107.9.156/31 */, 31, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x28519C9A /* 40.81.156.154/32 */, 32, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x285ADAC6 /* 40.90.218.198/32 */, 32, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x346C0000 /* 52.108.0.0/14 */, 14, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x34AE38B4 /* 52.174.56.180/32 */, 32, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x34B74B3E /* 52.183.75.62/32 */, 32, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x34B8A552 /* 52.184.165.82/32 */, 32, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x682AE65B /* 104.42.230.91/32 */, 32, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x9D379100 /* 157.55.145.0/25 */, 25, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x9D379B00 /* 157.55.155.0/25 */, 25, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x9D37E3C0 /* 157.55.227.192/26 */, 26, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x0D6B06AB /* 13.107.6.171/32 */, 32, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x0D6B8C06 /* 13.107.140.6/32 */, 32, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x346C0000 /* 52.108.0.0/14 */, 14, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x34EE6A74 /* 52.238.106.116/32 */, 32, NDPI_PROTOCOL_MICROSOFT_365 },
 { 0x34F796BF /* 52.247.150.191/32 */, 32, NDPI_PROTOCOL_MICROSOFT_365 },
  /* ** */
  { 0x0D400000 /* 13.64.0.0 */, 11, NDPI_PROTOCOL_MICROSOFT },
  { 0x0D600000 /* 13.96.0.0 */, 13, NDPI_PROTOCOL_MICROSOFT },
  { 0x0D680000 /* 13.104.0.0 */, 14, NDPI_PROTOCOL_MICROSOFT },

  /* End */
  { 0x0, 0, 0 }
};
#endif

/* ****************************************************** */

/*
  Host-based match

  HTTP:  Server: field
  HTTPS: Server certificate name

  Risk classification criteria
  ----------------------------

  NDPI_PROTOCOL_SAFE
  - Web sites (and CDNs) which are not commonly used to host malicious activities.
  - OS update hosts.
  - App stores.
  - Commonly used services with passwords in encrypted channels (SMTPS, POPS, etc)

  NDPI_PROTOCOL_ACCEPTABLE
  - Cloud services may be used to host malware (e.g., https://www.fireeye.com/blog/threat-research/2015/11/china-based-threat.html),
  but it is mostly used for normal purposes.
  - Webmail sites, which can be used to phising.
  - Encrypted administrative protocols, such as SSH.
  - Text, voice or video communication (e.g., Skype, Slack, Whatsapp).
  - Ads services are commonly used to spread malware
  (https://www.tripwire.com/state-of-security/security-data-protection/crypto-ransomware-spreads-via-poisoned-ads-on-major-websites/)

  NDPI_PROTOCOL_FUN
  - Social media sites and services.
  - Communication used for fun purposes, like Snapchat, Tinder, etc.
  - Audio and videostreamming services (e.g., Netflix).
  - Game services.

  NDPI_PROTOCOL_UNSAFE
  - Unencrypted administrative protocols, such as Telnet.
  - Cloud hosted servers when accessed by default domains, such as *.amazonaws.com.
  - "AWS Supports 41% of Malware Hosting Sites, More than Any Other Web Host or ISP"
  http://www.thewhir.com/web-hosting-news/aws-supports-41-malware-hosting-sites-web-host-isp
  - https://www.scmagazine.com/600-plus-cloud-repositories-spotted-hosting-malware-and-malicious-files/article/572205/
  - https://howtoremove.guide/remove-s3-amazonaws-virus/
  - Torrents.
  - Commonly used services with passwords in unencrypted channels (SMTP, POP, etc)

  NDPI_PROTOCOL_POTENTIALLY_DANGEROUS
  - Tor and other anonymization access.
  - Sites commonly used to host malware and not as commonly used by "normal" users. (e.g., pastebin.com)
  https://isc.sans.edu/forums/diary/Many+Malware+Samples+Found+on+Pastebin/22036/

  NDPI_PROTOCOL_UNRATED
  - Avoid this class.

*/

/* ****************************************************** */

ndpi_protocol_match host_match[] =
  {
   { "dmqdd6hw24ucf.cloudfront.net",                      "AmazonVideo",      NDPI_PROTOCOL_AMAZON_VIDEO, NDPI_PROTOCOL_CATEGORY_VIDEO, NDPI_PROTOCOL_FUN },
   { "d25xi40x97liuc.cloudfront.net",                     "AmazonVideo",      NDPI_PROTOCOL_AMAZON_VIDEO, NDPI_PROTOCOL_CATEGORY_VIDEO, NDPI_PROTOCOL_FUN },
   { ".aiv-delivery.net",                                 "AmazonVideo",      NDPI_PROTOCOL_AMAZON_VIDEO, NDPI_PROTOCOL_CATEGORY_VIDEO, NDPI_PROTOCOL_FUN },
   { ".aiv-cdn.net",                                      "AmazonVideo",      NDPI_PROTOCOL_AMAZON_VIDEO, NDPI_PROTOCOL_CATEGORY_VIDEO, NDPI_PROTOCOL_FUN },
   { "1s3.lvlt.dash.us.aiv-cdn.net.c.footprint.net",      "AmazonVideo",      NDPI_PROTOCOL_AMAZON_VIDEO, NDPI_PROTOCOL_CATEGORY_STREAMING, NDPI_PROTOCOL_FUN },
   { ".s.loris.llnwd.net",                                "AmazonVideo",      NDPI_PROTOCOL_AMAZON_VIDEO, NDPI_PROTOCOL_CATEGORY_VIDEO, NDPI_PROTOCOL_FUN },
   { "atv-ext.amazon.com",                                "AmazonVideo",      NDPI_PROTOCOL_AMAZON_VIDEO, NDPI_PROTOCOL_CATEGORY_VIDEO, NDPI_PROTOCOL_FUN },
   { "atv-ps.amazon.com",                                 "AmazonVideo",      NDPI_PROTOCOL_AMAZON_VIDEO, NDPI_PROTOCOL_CATEGORY_VIDEO, NDPI_PROTOCOL_FUN },
   { ".media-amazon.com",                                 "AmazonVideo",      NDPI_PROTOCOL_AMAZON_VIDEO, NDPI_PROTOCOL_CATEGORY_VIDEO, NDPI_PROTOCOL_FUN },
   { ".amazonvideo.com",                                  "AmazonVideo",      NDPI_PROTOCOL_AMAZON_VIDEO, NDPI_PROTOCOL_CATEGORY_VIDEO, NDPI_PROTOCOL_FUN },
   { ".primevideo.com",                                   "AmazonVideo",      NDPI_PROTOCOL_AMAZON_VIDEO, NDPI_PROTOCOL_CATEGORY_VIDEO, NDPI_PROTOCOL_FUN },

   { "amazon.",                                                "Amazon",           NDPI_PROTOCOL_AMAZON, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },
   { "amazon.com",                                             "Amazon",           NDPI_PROTOCOL_AMAZON, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },
   { "images-amazon.com",                                      "Amazon",           NDPI_PROTOCOL_AMAZON, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },
   { "amazonaws.com",                                          "Amazon",           NDPI_PROTOCOL_AMAZON, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },
   { "amazon-adsystem.com",                                    "Amazon",           NDPI_PROTOCOL_AMAZON, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },
   { ".aws.",                                                  "Amazon",           NDPI_PROTOCOL_AMAZON, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },
   { ".cloudfront.net",                                        "Amazon",           NDPI_PROTOCOL_AMAZON, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },
   { ".us-west-2.compute.amazonaws.com",                       "Amazon",           NDPI_PROTOCOL_AMAZON, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },
   { ".teamviewer.com",                                        "Teamviewer",           NDPI_PROTOCOL_TEAMVIEWER, NDPI_PROTOCOL_CATEGORY_REMOTE_ACCESS, NDPI_PROTOCOL_ACCEPTABLE },
   { ".bloombergvault.com",                          "Bloomberg",        NDPI_PROTOCOL_BLOOMBERG, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { ".bloomberg.com",                                    "Bloomberg",        NDPI_PROTOCOL_BLOOMBERG, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { ".apple-dns.net",                            "Apple",            NDPI_PROTOCOL_APPLE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { "origin-apple.com.akadns.net",               "Apple",            NDPI_PROTOCOL_APPLE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { "e6858.dsce9.akamaiedge.net",                "Apple",            NDPI_PROTOCOL_APPLE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { ".mzstatic.com",                             "Apple",            NDPI_PROTOCOL_APPLE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { "aaplimg.com",                               "Apple",            NDPI_PROTOCOL_APPLE, NDPI_PROTOCOL_CATEGORY_SW_UPDATE, NDPI_PROTOCOL_SAFE },
   { ".apple.com",                                "Apple",            NDPI_PROTOCOL_APPLE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { ".apple.news",                               "Apple",            NDPI_PROTOCOL_APPLE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { ".cdn-apple.com",                            "Apple",            NDPI_PROTOCOL_APPLE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { ".ls4-apple.com",                            "Apple",            NDPI_PROTOCOL_APPLE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { ".gc-apple.com",                             "Apple",            NDPI_PROTOCOL_APPLE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { ".ls-apple.com",                             "Apple",            NDPI_PROTOCOL_APPLE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { ".apple-cloudkit.com",                       "Apple",            NDPI_PROTOCOL_APPLE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { ".push.apple.com",                           "ApplePush",        NDPI_PROTOCOL_APPLE_PUSH, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { "push-apple.com",                            "ApplePush",        NDPI_PROTOCOL_APPLE_PUSH, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { ".icloud.com",                               "AppleiCloud",      NDPI_PROTOCOL_APPLE_ICLOUD, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },
   { ".icloud.com.",                              "AppleiCloud",      NDPI_PROTOCOL_APPLE_ICLOUD, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE }, /* icloud.com.akadns.net */
   { ".me.com",                                   "AppleiCloud",      NDPI_PROTOCOL_APPLE_ICLOUD, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },
   { ".icloud-content.com",                       "AppleiCloud",      NDPI_PROTOCOL_APPLE_ICLOUD, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },
   { "iosapps.itunes.apple.com",                  "AppleStore",       NDPI_PROTOCOL_APPLESTORE, NDPI_PROTOCOL_CATEGORY_SW_UPDATE, NDPI_PROTOCOL_SAFE }, /* iOS */
   { "osxapps.itunes.apple.com",                  "AppleStore",       NDPI_PROTOCOL_APPLESTORE, NDPI_PROTOCOL_CATEGORY_SW_UPDATE, NDPI_PROTOCOL_SAFE }, /* MacOS */
   { "buy.itunes.apple.com",                      "AppleStore",       NDPI_PROTOCOL_APPLESTORE, NDPI_PROTOCOL_CATEGORY_SW_UPDATE, NDPI_PROTOCOL_SAFE },
   { "su.itunes.apple.com",                       "AppleStore",       NDPI_PROTOCOL_APPLESTORE, NDPI_PROTOCOL_CATEGORY_SW_UPDATE, NDPI_PROTOCOL_SAFE },
   { "se.itunes.apple.com",                       "AppleStore",       NDPI_PROTOCOL_APPLESTORE, NDPI_PROTOCOL_CATEGORY_SW_UPDATE, NDPI_PROTOCOL_SAFE },
   { "myapp.itunes.apple.com",                    "AppleStore",       NDPI_PROTOCOL_APPLESTORE, NDPI_PROTOCOL_CATEGORY_SW_UPDATE, NDPI_PROTOCOL_SAFE },
   { "swscan.apple.com",                          "AppleStore",       NDPI_PROTOCOL_APPLESTORE, NDPI_PROTOCOL_CATEGORY_SW_UPDATE, NDPI_PROTOCOL_SAFE },
   { "itunes-apple.com",                          "AppleStore",       NDPI_PROTOCOL_APPLESTORE, NDPI_PROTOCOL_CATEGORY_SW_UPDATE, NDPI_PROTOCOL_SAFE },
   { "itunes.apple.com",                          "AppleiTunes",      NDPI_PROTOCOL_APPLE_ITUNES, NDPI_PROTOCOL_CATEGORY_STREAMING, NDPI_PROTOCOL_FUN },
   { "tlnk.io",         	                      "AppleiTunes",      NDPI_PROTOCOL_APPLE_ITUNES, NDPI_PROTOCOL_CATEGORY_STREAMING, NDPI_PROTOCOL_FUN },
   { "guzzoni.apple.",         	   "AppleSiri",      NDPI_PROTOCOL_APPLE_SIRI, NDPI_PROTOCOL_CATEGORY_VIRTUAL_ASSISTANT, NDPI_PROTOCOL_ACCEPTABLE },
   { ".wbagora.com",                              "Playstation",      NDPI_PROTOCOL_PLAYSTATION, NDPI_PROTOCOL_CATEGORY_GAME, NDPI_PROTOCOL_UNRATED },
   { ".wbplay.com",                                "Playstation",      NDPI_PROTOCOL_PLAYSTATION, NDPI_PROTOCOL_CATEGORY_GAME, NDPI_PROTOCOL_UNRATED },
   { ".xbox.com",                                    "Xbox",             NDPI_PROTOCOL_XBOX, NDPI_PROTOCOL_CATEGORY_GAME, NDPI_PROTOCOL_FUN },
   { ".xboxlive.com",                            "Xbox",             NDPI_PROTOCOL_XBOX, NDPI_PROTOCOL_CATEGORY_GAME, NDPI_PROTOCOL_FUN },
   { ".xboxlive.com.akadns.net",                 "Xbox",             NDPI_PROTOCOL_XBOX, NDPI_PROTOCOL_CATEGORY_GAME, NDPI_PROTOCOL_FUN },
   { ".xboxlive.com.c.footprint.net",            "Xbox",             NDPI_PROTOCOL_XBOX, NDPI_PROTOCOL_CATEGORY_GAME, NDPI_PROTOCOL_FUN },
   { "e13555.b.akamaiedge.net",   "Playstation",      NDPI_PROTOCOL_PLAYSTATION, NDPI_PROTOCOL_CATEGORY_GAME, NDPI_PROTOCOL_FUN },
   { "e1800.d.akamaiedge.net",     "Playstation",      NDPI_PROTOCOL_PLAYSTATION, NDPI_PROTOCOL_CATEGORY_GAME, NDPI_PROTOCOL_FUN },
   { "e1879.e7.akamaiedge.net",   "Playstation",      NDPI_PROTOCOL_PLAYSTATION, NDPI_PROTOCOL_CATEGORY_GAME, NDPI_PROTOCOL_FUN },

   { ".cnn.com",           "CNN",              NDPI_PROTOCOL_CNN, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { ".cnn.net",           "CNN",              NDPI_PROTOCOL_CNN, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },

   { ".dropbox.com",             "DropBox",          NDPI_PROTOCOL_DROPBOX, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_ACCEPTABLE },
   { ".dropboxstatic.com", "DropBox",          NDPI_PROTOCOL_DROPBOX, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_ACCEPTABLE },
   { ".dropbox-dns.com",     "DropBox",          NDPI_PROTOCOL_DROPBOX, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_ACCEPTABLE },
   { "log.getdropbox.com", "DropBox",          NDPI_PROTOCOL_DROPBOX, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_ACCEPTABLE },

   { ".ebay.",                      "eBay",             NDPI_PROTOCOL_EBAY, NDPI_PROTOCOL_CATEGORY_SHOPPING, NDPI_PROTOCOL_SAFE },  /* or FUN */
   { ".ebay.com",                            "eBay",             NDPI_PROTOCOL_EBAY, NDPI_PROTOCOL_CATEGORY_SHOPPING, NDPI_PROTOCOL_SAFE },
   { ".ebaystatic.com",       "eBay",             NDPI_PROTOCOL_EBAY, NDPI_PROTOCOL_CATEGORY_SHOPPING, NDPI_PROTOCOL_SAFE },
   { ".ebaydesc.com",           "eBay",             NDPI_PROTOCOL_EBAY, NDPI_PROTOCOL_CATEGORY_SHOPPING, NDPI_PROTOCOL_SAFE },
   { ".ebayrtm.com",             "eBay",             NDPI_PROTOCOL_EBAY, NDPI_PROTOCOL_CATEGORY_SHOPPING, NDPI_PROTOCOL_SAFE },
   { ".ebaystratus.com",     "eBay",             NDPI_PROTOCOL_EBAY, NDPI_PROTOCOL_CATEGORY_SHOPPING, NDPI_PROTOCOL_SAFE },
   { ".ebayimg.com",             "eBay",             NDPI_PROTOCOL_EBAY, NDPI_PROTOCOL_CATEGORY_SHOPPING, NDPI_PROTOCOL_SAFE },

   /* Detected "instagram.c10r.facebook.com". Omitted "*amazonaws.com" and "*facebook.com" CDNs e.g. "ig-telegraph-shv-04-frc3.facebook.com" */
   { ".instagram.",            "Instagram",        NDPI_PROTOCOL_INSTAGRAM, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "instagram.",                "Instagram",        NDPI_PROTOCOL_INSTAGRAM, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { ".cdninstagram.com",   "Instagram",        NDPI_PROTOCOL_INSTAGRAM, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },

   { "igcdn-photos-",          "Instagram",        NDPI_PROTOCOL_INSTAGRAM, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "instagramimages-",       "Instagram",        NDPI_PROTOCOL_INSTAGRAM, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "instagramstatic-",       "Instagram",        NDPI_PROTOCOL_INSTAGRAM, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },

   { "facebook.com",            "Facebook",         NDPI_PROTOCOL_FACEBOOK, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { ".facebook.net",           "Facebook",         NDPI_PROTOCOL_FACEBOOK, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "fbstatic-a.akamaihd.net", "Facebook",         NDPI_PROTOCOL_FACEBOOK, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { ".fbcdn.net",              "Facebook",         NDPI_PROTOCOL_FACEBOOK, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "fbcdn-",                  "Facebook",         NDPI_PROTOCOL_FACEBOOK, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { ".fbsbx.com",              "Facebook",         NDPI_PROTOCOL_FACEBOOK, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { ".fbwat.ch",               "Facebook",         NDPI_PROTOCOL_FACEBOOK, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { ".fb.com",                 "Facebook",         NDPI_PROTOCOL_FACEBOOK, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { ".fb.gg",                  "Facebook",         NDPI_PROTOCOL_FACEBOOK, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },

   { "speedtest.",                       "Ookla",            NDPI_PROTOCOL_OOKLA, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_SAFE },
   { ".ooklaserver.net",         "Ookla",            NDPI_PROTOCOL_OOKLA, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_SAFE },

   { "ntop.org",                     "ntop",         NDPI_PROTOCOL_NTOP, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_SAFE },

   { "docs.googleusercontent.com",   "GoogleDocs",     NDPI_PROTOCOL_GOOGLE_DOCS, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { "docs.google.com",              "GoogleDocs",     NDPI_PROTOCOL_GOOGLE_DOCS, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },

   { "drive-thirdparty.googleusercontent.com",  "GoogleDrive",      NDPI_PROTOCOL_GOOGLE_DRIVE, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_ACCEPTABLE },
   { "drive.google.com",                          "GoogleDrive",      NDPI_PROTOCOL_GOOGLE_DRIVE, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_ACCEPTABLE },

   { "android.clients.google.com",   "PlayStore",    NDPI_PROTOCOL_PLAYSTORE, NDPI_PROTOCOL_CATEGORY_SW_UPDATE, NDPI_PROTOCOL_SAFE },

   /*
     https://www.fastvue.co/sophos/blog/google-data-saver-affect-security-confidentiality-reporting/
     Used by Google Chrome Lite Mode for Android

     This traffic will bypass checks and blocks as it will include all the communications from/to
     the browser instead of using the standard communication mechanisms SSL/HTTP(S)/DNS

     https://github.com/curl/curl/wiki/DNS-over-HTTPS
   */
   { ".googlezip.net",                       "DataSaver",     NDPI_PROTOCOL_DATASAVER, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },
   { "datasaver.googleapis.com", "DataSaver",     NDPI_PROTOCOL_DATASAVER, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },

   /* http://check.googlezip.net/connect [check browser connectivity] */
   // { ".googlezip.net",                   "Google",           NDPI_PROTOCOL_GOOGLE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },

   /*
      https://github.com/bambenek/block-doh/blob/master/db.doh-redirect
      https://github.com/curl/curl/wiki/DNS-over-HTTPS
   */
   { "dns.google", "DoH_DoT",     NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "dns.google.com", "DoH_DoT",     NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "mozilla.cloudflare-dns.com", "DoH_DoT",     NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE }, /* Firefox */
   { "cloudflare-dns.com", "DoH_DoT",     NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "commons.host", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "doh.libredns.gr", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "dns9.quad9.net", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "doh.opendns.com", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "doh.dns.sb", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "doh.netweaver.uk", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "dns.dns-over-https.com", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "jp.tiarap.org", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "dns.dnsoverhttps.net", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "doh.powerdns.org", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "adblock.mydns.network", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "jp.tiar.app", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "doh.crypto.sx", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "dns.quad9.net", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "dns.containerpi.com", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "ibksturm.synology.me", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "doh.captnemo.in", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "dns.rubyfish.cn", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "doh.42l.fr", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "dns-family.adguard.com", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "appliedprivacy.net", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "doh.cleanbrowsing.org", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "dns10.quad9.net", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "doh-ch.blahdns.com", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "doh.seby.io", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "dns.adguard.com", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "ibuki.cgnat.net", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "jcdns.fun", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "doh-2.seby.io", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "doh.tiar.app", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "doh.dnswarden.com", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "doh-de.blahdns.com", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "doh-jp.blahdns.com", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "doh.appliedprivacy.net", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "doh.tiarap.org", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "doh.armadillodns.net", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "dns-nyc.aaflalo.me", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "dns.aa.net.uk", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "dns.aaflalo.me", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "dns11.quad9.net", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "dns.nextdns.io", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "doh.securedns.eu", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "rdns.faelix.net", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "captnemo.in", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "dns.dnshome.de", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "doh.dnslify.com", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "resolver-eu.lelux.fi", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "doh.bortzmeyer.fr", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { ".doh.dns.snopyta.org", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "jarjar.meganerd.nl", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "rumpelsepp.org", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "dnsnl.alekberg.net", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "dnses.alekberg.net", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "dnsse.alekberg.net", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "odvr.nic.cz", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "dns.dnscrypt.ca", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "dns1.dnscrypt.ca", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "dns2.dnscrypt.ca", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "dns.digitale-gesellschaft.ch", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "dns1.digitale-gesellschaft.ch", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "dns.cloudflare.com", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { "doh.ffmuc.net", "DoH_DoT", NDPI_PROTOCOL_DOH_DOT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },


   /*
     See https://better.fyi/trackers/

     DoubleClick by Google (2mdn.net)
     DoubleClick by Google (doubleclick.net)
     DoubleClick by Google
     Google AdSense by Google (google.com)
     Google AdSense by Google (google.se)
     Google AdSense by Google (googleadservices.com)
     Google Analytics by Google (google-analytics.com)
     Google APIs by Google (ajax.googleapis.com)
     Google Fonts by Google (fonts.googleapis.com)
     Google Interactive Media Ads (imasdk.googleapis.com)
     Google Syndication (googlesyndication.com)
     Google Tag Manager by Google (googletagmanager.com)
     Google Tag Manager by Google (googletagservices.com)
     Gstatic by Google (gstatic.com)
   */

   /* Google Advertisements */
   { ".googlesyndication.com",   "Google",           NDPI_PROTOCOL_GOOGLE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_TRACKER_ADS },
   { "googleads.",                           "Google",           NDPI_PROTOCOL_GOOGLE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_TRACKER_ADS },
   { ".doubleclick.net",               "Google",           NDPI_PROTOCOL_GOOGLE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_TRACKER_ADS },
   { "googleadservices.",             "Google",           NDPI_PROTOCOL_GOOGLE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_TRACKER_ADS },
   { ".2mdn.net",                             "Google",           NDPI_PROTOCOL_GOOGLE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_TRACKER_ADS },
   { ".dmtry.com",                           "Google",           NDPI_PROTOCOL_GOOGLE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_TRACKER_ADS },
   { "google-analytics.",             "Google",           NDPI_PROTOCOL_GOOGLE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_TRACKER_ADS },
   { "gtv1.com",                                 "Google",           NDPI_PROTOCOL_GOOGLE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },

   /* Google Hangout */
   { "images2-hangout-opensocial.googleusercontent.com", "GoogleHangout", NDPI_PROTOCOL_HANGOUT_DUO, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_ACCEPTABLE },

   /* Google Services */
   { "googleapis.com",                     "GoogleServices",   NDPI_PROTOCOL_GOOGLE_SERVICES, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },
   { ".googletagservices.com",   "GoogleServices",   NDPI_PROTOCOL_GOOGLE_SERVICES, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },
   { "mtalk.google.com",               "GoogleServices",   NDPI_PROTOCOL_GOOGLE_SERVICES, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },

   { "plus.google.com",                 "GooglePlus",       NDPI_PROTOCOL_GOOGLE_PLUS, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "plus.url.google.com",       "GooglePlus",       NDPI_PROTOCOL_GOOGLE_PLUS, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },

   { "googleusercontent.com",       "Google",           NDPI_PROTOCOL_GOOGLE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },
   { "1e100.net",                               "Google",           NDPI_PROTOCOL_GOOGLE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },

   { "maps.google.",                    "GoogleMaps",       NDPI_PROTOCOL_GOOGLE_MAPS, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { "maps.gstatic.com",               "GoogleMaps",       NDPI_PROTOCOL_GOOGLE_MAPS, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },

   { ".gmail.",                              "GMail",            NDPI_PROTOCOL_GMAIL, NDPI_PROTOCOL_CATEGORY_MAIL, NDPI_PROTOCOL_ACCEPTABLE },
   { "mail.google.",                    "GMail",            NDPI_PROTOCOL_GMAIL, NDPI_PROTOCOL_CATEGORY_MAIL, NDPI_PROTOCOL_ACCEPTABLE },

   { "google.",                                "Google",           NDPI_PROTOCOL_GOOGLE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { ".google.",                                       "Google",           NDPI_PROTOCOL_GOOGLE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { ".gstatic.com",                       "Google",           NDPI_PROTOCOL_GOOGLE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { "ggpht.com",                               "Google",           NDPI_PROTOCOL_GOOGLE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },

   { "mail.outlook.com",               "Hotmail",          NDPI_PROTOCOL_HOTMAIL, NDPI_PROTOCOL_CATEGORY_MAIL, NDPI_PROTOCOL_ACCEPTABLE },

   { ".last.fm",                            "LastFM",           NDPI_PROTOCOL_LASTFM, NDPI_PROTOCOL_CATEGORY_MUSIC, NDPI_PROTOCOL_FUN },

   { "netflix.com",                           "NetFlix",          NDPI_PROTOCOL_NETFLIX, NDPI_PROTOCOL_CATEGORY_VIDEO, NDPI_PROTOCOL_FUN },
   { "nflxext.com",                           "NetFlix",          NDPI_PROTOCOL_NETFLIX, NDPI_PROTOCOL_CATEGORY_VIDEO, NDPI_PROTOCOL_FUN },
   { "nflximg.com",                           "NetFlix",          NDPI_PROTOCOL_NETFLIX, NDPI_PROTOCOL_CATEGORY_VIDEO, NDPI_PROTOCOL_FUN },
   { "nflximg.net",                           "NetFlix",          NDPI_PROTOCOL_NETFLIX, NDPI_PROTOCOL_CATEGORY_VIDEO, NDPI_PROTOCOL_FUN },
   { "nflxvideo.net",                         "NetFlix",          NDPI_PROTOCOL_NETFLIX, NDPI_PROTOCOL_CATEGORY_VIDEO, NDPI_PROTOCOL_FUN },
   { "nflxso.net",                            "NetFlix",          NDPI_PROTOCOL_NETFLIX, NDPI_PROTOCOL_CATEGORY_VIDEO, NDPI_PROTOCOL_FUN },
   { "fast.com",                              "NetFlix",          NDPI_PROTOCOL_NETFLIX, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_SAFE },

   { ".skype.",                                    "Skype",            NDPI_PROTOCOL_SKYPE, NDPI_PROTOCOL_CATEGORY_VOIP, NDPI_PROTOCOL_ACCEPTABLE },
   { ".skypeassets.",                              "Skype",            NDPI_PROTOCOL_SKYPE, NDPI_PROTOCOL_CATEGORY_VOIP, NDPI_PROTOCOL_ACCEPTABLE },
   { ".skypedata.",                                "Skype",            NDPI_PROTOCOL_SKYPE, NDPI_PROTOCOL_CATEGORY_VOIP, NDPI_PROTOCOL_ACCEPTABLE },
   { ".skypeecs-",                                 "Skype",            NDPI_PROTOCOL_SKYPE, NDPI_PROTOCOL_CATEGORY_VOIP, NDPI_PROTOCOL_ACCEPTABLE },
   { ".skypeforbusiness.",                         "Skype",            NDPI_PROTOCOL_SKYPE, NDPI_PROTOCOL_CATEGORY_VOIP, NDPI_PROTOCOL_ACCEPTABLE },
   { ".lync.com",                                  "Skype",            NDPI_PROTOCOL_SKYPE, NDPI_PROTOCOL_CATEGORY_VOIP, NDPI_PROTOCOL_ACCEPTABLE },
   { "e7768.b.akamaiedge.net",                     "Skype",            NDPI_PROTOCOL_SKYPE, NDPI_PROTOCOL_CATEGORY_VOIP, NDPI_PROTOCOL_ACCEPTABLE },
   { "e4593.dspg.akamaiedge.net",                  "Skype",            NDPI_PROTOCOL_SKYPE, NDPI_PROTOCOL_CATEGORY_VOIP, NDPI_PROTOCOL_ACCEPTABLE },
   { "e4593.g.akamaiedge.net",                     "Skype",            NDPI_PROTOCOL_SKYPE, NDPI_PROTOCOL_CATEGORY_VOIP, NDPI_PROTOCOL_ACCEPTABLE },
   { "*.gateway.messenger.live.com",               "Skype",            NDPI_PROTOCOL_SKYPE, NDPI_PROTOCOL_CATEGORY_VOIP, NDPI_PROTOCOL_ACCEPTABLE },
   { "skype-calling-missedcallsregistrar-",        "Skype",            NDPI_PROTOCOL_SKYPE, NDPI_PROTOCOL_CATEGORY_VOIP, NDPI_PROTOCOL_ACCEPTABLE },

   { ".tuenti.com",                              "Tuenti",           NDPI_PROTOCOL_TUENTI, NDPI_PROTOCOL_CATEGORY_VOIP, NDPI_PROTOCOL_ACCEPTABLE },

   { ".twttr.com",                                "Twitter",          NDPI_PROTOCOL_TWITTER, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "twitter.",                                   "Twitter",          NDPI_PROTOCOL_TWITTER, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "twimg.com",                                    "Twitter",          NDPI_PROTOCOL_TWITTER, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },

   { ".viber.com",                                "Viber",            NDPI_PROTOCOL_VIBER, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_ACCEPTABLE },
   { ".cdn.viber.com",                                      "Viber",            NDPI_PROTOCOL_VIBER, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_ACCEPTABLE },
   { ".viber.it",                                           "Viber",            NDPI_PROTOCOL_VIBER, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_ACCEPTABLE },

   { "wikipedia.",                               "Wikipedia",        NDPI_PROTOCOL_WIKIPEDIA, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { "wikimedia.",                               "Wikipedia",        NDPI_PROTOCOL_WIKIPEDIA, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { "mediawiki.",                               "Wikipedia",        NDPI_PROTOCOL_WIKIPEDIA, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { "wikimediafoundation.",           "Wikipedia",        NDPI_PROTOCOL_WIKIPEDIA, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },

   { "mmg-fna.whatsapp.net",            "WhatsAppFiles",    NDPI_PROTOCOL_WHATSAPP_FILES, NDPI_PROTOCOL_CATEGORY_DOWNLOAD_FT, NDPI_PROTOCOL_ACCEPTABLE },
   { ".whatsapp.",                             "WhatsApp",         NDPI_PROTOCOL_WHATSAPP, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_ACCEPTABLE },
   { "g.whatsapp.net",                        "WhatsApp",         NDPI_PROTOCOL_WHATSAPP, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_ACCEPTABLE },
   { "v.whatsapp.net",                        "WhatsApp",         NDPI_PROTOCOL_WHATSAPP, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_ACCEPTABLE },
   { "mmg.whatsapp.net",                    "WhatsApp",         NDPI_PROTOCOL_WHATSAPP, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_ACCEPTABLE },

   { ".yahoo.",                                   "Yahoo",            NDPI_PROTOCOL_YAHOO, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { ".yimg.com",                                  "Yahoo",            NDPI_PROTOCOL_YAHOO, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { "yahooapis.",                               "Yahoo",            NDPI_PROTOCOL_YAHOO, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },

   { "upload.youtube.com",                "YouTubeUpload",    NDPI_PROTOCOL_YOUTUBE_UPLOAD, NDPI_PROTOCOL_CATEGORY_MEDIA, NDPI_PROTOCOL_FUN },
   { "upload.video.google.com",           "YouTubeUpload",    NDPI_PROTOCOL_YOUTUBE_UPLOAD, NDPI_PROTOCOL_CATEGORY_MEDIA, NDPI_PROTOCOL_FUN },
   { "youtubei.googleapis.com",           "YouTube",          NDPI_PROTOCOL_YOUTUBE, NDPI_PROTOCOL_CATEGORY_MEDIA, NDPI_PROTOCOL_FUN },
   { "youtube.",                          "YouTube",          NDPI_PROTOCOL_YOUTUBE, NDPI_PROTOCOL_CATEGORY_MEDIA, NDPI_PROTOCOL_FUN },
   { "youtu.be",                          "YouTube",          NDPI_PROTOCOL_YOUTUBE, NDPI_PROTOCOL_CATEGORY_MEDIA, NDPI_PROTOCOL_FUN },
   { "yt3.ggpht.com",                     "YouTube",          NDPI_PROTOCOL_YOUTUBE, NDPI_PROTOCOL_CATEGORY_MEDIA, NDPI_PROTOCOL_FUN },
   { ".googlevideo.com",                  "YouTube",          NDPI_PROTOCOL_YOUTUBE, NDPI_PROTOCOL_CATEGORY_MEDIA, NDPI_PROTOCOL_FUN },
   { ".ytimg.com",                        "YouTube",          NDPI_PROTOCOL_YOUTUBE, NDPI_PROTOCOL_CATEGORY_MEDIA, NDPI_PROTOCOL_FUN },
   { "youtube-nocookie.",                 "YouTube",          NDPI_PROTOCOL_YOUTUBE, NDPI_PROTOCOL_CATEGORY_MEDIA, NDPI_PROTOCOL_FUN },
   { ".youtube-ui.l.google.com",          "YouTube",          NDPI_PROTOCOL_YOUTUBE, NDPI_PROTOCOL_CATEGORY_MEDIA, NDPI_PROTOCOL_FUN },
   { ".youtubeeducation.com",             "YouTube",          NDPI_PROTOCOL_YOUTUBE, NDPI_PROTOCOL_CATEGORY_MEDIA, NDPI_PROTOCOL_FUN },

   { ".vevo.com",                                  "Vevo",             NDPI_PROTOCOL_VEVO,    NDPI_PROTOCOL_CATEGORY_MUSIC, NDPI_PROTOCOL_FUN },

   { ".spotify.com",                            "Spotify",          NDPI_PROTOCOL_SPOTIFY, NDPI_PROTOCOL_CATEGORY_MUSIC, NDPI_PROTOCOL_FUN },
   { ".scdn.co",                                "Spotify",          NDPI_PROTOCOL_SPOTIFY, NDPI_PROTOCOL_CATEGORY_MUSIC, NDPI_PROTOCOL_FUN },
   { ".pscdn.co",                               "Spotify",          NDPI_PROTOCOL_SPOTIFY, NDPI_PROTOCOL_CATEGORY_MUSIC, NDPI_PROTOCOL_FUN },
   { "spotifycdn.net",                          "Spotify",          NDPI_PROTOCOL_SPOTIFY, NDPI_PROTOCOL_CATEGORY_MUSIC, NDPI_PROTOCOL_FUN },
   { "spotifycdn.com",                          "Spotify",          NDPI_PROTOCOL_SPOTIFY, NDPI_PROTOCOL_CATEGORY_MUSIC, NDPI_PROTOCOL_FUN },
   { "audio4-ak-spotify-com.akamaized.net",     "Spotify",          NDPI_PROTOCOL_SPOTIFY, NDPI_PROTOCOL_CATEGORY_MUSIC, NDPI_PROTOCOL_FUN },
   { "audio-ak-spotify-com.akamaized.net",      "Spotify",          NDPI_PROTOCOL_SPOTIFY, NDPI_PROTOCOL_CATEGORY_MUSIC, NDPI_PROTOCOL_FUN },
   { "heads-ak-spotify-com.akamaized.net",      "Spotify",          NDPI_PROTOCOL_SPOTIFY, NDPI_PROTOCOL_CATEGORY_MUSIC, NDPI_PROTOCOL_FUN },
   { "spotify-com.akamaized.net",               "Spotify",          NDPI_PROTOCOL_SPOTIFY, NDPI_PROTOCOL_CATEGORY_MUSIC, NDPI_PROTOCOL_FUN },
   { "spotify.com.edgesuite.net",               "Spotify",          NDPI_PROTOCOL_SPOTIFY, NDPI_PROTOCOL_CATEGORY_MUSIC, NDPI_PROTOCOL_FUN },
   { "spotify.map.fastly.net",                  "Spotify",          NDPI_PROTOCOL_SPOTIFY, NDPI_PROTOCOL_CATEGORY_MUSIC, NDPI_PROTOCOL_FUN },
   { "spotify.edgekey.net",                     "Spotify",          NDPI_PROTOCOL_SPOTIFY, NDPI_PROTOCOL_CATEGORY_MUSIC, NDPI_PROTOCOL_FUN },
   { "spotify.demdex.net",                      "Spotify",          NDPI_PROTOCOL_SPOTIFY, NDPI_PROTOCOL_CATEGORY_MUSIC, NDPI_PROTOCOL_FUN },
   { ".spotilocal.com",                         "Spotify",          NDPI_PROTOCOL_SPOTIFY, NDPI_PROTOCOL_CATEGORY_MUSIC, NDPI_PROTOCOL_FUN },


   { "edge-mqtt.facebook.com",        "Messenger",        NDPI_PROTOCOL_MESSENGER, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_ACCEPTABLE },
   { "mqtt-mini.facebook.com",        "Messenger",        NDPI_PROTOCOL_MESSENGER, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_ACCEPTABLE }, /* Messenger Lite */
   { "messenger.com",                 "Messenger",        NDPI_PROTOCOL_MESSENGER, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_ACCEPTABLE },
   { ".m.me",                         "Messenger",        NDPI_PROTOCOL_MESSENGER, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_ACCEPTABLE },

   { ".pandora.com",                            "Pandora",          NDPI_PROTOCOL_PANDORA,  NDPI_PROTOCOL_CATEGORY_STREAMING, NDPI_PROTOCOL_FUN },

   { ".torproject.org",                   "Tor",              NDPI_PROTOCOL_TOR, NDPI_PROTOCOL_CATEGORY_VPN, NDPI_PROTOCOL_POTENTIALLY_DANGEROUS },

   { ".kakao.com",                                "KakaoTalk",        NDPI_PROTOCOL_KAKAOTALK, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_ACCEPTABLE },

   { "ttvnw.net",                       "Twitch",           NDPI_PROTOCOL_TWITCH, NDPI_PROTOCOL_CATEGORY_VIDEO, NDPI_PROTOCOL_FUN },
   { "jtvnw.net",                       "Twitch",           NDPI_PROTOCOL_TWITCH, NDPI_PROTOCOL_CATEGORY_VIDEO, NDPI_PROTOCOL_FUN },
   { "twitch.tv",                       "Twitch",           NDPI_PROTOCOL_TWITCH, NDPI_PROTOCOL_CATEGORY_VIDEO, NDPI_PROTOCOL_FUN },
   { "twitchcdn.net",                   "Twitch",           NDPI_PROTOCOL_TWITCH, NDPI_PROTOCOL_CATEGORY_VIDEO, NDPI_PROTOCOL_FUN },
   { "twitchsvc.net",                   "Twitch",           NDPI_PROTOCOL_TWITCH, NDPI_PROTOCOL_CATEGORY_VIDEO, NDPI_PROTOCOL_FUN },

   { ".qq.com",                                      "QQ",               NDPI_PROTOCOL_QQ, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_FUN },
   { ".gtimg.com",                                "QQ",               NDPI_PROTOCOL_QQ, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_FUN },

   { ".weibo.com",                                "Sina(Weibo)",      NDPI_PROTOCOL_SINA, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { ".weibo.cn",                                           "Sina(Weibo)",      NDPI_PROTOCOL_SINA, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { ".sinaimg.cn",                             "Sina",             NDPI_PROTOCOL_SINA, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { ".sinajs.cn",                               "Sina",             NDPI_PROTOCOL_SINA, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { ".sina.cn",                                   "Sina",             NDPI_PROTOCOL_SINA, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { ".sina.com.cn",                       "Sina",             NDPI_PROTOCOL_SINA, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },

   /* https://support.cipafilter.com/index.php?/Knowledgebase/Article/View/117/0/snapchat---how-to-block */
   { "feelinsonice.appspot.com",                     "Snapchat",     NDPI_PROTOCOL_SNAPCHAT, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "feelinsonice-hrd.appspot.com", "Snapchat",     NDPI_PROTOCOL_SNAPCHAT, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "feelinsonice.com",                          "Snapchat",     NDPI_PROTOCOL_SNAPCHAT, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { ".snapchat.",                                  "Snapchat",     NDPI_PROTOCOL_SNAPCHAT, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { ".snapads.",                                    "Snapchat",     NDPI_PROTOCOL_SNAPCHAT, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { ".sc-cdn.net",                             "Snapchat",     NDPI_PROTOCOL_SNAPCHAT, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { ".sc-prod.net",                           "Snapchat",     NDPI_PROTOCOL_SNAPCHAT, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { ".sc-jpl.com",                             "Snapchat",     NDPI_PROTOCOL_SNAPCHAT, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "sc-analytics.appspot.com",       "Snapchat",     NDPI_PROTOCOL_SNAPCHAT, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },

   { ".waze.com",                                  "Waze",             NDPI_PROTOCOL_WAZE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },
   { "wazespeechactiviation-pa.googleapis.com",    "Waze",             NDPI_PROTOCOL_WAZE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },

   { ".deezer.com",                              "Deezer",           NDPI_PROTOCOL_DEEZER, NDPI_PROTOCOL_CATEGORY_MUSIC, NDPI_PROTOCOL_FUN },

   /* Microsoft + Azure */
   { ".wpc.v0cdn.net",                                        "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { ".gfx.ms",                                               "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { ".aka.ms",                                               "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { ".sfx.ms",                                               "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { ".appcenter.ms",                                         "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { "-msedge.net",                                           "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { ".microsoft.us",                                         "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { ".dynamics.com",                                         "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { "msftncsi.com",                                          "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_CONNECTIVITY_CHECK, NDPI_PROTOCOL_SAFE },
   { ".azure.com",                                            "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { ".windows.net",                                          "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { ".windows.com",                                          "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { ".microsoft.com",                                        "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { "msn.com",                                               "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },
   { ".s-msft.com",                                           "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_SYSTEM_OS, NDPI_PROTOCOL_ACCEPTABLE },
   { ".webtrends.com",                                        "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },
   { ".msecnd.net",                                           "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },
   { "bing.com",                                              "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { ".visualstudio.com",                                     "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_SAFE },
   { "login.live.com",                                        "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_SYSTEM_OS, NDPI_PROTOCOL_SAFE },
   { "statics-marketingsites-wcus-ms-com.akamaized.net",      "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { "statics-marketingsites-eus-ms-com.akamaized.net",       "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { "img-prod-cms-rt-microsoft-com.akamaized.net",           "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { "onecollector.cloudapp.aria.akadns.net",                 "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { "onecollector.akadns.net",                               "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { "microsoft.akadns.net",                                  "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { "e1723.dscd.akamaiedge.net",                             "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { ".microsofttranslator.com",                              "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { "sharepointonline.com",                                  "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { ".msftconnecttest.com",                                  "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_CONNECTIVITY_CHECK, NDPI_PROTOCOL_SAFE },
   { ".windowsmedia.com",                                     "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_SYSTEM_OS, NDPI_PROTOCOL_SAFE },
   { ".windowsphone.com",                                     "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_SYSTEM_OS, NDPI_PROTOCOL_SAFE },
   { ".msa.akadns6.net",                                      "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { ".s-microsoft.com",                                      "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { ".msidentity.com",                                       "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { ".wac.phicdn.net",                                       "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { ".onestore.ms",                                          "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { ".msedge.net",                                           "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { ".mshome.net",                                           "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_SAFE },
   { "..msn-com.",                                            "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { ".-s-msn-com.",                                          "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },
   { ".s-msn.com",                                            "Microsoft",        NDPI_PROTOCOL_MICROSOFT, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_SAFE },

   { "teams.microsoft.com",              "Teams",         NDPI_PROTOCOL_MSTEAMS, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_SAFE },
   { "teams.microsoft.us",               "Teams",         NDPI_PROTOCOL_MSTEAMS, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_SAFE },
   { "teams.skype.com",                  "Teams",         NDPI_PROTOCOL_MSTEAMS, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_SAFE },
   { "-teams.cloudapp.net",              "Teams",         NDPI_PROTOCOL_MSTEAMS, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_SAFE },
   { "teams.trafficmanager.net",         "Teams",         NDPI_PROTOCOL_MSTEAMS, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_SAFE },
   { "teams-msgapi.trafficmanager.net",  "Teams",         NDPI_PROTOCOL_MSTEAMS, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_SAFE },
   { "teams.office.net",                 "Teams",         NDPI_PROTOCOL_MSTEAMS, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_SAFE },
   { "teams.office.com",                 "Teams",         NDPI_PROTOCOL_MSTEAMS, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_SAFE },

   { ".storage.live.com",               "MS_OneDrive",  NDPI_PROTOCOL_MS_ONE_DRIVE,NDPI_PROTOCOL_CATEGORY_CLOUD,  NDPI_PROTOCOL_ACCEPTABLE },
   { "skyapi.live.net",                 "MS_OneDrive",  NDPI_PROTOCOL_MS_ONE_DRIVE, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_ACCEPTABLE },
   { "d.docs.live.net",                 "MS_OneDrive",  NDPI_PROTOCOL_MS_ONE_DRIVE, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_ACCEPTABLE },
   { "onedrive.live.com",               "MS_OneDrive",  NDPI_PROTOCOL_MS_ONE_DRIVE, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_ACCEPTABLE },

   { "update.microsoft.com",            "WindowsUpdate",    NDPI_PROTOCOL_WINDOWS_UPDATE, NDPI_PROTOCOL_CATEGORY_SW_UPDATE, NDPI_PROTOCOL_SAFE },
   { ".windowsupdate.com",              "WindowsUpdate",    NDPI_PROTOCOL_WINDOWS_UPDATE, NDPI_PROTOCOL_CATEGORY_SW_UPDATE, NDPI_PROTOCOL_SAFE },
   { ".ntservicepack.microsoft.com",    "WindowsUpdate",    NDPI_PROTOCOL_WINDOWS_UPDATE, NDPI_PROTOCOL_CATEGORY_SW_UPDATE, NDPI_PROTOCOL_SAFE },
   { ".wustat.windows.com",             "WindowsUpdate",    NDPI_PROTOCOL_WINDOWS_UPDATE, NDPI_PROTOCOL_CATEGORY_SW_UPDATE, NDPI_PROTOCOL_SAFE },

   { "worldofwarcraft.com",                "WorldOfWarcraft",  NDPI_PROTOCOL_WORLDOFWARCRAFT, NDPI_PROTOCOL_CATEGORY_GAME, NDPI_PROTOCOL_FUN },

   { ".anchorfree.",                         "HotspotShield",    NDPI_PROTOCOL_HOTSPOT_SHIELD, NDPI_PROTOCOL_CATEGORY_VPN, NDPI_PROTOCOL_POTENTIALLY_DANGEROUS },
   { "hotspotshield.com",                    "HotspotShield",    NDPI_PROTOCOL_HOTSPOT_SHIELD, NDPI_PROTOCOL_CATEGORY_VPN, NDPI_PROTOCOL_POTENTIALLY_DANGEROUS },
   { ".northghost.com",                      "HotspotShield",    NDPI_PROTOCOL_HOTSPOT_SHIELD, NDPI_PROTOCOL_CATEGORY_VPN, NDPI_PROTOCOL_POTENTIALLY_DANGEROUS },

   { ".webex.com",                           "Webex",            NDPI_PROTOCOL_WEBEX, NDPI_PROTOCOL_CATEGORY_VOIP, NDPI_PROTOCOL_ACCEPTABLE },
   { ".zoom.us",                            "Zoom",             NDPI_PROTOCOL_ZOOM,  NDPI_PROTOCOL_CATEGORY_VIDEO, NDPI_PROTOCOL_ACCEPTABLE },

   { ".ocsdomain.com",                        "OCS",              NDPI_PROTOCOL_OCS, NDPI_PROTOCOL_CATEGORY_MEDIA, NDPI_PROTOCOL_FUN },
   { "ocs.fr",                                         "OCS",              NDPI_PROTOCOL_OCS, NDPI_PROTOCOL_CATEGORY_MEDIA, NDPI_PROTOCOL_FUN },
   { ".ocs.fr",                                             "OCS",              NDPI_PROTOCOL_OCS, NDPI_PROTOCOL_CATEGORY_MEDIA, NDPI_PROTOCOL_FUN },
   { ".labgency.ws",                             "OCS",              NDPI_PROTOCOL_OCS, NDPI_PROTOCOL_CATEGORY_MEDIA, NDPI_PROTOCOL_FUN },

   { ".iflix.com",                                "IFLIX",            NDPI_PROTOCOL_IFLIX, NDPI_PROTOCOL_CATEGORY_VIDEO, NDPI_PROTOCOL_FUN },
   { ".app.iflixcorp.com",              "IFLIX",            NDPI_PROTOCOL_IFLIX, NDPI_PROTOCOL_CATEGORY_VIDEO, NDPI_PROTOCOL_FUN },
   { ".images.iflixassets.com",    "IFLIX",            NDPI_PROTOCOL_IFLIX, NDPI_PROTOCOL_CATEGORY_VIDEO, NDPI_PROTOCOL_FUN },

   { "crl.microsoft.com",                       "Microsoft365",    NDPI_PROTOCOL_MICROSOFT_365, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { "evsecure-ocsp.verisign.com",              "Microsoft365",    NDPI_PROTOCOL_MICROSOFT_365, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { "evsecure-aia.verisign.com",               "Microsoft365",    NDPI_PROTOCOL_MICROSOFT_365, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { "evsecure-crl.verisign.com",               "Microsoft365",    NDPI_PROTOCOL_MICROSOFT_365, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { ".omniroot.com",                           "Microsoft365",    NDPI_PROTOCOL_MICROSOFT_365, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { ".microsoftonline.com",                    "Microsoft365",    NDPI_PROTOCOL_MICROSOFT_365, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { ".microsoftonline.us",                     "Microsoft365",    NDPI_PROTOCOL_MICROSOFT_365, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { ".office365.com",                          "Microsoft365",    NDPI_PROTOCOL_MICROSOFT_365, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { ".office.com",                             "Microsoft365",    NDPI_PROTOCOL_MICROSOFT_365, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { "office.net",                              "Microsoft365",    NDPI_PROTOCOL_MICROSOFT_365, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { ".msocsp.com",                             "Microsoft365",    NDPI_PROTOCOL_MICROSOFT_365, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { ".msocdn.com",                             "Microsoft365",    NDPI_PROTOCOL_MICROSOFT_365, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { "officeapps.live.com",                     "Microsoft365",    NDPI_PROTOCOL_MICROSOFT_365, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { "outlook.live.com",                        "Microsoft365",    NDPI_PROTOCOL_MICROSOFT_365, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { "office.live.com",                         "Microsoft365",    NDPI_PROTOCOL_MICROSOFT_365, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { ".onenote.",                               "Microsoft365",    NDPI_PROTOCOL_MICROSOFT_365, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },

   /* http://www.urlquery.net/report.php?id=1453233646161 */
   { "lifedom.top",                                "Cloudflare",       NDPI_PROTOCOL_CLOUDFLARE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },
   { "coby.ns.cloudflare.com",      "Cloudflare",       NDPI_PROTOCOL_CLOUDFLARE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },
   { "amanda.ns.cloudflare.com",  "Cloudflare",       NDPI_PROTOCOL_CLOUDFLARE, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },

   { "d295hzzivaok4k.cloudfront.net","OpenDNS",      NDPI_PROTOCOL_OPENDNS, NDPI_PROTOCOL_CATEGORY_WEB, NDPI_PROTOCOL_ACCEPTABLE },
   { ".opendns.com",                                  "OpenDNS",      NDPI_PROTOCOL_OPENDNS, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },

   /* https://get.slack.help/hc/en-us/articles/205138367-Troubleshooting-Slack-connection-issues */
   { "slack.com",                                    "Slack",            NDPI_PROTOCOL_SLACK, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { ".slack-msgs.com",                      "Slack",            NDPI_PROTOCOL_SLACK, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { "slack-files.com",                        "Slack",            NDPI_PROTOCOL_SLACK, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { "slack-imgs.com",                          "Slack",            NDPI_PROTOCOL_SLACK, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { ".slack-edge.com",                      "Slack",            NDPI_PROTOCOL_SLACK, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { ".slack-core.com",                      "Slack",            NDPI_PROTOCOL_SLACK, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { "slack-redir.net",                        "Slack",            NDPI_PROTOCOL_SLACK, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   /* Detected "slack-assets2.s3-us-west-2.amazonaws.com.". Omitted "*amazonaws.com" CDN */
   { "slack-assets2.s3-",                  "Slack",            NDPI_PROTOCOL_SLACK, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },

   { "github.com",                                  "Github",           NDPI_PROTOCOL_GITHUB, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { ".github.com",                              "Github",           NDPI_PROTOCOL_GITHUB, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { "github.io",                                           "Github",           NDPI_PROTOCOL_GITHUB, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { ".github.io",                                          "Github",           NDPI_PROTOCOL_GITHUB, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { "githubusercontent.com",            "Github",           NDPI_PROTOCOL_GITHUB, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { ".githubusercontent.com",        "Github",           NDPI_PROTOCOL_GITHUB, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },

   { ".steampowered.com",                        "Steam",        NDPI_PROTOCOL_STEAM, NDPI_PROTOCOL_CATEGORY_GAME, NDPI_PROTOCOL_FUN },
   { "steamcommunity.com",                        "Steam",        NDPI_PROTOCOL_STEAM, NDPI_PROTOCOL_CATEGORY_GAME, NDPI_PROTOCOL_FUN },
   { ".steamcontent.com",                        "Steam",        NDPI_PROTOCOL_STEAM, NDPI_PROTOCOL_CATEGORY_GAME, NDPI_PROTOCOL_FUN },
   { ".steamstatic.com",                          "Steam",        NDPI_PROTOCOL_STEAM, NDPI_PROTOCOL_CATEGORY_GAME, NDPI_PROTOCOL_FUN },
   { "steamcommunity-a.akamaihd.net",             "Steam",        NDPI_PROTOCOL_STEAM, NDPI_PROTOCOL_CATEGORY_GAME, NDPI_PROTOCOL_FUN },

   { ".wechat.com",                            "WeChat",           NDPI_PROTOCOL_WECHAT, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_FUN },
   { ".wechat.org",                            "WeChat",           NDPI_PROTOCOL_WECHAT, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_FUN },
   { ".wechatapp.com",                        "WeChat",           NDPI_PROTOCOL_WECHAT, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_FUN },
   { ".we.chat",                                  "WeChat",           NDPI_PROTOCOL_WECHAT, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_FUN },
   { ".wx.",                                          "WeChat",           NDPI_PROTOCOL_WECHAT, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_FUN },
//   { ".weixin.",                                  "WeChat",           NDPI_PROTOCOL_WECHAT, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_FUN },
   { ".mmsns.qpic.cn",                     "WeChat",           NDPI_PROTOCOL_WECHAT, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_FUN },

   { "dnscrypt.org",                           "DNScrypt",         NDPI_PROTOCOL_DNSCRYPT, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },

   { "torrent.",                                   "BitTorrent",       NDPI_PROTOCOL_BITTORRENT, NDPI_PROTOCOL_CATEGORY_DOWNLOAD_FT, NDPI_PROTOCOL_UNSAFE },
   { "torrents.",                                 "BitTorrent",       NDPI_PROTOCOL_BITTORRENT, NDPI_PROTOCOL_CATEGORY_DOWNLOAD_FT, NDPI_PROTOCOL_UNSAFE },
   { "torrentz.",                                 "BitTorrent",       NDPI_PROTOCOL_BITTORRENT, NDPI_PROTOCOL_CATEGORY_DOWNLOAD_FT, NDPI_PROTOCOL_UNSAFE },

   { ".nintendo.net",                          "Nintendo",         NDPI_PROTOCOL_NINTENDO, NDPI_PROTOCOL_CATEGORY_GAME, NDPI_PROTOCOL_FUN },
   { ".nintendo.com",                                       "Nintendo",         NDPI_PROTOCOL_NINTENDO, NDPI_PROTOCOL_CATEGORY_GAME, NDPI_PROTOCOL_FUN },

   { ".playstation.net",                          "Playstation",  NDPI_PROTOCOL_PLAYSTATION, NDPI_PROTOCOL_CATEGORY_GAME, NDPI_PROTOCOL_FUN },
   { ".playstation.com",                                          "Playstation",  NDPI_PROTOCOL_PLAYSTATION, NDPI_PROTOCOL_CATEGORY_GAME, NDPI_PROTOCOL_FUN },
   { ".sonyentertainmentnetwork.com",            "Playstation",  NDPI_PROTOCOL_PLAYSTATION, NDPI_PROTOCOL_CATEGORY_GAME, NDPI_PROTOCOL_FUN },

   { ".linkedin.com",                          "LinkedIn",         NDPI_PROTOCOL_LINKEDIN, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { ".licdn.com",                                "LinkedIn",         NDPI_PROTOCOL_LINKEDIN, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },

   { ".sndcdn.com",                              "SoundCloud",       NDPI_PROTOCOL_SOUNDCLOUD, NDPI_PROTOCOL_CATEGORY_MUSIC, NDPI_PROTOCOL_FUN },
   { ".soundcloud.com",                      "SoundCloud",       NDPI_PROTOCOL_SOUNDCLOUD, NDPI_PROTOCOL_CATEGORY_MUSIC, NDPI_PROTOCOL_FUN },
   { "getrockerbox.com",                      "SoundCloud",       NDPI_PROTOCOL_SOUNDCLOUD, NDPI_PROTOCOL_CATEGORY_MUSIC, NDPI_PROTOCOL_FUN },

   { "web.telegram.org",                    "Telegram",         NDPI_PROTOCOL_TELEGRAM, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_ACCEPTABLE },
   { "tdesktop.com",                              "Telegram",         NDPI_PROTOCOL_TELEGRAM, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_ACCEPTABLE },
   { "tupdate.com",                                "Telegram",         NDPI_PROTOCOL_TELEGRAM, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_ACCEPTABLE },

   { ".pastebin.com",                          "Pastebin",         NDPI_PROTOCOL_PASTEBIN, NDPI_PROTOCOL_CATEGORY_DOWNLOAD_FT, NDPI_PROTOCOL_POTENTIALLY_DANGEROUS },
   { "pastebin.com",                             "Pastebin",         NDPI_PROTOCOL_PASTEBIN, NDPI_PROTOCOL_CATEGORY_DOWNLOAD_FT, NDPI_PROTOCOL_POTENTIALLY_DANGEROUS },

   { ".ppstream.com",                          "PPStream",         NDPI_PROTOCOL_PPSTREAM, NDPI_PROTOCOL_CATEGORY_STREAMING, NDPI_PROTOCOL_FUN },
   { ".pps.tv",                                   "PPStream",         NDPI_PROTOCOL_PPSTREAM, NDPI_PROTOCOL_CATEGORY_STREAMING, NDPI_PROTOCOL_FUN },

   { ".hulustream.com",                                 "Hulu",            NDPI_PROTOCOL_HULU, NDPI_PROTOCOL_CATEGORY_STREAMING, NDPI_PROTOCOL_FUN },
   { ".hulu.com",                                       "Hulu",            NDPI_PROTOCOL_HULU, NDPI_PROTOCOL_CATEGORY_STREAMING, NDPI_PROTOCOL_FUN },
   { "assetshuluimcom-a.akamaihd.net",                  "Hulu",            NDPI_PROTOCOL_HULU, NDPI_PROTOCOL_CATEGORY_STREAMING, NDPI_PROTOCOL_FUN },
   { "ibhuluimcom-a.akamaihd.net",                      "Hulu",            NDPI_PROTOCOL_HULU, NDPI_PROTOCOL_CATEGORY_STREAMING, NDPI_PROTOCOL_FUN },
   { ".huluad.com",                                     "Hulu",            NDPI_PROTOCOL_HULU, NDPI_PROTOCOL_CATEGORY_STREAMING, NDPI_PROTOCOL_FUN },
   { ".huluim.com",                                     "Hulu",            NDPI_PROTOCOL_HULU, NDPI_PROTOCOL_CATEGORY_STREAMING, NDPI_PROTOCOL_FUN },

   /*
     VidTO streaming service
   */
   { ".vidto.me",                                 "VidTO",            NDPI_PROTOCOL_PPSTREAM, NDPI_PROTOCOL_CATEGORY_STREAMING, NDPI_PROTOCOL_FUN },
   { ".vidto.se",                                           "VidTO",            NDPI_PROTOCOL_PPSTREAM, NDPI_PROTOCOL_CATEGORY_STREAMING, NDPI_PROTOCOL_FUN },

   { "snapcraft.io",                        "UbuntuONE",        NDPI_PROTOCOL_UBUNTUONE, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_ACCEPTABLE },
   { "ubuntu.com",                            "UbuntuONE",        NDPI_PROTOCOL_UBUNTUONE, NDPI_PROTOCOL_CATEGORY_CLOUD, NDPI_PROTOCOL_ACCEPTABLE },

   { "signal.org",                            "Signal",           NDPI_PROTOCOL_SIGNAL, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_ACCEPTABLE },
   { "whispersystems.org",            "Signal",           NDPI_PROTOCOL_SIGNAL, NDPI_PROTOCOL_CATEGORY_CHAT, NDPI_PROTOCOL_ACCEPTABLE },

   { "musical.ly",                            "TikTok",           NDPI_PROTOCOL_TIKTOK, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "byteoversea.com",                       "TikTok",           NDPI_PROTOCOL_TIKTOK, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "p16-tiktok-sign-va-h2.ibyteimg.com",    "TikTok",           NDPI_PROTOCOL_TIKTOK, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "p16-tiktok-sg.ibyteimg.com",            "TikTok",           NDPI_PROTOCOL_TIKTOK, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "p16-tiktok-va.ibyteimg.com",            "TikTok",           NDPI_PROTOCOL_TIKTOK, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "p16-va-tiktok.ibyteimg.com",            "TikTok",           NDPI_PROTOCOL_TIKTOK, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "tiktokcdn.com",                         "TikTok",           NDPI_PROTOCOL_TIKTOK, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "p16-tiktok-va-h2.ibyteimg.com",         "TikTok",           NDPI_PROTOCOL_TIKTOK, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "p16-tiktokcdn-com.akamaized.net",       "TikTok",           NDPI_PROTOCOL_TIKTOK, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "tiktokcdn.liveplay.myqcloud.com",       "TikTok",           NDPI_PROTOCOL_TIKTOK, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "musemuse.cn",                           "TikTok",           NDPI_PROTOCOL_TIKTOK, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "tiktokv.com",                           "TikTok",           NDPI_PROTOCOL_TIKTOK, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "bytecdn.cn",                            "TikTok",           NDPI_PROTOCOL_TIKTOK, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "muscdn.com",                            "TikTok",           NDPI_PROTOCOL_TIKTOK, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "tiktok.com",                            "TikTok",           NDPI_PROTOCOL_TIKTOK, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "byted.org",                             "TikTok",           NDPI_PROTOCOL_TIKTOK, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },

   { "brasilbandalarga.com.br",     "EAQ",              NDPI_PROTOCOL_EAQ, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },
   { ".eaqbr.com.br",                       "EAQ",              NDPI_PROTOCOL_EAQ, NDPI_PROTOCOL_CATEGORY_NETWORK, NDPI_PROTOCOL_ACCEPTABLE },

   { ".net.anydesk.com",              "AnyDesk",        NDPI_PROTOCOL_ANYDESK, NDPI_PROTOCOL_CATEGORY_REMOTE_ACCESS, NDPI_PROTOCOL_ACCEPTABLE },

   { "discordapp.com",               "Discord",        NDPI_PROTOCOL_DISCORD, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { "discordapp.net",               "Discord",        NDPI_PROTOCOL_DISCORD, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { "discord.com",                  "Discord",        NDPI_PROTOCOL_DISCORD, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { "discord.gg",                   "Discord",        NDPI_PROTOCOL_DISCORD, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },
   { "discord.media",                "Discord",        NDPI_PROTOCOL_DISCORD, NDPI_PROTOCOL_CATEGORY_COLLABORATIVE, NDPI_PROTOCOL_ACCEPTABLE },

   /*
     Amazon Alexa services
   */
   { "alexa.amazon.com",             "AmazonAlexa",        NDPI_PROTOCOL_AMAZON_ALEXA, NDPI_PROTOCOL_CATEGORY_VIRTUAL_ASSISTANT, NDPI_PROTOCOL_ACCEPTABLE },
   { "amazonalexa.com",              "AmazonAlexa",        NDPI_PROTOCOL_AMAZON_ALEXA, NDPI_PROTOCOL_CATEGORY_VIRTUAL_ASSISTANT, NDPI_PROTOCOL_ACCEPTABLE },
   { "avs-alexa-1-na.amazon.com",    "AmazonAlexa",        NDPI_PROTOCOL_AMAZON_ALEXA, NDPI_PROTOCOL_CATEGORY_VIRTUAL_ASSISTANT, NDPI_PROTOCOL_ACCEPTABLE },
   { "avs-alexa-2-na.amazon.com",    "AmazonAlexa",        NDPI_PROTOCOL_AMAZON_ALEXA, NDPI_PROTOCOL_CATEGORY_VIRTUAL_ASSISTANT, NDPI_PROTOCOL_ACCEPTABLE },
   { "avs-alexa-3-na.amazon.com",    "AmazonAlexa",        NDPI_PROTOCOL_AMAZON_ALEXA, NDPI_PROTOCOL_CATEGORY_VIRTUAL_ASSISTANT, NDPI_PROTOCOL_ACCEPTABLE },
   { "avs-alexa-4-na.amazon.com",    "AmazonAlexa",        NDPI_PROTOCOL_AMAZON_ALEXA, NDPI_PROTOCOL_CATEGORY_VIRTUAL_ASSISTANT, NDPI_PROTOCOL_ACCEPTABLE },
   { "avs-alexa-5-na.amazon.com",    "AmazonAlexa",        NDPI_PROTOCOL_AMAZON_ALEXA, NDPI_PROTOCOL_CATEGORY_VIRTUAL_ASSISTANT, NDPI_PROTOCOL_ACCEPTABLE },
   { "avs-alexa-6-na.amazon.com",    "AmazonAlexa",        NDPI_PROTOCOL_AMAZON_ALEXA, NDPI_PROTOCOL_CATEGORY_VIRTUAL_ASSISTANT, NDPI_PROTOCOL_ACCEPTABLE },
   { "avs-alexa-7-na.amazon.com",    "AmazonAlexa",        NDPI_PROTOCOL_AMAZON_ALEXA, NDPI_PROTOCOL_CATEGORY_VIRTUAL_ASSISTANT, NDPI_PROTOCOL_ACCEPTABLE },
   { "avs-alexa-8-na.amazon.com",    "AmazonAlexa",        NDPI_PROTOCOL_AMAZON_ALEXA, NDPI_PROTOCOL_CATEGORY_VIRTUAL_ASSISTANT, NDPI_PROTOCOL_ACCEPTABLE },
   { "avs-alexa-9-na.amazon.com",    "AmazonAlexa",        NDPI_PROTOCOL_AMAZON_ALEXA, NDPI_PROTOCOL_CATEGORY_VIRTUAL_ASSISTANT, NDPI_PROTOCOL_ACCEPTABLE },
   { "avs-alexa-10-na.amazon.com",   "AmazonAlexa",        NDPI_PROTOCOL_AMAZON_ALEXA, NDPI_PROTOCOL_CATEGORY_VIRTUAL_ASSISTANT, NDPI_PROTOCOL_ACCEPTABLE },
   { "avs-alexa-11-na.amazon.com",   "AmazonAlexa",        NDPI_PROTOCOL_AMAZON_ALEXA, NDPI_PROTOCOL_CATEGORY_VIRTUAL_ASSISTANT, NDPI_PROTOCOL_ACCEPTABLE },
   { "avs-alexa-12-na.amazon.com",   "AmazonAlexa",        NDPI_PROTOCOL_AMAZON_ALEXA, NDPI_PROTOCOL_CATEGORY_VIRTUAL_ASSISTANT, NDPI_PROTOCOL_ACCEPTABLE },
   { "avs-alexa-13-na.amazon.com",   "AmazonAlexa",        NDPI_PROTOCOL_AMAZON_ALEXA, NDPI_PROTOCOL_CATEGORY_VIRTUAL_ASSISTANT, NDPI_PROTOCOL_ACCEPTABLE },
   { "avs-alexa-14-na.amazon.com",   "AmazonAlexa",        NDPI_PROTOCOL_AMAZON_ALEXA, NDPI_PROTOCOL_CATEGORY_VIRTUAL_ASSISTANT, NDPI_PROTOCOL_ACCEPTABLE },
   { "avs-alexa-15-na.amazon.com",   "AmazonAlexa",        NDPI_PROTOCOL_AMAZON_ALEXA, NDPI_PROTOCOL_CATEGORY_VIRTUAL_ASSISTANT, NDPI_PROTOCOL_ACCEPTABLE },
   { "avs-alexa-16-na.amazon.com",   "AmazonAlexa",        NDPI_PROTOCOL_AMAZON_ALEXA, NDPI_PROTOCOL_CATEGORY_VIRTUAL_ASSISTANT, NDPI_PROTOCOL_ACCEPTABLE },
   { "avs-alexa-17-na.amazon.com",   "AmazonAlexa",        NDPI_PROTOCOL_AMAZON_ALEXA, NDPI_PROTOCOL_CATEGORY_VIRTUAL_ASSISTANT, NDPI_PROTOCOL_ACCEPTABLE },
   { "avs-alexa-18-na.amazon.com",   "AmazonAlexa",        NDPI_PROTOCOL_AMAZON_ALEXA, NDPI_PROTOCOL_CATEGORY_VIRTUAL_ASSISTANT, NDPI_PROTOCOL_ACCEPTABLE },
   { "avs-alexa-19-na.amazon.com",   "AmazonAlexa",        NDPI_PROTOCOL_AMAZON_ALEXA, NDPI_PROTOCOL_CATEGORY_VIRTUAL_ASSISTANT, NDPI_PROTOCOL_ACCEPTABLE },

   /*
     Tumblr social network service
   */
   { "tumblr.com",                   "Tumblr",        NDPI_PROTOCOL_TUMBLR, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },

   /*
     Reddit social network service
   */
   { ".redd.it",                   "Reddit",        NDPI_PROTOCOL_REDDIT, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { ".reddit.com",                "Reddit",        NDPI_PROTOCOL_REDDIT, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { ".redditmedia.com",           "Reddit",        NDPI_PROTOCOL_REDDIT, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { ".redditstatic.com",          "Reddit",        NDPI_PROTOCOL_REDDIT, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { ".reddit.map.fastly.net",          "Reddit",        NDPI_PROTOCOL_REDDIT, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },

   /*
     Pinterest social network service
   */
   { ".pinimg.com",                      "Pinterest",      NDPI_PROTOCOL_PINTEREST, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "pinterest.global.map.fastly.net",  "Pinterest",      NDPI_PROTOCOL_PINTEREST, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "pinterest.map.fastly.net",         "Pinterest",      NDPI_PROTOCOL_PINTEREST, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "pinterest.",                     "Pinterest",        NDPI_PROTOCOL_PINTEREST, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   { "pinterest.co.",                  "Pinterest",        NDPI_PROTOCOL_PINTEREST, NDPI_PROTOCOL_CATEGORY_SOCIAL_NETWORK, NDPI_PROTOCOL_FUN },
   
   /*
     Disney's DisneyPlus streaming service
   */
   { "dssott.com.akamaized.net",               "DisneyPlus",        NDPI_PROTOCOL_DISNEYPLUS, NDPI_PROTOCOL_CATEGORY_STREAMING, NDPI_PROTOCOL_FUN },
   { "disney-plus.com",                        "DisneyPlus",        NDPI_PROTOCOL_DISNEYPLUS, NDPI_PROTOCOL_CATEGORY_STREAMING, NDPI_PROTOCOL_FUN },
   { "disneyplus.com",                         "DisneyPlus",        NDPI_PROTOCOL_DISNEYPLUS, NDPI_PROTOCOL_CATEGORY_STREAMING, NDPI_PROTOCOL_FUN },
   { "disneyplus.net",                         "DisneyPlus",        NDPI_PROTOCOL_DISNEYPLUS, NDPI_PROTOCOL_CATEGORY_STREAMING, NDPI_PROTOCOL_FUN },
   { "dssott.com",                             "DisneyPlus",        NDPI_PROTOCOL_DISNEYPLUS, NDPI_PROTOCOL_CATEGORY_STREAMING, NDPI_PROTOCOL_FUN },
   { "disneyplus.com.ssl.sc.omtrdc.net",       "DisneyPlus",        NDPI_PROTOCOL_DISNEYPLUS, NDPI_PROTOCOL_CATEGORY_STREAMING, NDPI_PROTOCOL_FUN },
   { "search-api-disney.bamgrid.com",          "DisneyPlus",        NDPI_PROTOCOL_DISNEYPLUS, NDPI_PROTOCOL_CATEGORY_STREAMING, NDPI_PROTOCOL_FUN },

   { NULL, NULL, NDPI_PROTOCOL_UNKNOWN, NDPI_PROTOCOL_CATEGORY_UNSPECIFIED, NDPI_PROTOCOL_SAFE }
  };

/* ******************************************************************** */

static ndpi_tls_cert_name_match tls_certificate_match [] = {
  { "CN=AnyDesk Client",               NDPI_PROTOCOL_ANYDESK   },
  { "O=Kakao",                         NDPI_PROTOCOL_KAKAOTALK },
  { "O=ntop.org",                      NDPI_PROTOCOL_NTOP      },
  { "CN=simplednscrypt.org",           NDPI_PROTOCOL_DNSCRYPT  },
  { "CN=*.gateway.messenger.live.com", NDPI_PROTOCOL_SKYPE     },

  { NULL, 0 }
};

/* ******************************************************************** */

/*
   IMPORTANT

   Do NOT pur here strings that overlap with string in host_match[]
   specified above
*/
#ifndef __KERNEL__

static ndpi_category_match category_match[] = {
   { ".edgecastcdn.net",                 NDPI_PROTOCOL_CATEGORY_MEDIA },
   { ".hwcdn.net",                       NDPI_PROTOCOL_CATEGORY_MEDIA },
   { ".llnwd.net",                       NDPI_PROTOCOL_CATEGORY_MEDIA },
   { ".llns.net",                        NDPI_PROTOCOL_CATEGORY_MEDIA },
   { ".fastly.net",                      NDPI_PROTOCOL_CATEGORY_MEDIA },
   { ".vultr.com",                       NDPI_PROTOCOL_CATEGORY_CLOUD },
   { "baidu.com",                        NDPI_PROTOCOL_CATEGORY_WEB },
   { "icq.com",                          NDPI_PROTOCOL_CATEGORY_CHAT },
   { "quickplay.com",                    NDPI_PROTOCOL_CATEGORY_STREAMING },
   { ".iqiyi.com",                       NDPI_PROTOCOL_CATEGORY_STREAMING },
   { ".qiyi.com",                        NDPI_PROTOCOL_CATEGORY_STREAMING },
   { ".71.am",                           NDPI_PROTOCOL_CATEGORY_STREAMING },
   { ".qiyipic.com",                     NDPI_PROTOCOL_CATEGORY_STREAMING },
   { ".1kxun.",                          NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "tcad.wedolook.com",                NDPI_PROTOCOL_CATEGORY_STREAMING },
   { ".rapidvideo.com",                  NDPI_PROTOCOL_CATEGORY_STREAMING },
   { ".playercdn.net",                   NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "showmax.com",                      NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "showmax.akamaized.net",            NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "skyq.sky.com",                     NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "iptv.sky.",                        NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "pcdn.skycdn.",                     NDPI_PROTOCOL_CATEGORY_STREAMING },

   /* https://success.tanaza.com/s/article/How-Automatic-Detection-of-Captive-Portal-works */
   { "captive.apple.com",                NDPI_PROTOCOL_CATEGORY_CONNECTIVITY_CHECK },
   { "captive.apple.com.",               NDPI_PROTOCOL_CATEGORY_CONNECTIVITY_CHECK }, /* apple.com.edgekey.net */
   { "thinkdifferent.us",                NDPI_PROTOCOL_CATEGORY_CONNECTIVITY_CHECK },
   { "airport.us",                       NDPI_PROTOCOL_CATEGORY_CONNECTIVITY_CHECK },
   { "gsp1.apple.com",                   NDPI_PROTOCOL_CATEGORY_CONNECTIVITY_CHECK },
   { "testconnectivity.microsoft.com",   NDPI_PROTOCOL_CATEGORY_CONNECTIVITY_CHECK },
   { "teredo.ipv6.microsoft.com",        NDPI_PROTOCOL_CATEGORY_CONNECTIVITY_CHECK },
   { "teredo.ipv6.microsoft.com.nsatc.net",   NDPI_PROTOCOL_CATEGORY_CONNECTIVITY_CHECK },
   { "detectportal.firefox.com",         NDPI_PROTOCOL_CATEGORY_CONNECTIVITY_CHECK },
   { "connectivitycheck.android.com",    NDPI_PROTOCOL_CATEGORY_CONNECTIVITY_CHECK },
   { "connectivitycheck.gstatic.com",    NDPI_PROTOCOL_CATEGORY_CONNECTIVITY_CHECK },

   /* Hulu Streaming services AS23286 */
   { "8.28.124.0/24",                   NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "8.28.125.0/24",                   NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "199.200.50.0/23",                 NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "199.200.51.0/24",                 NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "199.60.116.0/24",                 NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "208.91.158.0/23",                 NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "209.249.186.0/24",                NDPI_PROTOCOL_CATEGORY_STREAMING },

   /* Disney Streaming services AS11251 */
   { "8.4.4.0/24",                      NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "8.5.5.0/24",                      NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "8.33.30.0/24",                    NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "63.116.222.0/24",                 NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "63.116.223.0/24",                 NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "139.104.192.0/24",                NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "139.104.193.0/24",                NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "139.104.200.0/24",                NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "139.104.201.0/24",                NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "139.104.202.0/24",                NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "139.104.203.0/24",                NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "139.104.204.0/24",                NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "139.104.205.0/24",                NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "139.104.206.0/24",                NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "139.104.207.0/24",                NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "139.104.208.0/24",                NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "139.104.209.0/24",                NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "139.104.212.0/24",                NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "139.104.216.0/24",                NDPI_PROTOCOL_CATEGORY_STREAMING },
   { "139.104.217.0/24",                NDPI_PROTOCOL_CATEGORY_STREAMING },

   { NULL, 0 }
};
#endif
/* ******************************************************************** */

/*
  Tor
  The tor protocol uses SSL to contact peers so it could be exchanged with
  standard SSL. However the host names such as

  - www.fgd2iwya7vinfutj5wq5we.com
  - www.qbtxzhetq4s2f.com
  - www.fgd2iwya7vinfutj5wq5we.net

  See also DGA (Domain Generation Algorithm)

  In essence www.<name>.com|net

  To do things properly we should check if host name in the certificate
  exists or if the IP address of the SSL peer resolves to a name. Unfortunately
  for performance reasons we can't afford to do a DNS lookup in nDPI (however apps
  can do it if possible) and thus we have created a heuristic algorithm that tries
  to check the host name (in the SSL certificate) to see if it looks like a
  random name or a real name. We cannot use a dictionary (how can the kernel read a file?)
  and this we use bigrams distribution to decide if the string looks like a
  word or just random chars.

  http://www3.nd.edu/~busiforc/handouts/cryptography/Letter%20Frequencies.html

  DGA Datasets
  - https://data.netlab.360.com/dga/
  - https://github.com/baderj/domain_generation_algorithms
*/

static const char *ndpi_en_bigrams[] = {
  "aa", "ba", "ca", "da", "ea", "fa", "ga", "ha", "ia", "ja", "ka", "la", "ma", "na", "oa", "pa", "qa",
  "ra", "sa", "ta", "ua", "va", "wa", "xa", "ya", "za", "ab", "bb", "db", "eb", "fb", "gb", "hb", "ib",
  "kb", "lb", "mb", "nb", "ob", "pb", "rb", "sb", "tb", "ub", "wb", "yb", "ac", "bc", "cc", "dc", "ec",
  "fc", "gc", "hc", "ic", "kc", "lc", "mc", "nc", "oc", "pc", "rc", "sc", "tc", "uc", "wc", "xc", "yc",
  "ad", "bd", "cd", "dd", "ed", "fd", "gd", "hd", "id", "kd", "ld", "md", "nd", "od", "pd", "rd", "sd",
  "td", "ud", "wd", "xd", "yd", "zd", "ae", "be", "ce", "de", "ee", "fe", "ge", "he", "ie", "je", "ke",
  "le", "me", "ne", "oe", "pe", "re", "se", "te", "ue", "ve", "we", "xe", "ye", "ze", "af", "bf", "df",
  "ef", "ff", "gf", "hf", "if", "kf", "lf", "mf", "nf", "of", "pf", "rf", "sf", "tf", "uf", "wf", "xf",
  "yf", "zf", "ag", "bg", "dg", "eg", "fg", "gg", "hg", "ig", "kg", "lg", "ng", "og", "pg", "rg", "sg",
  "tg", "ug", "wg", "yg", "ah", "bh", "ch", "dh", "eh", "fh", "gh", "hh", "ih", "kh", "lh", "mh", "nh",
  "oh", "ph", "rh", "sh", "th", "uh", "wh", "xh", "yh", "ai", "bi", "ci", "di", "ei", "fi", "gi", "hi",
  "ii", "ji", "ki", "li", "mi", "ni", "oi", "pi", "qi", "ri", "si", "ti", "ui", "vi", "wi", "xi", "yi",
  "zi", "aj", "bj", "dj", "ej", "fj", "gj", "hj", "ij", "jj", "kj", "lj", "nj", "oj", "pj", "rj", "sj",
  "tj", "uj", "wj", "yj", "ak", "ck", "dk", "ek", "gk", "ik", "kk", "lk", "mk", "nk", "ok", "pk", "rk",
  "sk", "tk", "uk", "wk", "yk", "zk", "al", "bl", "cl", "dl", "el", "fl", "gl", "hl", "il", "kl", "ll",
  "ml", "nl", "ol", "pl", "rl", "sl", "tl", "ul", "vl", "wl", "xl", "yl", "zl", "am", "bm", "cm", "dm",
  "em", "fm", "gm", "hm", "im", "km", "lm", "mm", "nm", "om", "pm", "rm", "sm", "tm", "um", "wm", "xm",
  "ym", "zm", "an", "bn", "cn", "dn", "en", "fn", "gn", "hn", "in", "kn", "ln", "mn", "nn", "on", "pn",
  "rn", "sn", "tn", "un", "wn", "xn", "yn", "ao", "bo", "co", "do", "eo", "fo", "go", "ho", "io", "jo",
  "ko", "lo", "mo", "no", "oo", "po", "ro", "so", "to", "uo", "vo", "wo", "xo", "yo", "zo", "ap", "bp",
  "dp", "ep", "fp", "gp", "hp", "ip", "kp", "lp", "mp", "np", "op", "pp", "rp", "sp", "tp", "up", "wp",
  "xp", "yp", "zp", "aq", "cq", "dq", "eq", "hq", "iq", "nq", "oq", "qq", "rq", "sq", "uq", "xq", "ar",
  "br", "cr", "dr", "er", "fr", "gr", "hr", "ir", "kr", "lr", "mr", "nr", "or", "pr", "rr", "sr", "tr",
  "ur", "vr", "wr", "xr", "yr", "as", "bs", "cs", "ds", "es", "fs", "gs", "hs", "is", "ks", "ls", "ms",
  "ns", "os", "ps", "rs", "ss", "ts", "us", "vs", "ws", "xs", "ys", "at", "bt", "ct", "dt", "et", "ft",
  "gt", "ht", "it", "kt", "lt", "mt", "nt", "ot", "pt", "rt", "st", "tt", "ut", "wt", "xt", "yt", "zt",
  "au", "bu", "cu", "du", "eu", "fu", "gu", "hu", "iu", "ju", "ku", "lu", "mu", "nu", "ou", "pu", "qu",
  "ru", "su", "tu", "uu", "vu", "wu", "xu", "yu", "zu", "av", "bv", "dv", "ev", "iv", "lv", "mv", "nv",
  "ov", "rv", "sv", "tv", "uv", "vv", "zv", "aw", "bw", "dw", "ew", "fw", "gw", "hw", "iw", "kw", "lw",
  "mw", "nw", "ow", "pw", "rw", "sw", "tw", "uw", "ww", "xw", "yw", "zw", "ax", "ex", "ix", "nx", "ox",
  "rx", "ux", /* "xx", */ "yx", "ay", "by", "cy", "dy", "ey", "fy", "gy", "hy", "ky", "ly", "my", "ny", "oy",
  "py", "ry", "sy", "ty", "uy", "vy", "wy", "xy", "yy", "zy", "az", "bz", "cz", "dz", "ez", "gz", "iz",
  "lz", "nz", "oz", "pz", "rz", "tz", "uz", "zz",
  NULL };

/* ******************************************************************** */

#if 0
static const char *ndpi_en_popular_bigrams[] = {
   "th", "he", "in", "er", "an", "re", "on", "at", "en", "nd", "ti", "es", "or", "te", "of", "ed", "is", "it",
   "al", "ar", "st", "to", "nt", "ng", "se", "ha", "as", "ou", "io", "le", "ve", "co", "me", "de", "hi", "ri",
   "ro", "ic", "ne", "ea", "ra", "ce", "li", "ch", "ll", "be", "ma", "si", "om", "ur", "ca", "el", "ta", "la",
   "ns", "di", "fo", "ho", "pe", "ec", "pr", "no", "ct", "us", "ac", "ot", "il", "tr", "ly", "nc", "et", "ut",
   "ss", "so", "rs", "un", "lo", "wa", "ge", "ie", "wh", "ee", "wi", "em", "ad", "ol", "rt", "po", "we", "na",
   "ul", "ni", "ts", "mo", "ow", "pa", "im", "mi", "ai", "sh", "ir", "su", "id", "os", "iv", "ia", "am", "fi",
   "ci", "vi", "pl", "ig", "tu", "ev", "ld", "ry", "mp", "fe", "bl", "ab", "gh", "ty", "op", "wo", "sa", "ay",
   "ex", "ke", "fr", "oo", "av", "ag", "if", "ap", "gr", "od", "bo", "sp", "rd", "do", "uc", "bu", "ei", "ov",
   "by", "rm", "ep", "tt", "oc", "fa", "ef", "cu", "rn", "sc", "gi", "da", "yo", "cr", "cl", "du", "ga", "qu",
   "ue", "ff", "ba", "ey", "ls", "va", "um", "pp", "ua", "up", "lu", "go", "ht", "ru", "ug", "ds", "lt", "pi",
   "rc", "rr", "eg", "au", "ck", "ew", "mu", "br", "bi", "pt", "ak", "pu", "ui", "rg", "ib", "tl", "ny", "ki",
   "rk", "ys", "ob", "mm", "fu", "ph", "og", "ms", "ye", "ud", "mb", "ip", "ub", "oi", "rl", "gu", "dr", "hr",
   "cc", "tw", "ft", "wn", "nu", "af", "hu", "nn", "eo", "vo", "rv", "nf", "xp", "gn", "sm", "fl", "iz", "ok",
   "nl", "my", "gl", "aw", "ju", "oa", "eq", "sy", "sl", "ps", "jo", "lf", "nv", "je", "nk", "kn", "gs", "dy",
   "hy", "ze", "ks", "xt", "bs", "ik", "dd", "cy", "rp", "sk", "xi", "oe", "oy", "ws", "lv", "dl", "rf", "eu",
   "dg", "wr", "xa", "yi", "nm", "eb", "rb", "tm", "xc", "eh", "tc", "gy", "ja", "hn", "yp", "za", "gg", "ym",
   "sw", "bj", "lm", "cs", "ii", "ix", "xe", "oh", "lk", "dv", "lp", "ax", "ox", "uf", "dm", "iu", "sf", "bt",
   "ka", "yt", "ek", "pm", "ya", "gt", "wl", "rh", "yl", "hs", "ah", "yc", "yn", "rw", "hm", "lw", "hl", "ae",
   "zi", "az", "lc", "py", "aj", "iq", "nj", "bb", "nh", "uo", "kl", "lr", "tn", "gm", "sn", "nr", "fy", "mn",
   "dw", "sb", "yr", "dn", "sq", "zo", "oj", "yd", "lb", "wt", "lg", "ko", "np", "sr", "nq", "ky", "ln", "nw",
   "tf", "fs", "cq", "dh", "sd", "vy", "dj", "hw", "xu", "ao", "ml", "uk", "uy", "ej", "ez", "hb", "nz", "nb",
   "mc", "yb", "tp", "xh", "ux", "tz", "bv", "mf", "wd", "oz", "yw", "kh", "gd", "bm", "mr", "ku", "uv", "dt",
   "hd", "aa", "xx", "df", "db", "ji", "kr", "xo", "cm", "zz", "nx", "yg", "xy", "kg", "tb", "dc", "bd", "sg",
   "wy", "zy", "aq", "hf", "cd", "vu", "kw", "zu", "bn", "ih", "tg", "xv", "uz", "bc", "xf", "yz", "km", "dp",
   "lh", "wf", "kf", "pf", "cf", "mt", "yu", "cp", "pb", "td", "zl", "sv", "hc", "mg", "pw", "gf", "pd", "pn",
   "pc", "rx", "tv", "ij", "wm", "uh", "wk", "wb", "bh", "oq", "kt", "rq", "kb", "cg", "vr", "cn", "pk", "uu",
   "yf", "wp", "cz", "kp", "dq", "wu", "fm", "wc", "md", "kd", "zh", "gw", "rz", "cb", "iw", "xl", "hp", "mw",
   "vs", "fc", "rj", "bp", "mh", "hh", "yh", "uj", "fg", "fd", "gb", "pg", "tk", "kk", "hq", "fn", "lz", "vl",
   "gp", "hz", "dk", "yk", "qi", "lx", "vd", "zs", "bw", "xq", "mv", "uw", "hg", "fb", "sj", "ww", "gk", "uq",
   "bg", "sz", "jr", "ql", "zt", "hk", "vc", "xm", "gc", "fw", "pz", "kc", "hv", "xw", "zw", "fp", "iy", "pv",
   "vt", "jp", "cv", "zb", "vp", "zr", "fh", "yv", "zg", "zm", "zv", "qs", "kv", "vn", "zn", "qa", "yx", "jn",
   "bf", "mk", "cw", "jm", "lq", "jh", "kj", "jc", "gz", "js", "tx", "fk", "jl", "vm", "lj", "tj", "jj", "cj",
   "vg", "mj", "jt", "pj", "wg", "vh", "bk", "vv", "jd", "tq", "vb", "jf", "dz", "xb", "jb", "zc", "fj", "yy",
   "qn", "xs", "qr", "jk", "jv", "qq", "xn", "vf", "px", "zd", "qt", "zp", "qo", "dx", "hj", "gv", "jw", "qc",
   "jy", "gj", "qb", "pq", "jg", "bz", "mx", "qm", "mz", "qf", "wj", "zq", "xr", "zk", "cx", "fx", "fv", "bx",
   "vw", "vj", "mq", "qv", "zf", "qe", "yj", "gx", "kx", "xg", "qd", "xj", "sx", "vz", "vx", "wv", "yq", "bq",
   "gq", "vk", "zj", "xk", "qp", "hx", "fz", "qh", "qj", "jz", "vq", "kq", "xd", "qw", "jx", "qx", "kz", "wx",
   "fq", "xz", "zx", "jq", "qg", "qk", "qy", "qz", "wq", "wz", NULL
  };
#endif

/* ******************************************************************** */

static const char *ndpi_en_impossible_bigrams[] = {
  "bk", "bq", "bx", "cb", "cf", "cg", "cj", "cp", "cv", "cw", "cx", "dx", "fk", "fq", "fv", "fx", /* "ee", removed it can be found in 'meeting' */
  "fz", "gq", "gv", "gx", "hh", "hk", "hv", "hx", "hz", "iy", "jb", /* "jc", jcrew.com */ "jd", "jf", "jg", "jh", "jk",
  "jl", "jm", "jn", "jp", "jq", /* "jr",*/  /* "js", */ "jt", "jv", "jw", "jx", "jy", "jz", /* "kg", */ "kq", "kv", "kx",
  "kz", "lq", "lx", /* "mg" tamgrt.com , */ "mj", /* "mq", mqtt */  "mx", "mz", "pq", "pv", "px", "qb", "qc", "qd", "qe", "qf", "ii",
  "qg", "qh", "qj", "qk", "ql", "qm", "qn", "qo", "qp", "qr", "qs", "qt", "qv", "qw", "qx", "qy", "uu",
  "qz", "sx", "sz", "tq", "tx", "vb", "vc", "vd", "vf", "vg", "vh", "vj", "vm", "vn", /* "vp", Removed for vpbank.com */ "bw", /* "vk", "zr" Removed for kavkazr */
  "vq", "vt", "vw", "vx", "vz", "wq", "wv", "wx", "wz", /* "xb", foxbusiness.com */
  "xg", "xj", "xk", "xv", "xz", "xw", "yd", /*"yp", Removed for paypal */
  "yj", "yq", "yv", "yz", "yw", "zb", "zc", "zg", "zh", "zj", "zn", "zq", "zs", "zx", "wh", "wk",
  "wb", "zk", "kp", "zk", "xy", "xx",
  NULL };
